#!/bin/bash
#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Main GUI code for basic fllow solver
#
# Author
#    NEXTFOAM Inc.
##############################################################################
import vte;import os,math,sys;import pygtk
pygtk.require('2.0')
import gtk
import pickle

from generalSub import *;from misc import *;from GtknoGL import *
from panel_mesh import *;from panel_cfMesh import *;from panel_initial import *;from panel_boundaryCondition import *
from panel_cellZone import *;from panel_simulation import *;from panel_runCondition import *;from panel_fvSolution import *
from panel_fvSchemes import *;from panel_monitoring import *;from panel_cuttingPlane import *
from etcSub import *
from panel_patchScalar import *

class basicFlowMainWindow:

    def delete_event(self,widget,event,data=None):
        self.window.destroy();gtk.main_quit()

    def destroy(self,widget,data=None):
        self.window.destroy();gtk.main_quit()

    def __init__(self,caseDir,installpath):
        self.caseDir=caseDir
        self.installpath=installpath
        self.mode='New'
        self.rr=1;self.gg=1;self.bb=1
        self.solver='simpleNFoam'

    def basicFlowMainGUI(self):

        def selectStartMode():
        
            def start(widget):
                GEN=generalClass(self.caseDir)
                if newradio.get_active()==1:
                    self.mode='New';self.caseDir=GEN.newcase()
                    if self.caseDir!='None':
                        setfolder();self.window.set_title('Baram-v2.0.2     '+self.caseDir)
                    else:return
                else:
                    self.mode='Open';self.caseDir=GEN.readcase()
                    if self.caseDir!='None':
                        setfolder();self.window.set_title('Baram-v2.0.2     '+self.caseDir)
                        if len(glob.glob(self.caseDir+'/VTK'))==1:
                            VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb)
                            GEN=generalClass(self.caseDir);bcname=GEN.getBCName()
                            onOff=[]
                            for ii in bcname:onOff.append(1)
                            onOff.append(0)
                            viewposition=[1,1,1]
                            displayOpt=self.displayOptCombo.child.get_text()
                            self.renderer=VTK.unsgeometry(bcname,onOff,viewposition,displayOpt)
                            self.gvtk.GetRenderWindow().AddRenderer(self.renderer)
                            self.gvtk.Initialize();self.gvtk.Start()
                            self.notebook.set_current_page(1)
                    else:return
                win.destroy()
                setFree()
                aa=self.freevbox.get_children()
                for ii in aa:self.freevbox.remove(ii)
                self.simulationbox=self.FREESIMULATION.simulation(self.notebook,self.textbuffer,self.energy);self.freevbox.pack_start(self.simulationbox,False,False,0)
                cmd='cd '+self.caseDir+'\n';length=len(cmd)
                self.terminal.feed_child(cmd,length)        
                
                aa=glob.glob(self.caseDir+'/system/settings/solver')
                if aa!=[]:
                    f=open(aa[0],'r');savedSolver=f.readline();f.close()
                    if savedSolver=='simpleNFoam':
                        self.energyCB.set_active(0);self.timeCB.set_active(0)
                    elif savedSolver=='pimpleNFoam':
                        self.energyCB.set_active(0);self.timeCB.set_active(1)
                    elif savedSolver=='buoyantSimpleNFoam':
                        self.energyCB.set_active(1);self.timeCB.set_active(0)
                    elif savedSolver=='buoyantPimpleNFoam':
                        self.energyCB.set_active(1);self.timeCB.set_active(1)
                    
                self.window.show_all()

                if glob.glob(self.caseDir+'/Running')!=[]:os.system('rm '+self.caseDir+'/Running')
                if glob.glob(self.caseDir+'/system/settings/displaymode')!=[]:os.system('rm '+self.caseDir+'/system/settings/displaymode')
                
            win=gtk.Window(gtk.WINDOW_TOPLEVEL);win.set_title('Select start mode');win.set_border_width(5);win.set_position(gtk.WIN_POS_CENTER)
            win.connect("delete_event", self.delete_event);win.set_transient_for(self.window)
            mbox=gtk.VBox(False,0);win.add(mbox)
            
            label=gtk.Label();label.set_markup('<b>  Select Start Mode  </b>');label.set_alignment(0,0.5)
            hbox=gtk.HBox(False,5);mbox.pack_start(hbox,False,False,15)
            hbox.pack_start(label,False,False,5)
                      
            newradio=gtk.RadioButton(None,'New Simulation')
            hbox=gtk.HBox(False,5);mbox.pack_start(hbox,False,False,10);hbox.pack_start(newradio,False,False,25);
            openradio=gtk.RadioButton(newradio,'Open Simulation')
            hbox=gtk.HBox(False,5);mbox.pack_start(hbox,False,False,10);hbox.pack_start(openradio,False,False,25)        

            separator=gtk.HSeparator();separator.set_size_request(285,5);mbox.pack_start(separator,True,True,10)
            
            buttonbox=gtk.HBox(False,5);mbox.pack_start(buttonbox,False,False,10)
            startB=gtk.Button(label='Create / Select folder');startB.connect('clicked',start);startB.set_size_request(150,35)
            buttonbox.pack_end(startB,True,True,10)
            
            win.show_all()
        
        def setfolder():
            MISC=miscClass(self.caseDir)
            a0=glob.glob(self.caseDir+'/0');a1=glob.glob(self.caseDir+'/constant');a2=glob.glob(self.caseDir+'/system');a3=glob.glob(self.caseDir+'/system/settings')
            a4=glob.glob(self.caseDir+'/logfiles')
            if len(a0)==0:os.system('mkdir '+self.caseDir+'/0')
            if len(a1)==0:os.system('mkdir '+self.caseDir+'/constant')
            if len(a2)==0:os.system('mkdir '+self.caseDir+'/system')
            if len(a3)==0:os.system('mkdir '+self.caseDir+'/system/settings')
            if len(a3)==0:os.system('mkdir '+self.caseDir+'/logfiles')
            if self.mode=='New':
                MISC.basicfvsolution();MISC.basicfvschemes(self.solver)
            else:
                if glob.glob(self.caseDir+'/system/fvSolution')==[]:MISC.basicfvsolution(self.solver)
                if glob.glob(self.caseDir+'/system/fvSchemes')==[]:MISC.basicfvschemes(self.solver)
            MISC.basiccontroldict()
        #------------------------------------------------------------------------------------------
        def setFree():        
            self.FREEINITIAL=freepanelInitialClass(self.caseDir,self.window,self.solver,self.installpath)
            self.FREECFMESH=freepanelCfMeshClass(self.caseDir,self.window,self.solver,self.installpath,self.rr,self.gg,self.bb)
            self.FREEMESH=freepanelMeshClass(self.caseDir,self.window,self.solver,self.installpath,self.rr,self.gg,self.bb)
            self.FREEBOUNDARY=freepanelBoundaryConditionClass(self.caseDir,self.window,self.solver,self.installpath,self.rr,self.gg,self.bb)
            self.FREECELLZONE=freepanelCellZoneClass(self.caseDir,self.window,self.solver,self.installpath)
            self.FREESIMULATION=freepanelSimulationClass(self.caseDir,self.window,self.solver,self.installpath)
            self.FREERUNCONDITION=freepanelRunConditionClass(self.caseDir,self.window,self.solver,self.installpath)  
            self.FREEFVSOLUTION=freepanelFvSolutionClass(self.caseDir,self.window,self.solver,self.installpath)
            self.FREEFVSCHEMES=freepanelFvSchemesClass(self.caseDir,self.window,self.solver,self.installpath)
            self.FREEMONITORING=freepanelMonitoringClass(self.caseDir,self.window,self.solver,self.installpath,self.rr,self.gg,self.bb)
            self.FREECUTTINGPLANE=freepanelCuttingPlaneClass(self.caseDir,self.window,self.solver,self.installpath,self.rr,self.gg,self.bb)
            self.FREEPATCHSCALAR=freepanelPatchScalarClass(self.caseDir,self.window,self.solver,self.installpath,self.rr,self.gg,self.bb)            
        #-----------------------------------------------------------------------------------------#
        #  menu item response functions                                                           #
        #-----------------------------------------------------------------------------------------#
        def newcase():
            GEN=generalClass(self.caseDir);returnedname=GEN.newcase()
            if returnedname!='None':
                self.caseDir=returnedname
                setfolder();self.window.set_title('Baram-v2.0.2     '+self.caseDir)
                setFree()
                aa=self.freevbox.get_children()
                for ii in aa:self.freevbox.remove(ii)
                self.simulationbox=self.FREESIMULATION.simulation(self.notebook,self.textbuffer,self.energy);self.freevbox.pack_start(self.simulationbox,False,False,0)
                cmd='cd '+self.caseDir+'\n';length=len(cmd)
                self.terminal.feed_child(cmd,length)
                self.window.show_all()
                
                self.renderer=vtk.vtkRenderer()
                self.renderer.SetBackground(self.rr,self.gg,self.bb)
                self.gvtk.GetRenderWindow().AddRenderer(self.renderer)
                
                message='\n    ***     New Simulation : '+self.caseDir+'     ********** \n\n'
                enditer=self.textbuffer.get_end_iter()
                self.textbuffer.insert(enditer,message)
                self.notebook.set_current_page(0) 
                        
                return self.caseDir
        #-------------------------------------------------------------------------------------------------    
        def readcase():
            GEN=generalClass(self.caseDir);returnedname=GEN.readcase()                        
            if returnedname!='None':
                self.caseDir=returnedname
                setfolder();self.window.set_title('Baram-v2.0.2     '+self.caseDir)
                setFree()
                aa=self.freevbox.get_children()
                for ii in aa:self.freevbox.remove(ii)
                self.simulationbox=self.FREESIMULATION.simulation(self.notebook,self.textbuffer,self.energy);self.freevbox.pack_start(self.simulationbox,False,False,0)
                cmd='cd '+self.caseDir+'\n';length=len(cmd)
                self.terminal.feed_child(cmd,length)
                self.window.show_all()

                aa=glob.glob(self.caseDir+'/system/settings/openSubWindow')
                for ii in aa:os.system('rm '+ii)
                cc=glob.glob(self.caseDir+'/system/settings/displayedPatch')
                for ii in cc:os.system('rm '+ii)
                
                if len(glob.glob(self.caseDir+'/VTK'))==1:
                    VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb)
                    GEN=generalClass(self.caseDir);bcname=GEN.getBCName()
                    onOff=[]
                    for ii in bcname:onOff.append(1)
                    onOff.append(0)
                    viewposition=[1,1,1]
                    displayOpt=self.displayOptCombo.child.get_text()
                    self.renderer=VTK.unsgeometry(bcname,onOff,viewposition,displayOpt)
                    self.gvtk.GetRenderWindow().AddRenderer(self.renderer)
                    self.gvtk.Initialize();self.gvtk.Start()
                    self.notebook.set_current_page(1)
                
                message='\n    ***     Open Simulation : '+self.caseDir+'     ********** \n\n'
                enditer=self.textbuffer.get_end_iter()
                self.textbuffer.insert(enditer,message)
                            
                return self.caseDir              
        #------------------------------------------------------------------------------------------           
        def saveAs():
            GEN=generalClass(self.caseDir);clonename=GEN.saveas()	    
            if clonename!='None':        
                self.caseDir=clonename
                self.window.set_title('Baram-v2.0.2     '+self.caseDir)
                setFree()

                cmd='cd '+self.caseDir+'\n';length=len(cmd)
                self.terminal.feed_child(cmd,length)
                self.window.show_all()
                
                aa=glob.glob(self.caseDir+'/system/settings/openSubWindow')
                for ii in aa:os.system('rm '+ii)
                cc=glob.glob(self.caseDir+'/system/settings/displayedPatch')
                for ii in cc:os.system('rm '+ii)  
                
                message='\n    ***     SIMULATION CASE is saved : '+self.caseDir+'     ********** \n\n'
                enditer=self.textbuffer.get_end_iter()
                self.textbuffer.insert(enditer,message)
                self.notebook.set_current_page(0)
                                              
                return self.caseDir
        #------------------------------------------------------------------------------------------
        def cloneCase():
            GEN=generalClass(self.caseDir);clonename=GEN.clone()
            if clonename!='None':
                self.caseDir=clonename
                elf.window.set_title('Baram-v2.0.2     '+self.caseDir)
                setFree()

                cmd='cd '+self.caseDir+'\n';length=len(cmd)
                self.terminal.feed_child(cmd,length)
                self.window.show_all()

                aa=glob.glob(self.caseDir+'/system/settings/openSubWindow')
                for ii in aa:os.system('rm '+ii)
                cc=glob.glob(self.caseDir+'/system/settings/displayedPatch')
                for ii in cc:os.system('rm '+ii)                
                
                message='\n    ***     SIMULATION CASE is cloned : '+self.caseDir+'     ********** \n\n'
                enditer=self.textbuffer.get_end_iter()
                self.textbuffer.insert(enditer,message)
                self.notebook.set_current_page(0)
                        
                return self.caseDir
        #------------------------------------------------------------------------------------------
        def paraFoam():os.system('paraFoam -builtin -case '+self.caseDir+'&')
        #------------------------------------------------------------------------------------------
        def menuitem_response(widget,string):
            GEN=generalClass(self.caseDir)
            MESH=freepanelMeshClass(self.caseDir,self.window,self.solver,self.installpath,self.rr,self.gg,self.bb)            
            ETC=etcClass(self.caseDir,self.solver,self.installpath,self.rr,self.gg,self.bb)
            if string=='New simulation':newcase()
            elif string=='Open simulation':readcase()
            elif string=='Save As':saveAs() 
            elif string=='Clone Case':cloneCase()
            elif string=='Clear Data':os.system('pyFoamClearCase.py '+self.caseDir)
            elif string=='reconstructPar':ETC.reconstructPar(self.window,self.notebook,self.terminal)
            elif string=='Exit':closedialog()
            elif string=='Check Mesh':MESH.checkMesh(self.notebook,self.textbuffer,self.terminal)            
            elif string=='Scale Mesh':MESH.scaleMesh(self.notebook,self.textbuffer,self.terminal)
            elif string=='Translate Mesh':MESH.translateMesh(self.notebook,self.textbuffer,self.terminal)                        
            elif string=='paraFoam -builtin':os.system('paraFoam -builtin -case '+self.caseDir+'&')
            elif string=='paraFoam':os.system('paraFoam -case '+self.caseDir+'&')
            elif string=='mapFields':ETC.mapFields(self.window,self.notebook,self.terminal)
            elif string=='setFields':ETC.setFields(self.window,self.notebook,self.terminal,self.gvtk)
            elif string=='yPlusRAS':ETC.yPlusRAS(self.window,self.solver,self.notebook,self.terminal)
            elif string=='Umag':GEN.Umag(self.window)
            elif string=='kill-job':GEN.killjob(self.window)
            elif string=='Job-Status':GEN.jobStatusCheck(self.window)
            elif string=='caseReport':GEN.caseReport(self.window)
            elif string=='createPdf':GEN.caseReportToPdf()
            elif string=='users guide':os.system('evince '+self.installpath+'/Baram-v2.0.1-usersGuide.pdf &')
        #----------------------------------------------------------------------------------------------------
        def resetview(viewposition):
        
            displayOpt=self.displayOptCombo.child.get_text()            
            GEN=generalClass(self.caseDir);VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb)                      
            camera=vtk.vtkCamera();camera.SetPosition(viewposition[0],viewposition[1],viewposition[2])            
            
            aa=glob.glob(self.caseDir+'/system/settings/displaymode')
            if len(aa)!=0:
                f=open(self.caseDir+'/system/settings/displaymode','r');displaymode=f.read();f.close()
                if displaymode=='stl':
                    stlfile=self.caseDir+'/mesh.stl'
                    self.renderer=VTK.showSTL(stlfile,viewposition,displayOpt)
                elif displaymode=='stlpatch':
                    cc=glob.glob(self.caseDir+'/system/settings/displayedSTL')
                    if cc!=[]:
                        g=open(cc[0],'r');gg=g.readlines();g.close()
                        ab=glob.glob(self.caseDir+'/system/settings/*.stl')                    
                        stlfiles=[]
                        for i in range(len(ab)):
                            nn=ab[i].split('/')
                            if gg[i][:-1]=='1':stlfiles.append(nn[-1][:-4])
                        self.renderer=VTK.showSTLMulti(stlfiles,viewposition,displayOpt)
                elif displaymode=='mesh' or displaymode=='patch':
                    bcname=GEN.getBCName()  
                    dd=glob.glob(self.caseDir+'/system/settings/displayedPatch')
                    if dd!=[]:
                        g=open(dd[0],'r');gg=g.readlines();g.close()
                        if len(gg)==len(bcname)+1:
                            onOff=[]
                            for ii in gg:onOff.append(int(ii[:-1]))
                        else:
                            onOff=[]
                            for ii in gg:onOff.append(int(ii[:-1]))
                            onOff.append(0)
                    else:            
                        onOff=[]
                        for ii in bcname:onOff.append(1)
                        onOff.append(0)
                        
                    if displaymode=='mesh':self.renderer=VTK.unsgeometry(bcname,onOff,viewposition,displayOpt)
                    elif displaymode=='patch':self.renderer=VTK.unsshowPatch(bcname,onOff,viewposition)
                elif displaymode=='cuttingPlane':
                    f=open(self.caseDir+'/system/settings/cuttingPlaneSet','r')
                    dic=pickle.load(f);f.close()
                    self.renderer=VTK.cutPlane(dic['normallist'],dic['originlist'],dic['scalar'],dic['caseType'],dic['selectedTime'],viewposition)
                elif displaymode=='patchScalar':
                    f=open(self.caseDir+'/system/settings/displayedPatchScalar','r')
                    dic=pickle.load(f);f.close()
                    self.renderer=VTK.patchField(dic['patchzone'],dic['onOff'],dic['scalar'],dic['time'],dic['caseType'],viewposition,displayOpt)
            else:
                self.renderer.SetActiveCamera(camera)
                self.renderer.ResetCamera()
            
            self.gvtk.GetRenderWindow().AddRenderer(self.renderer)
            self.gvtk.Initialize();self.gvtk.Start()
        #----------------------------------------------------------------------------------------------------#
        #   MAIN GUI 											                                             #
        #----------------------------------------------------------------------------------------------------#              
        backgroundcolor='white'        

        self.window=gtk.Window(gtk.WINDOW_TOPLEVEL);self.window.set_title('Baram-v2.0.2')
        self.window.set_border_width(2);self.window.set_position(gtk.WIN_POS_CENTER)
        self.window.connect("delete_event", self.delete_event)
        
        self.swin=gtk.ScrolledWindow();self.swin.set_border_width(0);self.swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        self.swin.set_size_request(1420,880)
        self.window.add(self.swin)
        self.mainbox=gtk.VBox(False,0);self.swin.add_with_viewport(self.mainbox)
        self.menubox=gtk.HBox(False,0);self.vvbox=gtk.VBox(False,0)
        self.mainbox.pack_start(self.menubox,False,False,0);self.mainbox.pack_start(self.vvbox,True,True,0)
        self.mb=gtk.MenuBar();self.menubox.pack_start(self.mb,False,False,0)

        self.toolframe=gtk.Frame();self.toolframe.set_shadow_type(gtk.SHADOW_IN)
        self.vvbox.pack_start(self.toolframe,False,False,0)
        self.toolbarbox=gtk.HBox(False,0)
        self.toolframe.add(self.toolbarbox)
        self.hhbox=gtk.HBox(False,0);self.vvbox.pack_start(self.hhbox,True,True,0)

        self.toolframe.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse(backgroundcolor))

        self.freepanelbox=gtk.VBox(False,0);self.hhbox.pack_start(self.freepanelbox,False,False,0)
        self.graphicbox=gtk.HBox(False,0);self.hhbox.pack_start(self.graphicbox,True,True,0)
        #-----------------------------------------------------------------------------------------------------
        # create menu    
        #-----------------------------------------------------------------------------------------------------
        self.fmenu=gtk.Menu()
        files=['New simulation','Open simulation','Save As','Clone Case','Clear Data','reconstructPar','Exit']
        for i in range(len(files)):
            self.mi=gtk.MenuItem(files[i]);self.fmenu.append(self.mi);self.mi.connect('activate',menuitem_response,files[i])            
        self.mmenu=gtk.Menu()
        meshs=['Check Mesh','Scale Mesh','Translate Mesh']
        for i in range(len(meshs)):
            self.mi=gtk.MenuItem(meshs[i]);self.mmenu.append(self.mi);self.mi.connect('activate',menuitem_response,meshs[i])                                   
        self.pmenu=gtk.Menu()
        posts=['paraFoam','paraFoam -builtin']
        for i in range(len(posts)):
            self.mi=gtk.MenuItem(posts[i]);self.pmenu.append(self.mi);self.mi.connect('activate',menuitem_response,posts[i])        
        self.kmenu=gtk.Menu()
        kills=['kill-job']
        for i in range(len(kills)):
            self.mi=gtk.MenuItem(kills[i]);self.kmenu.append(self.mi);self.mi.connect('activate',menuitem_response,kills[i])        
        self.fimenu=gtk.Menu()
        fields=['mapFields','setFields','yPlusRAS']
        for i in range(len(fields)):
            self.mi=gtk.MenuItem(fields[i]);self.fimenu.append(self.mi);self.mi.connect('activate',menuitem_response,fields[i])        
        self.remenu=gtk.Menu()
        report=['caseReport','createPdf']
        for i in range(len(report)):
            self.mi=gtk.MenuItem(report[i]);self.remenu.append(self.mi);self.mi.connect('activate',menuitem_response,report[i])        
        self.hmenu=gtk.Menu()
        help=['users guide']
        for i in range(len(help)):
            self.mi=gtk.MenuItem(help[i]);self.hmenu.append(self.mi);self.mi.connect('activate',menuitem_response,help[i])        

        self.filemenu=gtk.MenuItem('File  ');self.filemenu.set_submenu(self.fmenu)
        self.meshmenu=gtk.MenuItem('Mesh  ');self.meshmenu.set_submenu(self.mmenu)        
        self.fieldmenu=gtk.MenuItem('Fields  ');self.fieldmenu.set_submenu(self.fimenu)
        self.reportmenu=gtk.MenuItem('Report  ');self.reportmenu.set_submenu(self.remenu)
        self.killmenu=gtk.MenuItem('Job-control  ');self.killmenu.set_submenu(self.kmenu)
        self.postmenu=gtk.MenuItem('PostProcessing  ');self.postmenu.set_submenu(self.pmenu) 
        self.helpmenu=gtk.MenuItem('Help  ');self.helpmenu.set_submenu(self.hmenu)

        self.mb.append(self.filemenu);self.mb.append(self.meshmenu);self.mb.append(self.fieldmenu)      
        self.mb.append(self.reportmenu);self.mb.append(self.postmenu);self.mb.append(self.helpmenu)
        #-----------------------------------------------------------------------------------------------------	
        # create toolbar
        #-----------------------------------------------------------------------------------------------------
        self.toolbox=gtk.HBox(False,5)

        def chenergytime(widget):
            if self.energyCB.get_active()==0:
                if self.timeCB.get_active()==0:self.solver='simpleNFoam'
                else:self.solver='pimpleNFoam'
                self.energy=False
            else:
                if self.timeCB.get_active()==0:self.solver='buoyantSimpleNFoam'
                else:self.solver='buoyantPimpleNFoam'
                self.energy=True
            
            cc=self.freevbox.get_children()
            for ii in cc:self.freevbox.remove(ii)
            self.simulationbox=self.FREESIMULATION.simulation(self.notebook,self.textbuffer,self.energy);self.freevbox.pack_start(self.simulationbox,False,False,5)
            self.window.show_all()
            
            MISC=miscClass(self.caseDir);MISC.fvSchemes_change_ddt(self.solver)
            setFree()
            
            message='\n    ***     Solver is changed to '+self.solver+'     ********** \n\n'
            self.textbuffer.insert_at_cursor(message)
            
        self.timeCB=gtk.CheckButton('Transient      ');self.energyCB=gtk.CheckButton('Energy        ')
        hbox1=gtk.EventBox();self.toolbarbox.pack_start(hbox1,False,False,0)
        hbox2=gtk.EventBox();self.toolbarbox.pack_start(hbox2,False,False,0)
        hbox1.add(self.timeCB);hbox2.add(self.energyCB)
        self.energyCB.connect('toggled',chenergytime);self.timeCB.connect('toggled',chenergytime)

        self.toolbarbox.pack_start(self.toolbox,True,True,0)
        self.handlebox=gtk.HandleBox();self.toolbox.pack_start(self.handlebox,True,True,0)
        self.toolbar=gtk.Toolbar();self.toolbar.set_orientation(gtk.ORIENTATION_HORIZONTAL)
        self.toolbar.set_style(gtk.TOOLBAR_BOTH);self.toolbar.set_border_width(0)
        
        hbox1.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse(backgroundcolor))
        hbox2.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse(backgroundcolor))
        
        self.handlebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse(backgroundcolor))
        self.toolbar.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse(backgroundcolor))
        self.handlebox.add(self.toolbar)
        
        self.displayOptCombo=gtk.combo_box_entry_new_text();self.displayOptCombo.set_size_request(180,28)
        displayoptList=['surface','surfaceEdge','wireframe']
        for ii in displayoptList:self.displayOptCombo.append_text(ii)
        self.displayOptCombo.set_size_request(120,28)
        self.displayOptCombo.set_active(0)
        hbox3=gtk.EventBox();self.toolbarbox.pack_start(hbox3,True,True,0)
        hbox3.add(self.displayOptCombo)
        hbox3.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse(backgroundcolor))
                
        def closedialog():
            def applythis(widget):
                win.destroy()
                self.window.destroy();gtk.main_quit()
            def closethis(widget):
                win.destroy()
            win=gtk.Window(gtk.WINDOW_TOPLEVEL);win.set_border_width(5);win.set_position(gtk.WIN_POS_CENTER)
            mbox=gtk.VBox(False,0);win.add(mbox)
            frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);mbox.pack_start(frame,False,False,5);hbox=gtk.HBox(False,5);frame.add(hbox)
            ibox=gtk.VBox(False,5);hbox.pack_start(ibox,False,False,5)
            pic=gtk.Image();pic.set_from_file(self.installpath+'/pic/question.png');ibox.pack_start(pic,False,False,0)
            lbox=gtk.HBox(False,5);hbox.pack_start(lbox,False,False,5);label=gtk.Label('Exit this program ?');lbox.pack_start(label,False,False,5)
            bbox=gtk.HBox(False,5);mbox.pack_start(bbox,False,False,5)
            appB=gtk.Button('Exit');appB.set_size_request(100,28);appB.connect('clicked',applythis)
            clsB=gtk.Button('Cancel');clsB.set_size_request(100,28);clsB.connect('clicked',closethis)
            bbox.pack_end(clsB,True,True,5);bbox.pack_end(appB,True,True,5)	
            win.show_all()

        def tpara(widget):paraFoam()
        def tstop(widget):GEN=generalClass(self.caseDir);GEN.savestop()
        def tclose(widget):closedialog()
        def reset(widget):resetview([1,1,1])
        def xview(widget):resetview([1,0,0])
        def yview(widget):resetview([0,1,0])
        def zview(widget):resetview([0,0,1])
        def mxview(widget):resetview([-1,0,0])
        def myview(widget):resetview([0,-1,0])
        def mzview(widget):resetview([0,0,-1])
        def tmesh(widget):chfreepanel('Mesh Manipulation')
        def tcfmesh(widget):chfreepanel('CfMesh')        
        def tsim(widget):chfreepanel('Simulation Conditions')
        def tbc(widget):chfreepanel('Boundary Conditions')
        def tcellzone(widget):chfreepanel('Cell Zone Conditions')        
        def tinit(widget):chfreepanel('Initial Conditions')
        def tsolv(widget):chfreepanel('Solution Conditions')
        def tnume(widget):chfreepanel('Numerical Conditions')
        def tmonitor(widget):chfreepanel('Monitoring/Post')
        def tcut(widget):chfreepanel('Cutting Plane')
        def tpatchscalar(widget):chfreepanel('Patch Scalar')        
        def trun(widget):chfreepanel('Run Conditions')
        
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/turbulence.png")
        self.toolbar.append_item(None,'Simulation conditions','Private',self.iconw,tsim)        
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/cfmesh.png")
        self.toolbar.append_item(None,'CfMesh','Private',self.iconw,tcfmesh)
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/Mesh.png")
        self.toolbar.append_item(None,'Mesh manipulation','Private',self.iconw,tmesh)        
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/bc.png")
        self.toolbar.append_item(None,'Boundary conditions','Private',self.iconw,tbc)        
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/cellzone.png")        
        self.toolbar.append_item(None,'Cell zone conditions','Private',self.iconw,tcellzone)        
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/init.png")                        
        self.toolbar.append_item(None,'Initial conditions','Private',self.iconw,tinit)        
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/solv.jpg")
        self.toolbar.append_item(None,'Solution conditions','Private',self.iconw,tsolv)
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/nume.png")
        self.toolbar.append_item(None,'Numerical conditions','Private',self.iconw,tnume)
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/monitor.png")
        self.toolbar.append_item(None,'Monitoring/Post','Private',self.iconw,tmonitor)
        self.toolbar.append_space()         
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/run.png")
        self.toolbar.append_item(None,'Run conditions','Private',self.iconw,trun) 
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/stop.png")
        self.toolbar.append_item(None,'Stop','Private',self.iconw,tstop)
        self.toolbar.append_space() 
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/patchscalar.png")
        self.toolbar.append_item(None,'Patch Scalar','Private',self.iconw,tpatchscalar)                                              
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/cutplane.png")
        self.toolbar.append_item(None,'Cutting plane','Private',self.iconw,tcut)  
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/para.jpg")
        self.toolbar.append_item(None,'ParaFoam','Private',self.iconw,tpara)
        self.toolbar.append_space()               
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/reset.png")
        self.toolbar.append_item(None,'Reset','Private',self.iconw,reset)
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/plusx.png")
        self.toolbar.append_item(None,'view dir. +X','Private',self.iconw,xview)
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/minusx.png")
        self.toolbar.append_item(None,'view dir. -X','Private',self.iconw,mxview)
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/plusy.png")
        self.toolbar.append_item(None,'view dir. +Y','Private',self.iconw,yview)
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/minusy.png")
        self.toolbar.append_item(None,'view dir. -Y','Private',self.iconw,myview)
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/plusz.png")
        self.toolbar.append_item(None,'view dir. +Z','Private',self.iconw,zview)
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/minusz.png")
        self.toolbar.append_item(None,'view dir. -Z','Private',self.iconw,mzview)
        self.toolbar.append_space()
        self.iconw = gtk.Image();self.iconw.set_from_file(self.installpath+"/pic/close.png")
        self.toolbar.append_item(None,'Closes this app','Private',self.iconw,tclose)
        self.toolbar.append_space()

        if self.caseDir!='None':setfolder()
        #-----------------------------------------------------------------------------------------------------
        # left box
        #-----------------------------------------------------------------------------------------------------
        setFree()
        self.energy=False

        def chfreepanel(whatitem):        
            aa=self.freevbox.get_children()
            for ii in aa:self.freevbox.remove(ii)
            
            if whatitem=='Simulation Conditions':
                self.simulationbox=self.FREESIMULATION.simulation(self.notebook,self.textbuffer,self.energy);self.freevbox.pack_start(self.simulationbox,False,False,0)  
            elif whatitem=='CfMesh':
                self.cfmeshbox=self.FREECFMESH.cfMesh(self.gvtk,self.notebook,self.textbuffer,self.terminal,self.displayOptCombo);self.freevbox.pack_start(self.cfmeshbox,False,False,0)
            elif whatitem=='Mesh Manipulation':
                self.meshbox=self.FREEMESH.mesh(self.gvtk,self.notebook,self.textbuffer,self.terminal,self.displayOptCombo);self.freevbox.pack_start(self.meshbox,False,False,0)
            elif whatitem=='Boundary Conditions':
                self.boundarybox=self.FREEBOUNDARY.boundaryCondition(self.gvtk,self.notebook,self.textbuffer);self.freevbox.pack_start(self.boundarybox,False,False,0)
            elif whatitem=='Cell Zone Conditions':
                self.cellzonebox=self.FREECELLZONE.cellZone(self.notebook,self.textbuffer);self.freevbox.pack_start(self.cellzonebox,False,False,0)
            elif whatitem=='Initial Conditions':
                self.initialbox=self.FREEINITIAL.initialCondition(self.notebook,self.textbuffer);self.freevbox.pack_start(self.initialbox,False,False,0)
            elif whatitem=='Solution Conditions':
                self.solbox=self.FREEFVSOLUTION.fvSolution(self.solver,self.notebook,self.textbuffer);self.freevbox.pack_start(self.solbox,False,False,0)
            elif whatitem=='Numerical Conditions':
                self.schbox=self.FREEFVSCHEMES.fvSchemes(self.solver,self.notebook,self.textbuffer);self.freevbox.pack_start(self.schbox,False,False,0)
            elif whatitem=='Monitoring/Post':
                self.monitorbox=self.FREEMONITORING.monitoring(self.gvtk,self.notebook,self.textbuffer);self.freevbox.pack_start(self.monitorbox,False,False,0)
            elif whatitem=='Cutting Plane':
                self.cuttingPlanebox=self.FREECUTTINGPLANE.cuttingPlane(self.gvtk,self.notebook,self.textbuffer);self.freevbox.pack_start(self.cuttingPlanebox,False,False,0)
            elif whatitem=='Patch Scalar':
                self.patchScalarbox=self.FREEPATCHSCALAR.patchScalar(self.gvtk,self.notebook,self.textbuffer,self.displayOptCombo);self.freevbox.pack_start(self.patchScalarbox,False,False,0)
            elif whatitem=='Run Conditions':
                self.runbox=self.FREERUNCONDITION.runCondition(self.notebook,self.textbuffer,self.terminal);self.freevbox.pack_start(self.runbox,False,False,0)
            self.window.show_all()
        #-----------------------------------------------------------------------------------------------------
        self.freeframe=gtk.Frame();self.freeframe.set_shadow_type(gtk.SHADOW_IN);self.freepanelbox.pack_start(self.freeframe,True,True,0)
        freeswin=gtk.ScrolledWindow();freeswin.set_border_width(0);freeswin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
        freeswin.set_size_request(300,150);self.freeframe.add(freeswin)
        hbox=gtk.HBox(False,0);freeswin.add_with_viewport(hbox)
        self.freevbox=gtk.VBox(False,0);hbox.pack_start(self.freevbox,True,True,0)
        #----- render window ---------------------------------------------------------------------------------
        self.renderbox=gtk.VBox(False,5)        
        self.gvtk=GtkExtVTKRenderWindowInteractor();self.gvtk.SetDesiredUpdateRate(1000)
        self.renderbox.pack_start(self.gvtk,True,True,0);self.gvtk.Initialize();self.gvtk.Start()
        self.renderer=vtk.vtkRenderer()
        self.renderer.SetBackground(self.rr,self.gg,self.bb)
        self.gvtk.GetRenderWindow().AddRenderer(self.renderer)
        #----- shell ---------------------------------------------------------------------------------        
        self.shellbox=gtk.VBox(False,5)
        self.terminal=vte.Terminal()
        self.terminal.fork_command()
                        
        self.scroller = gtk.ScrolledWindow()
        self.scroller.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.scroller.add(self.terminal)
        self.shellbox.pack_start(self.scroller,True,True,2) 
        #----- text window ---------------------------------------------------------------------------------        
        self.messagesw=gtk.ScrolledWindow();self.messagesw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.textview=gtk.TextView()
        self.textbuffer=self.textview.get_buffer()
        self.messagesw.add(self.textview)
        
        self.textwindow=gtk.VBox(False,5)
        self.textwindow.pack_start(self.messagesw,True,True,5)             
        texthbox=gtk.HBox(False,5)
        self.textwindow.pack_start(texthbox,False,False,5)
        
        def textview_changed(widget,event):
            adj=self.messagesw.get_vadjustment()
            adj.set_value(adj.upper-adj.page_size)
        
        self.textview.connect('size-allocate',textview_changed)
        #----- notebook  -------------------------------------------------------------------------------------                
        self.notebook=gtk.Notebook();self.notebook.set_tab_pos(gtk.POS_TOP)
        self.graphicbox.pack_start(self.notebook,True,True,0)
        label1=gtk.Label('Message window')
        label2=gtk.Label('Graphic window')
        label3=gtk.Label('shell window')
        self.notebook.append_page(self.textwindow,label1)
        self.notebook.append_page(self.renderbox,label2)  
        self.notebook.append_page(self.shellbox,label3) 
        #-----------------------------------------------------------------------------------------
        self.window.show_all()
        
        selectStartMode()
        
        
    
