import sys
import pygtk
pygtk.require('2.0')
import vtk as vtk
import math
import os

from vtk import *
from generalSub import *

class VTKStuff():

    def __init__(self,caseDir,rr,gg,bb):
        self.caseDir=caseDir
        self.rr=rr
        self.gg=gg
        self.bb=bb

    def showPatch(self,patchName,onOff):

        fileName = self.caseDir+'/ '       
        reader=vtk.vtkOpenFOAMReader();reader.SetFileName(fileName)
        reader.SetCreateCellToPoint(1);reader.DecomposePolyhedraOn()
        reader.Update() 

        patchName.append('internalMesh');numberOfPatch=len(patchName)
        onOff.append(0)
        for i in range(len(patchName)):reader.SetPatchArrayStatus(patchName[i],onOff[i])
        reader.Update()

        compositeFilter=vtk.vtkCompositeDataGeometryFilter() 
        compositeFilter.SetInputConnection(reader.GetOutputPort()) 
        compositeFilter.Update()

        mapper=vtk.vtkPolyDataMapper() 
        mapper.SetInputConnection(compositeFilter.GetOutputPort());mapper.ScalarVisibilityOff()

        prop=vtk.vtkProperty();prop.SetColor(1,0,0)
        prop.EdgeVisibilityOn()

        actor=vtk.vtkActor();actor.SetMapper(mapper);actor.SetProperty(prop)
             
        reader1=vtk.vtkOpenFOAMReader();reader1.SetFileName(fileName)
        reader1.SetCreateCellToPoint(1);reader1.DecomposePolyhedraOn()
        reader1.Update() 

        onOff1=[]
        for ii in onOff:onOff1.append(1)
        onOff1[-1]=0

        for i in range(len(patchName)):reader1.SetPatchArrayStatus(patchName[i],onOff1[i])            
        reader1.Update()

        compositeFilter1=vtk.vtkCompositeDataGeometryFilter() 
        compositeFilter1.SetInputConnection(reader1.GetOutputPort()) 
        compositeFilter1.Update()

        mesh=vtk.vtkExtractEdges()                                  
        mesh.SetInputConnection(compositeFilter1.GetOutputPort())    
        mesh.Update()                                               
                                                            
        edgemapper=vtk.vtkPolyDataMapper()                          
        edgemapper.SetInputConnection(mesh.GetOutputPort())         
                                                            
        edgeprop=vtk.vtkProperty()  
        edgeprop.SetEdgeColor(1,1,1)                                
        edgeprop.EdgeVisibilityOn()                                 
                                                            
        edgeactor=vtk.vtkActor()                                  
        edgeactor.SetMapper(edgemapper)                             
        edgeactor.SetProperty(edgeprop)
        
        renderer=vtk.vtkRenderer();renderer.AddActor(actor);renderer.AddActor(edgeactor)
        renderer.SetBackground(self.rr,self.gg,self.bb)

        return renderer           
    #---------------------------------------------------------------------------------------
    def geometry(self,patchName,onOff,viewposition):

        fileName = self.caseDir+'/ '
        
        reader=vtk.vtkOpenFOAMReader()
        reader.SetFileName(fileName)
        reader.Update() 
        
        patchName.append('internalMesh');numberOfPatch=len(patchName)

        for i in range(numberOfPatch):reader.SetPatchArrayStatus(patchName[i],onOff[i])
        reader.Update()

        compositeFilter=vtk.vtkCompositeDataGeometryFilter() 
        compositeFilter.SetInputConnection(reader.GetOutputPort()) 
        compositeFilter.Update()

        mapper=vtk.vtkPolyDataMapper() 
        mapper.SetInputConnection(compositeFilter.GetOutputPort())
        mapper.ScalarVisibilityOff()

        prop=vtk.vtkProperty();prop.SetColor(1,1,1)
        prop.EdgeVisibilityOn()
        
        transform = vtk.vtkTransform();transform.Translate(0,0,0)
        axes = vtk.vtkAxesActor()
        axes.SetUserTransform(transform)
        
        #www=vtk.vtkOrientationMarkerWidget()
        #www.SetOutlineColor( 0.9300, 0.5700, 0.1300 )
        #www.SetOrientationMarker( axes )
        #www.SetInteractor(gvtk.GetInteractor())
        #www.SetEnabled(1)
        #www.SetInteractive(1)
        
        GEN=generalClass(self.caseDir);minmax=GEN.getDomainRange()
        delx=float(minmax[1][0])-float(minmax[0][0])
        dely=float(minmax[1][1])-float(minmax[0][1])
        delz=float(minmax[1][2])-float(minmax[0][2])
        mmm=[delx,dely,delz];mmm.sort();xx=mmm[-1]*0.1  
        
        axes.SetTotalLength(xx,xx,xx)
        #axes.SetTotalLength(1,1,1)
        #axes.SetNormalizedShaftLength(1.0, 1.0, 1.0)
        #axes.SetNormalizedTipLength(0.2, 0.2, 0.2)

        xAxisLabel = axes.GetXAxisCaptionActor2D()
        xAxisLabel.GetTextActor().SetTextScaleModeToNone()
        xAxisLabel.GetCaptionTextProperty().SetColor(1,1,0)        
        yAxisLabel = axes.GetYAxisCaptionActor2D()
        yAxisLabel.GetTextActor().SetTextScaleModeToNone()
        yAxisLabel.GetCaptionTextProperty().SetColor(1,1,0)        
        zAxisLabel = axes.GetZAxisCaptionActor2D()
        zAxisLabel.GetTextActor().SetTextScaleModeToNone()
        zAxisLabel.GetCaptionTextProperty().SetColor(1,1,0)

        actor=vtk.vtkActor();actor.SetMapper(mapper);actor.SetProperty(prop)

        renderer=vtk.vtkRenderer();renderer.AddActor(actor);renderer.AddActor(axes)
        renderer.SetBackground(self.rr,self.gg,self.bb)
                
        camera=vtk.vtkCamera()
        #camera.SetPosition(1,1,1)
        camera.SetPosition(viewposition[0],viewposition[1],viewposition[2])
        renderer.SetActiveCamera(camera)
        renderer.ResetCamera()
      
        return renderer
    #---------------------------------------------------------------------------------------
    def unsshowPatch(self,patchName,onOff,viewposition):
    
        filesnon=[]
        for i in range(len(patchName)):
            if onOff[i]==0:
                filesnon.append(self.caseDir+'/VTK/'+patchName[i]+'/'+patchName[i]+'_0.vtk')
            else:
                selectedfile=self.caseDir+'/VTK/'+patchName[i]+'/'+patchName[i]+'_0.vtk'

        renderer=vtkRenderer()
        
        readers=[];mappers=[];actors=[]
        for i in range(len(filesnon)): 
            readers.append(vtkPolyDataReader())
            readers[i].SetFileName(filesnon[i])
            readers[i].Update()

            mappers.append(vtkDataSetMapper())
            mappers[i].SetInputConnection(readers[i].GetOutputPort())
 
            actors.append(vtkActor())
            actors[i].SetMapper(mappers[i])
            
            actors[i].GetProperty().SetRepresentationToWireframe()
 
            renderer.AddActor(actors[i])

        selectedReader=vtkPolyDataReader()
        selectedReader.SetFileName(selectedfile)
        selectedReader.Update()
        
        selectedMapper=vtkDataSetMapper()
        selectedMapper.SetInputConnection(selectedReader.GetOutputPort())
 
        prop=vtk.vtkProperty();prop.SetColor(1,0,0)

        selectedActor=vtkActor()
        selectedActor.SetMapper(selectedMapper)
        selectedActor.SetProperty(prop)
 
        renderer.AddActor(selectedActor)

        axes = vtk.vtkAxesActor()
        
        GEN=generalClass(self.caseDir);minmax=GEN.getDomainRange()
        delx=float(minmax[1][0])-float(minmax[0][0])
        dely=float(minmax[1][1])-float(minmax[0][1])
        delz=float(minmax[1][2])-float(minmax[0][2])
        mmm=[delx,dely,delz];mmm.sort();xx=mmm[-1]*0.1  
        
        axes.SetTotalLength(xx,xx,xx)
        #axes.SetNormalizedShaftLength(1.0, 1.0, 1.0)
        #axes.SetNormalizedTipLength(0.2, 0.2, 0.2)

        xAxisLabel = axes.GetXAxisCaptionActor2D()
        xAxisLabel.GetTextActor().SetTextScaleModeToNone()
        xAxisLabel.GetCaptionTextProperty().SetColor(1,1,0)        
        yAxisLabel = axes.GetYAxisCaptionActor2D()
        yAxisLabel.GetTextActor().SetTextScaleModeToNone()
        yAxisLabel.GetCaptionTextProperty().SetColor(1,1,0)        
        zAxisLabel = axes.GetZAxisCaptionActor2D()
        zAxisLabel.GetTextActor().SetTextScaleModeToNone()
        zAxisLabel.GetCaptionTextProperty().SetColor(1,1,0)
        
        renderer.AddActor(axes)
                    
        renderer.SetBackground(self.rr,self.gg,self.bb)        
        camera=vtk.vtkCamera()
        camera.SetPosition(viewposition[0],viewposition[1],viewposition[2])
        renderer.SetActiveCamera(camera)
        renderer.ResetCamera()

        return renderer  
    #---------------------------------------------------------------------------------------    
    def unsgeometry(self,patchName,onOff,viewposition,displayOpt):

        files=[]
        for i in range(len(patchName)):
            if onOff[i]==1:
                files.append(self.caseDir+'/VTK/'+patchName[i]+'/'+patchName[i]+'_0.vtk')

        renderer=vtkRenderer()
        
        readers=[];mappers=[];actors=[];props=[]
        for i in range(len(files)): 
            readers.append(vtkPolyDataReader())
            readers[i].SetFileName(files[i])
            readers[i].Update()

            mappers.append(vtkDataSetMapper())
            mappers[i].SetInputConnection(readers[i].GetOutputPort())
 
            actors.append(vtkActor())
            actors[i].SetMapper(mappers[i])
                
            props.append(vtk.vtkProperty())
            aa=divmod(i,6);res=aa[1]
            if res==0:props[i].SetColor(0,0,1)
            elif res==1:props[i].SetColor(0,1,0)
            elif res==2:props[i].SetColor(1,0,0)
            elif res==3:props[i].SetColor(1,1,0)
            elif res==4:props[i].SetColor(0,1,1)
            elif res==5:props[i].SetColor(1,0,1)
            
            if displayOpt=='surfaceEdge':props[i].EdgeVisibilityOn()
            
            actors[i].SetProperty(props[i])            

            if displayOpt=='wireframe':actors[i].GetProperty().SetRepresentationToWireframe()
                 
            renderer.AddActor(actors[i])

        axes = vtk.vtkAxesActor()
        
        GEN=generalClass(self.caseDir);minmax=GEN.getDomainRange()
        delx=float(minmax[1][0])-float(minmax[0][0])
        dely=float(minmax[1][1])-float(minmax[0][1])
        delz=float(minmax[1][2])-float(minmax[0][2])
        mmm=[delx,dely,delz];mmm.sort();xx=mmm[-1]*0.1  
        
        axes.SetTotalLength(xx,xx,xx)
        #axes.SetNormalizedShaftLength(1.0, 1.0, 1.0)
        #axes.SetNormalizedTipLength(0.1, 0.1, 0.1)

        xAxisLabel = axes.GetXAxisCaptionActor2D()
        xAxisLabel.GetTextActor().SetTextScaleModeToNone()
        xAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        yAxisLabel = axes.GetYAxisCaptionActor2D()
        yAxisLabel.GetTextActor().SetTextScaleModeToNone()
        yAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        zAxisLabel = axes.GetZAxisCaptionActor2D()
        zAxisLabel.GetTextActor().SetTextScaleModeToNone()
        zAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)
        
        renderer.AddActor(axes)
                    
        renderer.SetBackground(self.rr,self.gg,self.bb)        
        camera=vtk.vtkCamera()
        camera.SetPosition(viewposition[0],viewposition[1],viewposition[2])
        renderer.SetActiveCamera(camera)
        renderer.ResetCamera()
      
        return renderer              
    #---------------------------------------------------------------------------------------
    def showPoint(self,xc,yc,zc):
    
        GEN=generalClass(self.caseDir)
        patches=GEN.getBCName()
        files=[]
        
        for ii in patches:files.append(self.caseDir+'/VTK/'+ii+'/'+ii+'_0.vtk')

        renderer=vtkRenderer()
        
        readers=[];mappers=[];actors=[]
        for i in range(len(files)): 
            readers.append(vtkPolyDataReader())
            readers[i].SetFileName(files[i])
            readers[i].Update()

            mappers.append(vtkDataSetMapper())
            mappers[i].SetInputConnection(readers[i].GetOutputPort())
 
            actors.append(vtkActor())
            actors[i].SetMapper(mappers[i])
            
            actors[i].GetProperty().SetRepresentationToWireframe()
 
            renderer.AddActor(actors[i])

        # axes
        axes = vtk.vtkAxesActor()
        
        GEN=generalClass(self.caseDir);minmax=GEN.getDomainRange()
        delx=float(minmax[1][0])-float(minmax[0][0])
        dely=float(minmax[1][1])-float(minmax[0][1])
        delz=float(minmax[1][2])-float(minmax[0][2])
        mmm=[delx,dely,delz];mmm.sort();xx=mmm[-1]*0.1  
        
        axes.SetTotalLength(xx,xx,xx)
        #axes.SetNormalizedShaftLength(1.0, 1.0, 1.0)
        #axes.SetNormalizedTipLength(0.2, 0.2, 0.2)
        
        xAxisLabel = axes.GetXAxisCaptionActor2D()
        xAxisLabel.GetTextActor().SetTextScaleModeToNone()
        xAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        yAxisLabel = axes.GetYAxisCaptionActor2D()
        yAxisLabel.GetTextActor().SetTextScaleModeToNone()
        yAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        zAxisLabel = axes.GetZAxisCaptionActor2D()
        zAxisLabel.GetTextActor().SetTextScaleModeToNone()
        zAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)
        
        renderer.AddActor(axes)
        # cone
        cone = vtk.vtkConeSource()
        cone.SetResolution(60)
        cone.SetCenter(float(xc),float(yc),float(zc))
        cone.SetHeight(xx*0.5)
        cone.SetRadius(xx/4.0)
        #cone.SetDirection(1,1,1)
        cone.SetCenter(float(xc)-cone.GetHeight()/2.0,float(yc),float(zc))
 
        coneMapper = vtk.vtkPolyDataMapper()
        coneMapper.SetInput(cone.GetOutput())

        # actor
        coneActor = vtk.vtkActor()
        coneActor.SetMapper(coneMapper)

        color=(1,0,0)
        coneActor.GetProperty().SetColor(color)

        renderer.AddActor(coneActor)
        #-------------------------------                            
        renderer.SetBackground(self.rr,self.gg,self.bb)        
        camera=vtk.vtkCamera()
        viewposition=[1,1,1]
        camera.SetPosition(viewposition[0],viewposition[1],viewposition[2])
        renderer.SetActiveCamera(camera)
        renderer.ResetCamera()

        return renderer  
    #---------------------------------------------------------------------------------------
    def showSTL(self,stlfile,viewposition,displayOpt):
    
        reader=vtk.vtkSTLReader()
        reader.SetFileName(stlfile)
        
        mapper=vtk.vtkPolyDataMapper()
    
        if vtk.VTK_MAJOR_VERSION <= 5:
            mapper.SetInput(reader.GetOutput())
        else:
            mapper.SetInputConnection(reader.GetOutputPort())
            
        actor=vtk.vtkActor()
        actor.SetMapper(mapper)

        prop=vtk.vtkProperty();prop.SetColor(0,0,1)             

        if displayOpt=='surfaceEdge':prop.EdgeVisibilityOn()
                        
        actor.SetProperty(prop)
        
        if displayOpt=='wireframe':actor.GetProperty().SetRepresentationToWireframe()        
        
        renderer=vtkRenderer()
        renderer.AddActor(actor)

        axes = vtk.vtkAxesActor()
        
        GEN=generalClass(self.caseDir);minmax=GEN.getSTLRange(stlfile)
        delx=float(minmax[1][0])-float(minmax[0][0])
        dely=float(minmax[1][1])-float(minmax[0][1])
        delz=float(minmax[1][2])-float(minmax[0][2])
        mmm=[delx,dely,delz];mmm.sort();xx=mmm[-1]*0.1  
        
        axes.SetTotalLength(xx,xx,xx)
                      
        #axes.SetNormalizedShaftLength(1.0, 1.0, 1.0)
        #axes.SetNormalizedTipLength(0.2, 0.2, 0.2)
        
        xAxisLabel = axes.GetXAxisCaptionActor2D()
        xAxisLabel.GetTextActor().SetTextScaleModeToNone()
        xAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        yAxisLabel = axes.GetYAxisCaptionActor2D()
        yAxisLabel.GetTextActor().SetTextScaleModeToNone()
        yAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        zAxisLabel = axes.GetZAxisCaptionActor2D()
        zAxisLabel.GetTextActor().SetTextScaleModeToNone()
        zAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)
        
        renderer.AddActor(axes)
        
        renderer.SetBackground(self.rr,self.gg,self.bb)
        camera=vtk.vtkCamera()
        camera.SetPosition(viewposition[0],viewposition[1],viewposition[2])
        renderer.SetActiveCamera(camera)
        renderer.ResetCamera()
      
        return renderer         
    #---------------------------------------------------------------------------------------
    def showSTLMulti(self,stlfiles,viewposition,displayOpt):

        readers=[];mappers=[];actors=[];props=[]
        renderer=vtkRenderer()
        for i in range(len(stlfiles)):
            readers.append(vtk.vtkSTLReader())
            readers[i].SetFileName(self.caseDir+'/system/settings/'+stlfiles[i]+'.stl')
            readers[i].Update()
            
            mappers.append(vtk.vtkPolyDataMapper())
        
            if vtk.VTK_MAJOR_VERSION <= 5:
                mappers[i].SetInput(readers[i].GetOutput())
            else:
                mappers[i].SetInputConnection(readers[i].GetOutputPort())
                
            actors.append(vtk.vtkActor())
            actors[i].SetMapper(mappers[i])
            
            props.append(vtk.vtkProperty())
            aa=divmod(i,6);res=aa[1]
            if res==0:props[i].SetColor(0,0,1)
            elif res==1:props[i].SetColor(0,1,0)
            elif res==2:props[i].SetColor(1,0,0)
            elif res==3:props[i].SetColor(1,1,0)
            elif res==4:props[i].SetColor(0,1,1)
            elif res==5:props[i].SetColor(1,0,1)
            
            if displayOpt=='surfaceEdge':props[i].EdgeVisibilityOn()
            
            actors[i].SetProperty(props[i])
            
            if displayOpt=='wireframe':actors[i].GetProperty().SetRepresentationToWireframe()        
                    
            renderer.AddActor(actors[i])

        axes = vtk.vtkAxesActor()

        GEN=generalClass(self.caseDir)
        
        xmins=[];ymins=[];zmins=[];xmaxs=[];ymaxs=[];zmaxs=[]
        for ii in stlfiles:
            aa=GEN.getSTLRange(self.caseDir+'/system/settings/'+ii+'.stl')
            xmins.append(float(aa[0][0]));ymins.append(float(aa[0][1]));zmins.append(float(aa[0][2]))
            xmaxs.append(float(aa[1][0]));ymaxs.append(float(aa[1][1]));zmaxs.append(float(aa[1][2]))
            
        mins=[str(min(xmins)),str(min(ymins)),str(min(zmins))]
        maxs=[str(max(xmaxs)),str(max(ymaxs)),str(max(zmaxs))]
        
        minmax=[mins,maxs]            
        
        #minmax=GEN.getSTLRange()
        delx=float(minmax[1][0])-float(minmax[0][0])
        dely=float(minmax[1][1])-float(minmax[0][1])
        delz=float(minmax[1][2])-float(minmax[0][2])
        mmm=[delx,dely,delz];mmm.sort();xx=mmm[-1]*0.1  
        
        axes.SetTotalLength(xx,xx,xx)

        #axes.SetNormalizedShaftLength(1.0, 1.0, 1.0)
        #axes.SetNormalizedTipLength(0.2, 0.2, 0.2)        
        
        xAxisLabel = axes.GetXAxisCaptionActor2D()
        xAxisLabel.GetTextActor().SetTextScaleModeToNone()
        xAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        yAxisLabel = axes.GetYAxisCaptionActor2D()
        yAxisLabel.GetTextActor().SetTextScaleModeToNone()
        yAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        zAxisLabel = axes.GetZAxisCaptionActor2D()
        zAxisLabel.GetTextActor().SetTextScaleModeToNone()
        zAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)
            
        renderer.AddActor(axes)
            
        renderer.SetBackground(self.rr,self.gg,self.bb)
        camera=vtk.vtkCamera()
        camera.SetPosition(viewposition[0],viewposition[1],viewposition[2])
        renderer.SetActiveCamera(camera)
        renderer.ResetCamera()
          
        return renderer  
    #---------------------------------------------------------------------------------------
    def showHexaSphere(self,cx,cy,cz,lx,ly,lz,radius,objecttype,viewposition,stlfile):
        
        minx=float(cx)-float(lx)*0.5;maxx=float(cx)+float(lx)*0.5;miny=float(cy)-float(ly)*0.5
        maxy=float(cy)+float(ly)*0.5;minz=float(cz)-float(lz)*0.5;maxz=float(cz)+float(lz)*0.5
            
        actor=vtk.vtkActor()
        actor.GetProperty().SetRepresentationToWireframe()        
        renderer=vtk.vtkRenderer()
            
        if objecttype=='box':        
            numberOfVertices = 8         
            points = vtk.vtkPoints()
            points.InsertNextPoint(minx, miny, minz);points.InsertNextPoint(maxx, miny, minz);points.InsertNextPoint(maxx, maxy, minz);points.InsertNextPoint(minx, maxy, minz)
            points.InsertNextPoint(minx, miny, maxz);points.InsertNextPoint(maxx, miny, maxz);points.InsertNextPoint(maxx, maxy, maxz);points.InsertNextPoint(minx, maxy, maxz)

            hex_ = vtk.vtkHexahedron()
            for i in range(0, numberOfVertices):hex_.GetPointIds().SetId(i, i)
         
            uGrid = vtk.vtkUnstructuredGrid();uGrid.SetPoints(points)
            uGrid.InsertNextCell(hex_.GetCellType(), hex_.GetPointIds())
            
            mapper=vtk.vtkDataSetMapper()
            mapper.SetInput(uGrid)
            
        else:
            source = vtk.vtkSphereSource()
            source.SetCenter(float(cx),float(cy),float(cz));source.SetRadius(float(radius))
            mapper = vtk.vtkPolyDataMapper()
            mapper.SetInput(source.GetOutput())
            
        actor.SetMapper(mapper)
        renderer.AddActor(actor)
        #--------------------------
        reader=vtk.vtkSTLReader()
        reader.SetFileName(stlfile)
        
        stlmapper=vtk.vtkPolyDataMapper()
    
        if vtk.VTK_MAJOR_VERSION <= 5:
            stlmapper.SetInput(reader.GetOutput())
        else:
            stlmapper.SetInputConnection(reader.GetOutputPort())
            
        stlactor=vtk.vtkActor()
        stlactor.SetMapper(stlmapper)        
        stlprop=vtk.vtkProperty();stlprop.SetColor(0,0,1)           
        stlactor.SetProperty(stlprop)
        renderer.AddActor(stlactor)

        axes = vtk.vtkAxesActor()        
        GEN=generalClass(self.caseDir);minmax=GEN.getSTLRange(stlfile)
        delx=float(minmax[1][0])-float(minmax[0][0])
        dely=float(minmax[1][1])-float(minmax[0][1])
        delz=float(minmax[1][2])-float(minmax[0][2])
        mmm=[delx,dely,delz];mmm.sort();xx=mmm[-1]*0.1          

        axes.SetTotalLength(xx,xx,xx)                      
        #axes.SetNormalizedShaftLength(1.0, 1.0, 1.0)
        #axes.SetNormalizedTipLength(0.2, 0.2, 0.2)
        
        xAxisLabel = axes.GetXAxisCaptionActor2D()
        xAxisLabel.GetTextActor().SetTextScaleModeToNone()
        xAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        yAxisLabel = axes.GetYAxisCaptionActor2D()
        yAxisLabel.GetTextActor().SetTextScaleModeToNone()
        yAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        zAxisLabel = axes.GetZAxisCaptionActor2D()
        zAxisLabel.GetTextActor().SetTextScaleModeToNone()
        zAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)
        
        renderer.AddActor(axes)    
        
        renderer.SetBackground(self.rr,self.gg,self.bb)
        camera=vtk.vtkCamera()
        camera.SetPosition(viewposition[0],viewposition[1],viewposition[2])
        renderer.SetActiveCamera(camera)
        renderer.ResetCamera()        
        
        return renderer
    #---------------------------------------------------------------------------------------
    def showSetFieldRegion(self,minx,miny,minz,maxx,maxy,maxz,viewposition,patchName,minmax):
            
        actor=vtk.vtkActor()
        actor.GetProperty().SetRepresentationToWireframe()        
        renderer=vtk.vtkRenderer()
            
        numberOfVertices = 8         
        points = vtk.vtkPoints()
        points.InsertNextPoint(float(minx),float(miny),float(minz));points.InsertNextPoint(float(maxx),float(miny),float(minz))
        points.InsertNextPoint(float(maxx),float(maxy),float(minz));points.InsertNextPoint(float(minx),float(maxy),float(minz))
        points.InsertNextPoint(float(minx),float(miny),float(maxz));points.InsertNextPoint(float(maxx),float(miny),float(maxz))
        points.InsertNextPoint(float(maxx),float(maxy),float(maxz));points.InsertNextPoint(float(minx),float(maxy),float(maxz))

        hex_ = vtk.vtkHexahedron()
        for i in range(0, numberOfVertices):hex_.GetPointIds().SetId(i, i)
         
        uGrid = vtk.vtkUnstructuredGrid();uGrid.SetPoints(points)
        uGrid.InsertNextCell(hex_.GetCellType(), hex_.GetPointIds())
            
        mapper=vtk.vtkDataSetMapper()
        mapper.SetInput(uGrid)
            
        actor.SetMapper(mapper)
        renderer.AddActor(actor)
        #--------------------------        
        onOff=[]
        for ii in patchName:onOff.append(1)
        onOff.append(0)
            
        files=[]
        for i in range(len(patchName)):
            if onOff[i]==1:
                files.append(self.caseDir+'/VTK/'+patchName[i]+'/'+patchName[i]+'_0.vtk')

        readers=[];mappers=[];actors=[];props=[]
        for i in range(len(files)): 
            readers.append(vtkPolyDataReader())
            readers[i].SetFileName(files[i])
            readers[i].Update()

            mappers.append(vtkDataSetMapper())
            mappers[i].SetInputConnection(readers[i].GetOutputPort())
 
            actors.append(vtkActor())
            actors[i].SetMapper(mappers[i])
            
            #actors[i].GetProperty().SetRepresentationToWireframe()
            props.append(vtk.vtkProperty())
            aa=divmod(i,6);res=aa[1]
            if res==0:props[i].SetColor(0,0,1)
            elif res==1:props[i].SetColor(0,1,0)
            elif res==2:props[i].SetColor(1,0,0)
            elif res==3:props[i].SetColor(1,1,0)
            elif res==4:props[i].SetColor(0,1,1)
            elif res==5:props[i].SetColor(1,0,1)
            
            props[i].EdgeVisibilityOn()
            
            actors[i].SetProperty(props[i])            
 
            renderer.AddActor(actors[i])

        axes = vtk.vtkAxesActor()
        
        delx=float(minmax[1][0])-float(minmax[0][0])
        dely=float(minmax[1][1])-float(minmax[0][1])
        delz=float(minmax[1][2])-float(minmax[0][2])
        mmm=[delx,dely,delz];mmm.sort();xx=mmm[-1]*0.05  
        
        axes.SetTotalLength(xx,xx,xx)
        #axes.SetNormalizedShaftLength(1.0, 1.0, 1.0)
        #axes.SetNormalizedTipLength(0.1, 0.1, 0.1)

        xAxisLabel = axes.GetXAxisCaptionActor2D()
        xAxisLabel.GetTextActor().SetTextScaleModeToNone()
        xAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        yAxisLabel = axes.GetYAxisCaptionActor2D()
        yAxisLabel.GetTextActor().SetTextScaleModeToNone()
        yAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        zAxisLabel = axes.GetZAxisCaptionActor2D()
        zAxisLabel.GetTextActor().SetTextScaleModeToNone()
        zAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)
        
        renderer.AddActor(axes)
                    
        renderer.SetBackground(self.rr,self.gg,self.bb)        
        camera=vtk.vtkCamera()
        camera.SetPosition(viewposition[0],viewposition[1],viewposition[2])
        renderer.SetActiveCamera(camera)
        renderer.ResetCamera()      
        
        return renderer           
    #---------------------------------------------------------------------------------------
    def showCuttingPlane(self,p0,p1,p2,p3):
            
        actor=vtk.vtkActor()
        actor.GetProperty().SetRepresentationToSurface()
        prop=vtk.vtkProperty()
        prop.SetColor(1,0,0)
        actor.SetProperty(prop)  
        renderer=vtk.vtkRenderer()
        
        points = vtk.vtkPoints()
        points.InsertNextPoint(p0)
        points.InsertNextPoint(p1)
        points.InsertNextPoint(p2)
        points.InsertNextPoint(p3)
 
        quad = vtk.vtkQuad()
        quad.GetPointIds().SetId(0,0)
        quad.GetPointIds().SetId(1,1)
        quad.GetPointIds().SetId(2,2)
        quad.GetPointIds().SetId(3,3)
         
        quads = vtk.vtkCellArray()
        quads.InsertNextCell(quad)
         
        polydata = vtk.vtkPolyData()
         
        polydata.SetPoints(points)
        polydata.SetPolys(quads)
            
        mapper=vtk.vtkPolyDataMapper()
        mapper.SetInput(polydata)
            
        actor.SetMapper(mapper)
        renderer.AddActor(actor)
        #--------------------------  
        GEN=generalClass(self.caseDir)
        patchName=GEN.getBCName();minmax=GEN.getDomainRange()
                  
        onOff=[]
        for ii in patchName:onOff.append(1)
        onOff.append(0)
            
        files=[]
        for i in range(len(patchName)):
            if onOff[i]==1:
                files.append(self.caseDir+'/VTK/'+patchName[i]+'/'+patchName[i]+'_0.vtk')

        readers=[];mappers=[];actors=[];props=[]
        for i in range(len(files)): 
            readers.append(vtkPolyDataReader())
            readers[i].SetFileName(files[i])
            readers[i].Update()

            mappers.append(vtkDataSetMapper())
            mappers[i].SetInputConnection(readers[i].GetOutputPort())
 
            actors.append(vtkActor())
            actors[i].SetMapper(mappers[i])
            
            #actors[i].GetProperty().SetRepresentationToWireframe()
            props.append(vtk.vtkProperty())
 
            renderer.AddActor(actors[i])

        axes = vtk.vtkAxesActor()
        
        delx=float(minmax[1][0])-float(minmax[0][0])
        dely=float(minmax[1][1])-float(minmax[0][1])
        delz=float(minmax[1][2])-float(minmax[0][2])
        mmm=[delx,dely,delz];mmm.sort();xx=mmm[-1]*0.05  
        
        axes.SetTotalLength(xx,xx,xx)
        #axes.SetNormalizedShaftLength(1.0, 1.0, 1.0)
        #axes.SetNormalizedTipLength(0.1, 0.1, 0.1)

        xAxisLabel = axes.GetXAxisCaptionActor2D()
        xAxisLabel.GetTextActor().SetTextScaleModeToNone()
        xAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        yAxisLabel = axes.GetYAxisCaptionActor2D()
        yAxisLabel.GetTextActor().SetTextScaleModeToNone()
        yAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        zAxisLabel = axes.GetZAxisCaptionActor2D()
        zAxisLabel.GetTextActor().SetTextScaleModeToNone()
        zAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)
        
        renderer.AddActor(axes)
                    
        renderer.SetBackground(self.rr,self.gg,self.bb)        
        camera=vtk.vtkCamera()
        camera.SetPosition(1,1,1)
        renderer.SetActiveCamera(camera)
        renderer.ResetCamera()      
        
        return renderer
    #---------------------------------------------------------------------------------------
    def cutPlane(self,setNormallist,setOriginlist,fieldName,caseType,stime,viewposition):

        fileName = self.caseDir+"/ "

        reader=vtk.vtkPOpenFOAMReader()
        reader.SetFileName(fileName)
        reader.SetCaseType(caseType)
        reader.CreateCellToPointOn()
        reader.SetCreateCellToPoint(1)
        reader.DecomposePolyhedraOn()
        reader.EnableAllPatchArrays()
        reader.ReadZonesOn()
        reader.SetPatchArrayStatus('internalMesh',1)
        reader.Update()

        reader.UpdateInformation()
        exe = reader.GetExecutive()
        outInfo = exe.GetOutputInformation(0)
        timeStepsKey = vtk.vtkStreamingDemandDrivenPipeline.TIME_STEPS()
        nTimeSteps = outInfo.Length(timeStepsKey)
        
        if stime=='latestTime':
            timedata=[]
            for stepI in range(nTimeSteps):
                timeValue = outInfo.Get(timeStepsKey, stepI)
                timedata.append(timeValue)  
            plottime=timedata[-1]
        else:
            plottime=float(stime)
        exe.SetUpdateTimeStep(0, plottime)
        reader.Modified()
        reader.Update()
        
        readergetblock=reader.GetOutput().GetBlock(0)

        compositeFilter=vtk.vtkCompositeDataGeometryFilter() 
        compositeFilter.SetInputConnection(reader.GetOutputPort()) 
        compositeFilter.Update()

        outline = vtk.vtkOutlineFilter()
        outline.SetInputConnection(compositeFilter.GetOutputPort())
        outlineMapper = vtk.vtkPolyDataMapper()
        outlineMapper.SetInputConnection(outline.GetOutputPort())

        outlineActor = vtk.vtkActor();outlineActor.SetMapper(outlineMapper);outlineActor.GetProperty().SetColor(0, 0, 0)

        axes = vtk.vtkAxesActor()
        xAxisLabel = axes.GetXAxisCaptionActor2D();xAxisLabel.GetTextActor().SetTextScaleModeToNone();xAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        yAxisLabel = axes.GetYAxisCaptionActor2D();yAxisLabel.GetTextActor().SetTextScaleModeToNone();yAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        zAxisLabel = axes.GetZAxisCaptionActor2D();zAxisLabel.GetTextActor().SetTextScaleModeToNone();zAxisLabel.GetCaptionTextProperty().SetColor(0,1,0) 

        renderer = vtkRenderer()        
        renderer.AddActor(axes);
        renderer.AddActor(outlineActor)
        renderer.SetBackground(1,1,1)
               
        planelist=[];cutterlist=[];mapperlist=[];actorlist=[];rangelist=[]
        for i in range(len(setNormallist)):
            planelist.append(vtk.vtkPlane())
            planelist[i].SetOrigin(float(setOriginlist[i][0]),float(setOriginlist[i][1]),float(setOriginlist[i][2]))
            planelist[i].SetNormal(float(setNormallist[i][0]),float(setNormallist[i][1]),float(setNormallist[i][2]))

            cutterlist.append(vtk.vtkCutter())
            cutterlist[i].SetCutFunction(planelist[i])
            cutterlist[i].SetInput(readergetblock)
            cutterlist[i].Update()
            
            rangelist.append(cutterlist[i].GetOutput().GetCellData().GetArray(fieldName).GetRange())
       
        mins=[];maxs=[]    
        for ii in rangelist:
            mins.append(ii[0]);maxs.append(ii[1])
        drange=[min(mins),max(maxs)]
        
        colorFunction = vtk.vtkColorTransferFunction()
        colorFunction.SetColorSpaceToHSV();colorFunction.HSVWrapOff()
        colorFunction.AddRGBPoint(drange[0], 0.0, 0.0, 1.0);colorFunction.AddRGBPoint(drange[1], 1.0, 0.0, 0.0)

        scalar_bar = vtk.vtkScalarBarActor();scalar_bar.SetTitle(fieldName)
        scalar_bar.SetOrientationToVertical();scalar_bar.SetLookupTable(colorFunction)
        scalar_bar.SetPosition( 0.85, 0.7 );scalar_bar.SetPosition2( 0.1, 0.3 )        
        tprop = vtk.vtkTextProperty();tprop.SetColor(0,0,0);tprop.ShadowOff()
        scalar_bar.SetLabelTextProperty(tprop)        
        tprop1 = vtk.vtkTextProperty();tprop1.SetColor(0,0,0);tprop1.SetItalic(1);tprop1.SetBold(1)
        scalar_bar.SetTitleTextProperty(tprop1)
        
        renderer.AddActor(scalar_bar)
                    
        for i in range(len(setNormallist)):
            mapperlist.append(vtk.vtkPolyDataMapper())
            mapperlist[i].SetInputConnection(cutterlist[i].GetOutputPort())
            mapperlist[i].SetLookupTable(colorFunction)
            mapperlist[i].SetScalarModeToUsePointFieldData() # point value
            #mapperlist[i].SetScalarModeToUseCellFieldData() # cell value
            mapperlist[i].SelectColorArray(fieldName)
            mapperlist[i].SetScalarRange(drange)
        
            actorlist.append(vtk.vtkActor())
            actorlist[i].SetMapper(mapperlist[i])
 
            renderer.AddActor(actorlist[i])
        
        camera=vtk.vtkCamera()
        camera.SetPosition(viewposition[0],viewposition[1],viewposition[2])
        renderer.SetActiveCamera(camera);renderer.ResetCamera()

        return renderer  
    #---------------------------------------------------------------------------------------
    def cutPlane_global_range(self,setNormallist,setOriginlist,fieldName,caseType,stime,viewposition):

        fileName = self.caseDir+"/ "

        reader=vtk.vtkPOpenFOAMReader()
        reader.SetFileName(fileName)
        reader.SetCaseType(caseType)
        reader.CreateCellToPointOn()
        reader.SetCreateCellToPoint(1)
        reader.DecomposePolyhedraOn()
        reader.EnableAllPatchArrays()
        #reader.ReadZonesOn()
        reader.SetPatchArrayStatus('internalMesh',1)
        reader.Update()

        reader.UpdateInformation()
        exe = reader.GetExecutive()
        outInfo = exe.GetOutputInformation(0)
        timeStepsKey = vtk.vtkStreamingDemandDrivenPipeline.TIME_STEPS()
        nTimeSteps = outInfo.Length(timeStepsKey)
        
        if stime=='latestTime':
            timedata=[]
            for stepI in range(nTimeSteps):
                timeValue = outInfo.Get(timeStepsKey, stepI)
                timedata.append(timeValue)  
            plottime=timedata[-1]
        else:
            plottime=float(stime)
        exe.SetUpdateTimeStep(0, plottime)
        reader.Modified()
        reader.Update()
        
        readergetblock=reader.GetOutput().GetBlock(0)

        compositeFilter=vtk.vtkCompositeDataGeometryFilter() 
        compositeFilter.SetInputConnection(reader.GetOutputPort()) 
        compositeFilter.Update()

        outline = vtk.vtkOutlineFilter()
        outline.SetInputConnection(compositeFilter.GetOutputPort())
        outlineMapper = vtk.vtkPolyDataMapper()
        outlineMapper.SetInputConnection(outline.GetOutputPort())

        outlineActor = vtk.vtkActor();outlineActor.SetMapper(outlineMapper);outlineActor.GetProperty().SetColor(0, 0, 0)

        drange = readergetblock.GetCellData().GetArray(fieldName).GetRange()
        
        colorFunction = vtk.vtkColorTransferFunction()
        colorFunction.SetColorSpaceToHSV();colorFunction.HSVWrapOff()
        colorFunction.AddRGBPoint(drange[0], 0.0, 0.0, 1.0);colorFunction.AddRGBPoint(drange[1], 1.0, 0.0, 0.0)

        axes = vtk.vtkAxesActor()
        xAxisLabel = axes.GetXAxisCaptionActor2D();xAxisLabel.GetTextActor().SetTextScaleModeToNone();xAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        yAxisLabel = axes.GetYAxisCaptionActor2D();yAxisLabel.GetTextActor().SetTextScaleModeToNone();yAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        zAxisLabel = axes.GetZAxisCaptionActor2D();zAxisLabel.GetTextActor().SetTextScaleModeToNone();zAxisLabel.GetCaptionTextProperty().SetColor(0,1,0) 

        scalar_bar = vtk.vtkScalarBarActor();scalar_bar.SetTitle(fieldName)
        scalar_bar.SetOrientationToVertical();scalar_bar.SetLookupTable(colorFunction)
        scalar_bar.SetPosition( 0.85, 0.7 );scalar_bar.SetPosition2( 0.1, 0.3 )        
        tprop = vtk.vtkTextProperty();tprop.SetColor(0,0,0);tprop.ShadowOff()
        scalar_bar.SetLabelTextProperty(tprop)        
        tprop1 = vtk.vtkTextProperty();tprop1.SetColor(0,0,0);tprop1.SetItalic(1);tprop1.SetBold(1)
        scalar_bar.SetTitleTextProperty(tprop1)

        renderer = vtkRenderer()        
        renderer.AddActor(scalar_bar)
        renderer.AddActor(axes);
        renderer.AddActor(outlineActor)
        renderer.SetBackground(1,1,1)
                
        planelist=[];cutterlist=[];mapperlist=[];actorlist=[]
        for i in range(len(setNormallist)):
            planelist.append(vtk.vtkPlane())
            planelist[i].SetOrigin(float(setOriginlist[i][0]),float(setOriginlist[i][1]),float(setOriginlist[i][2]))
            planelist[i].SetNormal(float(setNormallist[i][0]),float(setNormallist[i][1]),float(setNormallist[i][2]))

            cutterlist.append(vtk.vtkCutter())
            cutterlist[i].SetCutFunction(planelist[i])
            cutterlist[i].SetInput(readergetblock)
            cutterlist[i].Update()

            mapperlist.append(vtk.vtkPolyDataMapper())
            mapperlist[i].SetInputConnection(cutterlist[i].GetOutputPort())
            mapperlist[i].SetLookupTable(colorFunction)
            mapperlist[i].SetScalarModeToUsePointFieldData() # point value
            #mapperlist[i].SetScalarModeToUseCellFieldData() # cell value
            mapperlist[i].SelectColorArray(fieldName)
            mapperlist[i].SetScalarRange(drange)
        
            actorlist.append(vtk.vtkActor())
            actorlist[i].SetMapper(mapperlist[i])
 
            renderer.AddActor(actorlist[i])
        
        camera=vtk.vtkCamera()
        camera.SetPosition(viewposition[0],viewposition[1],viewposition[2])
        renderer.SetActiveCamera(camera);renderer.ResetCamera()

        return renderer         
    #---------------------------------------------------------------------------------------
    def patchField(self,patchzone,onOff,fieldName,stime,caseType,viewposition,displayOpt):
       
        patchzone.append('internalMesh');onOff.append(0)

        fileName = self.caseDir+"/ "

        reader=vtk.vtkPOpenFOAMReader()
        reader.SetFileName(fileName)
        reader.SetCaseType(caseType)
        reader.CreateCellToPointOn()
        reader.SetCreateCellToPoint(1)
        reader.DecomposePolyhedraOn()
        reader.EnableAllPatchArrays()
        #reader.ReadZonesOn()
        #reader.SetPatchArrayStatus('internalMesh',0)
        reader.Update()

        reader.UpdateInformation()
        exe = reader.GetExecutive()
        outInfo = exe.GetOutputInformation(0)
        timeStepsKey = vtk.vtkStreamingDemandDrivenPipeline.TIME_STEPS()
        nTimeSteps = outInfo.Length(timeStepsKey)      

        if stime=='latestTime':
            timedata=[]
            for stepI in range(nTimeSteps):
                timeValue = outInfo.Get(timeStepsKey, stepI)
                timedata.append(timeValue)  
            plottime=timedata[-1]
        else:
            plottime=float(stime)
        exe.SetUpdateTimeStep(0, plottime)
        reader.Modified()
        
        for i in range(len(patchzone)):reader.SetPatchArrayStatus(patchzone[i],onOff[i])
        reader.Update()

        compositeFilter=vtk.vtkCompositeDataGeometryFilter() 
        compositeFilter.SetInputConnection(reader.GetOutputPort()) 
        compositeFilter.Update()

        drange = compositeFilter.GetOutput().GetCellData().GetArray(fieldName).GetRange()
	        
        colorFunction = vtk.vtkColorTransferFunction()
        colorFunction.SetColorSpaceToHSV();colorFunction.HSVWrapOff()
        colorFunction.AddRGBPoint(drange[0], 0.0, 0.0, 1.0);colorFunction.AddRGBPoint(drange[1], 1.0, 0.0, 0.0)

        mapper=vtk.vtkPolyDataMapper() 
        mapper.SetInputConnection(compositeFilter.GetOutputPort());mapper.SetLookupTable(colorFunction)
        mapper.SetScalarModeToUsePointFieldData();mapper.SelectColorArray(fieldName)        
        mapper.SetScalarRange(drange)

        axes = vtk.vtkAxesActor()
        xAxisLabel = axes.GetXAxisCaptionActor2D();xAxisLabel.GetTextActor().SetTextScaleModeToNone();xAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        yAxisLabel = axes.GetYAxisCaptionActor2D();yAxisLabel.GetTextActor().SetTextScaleModeToNone();yAxisLabel.GetCaptionTextProperty().SetColor(0,1,0)        
        zAxisLabel = axes.GetZAxisCaptionActor2D();zAxisLabel.GetTextActor().SetTextScaleModeToNone();zAxisLabel.GetCaptionTextProperty().SetColor(0,1,0) 

        scalar_bar = vtk.vtkScalarBarActor();scalar_bar.SetTitle(fieldName)
        scalar_bar.SetOrientationToVertical();scalar_bar.SetLookupTable(colorFunction)
        scalar_bar.SetPosition( 0.85, 0.7 );scalar_bar.SetPosition2( 0.1, 0.3 )        
        tprop = vtk.vtkTextProperty();tprop.SetColor(0,0,0);tprop.ShadowOff()
        scalar_bar.SetLabelTextProperty(tprop)        
        tprop1 = vtk.vtkTextProperty();tprop1.SetColor(0,0,0);tprop1.SetItalic(1);tprop1.SetBold(1)
        scalar_bar.SetTitleTextProperty(tprop1)

        actor=vtk.vtkActor();actor.SetMapper(mapper)
        
        renderer = vtkRenderer()        
        renderer.AddActor(scalar_bar)
        renderer.AddActor(axes)
        renderer.AddActor(actor)
        renderer.SetBackground(1,1,1)

        camera=vtk.vtkCamera()
        camera.SetPosition(viewposition[0],viewposition[1],viewposition[2])
        renderer.SetActiveCamera(camera);renderer.ResetCamera()

        return renderer           
