#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for boundary condition setup
#
# Author
#    NEXTFOAM Inc.
##############################################################################

import os,math,glob,sys;import pygtk;pygtk.require('2.0');import gtk

from generalSub import *
from VTKStuffClass import *

class boundaryConditionClass:

    def delete_event(self,widget,event,data=None):
        aa=glob.glob(self.caseDir+'/system/settings/openSubWindow')
        for ii in aa:os.system('rm '+ii)

    def destroy(self,widget,data=None):
        self.covWin.destroy()

    def __init__(self,caseDir,solver,installpath,rr,gg,bb):
        self.caseDir=caseDir
        self.solver=solver
        self.installpath=installpath
        self.rr=rr;self.gg=gg;self.bb=bb
        self.turmodel='standardKEpsilon'
    #-----------------------------------------------------------------------------------------------------------------
    def openBCWindow(self,patchname,patchtype,gvtk,mainwindow,notebook,textbuffer,liststore_patchname):
    
        GEN=generalClass(self.caseDir) 

        def closethis(widget,data=None):
            window.destroy()
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')

        def applythis(widget,data=None):
            bdict={}
            
            oldname=patchname
            newname=bcnameEntry.get_text()
            
            bdict['name']=bcnameEntry.get_text()            
            bdict['type']=patchtype;bdict['Utype']=utypeCombo.child.get_text()
            bdict['Ux']=uxEntry.get_text();bdict['Uy']=uyEntry.get_text();bdict['Uz']=uzEntry.get_text()
            bdict['Umag']=umagEntry.get_text();bdict['volflowrate']=vflowEntry.get_text();bdict['massflowrate']=mflowEntry.get_text()
            bdict['orix']=orixEntry.get_text();bdict['oriy']=oriyEntry.get_text();bdict['oriz']=orizEntry.get_text()
            aa=eCombo.child;bdict['axis']=aa.get_text();bdict['rpm']=rpmEntry.get_text()                                  

            bdict['ptype']=ptypeCombo.child.get_text();bdict['pstatic']=pstaticEntry.get_text();bdict['ptotal']=ptotalEntry.get_text()                     

            bdict['Ttype']=ttypeCombo.child.get_text();bdict['Tvalue']=tvalueEntry.get_text();bdict['Tinout']=tinoutEntry.get_text()
            bdict['heatflux']=tfluxEntry.get_text();bdict['htcoeff']=thEntry.get_text();bdict['Tinf']=tinfEntry.get_text()

            bdict['ktype']=ktypeCombo.child.get_text();bdict['kvalue']=kvalueEntry.get_text();bdict['kinout']=kinoutEntry.get_text()
            bdict['kintensity']=kintensityEntry.get_text()

            bdict['etype']=etypeCombo.child.get_text();bdict['evalue']=evalueEntry.get_text();bdict['einout']=einoutEntry.get_text()
            bdict['elength']=elengthEntry.get_text()  

            if GEN.isNumber(bdict['Ux'])==False:GEN.makeDialog('Error!!! Ux is not number')             
            if GEN.isNumber(bdict['Uy'])==False:GEN.makeDialog('Error!!! Uy is not number')             
            if GEN.isNumber(bdict['Uz'])==False:GEN.makeDialog('Error!!! Uz is not number')             
            if GEN.isNumber(bdict['Umag'])==False:GEN.makeDialog('Error!!! Umag is not number')             
            if GEN.isNumber(bdict['volflowrate'])==False:GEN.makeDialog('Error!!! volflowrate is not number')             
            if GEN.isNumber(bdict['massflowrate'])==False:GEN.makeDialog('Error!!! massflowrate is not number')
            if GEN.isNumber(bdict['orix'])==False:GEN.makeDialog('Error!!! x-ori is not number')             
            if GEN.isNumber(bdict['oriy'])==False:GEN.makeDialog('Error!!! y-ori is not number')             
            if GEN.isNumber(bdict['oriz'])==False:GEN.makeDialog('Error!!! z-ori is not number') 
            if GEN.isNumber(bdict['rpm'])==False:GEN.makeDialog('Error!!! rpm is not number') 
            if GEN.isNumber(bdict['pstatic'])==False:GEN.makeDialog('Error!!! pstatic is not number')                         
            if GEN.isNumber(bdict['ptotal'])==False:GEN.makeDialog('Error!!! ptotal is not number')                         
            if GEN.isNumber(bdict['Tvalue'])==False:GEN.makeDialog('Error!!! Tvalue is not number')                         
            if GEN.isNumber(bdict['Tinout'])==False:GEN.makeDialog('Error!!! inlet T is not number')                        
            if GEN.isNumber(bdict['heatflux'])==False:GEN.makeDialog('Error!!! heatflux is not number')                         
            if GEN.isNumber(bdict['htcoeff'])==False:GEN.makeDialog('Error!!! htcoeff is not number')                         
            if GEN.isNumber(bdict['Tinf'])==False:GEN.makeDialog('Error!!! Tinf is not number')
            if GEN.isNumber(bdict['kvalue'])==False:GEN.makeDialog('Error!!! k is not number')                
            if GEN.isNumber(bdict['kinout'])==False:GEN.makeDialog('Error!!! inlet k is not number')                
            if GEN.isNumber(bdict['kintensity'])==False:GEN.makeDialog('Error!!! tur. intensity is not number')
            if GEN.isNumber(bdict['evalue'])==False:GEN.makeDialog('Error!!! epsilon is not number')                    
            if GEN.isNumber(bdict['einout'])==False:GEN.makeDialog('Error!!! inlet epsilon is not number')                    
            if GEN.isNumber(bdict['elength'])==False:GEN.makeDialog('Error!!! dissipation length is not number')
                                
            f=open(self.caseDir+'/system/settings/BCDict:'+bdict['name'],'w')
            keys=bdict.keys()
            for ii in keys:f.write(ii+';'+bdict[ii]+'\n')
            f.close()                        
            window.destroy()
            
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')            
            # --- change patch name ------------------    
            if oldname!=newname:
                f=open(self.caseDir+'/constant/polyMesh/boundary','r');ff=f.readlines();f.close()
                for i in range(len(ff)):
                    if ff[i].strip()==oldname:ff[i]='    '+newname+'\n'
                g=open(self.caseDir+'/constant/polyMesh/boundary','w')
                for ii in ff:g.write(ii)
                g.close()
                
                os.system('mv '+self.caseDir+'/VTK/'+oldname+' '+self.caseDir+'/VTK/'+newname)
                os.system('mv '+self.caseDir+'/VTK/'+newname+'/'+oldname+'_0.vtk '+self.caseDir+'/VTK/'+newname+'/'+newname+'_0.vtk')

                aa=glob.glob(self.caseDir+'/system/settings/BCDict:'+oldname)
                if aa!=[]:
                    for ii in aa:os.system('rm '+ii)            
            #--- refresh boundary panel -------------------------
            bcnameList=GEN.getBCName();bctypeList=GEN.getBCType()
            liststore_patchname.clear()
            for i in range(len(bcnameList)): 
                liststore_patchname.append([bcnameList[i],bctypeList[i]])
            #--- text window message ------------------------------------------------        
            string='\n\n [  Boundary condition for "'+bdict['name']+'" is set  ]\n'
            if bdict['Utype']=='fixed-U':
                string=string+'\n    - U type is '+bdict['Utype']+' : ('+bdict['Ux']+' '+bdict['Uy']+' '+bdict['Uz']+')\n'
            elif bdict['Utype']=='surfaceNormal-U':
                string=string+'\n    - U type is '+bdict['Utype']+' : '+bdict['Umag']+'\n'
            elif bdict['Utype']=='volume-flowrate':
                string=string+'\n    - U type is '+bdict['Utype']+' : '+bdict['volflowrate']+'\n'
            elif bdict['Utype']=='mass-flowrate':
                string=string+'\n    - U type is '+bdict['Utype']+' : '+bdict['massflowrate']+'\n'
            elif bdict['Utype']=='rotatingWallVelocity':
                string=string+'\n    - U type is '+bdict['Utype']+' : origin ('+bdict['orix']+' '+bdict['oriy']+' '+bdict['oriz']+'), axis '+bdict['axis']+', rpm '+bdict['rpm']+'\n'
            else:
                string=string+'\n    - U type is '+bdict['Utype']+'\n'
                
            if bdict['ptype']=='fixedValue':
                string=string+'\n    - p type is '+bdict['ptype']+' : '+bdict['pstatic']+'\n'
            elif bdict['ptype']=='totalPressure':
                string=string+'\n    - p type is '+bdict['ptype']+' : '+bdict['ptotal']+'\n'
            else:
                string=string+'\n    - p type is '+bdict['ptype']+'\n'
                
            if self.solver=='buoyantSimpleNFoam' or self.solver=='buoyantPimpleNFoam':
                if bdict['Ttype']=='fixedValue':
                    string=string+'\n    - T type is '+bdict['Ttype']+' : '+bdict['Tvalue']+'\n'
                elif bdict['Ttype']=='heatflux':
                    string=string+'\n    - T type is '+bdict['Ttype']+' : '+bdict['heatflux']+'\n'
                elif bdict['Ttype']=='convection':
                    string=string+'\n    - T type is '+bdict['Ttype']+' : h '+bdict['htcoeff']+', Tinf '+bdict['Tinf']+'\n'
                elif bdict['Ttype']=='inletOutlet':
                    string=string+'\n    - T type is '+bdict['Ttype']+' : '+bdict['Tinout']+'\n'
                else:
                    string=string+'\n    - T type is '+bdict['Ttype']+'\n'
                
            if bdict['ktype']=='fixedValue':
                string=string+'\n    - k type is '+bdict['ktype']+' : '+bdict['kvalue']+'\n'
            elif bdict['ktype']=='inletOutlet':
                string=string+'\n    - k type is '+bdict['ktype']+' : '+bdict['kinout']+'\n'
            elif bdict['ktype']=='intensity':
                string=string+'\n    - k type is '+bdict['ktype']+' : '+bdict['kintensity']+'\n'
            else:
                string=string+'\n    - k type is '+bdict['ktype']+'\n'                   
                
            if self.turmodel=='kOmegaSST':
                if bdict['etype']=='fixedValue':
                    string=string+'\n    - omega type is '+bdict['etype']+' : '+bdict['evalue']+'\n'
                elif bdict['etype']=='inletOutlet':
                    string=string+'\n    - omega type is '+bdict['etype']+' : '+bdict['einout']+'\n'
                else:
                    string=string+'\n    - omega type is '+bdict['etype']+'\n'
            else:
                if bdict['etype']=='fixedValue':
                    string=string+'\n    - epsilon type is '+bdict['etype']+' : '+bdict['evalue']+'\n'
                elif bdict['etype']=='inletOutlet':
                    string=string+'\n    - epsilon type is '+bdict['etype']+' : '+bdict['einout']+'\n' 
                elif bdict['etype']=='mixingLength':
                    string=string+'\n    - epsilon type is '+bdict['etype']+' : '+bdict['elength']+'\n'
                else:
                    string=string+'\n    - epsilon type is '+bdict['etype']+'\n'            

            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,string)
            notebook.set_current_page(0)
            
        def setSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/BCDict:'+patchname)
            if len(aa)!=0:
                dic=GEN.makeDictFromFile(aa[0])
                utypeCombo.set_active(utypes.index(dic['Utype']))
                uxEntry.set_text(dic['Ux']);uyEntry.set_text(dic['Uy']);uzEntry.set_text(dic['Uz'])
                umagEntry.set_text(dic['Umag']);vflowEntry.set_text(dic['volflowrate']);mflowEntry.set_text(dic['massflowrate'])
                orixEntry.set_text(dic['orix']);oriyEntry.set_text(dic['oriy']);orizEntry.set_text(dic['oriz'])
                eCombo.set_active(axisList.index(dic['axis']));rpmEntry.set_text(dic['rpm']) 
                
                ptypeCombo.set_active(ptypes.index(dic['ptype']))
                pstaticEntry.set_text(dic['pstatic']);ptotalEntry.set_text(dic['ptotal'])

                ttypeCombo.set_active(ttypes.index(dic['Ttype']))
                tvalueEntry.set_text(dic['Tvalue']);tinoutEntry.set_text(dic['Tinout']);tfluxEntry.set_text(dic['heatflux'])
                thEntry.set_text(dic['htcoeff']);tinfEntry.set_text(dic['Tinf'])  

                ktypeCombo.set_active(ktypes.index(dic['ktype']));kvalueEntry.set_text(dic['kvalue'])
                kinoutEntry.set_text(dic['kinout']);kintensityEntry.set_text(dic['kintensity'])                
                
                etypeCombo.set_active(etypes.index(dic['etype']));evalueEntry.set_text(dic['evalue']);einoutEntry.set_text(dic['einout'])
                elengthEntry.set_text(dic['elength'])

        def displaymesh(widget):

            notebook.set_current_page(1)
            
            bcname=GEN.getBCName()
            onOff=[]
            for ii in bcname:
                if ii==patchname:onOff.append(1)
                else:onOff.append(0)
            viewposition=[1,1,1]            
            VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb);renderer=VTK.unsshowPatch(bcname,onOff,viewposition)
            gvtk.GetRenderWindow().AddRenderer(renderer)
            gvtk.Initialize();gvtk.Start()
            
            f=open(self.caseDir+'/system/settings/displayedPatch','w')
            for ii in onOff:f.write(str(ii)+'\n')
            f.close()
            
            f=open(self.caseDir+'/system/settings/displaymode','w')
            f.write('patch');f.close()
        # -- gui window --------------------------------------------------
        openSubWindow=GEN.subWindowOpened()
        
        if openSubWindow==False:

            window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Boundary Condition - '+patchname)
            window.set_border_width(10);window.set_position(gtk.WIN_POS_CENTER);window.set_transient_for(mainwindow)
            window.connect("delete_event", self.delete_event)
            
            mainvbox=gtk.VBox(False,5);window.add(mainvbox)

            label=gtk.Label('Name')
            bcnameEntry=gtk.Entry()
            bcnameEntry.set_text(patchname)
            hbox=gtk.HBox(False,5);mainvbox.pack_start(hbox,False,False,5)
            hbox.pack_start(label,False,False,5);hbox.pack_end(bcnameEntry,True,True,2)
            
            basicbox=gtk.VBox(True,5)     
            mainvbox.pack_start(basicbox,False,False,5)
            
            #-- velocity ---------
            def chutype(widget):
                ucondition=widget.child.get_text()
                for ii in ubox.get_children():ubox.remove(ii)
                ubox.pack_start(uhbox,False,False,5)
                if ucondition=='fixed-U':ubox.pack_start(fxubox,False,False,2)
                elif ucondition=='surfaceNormal-U':ubox.pack_start(usnbox,False,False,2)
                elif ucondition=='volume-flowrate':ubox.pack_start(uvfbox,False,False,2)
                elif ucondition=='mass-flowrate':ubox.pack_start(umfbox,False,False,2)
                elif ucondition=='rotatingWallVelocity':ubox.pack_start(rwvbox,False,False,2)
                window.resize(400,500)
                window.show_all()

            Uframe=gtk.Frame();Uframe.set_label('  Velocity  ');Uframe.set_label_align(0.1,0.5)
            Uframe.set_shadow_type(gtk.SHADOW_IN);basicbox.pack_start(Uframe,True,True,5)
            ubox=gtk.VBox(False,5);Uframe.add(ubox)

            label=gtk.Label('Type');label.set_size_request(65,28);label.set_alignment(0,0.5)
            utypeCombo=gtk.combo_box_entry_new_text();utypeCombo.set_size_request(220,28)
            utypes=['fixed-U','surfaceNormal-U','volume-flowrate','mass-flowrate','pressureInletOutletVelocity','zeroGradient','rotatingWallVelocity']
            for ii in utypes:utypeCombo.append_text(ii)                     
            uhbox=gtk.HBox(False,5);ubox.pack_start(uhbox,False,False,5)
            uhbox.pack_start(label,False,False,15);uhbox.pack_end(utypeCombo,False,False,5)
                   
            label=gtk.Label('U [m/s]')
            uxEntry=gtk.Entry();uxEntry.set_size_request(60,28);uxEntry.set_text('0')
            uyEntry=gtk.Entry();uyEntry.set_size_request(60,28);uyEntry.set_text('0')
            uzEntry=gtk.Entry();uzEntry.set_size_request(60,28);uzEntry.set_text('0')
            fxubox=gtk.HBox(False,5)
            fxubox.pack_start(label,False,False,15);fxubox.pack_end(uzEntry,False,False,5)
            fxubox.pack_end(uyEntry,False,False,0);fxubox.pack_end(uxEntry,False,False,5)

            label=gtk.Label('Velocity magnitude [m/s]')
            umagEntry=gtk.Entry();umagEntry.set_size_request(80,28);umagEntry.set_text('1');umagEntry.grab_focus()
            usnbox=gtk.HBox(False,5);usnbox.pack_start(label,False,False,15);usnbox.pack_end(umagEntry,False,False,5)

            label=gtk.Label('Volume flow rate [m3/sec]')
            vflowEntry=gtk.Entry();vflowEntry.set_size_request(80,28);vflowEntry.set_text('1')
            uvfbox=gtk.HBox(False,5);uvfbox.pack_start(label,False,False,15);uvfbox.pack_end(vflowEntry,False,False,5)

            label=gtk.Label('Mass flow rate [kg/sec]')
            mflowEntry=gtk.Entry();mflowEntry.set_size_request(80,28);mflowEntry.set_text('1')
            umfbox=gtk.HBox(False,5);umfbox.pack_start(label,False,False,15);umfbox.pack_end(mflowEntry,False,False,5)

            rotorilabel=gtk.Label('Origin');rotaxislabel=gtk.Label('Rot. axis');rpmlabel=gtk.Label('RPM')
            orixEntry=gtk.Entry();orixEntry.set_size_request(60,28);orixEntry.set_text('0')
            oriyEntry=gtk.Entry();oriyEntry.set_size_request(60,28);oriyEntry.set_text('0')
            orizEntry=gtk.Entry();orizEntry.set_size_request(60,28);orizEntry.set_text('0')
            eCombo=gtk.combo_box_entry_new_text();eCombo.set_size_request(60,28)
            axisList=['x','y','z','-x','-y','-z']
            for ii in axisList:eCombo.append_text(ii)
            eCombo.set_active(2)
            rpmEntry=gtk.Entry();rpmEntry.set_size_request(120,28);rpmEntry.set_text('100')

            rwvbox=gtk.VBox(False,5)
            rotoribox=gtk.HBox(False,5);rwvbox.pack_start(rotoribox,False,False,2)
            rotoribox.pack_start(rotorilabel,False,False,15);rotoribox.pack_end(orizEntry,False,False,5)
            rotoribox.pack_end(oriyEntry,False,False,0);rotoribox.pack_end(orixEntry,False,False,5)
            rotaxisbox=gtk.HBox(False,5);rwvbox.pack_start(rotaxisbox,False,False,2)
            rotaxisbox.pack_start(rotaxislabel,False,False,15);rotaxisbox.pack_start(eCombo,False,False,5)
            rotaxisbox.pack_start(rpmlabel,False,False,15);rotaxisbox.pack_end(rpmEntry,False,False,5)

            utypeCombo.connect('changed',chutype)
            if patchtype=='patch':
                if patchname[:3]=='out' or patchname[:3]=='Out' or patchname[:3]=='OUT':utypeCombo.set_active(4)
                else:utypeCombo.set_active(1)
            elif patchtype=='wall' or patchtype=='mappedWall':utypeCombo.set_active(0)
            #-- pressure ---------
            def chptype(widget):
                pcondition=widget.child.get_text()
                for ii in pbox.get_children():pbox.remove(ii)
                pbox.pack_start(phbox,False,False,5)
                if pcondition=='fixedValue':pbox.pack_start(pstaticbox,False,False,2)
                elif pcondition=='totalPressure':pbox.pack_start(ptotalbox,False,False,2)
                window.show_all()

            pframe=gtk.Frame();pframe.set_label('  Pressure  ');pframe.set_label_align(0.1, 0.5)
            pframe.set_shadow_type(gtk.SHADOW_IN);basicbox.pack_start(pframe,True,True,5)
            pbox=gtk.VBox(False,5);pframe.add(pbox)

            label=gtk.Label('Type')
            ptypeCombo=gtk.combo_box_entry_new_text();ptypeCombo.set_size_request(220,28)
            #ptypes=['fixedValue','totalPressure','zeroGradient','fixedFluxPressure']  
            ptypes=['fixedValue','totalPressure','zeroGradient']  
            for ii in ptypes:ptypeCombo.append_text(ii)                
            phbox=gtk.HBox(False,5);pbox.pack_start(phbox,False,False,2)
            phbox.pack_start(label,False,False,15);phbox.pack_end(ptypeCombo,False,False,5)

            label=gtk.Label('Static pressure [Pa]')
            pstaticEntry=gtk.Entry();pstaticEntry.set_size_request(80,28)
            if self.solver=='simpleNFoam' or self.solver=='pimpleNFoam':pstaticEntry.set_text('0')
            else:pstaticEntry.set_text('0')
            pstaticbox=gtk.HBox(False,5);pstaticbox.pack_start(label,False,False,15);pstaticbox.pack_end(pstaticEntry,False,False,5)

            label=gtk.Label('Total pressure [Pa]')
            ptotalEntry=gtk.Entry();ptotalEntry.set_size_request(80,28)
            if self.solver=='simpleNFoam' or self.solver=='pimpleNFoam':ptotalEntry.set_text('0')
            else:ptotalEntry.set_text('0')
            ptotalbox=gtk.HBox(False,5);ptotalbox.pack_start(label,False,False,15);ptotalbox.pack_end(ptotalEntry,False,False,5)
            
            ptypeCombo.connect('changed',chptype)
            if patchtype=='patch':
                if patchname[:3]=='out' or patchname[:3]=='Out' or patchname[:3]=='OUT':ptypeCombo.set_active(0)
                else:ptypeCombo.set_active(2)
            elif patchtype=='wall' or patchtype=='mappedWall':
                if self.solver=='simpleNFoam' or self.solver=='pimpleNFoam':ptypeCombo.set_active(2)
                else:ptypeCombo.set_active(2)        
            #-- temperature ---------
            def chttype(widget):
                tcondition=widget.child.get_text()
                for ii in tbox.get_children():tbox.remove(ii)
                tbox.pack_start(thbox,False,False,5)
                if tcondition=='fixedValue':tbox.pack_start(tvaluebox,False,False,2)
                elif tcondition=='inletOutlet':tbox.pack_start(tinoutbox,False,False,2)
                elif tcondition=='heatflux':tbox.pack_start(tfluxbox,False,False,2)
                elif tcondition=='convection':tbox.pack_start(tconvbox,False,False,2)
                window.show_all()

            tframe=gtk.Frame();tframe.set_label('  Temperature  ');tframe.set_label_align(0.1, 0.5)
            tframe.set_shadow_type(gtk.SHADOW_IN);basicbox.pack_start(tframe,True,True,5)
            tbox=gtk.VBox(False,5);tframe.add(tbox)

            label=gtk.Label('Type')
            ttypeCombo=gtk.combo_box_entry_new_text();ttypeCombo.set_size_request(220,28)
            ttypes=['fixedValue','zeroGradient','heatflux','convection','inletOutlet','coupled']  
            for ii in ttypes:ttypeCombo.append_text(ii)               
            thbox=gtk.HBox(False,5);tbox.pack_start(thbox,False,False,2)
            thbox.pack_start(label,False,False,15);thbox.pack_end(ttypeCombo,False,False,5)

            label=gtk.Label('T [K]')
            tvalueEntry=gtk.Entry();tvalueEntry.set_size_request(80,28);tvalueEntry.set_text('300')
            tvaluebox=gtk.HBox(False,5);tvaluebox.pack_start(label,False,False,15);tvaluebox.pack_end(tvalueEntry,False,False,5)

            label=gtk.Label('Inlet T [K]')
            tinoutEntry=gtk.Entry();tinoutEntry.set_size_request(80,28);tinoutEntry.set_text('300')
            tinoutbox=gtk.HBox(False,5);tinoutbox.pack_start(label,False,False,15);tinoutbox.pack_end(tinoutEntry,False,False,5)

            label=gtk.Label('Heat flux [W/m2]')
            tfluxEntry=gtk.Entry();tfluxEntry.set_size_request(80,28);tfluxEntry.set_text('100')
            tfluxbox=gtk.HBox(False,5);tfluxbox.pack_start(label,False,False,15);tfluxbox.pack_end(tfluxEntry,False,False,5)

            thlabel=gtk.Label('h [W/m2K]');tinflabel=gtk.Label('Tinf [K]')
            thEntry=gtk.Entry();thEntry.set_size_request(80,28);thEntry.set_text('10')
            tinfEntry=gtk.Entry();tinfEntry.set_size_request(80,28);tinfEntry.set_text('300')
            tconvbox=gtk.VBox(False,5)
            thcbox=gtk.HBox(False,5);tconvbox.pack_start(thcbox,False,False,5)
            thcbox.pack_start(thlabel,False,False,15);thcbox.pack_end(thEntry,False,False,5)
            tinfbox=gtk.HBox(False,5);tconvbox.pack_start(tinfbox,False,False,5)
            tinfbox.pack_start(tinflabel,False,False,5);tinfbox.pack_end(tinfEntry,False,False,5)
            
            ttypeCombo.connect('changed',chttype)
            if patchtype=='patch':
                ttypeCombo.set_active(0) 
                if patchname[:3]=='out' or patchname[:3]=='Out' or patchname[:3]=='OUT':
                    ttypeCombo.set_active(1)                               
            elif patchtype=='wall':
                ttypeCombo.set_active(1) 
            elif patchtype=='mappedWall':
                ttypeCombo.set_active(5)        
                ttypeCombo.set_sensitive(0)      
            #-- turbulence, k---------
            def chktype(widget):
                kcondition=widget.child.get_text()
                for ii in kbox.get_children():kbox.remove(ii)
                kbox.pack_start(khbox,False,False,5)
                if kcondition=='fixedValue':kbox.pack_start(kvaluebox,False,False,2)
                elif kcondition=='inletOutlet':kbox.pack_start(kinoutbox,False,False,2)
                elif kcondition=='intensity':kbox.pack_start(kintensitybox,False,False,2)
                window.show_all()

            kframe=gtk.Frame();kframe.set_label('  tur. kinetic energy ');kframe.set_label_align(0.1, 0.5)
            kframe.set_shadow_type(gtk.SHADOW_IN);basicbox.pack_start(kframe,True,True,5)
            kbox=gtk.VBox(False,5);kframe.add(kbox)

            label=gtk.Label('Type')
            ktypeCombo=gtk.combo_box_entry_new_text();ktypeCombo.set_size_request(220,28)
            ktypes=['wallFunction','fixedValue','zeroGradient','inletOutlet','intensity']  
            for ii in ktypes:ktypeCombo.append_text(ii)               
            khbox=gtk.HBox(False,5);kbox.pack_start(khbox,False,False,2)
            khbox.pack_start(label,False,False,15);khbox.pack_end(ktypeCombo,False,False,5)

            label=gtk.Label('k [m2/s2]')
            kvalueEntry=gtk.Entry();kvalueEntry.set_size_request(80,28);kvalueEntry.set_text('1')
            kvaluebox=gtk.HBox(False,5);kvaluebox.pack_start(label,False,False,15);kvaluebox.pack_end(kvalueEntry,False,False,5)

            label=gtk.Label('Inlet k [m2/s2]')
            kinoutEntry=gtk.Entry();kinoutEntry.set_size_request(80,28);kinoutEntry.set_text('1')
            kinoutbox=gtk.HBox(False,5);kinoutbox.pack_start(label,False,False,15);kinoutbox.pack_end(kinoutEntry,False,False,5)

            label=gtk.Label('Intensity')
            kintensityEntry=gtk.Entry();kintensityEntry.set_size_request(80,28);kintensityEntry.set_text('0.1')
            kintensitybox=gtk.HBox(False,5);kintensitybox.pack_start(label,False,False,15);kintensitybox.pack_end(kintensityEntry,False,False,5)
            
            ktypeCombo.connect('changed',chktype)
            if patchtype=='patch':
                ktypeCombo.set_active(1) 
                if patchname[:3]=='out' or patchname[:3]=='Out' or patchname[:3]=='OUT':
                    ktypeCombo.set_active(2) 
            elif patchtype=='wall' or patchtype=='mappedWall':ktypeCombo.set_active(0)
            #--------------------            
            aa=glob.glob(self.caseDir+'/system/settings/simulationConditions')
            if aa!=[]:
                dic=GEN.makeDictFromFile(aa[0])
                self.turmodel=dic['turmodel']
            
            #-- epsilon ---------
            def chetype(widget):
                econdition=widget.child.get_text()
                for ii in ebox.get_children():ebox.remove(ii)
                ebox.pack_start(ehbox,False,False,5)
                if econdition=='fixedValue':ebox.pack_start(evaluebox,False,False,2)
                elif econdition=='inletOutlet':ebox.pack_start(einoutbox,False,False,2)
                elif econdition=='mixingLength':
                    if self.turmodel=='kOmegaSST':
                        GEN.makeDialog('This type cannot be used with SST k-omega model')
                        widget.set_active(1)
                    else:
                        ebox.pack_start(elengthbox,False,False,2)
                window.show_all()

            if self.turmodel=='kOmegaSST':
                diss='omega';dim='[1/s]'
            else:
                diss='epsilon';dim='[m2/s3]'
            
            eframe=gtk.Frame();eframe.set_label('  '+diss+'  ');eframe.set_label_align(0.1, 0.5);eframe.set_shadow_type(gtk.SHADOW_IN)
            basicbox.pack_start(eframe,True,True,5)
            ebox=gtk.VBox(False,5);eframe.add(ebox)

            label=gtk.Label('Type')
            etypeCombo=gtk.combo_box_entry_new_text();etypeCombo.set_size_request(220,28)
            etypes=['wallFunction','fixedValue','zeroGradient','inletOutlet','mixingLength']  
            for ii in etypes:etypeCombo.append_text(ii)               
            ehbox=gtk.HBox(False,5);ebox.pack_start(ehbox,False,False,2)
            ehbox.pack_start(label,False,False,15);ehbox.pack_end(etypeCombo,False,False,5)

            label=gtk.Label(diss+' '+dim)
            evalueEntry=gtk.Entry();evalueEntry.set_size_request(80,28);evalueEntry.set_text('1')
            evaluebox=gtk.HBox(False,5);evaluebox.pack_start(label,False,False,15);evaluebox.pack_end(evalueEntry,False,False,5)

            label=gtk.Label('Inlet '+diss+' '+dim)
            einoutEntry=gtk.Entry();einoutEntry.set_size_request(80,28);einoutEntry.set_text('1')
            einoutbox=gtk.HBox(False,5);einoutbox.pack_start(label,False,False,15);einoutbox.pack_end(einoutEntry,False,False,5)
            
            label=gtk.Label('Length scale [m2/s3]')
            elengthEntry=gtk.Entry();elengthEntry.set_size_request(80,28);elengthEntry.set_text('1')
            elengthbox=gtk.HBox(False,5);elengthbox.pack_start(label,False,False,15);elengthbox.pack_end(elengthEntry,False,False,5)
            
            etypeCombo.connect('changed',chetype)
            if patchtype=='patch':
                etypeCombo.set_active(1)
                if patchname[:3]=='out' or patchname[:3]=='Out' or patchname[:3]=='OUT':
                    etypeCombo.set_active(2)  
            elif patchtype=='wall' or patchtype=='mappedWall':etypeCombo.set_active(0)
            #-------------------------------
            if self.solver=='simpleNFoam' or self.solver=='pimpleNFoam':
                ttypeCombo.set_sensitive(0);tvalueEntry.set_sensitive(0)
            else:
                ttypeCombo.set_sensitive(1);tvalueEntry.set_sensitive(1)                            
            
            buttonbox=gtk.HBox(False,5)        
            mainvbox.pack_start(buttonbox,False,False,5)
            
            app=gtk.Button(label='Apply');app.set_size_request(100,30);cll=gtk.Button(label='Close');cll.set_size_request(100,30)
            disp=gtk.Button(label='Show');disp.set_size_request(100,30)
            app.connect('clicked',applythis);cll.connect('clicked',closethis);disp.connect('clicked',displaymesh)
            buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(app,False,False,5);buttonbox.pack_end(disp,False,False,5)  
            
            setSavedValue()
            
            window.show_all()   

        else:return    

    def main(self):
        gtk.main()

if __name__=='__main__':
    solverwin=covWin()
    solverwin.main()
