#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for various function
#
# Author
#    NEXTFOAM Inc.
##############################################################################

import os,math,glob,sys;import pygtk;pygtk.require('2.0');import gtk

from generalSub import *
from VTKStuffClass import *

class etcClass:

    def delete_event(self,widget,event,data=None):
        aa=glob.glob(self.caseDir+'/system/settings/openSubWindow')
        for ii in aa:os.system('rm '+ii)

    def destroy(self,widget,data=None):
        self.covWin.destroy()

    def __init__(self,caseDir,solver,installpath,rr,gg,bb):
        self.caseDir=caseDir
        self.solver=solver
        self.installpath=installpath
        self.rr=rr;self.gg=gg;self.bb=bb
    #-----------------------------------------------------------------------------------------------------------------
    def setFields(self,mainwindow,notebook,terminal,gvtk):
    
        GEN=generalClass(self.caseDir)
        
        def closethis(widget):
            mwin.destroy()
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')

        def applythis(widget):
            minx=minxEntry.get_text();miny=minyEntry.get_text();minz=minzEntry.get_text()
            maxx=maxxEntry.get_text();maxy=maxyEntry.get_text();maxz=maxzEntry.get_text()
            setFieldsRangeMin='('+minx+' '+miny+' '+minz+')'
            setFieldsRangeMax='('+maxx+' '+maxy+' '+maxz+')'
            aa=scCombo.child;scalar=aa.get_text()
            dvalue=dvEntry.get_text();value=vEntry.get_text()	
            
            f=open(self.caseDir+'/system/settings/setFieldsSetup','w')
            f.write('minx;'+minx+'\n');f.write('miny;'+miny+'\n');f.write('minz;'+minx+'\n')
            f.write('maxx;'+maxx+'\n');f.write('maxy;'+maxy+'\n');f.write('maxz;'+maxz+'\n')
            f.write('scalar;'+scalar+'\n');f.write('default;'+dvalue+'\n');f.write('value;'+value+'\n')
            f.close()
            
            self.setFieldsDict(setFieldsRangeMin,setFieldsRangeMax,scalar,dvalue,value)
            
            bb=glob.glob(self.caseDir+'/0/U')
            if len(bb)==0:self.makeDialog('Error!!! setFields should be done after initialize')
            else:
                notebook.set_current_page(2)
                cmd='setFields -case '+self.caseDir+'\n'
                length=len(cmd)
                terminal.feed_child(cmd,length)
        
            mwin.destroy()
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')
            
            message='\n [  setFields utility is executed  ]\n' 
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            
        def setSavedValue():            
            aa=glob.glob(self.caseDir+'/system/settings/setFieldsSetup')
            if len(aa)!=0:
                dic=GEN.makeDictFromFile(aa[0])
                minxEntry.set_text(dic['minx']);minyEntry.set_text(dic['miny']);minzEntry.set_text(dic['minz'])
                maxxEntry.set_text(dic['maxx']);maxyEntry.set_text(dic['maxy']);maxzEntry.set_text(dic['maxz'])
                aaa=scalars.index(dic['scalar']);scCombo.set_active(aaa)
                dvEntry.set_text(dic['default']);vEntry.set_text(dic['value'])
                
        def showregion(widget):
            minx=minxEntry.get_text();miny=minyEntry.get_text();minz=minzEntry.get_text()
            maxx=maxxEntry.get_text();maxy=maxyEntry.get_text();maxz=maxzEntry.get_text() 
            
            notebook.set_current_page(1)
            
            VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb)
            viewposition=[1,1,1]
            GEN=generalClass(self.caseDir)
            patchName=GEN.getBCName();minmax=GEN.getDomainRange()           
            renderer=VTK.showSetFieldRegion(minx,miny,minz,maxx,maxy,maxz,viewposition,patchName,minmax)
            gvtk.GetRenderWindow().AddRenderer(renderer)
            gvtk.Initialize()
            gvtk.Start()
                               

        if self.subWindowOpened()==False:         
            mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
            mwin.set_title('setFields');mwin.set_position(gtk.WIN_POS_CENTER);mwin.set_transient_for(mainwindow)
            mainbox=gtk.VBox(False,0);mwin.add(mainbox)

            frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);mainbox.pack_start(frame,True,True,5)
            box1=gtk.VBox(False,5);frame.add(box1)

            label=gtk.Label('Min. x,y,z ')
            minxEntry=gtk.Entry();minyEntry=gtk.Entry();minzEntry=gtk.Entry()
            minxEntry.set_text('0');minyEntry.set_text('0');minzEntry.set_text('0')
            minxEntry.set_size_request(60,28);minyEntry.set_size_request(60,28);minzEntry.set_size_request(60,28)
            hbox1=gtk.HBox(False,5);box1.pack_start(hbox1,False,False,5)                
            hbox1.pack_start(label,False,False,5);hbox1.pack_end(minzEntry,False,False,5)
            hbox1.pack_end(minyEntry,False,False,5);hbox1.pack_end(minxEntry,False,False,5)	

            label=gtk.Label('Max. x,y,z ')
            maxxEntry=gtk.Entry();maxyEntry=gtk.Entry();maxzEntry=gtk.Entry()
            maxxEntry.set_text('0');maxyEntry.set_text('0');maxzEntry.set_text('0')
            maxxEntry.set_size_request(60,28);maxyEntry.set_size_request(60,28);maxzEntry.set_size_request(60,28)
            hbox2=gtk.HBox(False,5);box1.pack_start(hbox2,False,False,5)                
            hbox2.pack_start(label,False,False,5);hbox2.pack_end(maxzEntry,False,False,5)
            hbox2.pack_end(maxyEntry,False,False,5);hbox2.pack_end(maxxEntry,False,False,5)
            
            showB=gtk.Button('Display region');showB.set_size_request(160,28)
            showB.connect('clicked',showregion)
            hbox2=gtk.HBox(False,5);box1.pack_start(hbox2,False,False,5)                
            hbox2.pack_end(showB,False,False,5)            

            label=gtk.Label('Select scalar')
            scCombo=gtk.combo_box_entry_new_text();scCombo.set_size_request(100,28)
            scalars=['p','p_rgh','T','k','epsilon','omega'] 
            for ii in scalars:scCombo.append_text(ii)
            scCombo.set_active(0)
            hbox3=gtk.HBox(False,5);box1.pack_start(hbox3,False,False,5)
            hbox3.pack_start(label,False,False,5);hbox3.pack_end(scCombo,False,False,5)	

            label=gtk.Label('default value');dvEntry=gtk.Entry();dvEntry.set_size_request(100,28);dvEntry.set_text('0')
            hbox4=gtk.HBox(False,5);box1.pack_start(hbox4,False,False,5)
            hbox4.pack_start(label,False,False,5);hbox4.pack_end(dvEntry,False,False,5)
	    
            label=gtk.Label('fix value');vEntry=gtk.Entry();vEntry.set_size_request(100,28);vEntry.set_text('0')
            hbox5=gtk.HBox(False,5);box1.pack_start(hbox5,False,False,5)
            hbox5.pack_start(label,False,False,5);hbox5.pack_end(vEntry,False,False,5)	

            box2=gtk.HBox(False,5);mainbox.pack_start(box2,False,False,5)
            appB=gtk.Button('setFields');closeB=gtk.Button('Close')
            appB.set_size_request(100,28);closeB.set_size_request(100,28)
            appB.connect('clicked',applythis);closeB.connect('clicked',closethis)
            box2.pack_end(closeB,True,True,5);box2.pack_end(appB,True,True,5)
        
            setSavedValue()

            mwin.show_all()
        
            f=open(self.caseDir+'/system/settings/openSubWindow','w')	

        else:return
    #-----------------------------------------------------------------------------------------------------
    def setFieldsDict(self,setFieldsRangeMin,setFieldsRangeMax,scalar,defualtValue,value):
        f=open(self.caseDir+'/system/setFieldsDict','w')
        f.write("/*--------------------------------*- C++ -*----------------------------------*\ \n")
        f.write('| =========                 |                                                 |\n')
        f.write('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |\n')
        f.write('|  \\    /   O peration     | Version:  2.3.0                                 |\n')
        f.write('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      |\n')
        f.write('|    \\/     M anipulation  |                                                 |\n')
        f.write('\*---------------------------------------------------------------------------*/\n')
        f.write('FoamFile\n')
        f.write('{\n')
        f.write('    version     2.0;\n')
        f.write('    format      ascii;\n')
        f.write('    class       dictionary;\n')
        f.write('    object      setFieldsDict;\n')
        f.write('}\n')

        f.write('defaultFieldValues\n')
        f.write('(\n')
        f.write('    volScalarFieldValue '+scalar+' '+defualtValue+' \n')
        f.write(');\n')
        f.write('regions\n')
        f.write('(\n')
        f.write('    boxToCell\n')
        f.write('    {\n')
        f.write('        box '+setFieldsRangeMin+' '+setFieldsRangeMax+';\n')
        f.write('        fieldValues\n')
        f.write('        (\n')
        f.write('            volScalarFieldValue '+scalar+' '+value+'\n')
        f.write('        );\n')
        f.write('    }\n')
        f.write('    boxToFace\n')
        f.write('    {\n')
        f.write('        box '+setFieldsRangeMin+' '+setFieldsRangeMax+';\n')
        f.write('        fieldValues\n')
        f.write('        (\n')
        f.write('            volScalarFieldValue '+scalar+' '+value+'\n')
        f.write('        );\n')
        f.write('    }\n')         
        f.write(');\n')
        f.close()
    #-----------------------------------------------------------------------------------------------------
    def reconstructPar(self,mainwindow,notebook,terminal):
    
        GEN=generalClass(self.caseDir)
        
        def closethis(widget):
            mwin.destroy()
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')

        def applythis(widget):
            f=open(self.caseDir+'/system/settings/reconstruct','w')
            if latestCB.get_active()==True:
                f.write('reconstructPar -case '+self.caseDir+' -latestTime \n')
            else:
                if allCB.get_active()==True:
                    f.write('reconstructPar -case '+self.caseDir+'\n')
                else:
                    times=[]
                    for ii in CBs:
                        if ii.get_active()==1:times.append(ii.get_label())
                    
                    f.write('reconstructPar -case '+self.caseDir+' -time ')
                    for i in range(len(times)-1):f.write(times[i]+',')
                    f.write(times[-1]+'\n')                
            f.write('rm -r '+self.caseDir+'/processor* \n');f.close()
            
            os.system('chmod +x '+self.caseDir+'/system/settings/reconstruct')
            
            notebook.set_current_page(2)
            
            cmd=self.caseDir+'/system/settings/reconstruct\n'
            length=len(cmd)
            terminal.feed_child(cmd,length)
            
            mwin.destroy()
           
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')
            
            message='\n [  reconstructPar utility is executed  ]\n' 
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            
        def chlast(widget):
            onOff=widget.get_active()
            if onOff==1:
                for ii in CBs:ii.set_sensitive(0)
                allCB.set_sensitive(0)
            else:
                for ii in CBs:ii.set_sensitive(1)
                allCB.set_sensitive(1)

        def chall(widget):
            onOff=widget.get_active()
            if onOff==1:
                for ii in CBs:ii.set_sensitive(0)
                latestCB.set_sensitive(0)
            else:
                for ii in CBs:ii.set_sensitive(1)
                latestCB.set_sensitive(1)
                
        if self.subWindowOpened()==False:
        
            mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10);mwin.set_title('reconstructPar')
            mwin.set_position(gtk.WIN_POS_CENTER);mwin.set_transient_for(mainwindow)
            mainbox=gtk.VBox(False,0);mwin.add(mainbox)

            frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);mainbox.pack_start(frame,True,True,5)
            box1=gtk.VBox(False,5);frame.add(box1)

            swin=gtk.ScrolledWindow();swin.set_border_width(0);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
            box1.pack_start(swin)
            itembox=gtk.VBox(False,0)
            swin.add_with_viewport(itembox)
            swin.set_size_request(250,500)

            latestCB=gtk.CheckButton('SourceTime is latestTime');latestCB.set_active(1)
            latestCB.connect('toggled',chlast)
            hbox=gtk.HBox(False,5);itembox.pack_start(hbox,False,False,5);hbox.pack_start(latestCB,False,False,5)
            
            allCB=gtk.CheckButton('SourceTime is All');allCB.set_active(0);allCB.set_sensitive(0)
            allCB.connect('toggled',chall)
            hbox=gtk.HBox(False,5);itembox.pack_start(hbox,False,False,5);hbox.pack_start(allCB,False,False,5)

            separator=gtk.HSeparator();separator.set_size_request(10,5);itembox.pack_start(separator,False,True,5)
        
            label=gtk.Label('Select times')
            hbox=gtk.HBox(False,5);itembox.pack_start(hbox,False,False,5);hbox.pack_start(label,False,False,10)
        
            aa=glob.glob(self.caseDir+'/processor*')
            if len(aa)!=0:
                bb=os.listdir(self.caseDir+'/processor0/')
                res=[]
                for ii in bb:
                    if GEN.isNumber(ii)==True and ii!='0':res.append(ii)
                intres=[]
                for ii in res:intres.append(float(ii))
                intres.sort()
                results=[]
                for jj in intres:results.append(str(jj))
                    
                CBs=[]        
                for i in range(len(results)):
                    CBs.append(gtk.CheckButton(results[i]))
                    hbox=gtk.HBox(False,5);itembox.pack_start(hbox,False,False,5);hbox.pack_start(CBs[i],False,False,30)
                    CBs[i].set_sensitive(0)        
            else:
                GEN.makeDialog('There in no decomposed data')
                return
        
            box2=gtk.HBox(False,5);mainbox.pack_start(box2,False,False,5)
            appB=gtk.Button('reconstruct');closeB=gtk.Button('Close')
            appB.set_size_request(100,28);closeB.set_size_request(100,28)
            appB.connect('clicked',applythis);closeB.connect('clicked',closethis)
            box2.pack_end(closeB,False,False,5);box2.pack_end(appB,False,False,5)

            mwin.show_all()
            
            f=open(self.caseDir+'/system/settings/openSubWindow','w');f.close()
    #-----------------------------------------------------------------------------------------------------
    def yPlusRAS(self,mainwindow,solver,notebook,terminal):
    
        GEN=generalClass(self.caseDir)               

        def closethis(widget):
            mwin.destroy()
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')
            
        def applythis(widget):
            time=timeEntry.get_text();stime=stimeEntry.get_text();etime=etimeEntry.get_text()
            nozero=nozeroCB.get_active()

            aa=glob.glob(self.caseDir+'/system/settings/simulationConditions')
            if aa!=[]:
                dic=GEN.makeDictFromFile(aa[0])
                turmodel=dic['turmodel']
            else:turmodel='standardKEpsilon'
            
                        
            if turmodel=='laminar':
                GEN.makeDialog('Error!!! This is laminar')
                mwin.destroy()
                os.system('rm '+self.caseDir+'/system/settings/openSubWindow')
                return
            else:
                os.system('mv '+self.caseDir+'/constant/RASProperties '+self.caseDir+'/constant/ori.RASProperties')            
                self.changeRASFile(turmodel)
                
                if solver=='simpleNFoam' or solver=='pimpleNFoam':opt=''
                else:opt='-compressible'
                
                f=open(self.caseDir+'/system/settings/yplusras','w')
                
                if nozero==0:
                    if selmethod=='All':f.write('yPlusRAS '+opt+' -case '+self.caseDir+'\n')
                    elif selmethod=='latestTime':f.write('yPlusRAS '+opt+' -latestTime -case '+self.caseDir+'\n')
                    elif selmethod=='Time':f.write('yPlusRAS '+opt+' -time '+time+' -case '+self.caseDir+'\n')
                    elif selmethod=='Time Range':f.write('yPlusRAS '+opt+' -time '+stime+':'+etime+' -case '+self.caseDir+'\n')
                else:
                    if selmethod=='All':f.write('yPlusRAS '+opt+' -noZero -case '+self.caseDir+'\n')
                    elif selmethod=='latestTime':f.write('yPlusRAS '+opt+' -noZero -latestTime -case '+self.caseDir+'\n')
                    elif selmethod=='Time':f.write('yPlusRAS '+opt+' -noZero -time '+time+' -case '+self.caseDir+'\n')
                    elif selmethod=='Time Range':f.write('yPlusRAS '+opt+' -noZero -time '+stime+':'+etime+' -case '+self.caseDir+'\n')
                    
                f.write('mv '+self.caseDir+'/constant/ori.RASProperties '+self.caseDir+'/constant/RASProperties\n') 
                f.close()
                
                os.system('chmod +x '+self.caseDir+'/system/settings/yplusras')
                
                notebook.set_current_page(2)
            
                cmd=self.caseDir+'/system/settings/yplusras\n'
                length=len(cmd)
                terminal.feed_child(cmd,length)
            
                mwin.destroy()
                
                os.system('rm '+self.caseDir+'/system/settings/openSubWindow')
                
                message='\n [  yPlusRAS utility is executed  ]\n' 
                enditer=textbuffer.get_end_iter()
                textbuffer.insert(enditer,message)
            
        def toggled(widget):
            aa=widget.child;selmethod=aa.get_text()
            if selmethod=='All':
                timeEntry.set_sensitive(0);stimeEntry.set_sensitive(0);etimeEntry.set_sensitive(0)
            elif selmethod=='latestTime':
                timeEntry.set_sensitive(0);stimeEntry.set_sensitive(0);etimeEntry.set_sensitive(0)
            elif selmethod=='Time':
                timeEntry.set_sensitive(1);stimeEntry.set_sensitive(0);etimeEntry.set_sensitive(0)
            elif selmethod=='Time Range':
                timeEntry.set_sensitive(0);stimeEntry.set_sensitive(1);etimeEntry.set_sensitive(1)

        if self.subWindowOpened()==False:  

            selmethod='All'

            mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
            mwin.set_title('yPlusRAS');mwin.set_position(gtk.WIN_POS_CENTER);mwin.set_transient_for(mainwindow)
            mainbox=gtk.VBox(False,0);mwin.add(mainbox)

            frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN)
            frame.set_label('    Select time to create y+    ');frame.set_label_align(0.1, 0.5)
            mainbox.pack_start(frame,True,True,5)

            box1=gtk.VBox(False,5);frame.add(box1)

            but0=gtk.RadioButton(None,'All');but0.connect('toggled',toggled)
            hbox0=gtk.HBox(False,5);box1.pack_start(hbox0,False,False,5)
            hbox0.pack_start(but0,False,False,5)

            but1=gtk.RadioButton(but0,'latestTime');but1.connect('toggled',toggled)
            hbox1=gtk.HBox(False,5);box1.pack_start(hbox1,False,False,5)
            hbox1.pack_start(but1,False,False,5)

            but2=gtk.RadioButton(but0,'Time');but2.set_size_request(120,28);but2.connect('toggled',toggled)
            timeEntry=gtk.Entry();timeEntry.set_size_request(60,28)
            hbox2=gtk.HBox(False,5);box1.pack_start(hbox2,False,False,5)
            hbox2.pack_start(but2,False,False,5);hbox2.pack_start(timeEntry,False,False,5)

            but3=gtk.RadioButton(but0,'Time Range');but3.set_size_request(120,28);but3.connect('toggled',toggled)
            stimeEntry=gtk.Entry();stimeEntry.set_size_request(60,28)
            label=gtk.Label('~')
            etimeEntry=gtk.Entry();etimeEntry.set_size_request(60,28)
            hbox3=gtk.HBox(False,5);box1.pack_start(hbox3,False,False,5)
            hbox3.pack_start(but3,False,False,5);hbox3.pack_start(stimeEntry,False,False,5)
            hbox3.pack_start(label,False,False,5);hbox3.pack_start(etimeEntry,False,False,5)

            nozeroCB=gtk.CheckButton('noZero Option')
            hbox4=gtk.HBox(False,5);box1.pack_start(hbox4,False,False,5)
            hbox4.pack_start(nozeroCB,False,False,5)

            box2=gtk.HBox(False,5);mainbox.pack_start(box2,False,False,5)
            appB=gtk.Button('Apply');closeB=gtk.Button('Close')
            appB.set_size_request(100,28);closeB.set_size_request(100,28)
            appB.connect('clicked',applythis);closeB.connect('clicked',closethis)
            box2.pack_end(closeB,False,False,5);box2.pack_end(appB,False,False,5)

            mwin.show_all()	
        
            f=open(self.caseDir+'/system/settings/openSubWindow','w');f.close()
    #-------------------------------------------------------
    def changeRASFile(self,turmodel):        
        
        if turmodel=='kOmegaSST':tur='kOmegaSST' 
        elif turmodel=='standardKEpsilon':tur='kEpsilon'
        elif turmodel=='realizableKE':tur='realizableKE'
        elif turmodel=='RNGkEpsilon':tur='RNGkEpsilon'
        
        f=open(self.caseDir+'/constant/RASProperties','w')
        f.write('FoamFile\n')
        f.write('{\n')
        f.write('    version     2.0;\n')
        f.write('    format      ascii;\n')
        f.write('    class       dictionary;\n')
        f.write('    location    "constant";\n')
        f.write('    object      RASProperties;\n')
        f.write('}\n')
        f.write('RASModel        '+tur+';\n')
        f.write('turbulence      on;\n')
        f.write('printCoeffs     on;\n')
        f.close()
    #-----------------------------------------------------------------------------------------------------
    def mapFields(self,mainwindow,notebook,terminal):
        
        self.sourceCase='None'

        def source(widget):
            dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                          (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
            dialog.set_default_response(gtk.RESPONSE_OK)
            dialog.set_action(gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
            response = dialog.run()
            if response == gtk.RESPONSE_OK:self.sourceCase=dialog.get_filename()
            elif response == gtk.RESPONSE_CANCEL:self.sourceCase='None'
            dialog.destroy()

        def closethis(widget):
            mwin.destroy()
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')

        def applythis(widget):
            if latestCB.get_active()==True:sourceTime='latestTime'
            else:sourceTime=stimeEntry.get_text()
            
            notebook.set_current_page(2)
            
            cmd='mapFields -consistent -case '+self.caseDir+' -sourceTime '+sourceTime+' '+self.sourceCase+'\n'
            length=len(cmd)
            terminal.feed_child(cmd,length)
                
            mwin.destroy()
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')
            
            message='\n [  mapFields utility is executed. source case : '+self.sourceCase+'  ]\n' 
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)

        if self.subWindowOpened()==False:        
            mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
            mwin.set_title('mapFields');mwin.set_position(gtk.WIN_POS_CENTER);mwin.set_transient_for(mainwindow)
            mainbox=gtk.VBox(False,0);mwin.add(mainbox)

            frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);mainbox.pack_start(frame,True,True,5)
            box1=gtk.VBox(False,5);frame.add(box1)
            sourceB=gtk.Button(' Select source case ');sourceB.connect('clicked',source)
            hbox1=gtk.HBox(False,5);box1.pack_start(hbox1,False,False,5);hbox1.pack_start(sourceB,False,False,5)
            latestCB=gtk.CheckButton('SourceTime is latestTime');latestCB.set_active(1)
            hbox2=gtk.HBox(False,5);box1.pack_start(hbox2,False,False,5);hbox2.pack_start(latestCB,False,False,5)
            label=gtk.Label('sourceTime');stimeEntry=gtk.Entry();stimeEntry.set_size_request(100,28)
            hbox3=gtk.HBox(False,5);box1.pack_start(hbox3,False,False,5)
            hbox3.pack_start(label,False,False,5);hbox3.pack_end(stimeEntry,False,False,5)
            box2=gtk.HBox(False,5);mainbox.pack_start(box2,False,False,5)
            appB=gtk.Button('mapFields');closeB=gtk.Button('Close')
            appB.set_size_request(100,28);closeB.set_size_request(100,28)
            appB.connect('clicked',applythis);closeB.connect('clicked',closethis)
            box2.pack_end(closeB,False,False,5);box2.pack_end(appB,False,False,5)
            mwin.show_all()	
        
            f=open(self.caseDir+'/system/settings/openSubWindow','w');f.close()                    
    #-------------------------------------------------------
    def subWindowOpened(self):    
        aa=glob.glob(self.caseDir+'/system/settings/openSubWindow')
        if len(aa)==0:subwin=False
        else:subwin=True
        return subwin            

    def main(self):
        gtk.main()

if __name__=='__main__':
    solverwin=covWin()
    solverwin.main()
