#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for various subfunctions
#
# Author
#    NEXTFOAM Inc.
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob
import time

from generalSub import *

class generalClass:

    def delete_event(self,widget,event,data=None):
        aa=glob.glob(self.caseDir+'/system/settings/openSubWindow')
        for ii in aa:os.system('rm '+ii)

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir):
	    self.caseDir=caseDir    
    #--------------------------------------------------------------------------------------  
    def newcase(self):
        dialog = gtk.FileChooserDialog("New..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                       (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_action(gtk.FILE_CHOOSER_ACTION_CREATE_FOLDER)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:self.caseDir=dialog.get_filename()
        elif response == gtk.RESPONSE_CANCEL:self.caseDir='None'
        dialog.destroy()
        return self.caseDir
    #-------------------------------------------------------------------------------------------------
    def readcase(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                       (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_action(gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            caseDir=dialog.get_filename()
            a1=glob.glob(caseDir+'/0');a2=glob.glob(caseDir+'/constant');a3=glob.glob(caseDir+'/system')
            if len(a1)==0 or len(a2)==0 or len(a3)==0:
                self.makeDialog('Error! This folder is not proper OpenFOAM case.\n Ther is not 0 or constant or system folder')
                caseDir='None'
        elif response == gtk.RESPONSE_CANCEL:caseDir='None'
        dialog.destroy()          
        return caseDir        
    #-------------------------------------------------------------------------------------
    def saveas(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,(gtk.STOCK_CANCEL, 
					gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_action(gtk.FILE_CHOOSER_ACTION_CREATE_FOLDER)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:clonename=dialog.get_filename()
        elif response == gtk.RESPONSE_CANCEL:clonename='None'
        dialog.destroy()
        if clonename!='None':os.system('cp -r '+self.caseDir+'/* '+clonename+'/')
        return clonename
    #-------------------------------------------------------------------------------------
    def clone(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_action(gtk.FILE_CHOOSER_ACTION_CREATE_FOLDER)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:clonename=dialog.get_filename()
        elif response == gtk.RESPONSE_CANCEL:clonename='None'
        dialog.destroy()
        if clonename!='None':
            os.system('cp -r '+self.caseDir+'/0 '+clonename+'/')
            os.system('cp -r '+self.caseDir+'/constant '+clonename+'/')
            os.system('cp -r '+self.caseDir+'/system '+clonename+'/')
        return clonename
    #-------------------------------------------------------------------------------------
    def checkMesh(self):
        def closethis(widget):mwin.destroy()

        os.system('checkMesh -case '+self.caseDir+' > '+self.caseDir+'/checkMeshResult')
        
        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('Mesh Information');mwin.set_position(gtk.WIN_POS_CENTER)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)
        hbox=gtk.HBox(False,5);hbox.set_size_request(750,600);mainbox.pack_start(hbox,True,True,5)
        sw=gtk.ScrolledWindow();sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        textview=gtk.TextView()
        textbuffer=textview.get_buffer()
        sw.add(textview)
        hbox.pack_start(sw,True,True,5)

        f=open(self.caseDir+'/checkMeshResult','r');ff=f.readlines();f.close()
        res=ff[24:-2];string=''
        for ii in res:string=string+ii
        textbuffer.set_text(string)

        buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        closeB=gtk.Button(label='close');closeB.connect('clicked',closethis);closeB.set_size_request(140,28)
        buttonbox.pack_end(closeB,False,False,5)
        mwin.show_all()
    #-- get cellZones---------------------------------------------------------------------------------------
    def getCellZones(self):
        cellZones=[]
        aa=glob.glob(self.caseDir+'/constant/polyMesh/cellZones')
        if len(aa)!=0:
            filea=open(aa[0],'r');lines=filea.readlines();filea.close()
            line1=[]
            for i in range(15,len(lines)):
                a=(lines[i]).strip()
                if a=='{':line1.append(i)            
            for i in line1:
                b=(lines[i-1]).strip();cellZones.append(b)
        return cellZones
    #-- get faceZones---------------------------------------------------------------------------------------
    def getfaceZones(self):
        aa=self.caseDir+'/constant/polyMesh/faceZones'
        filea=open(aa);lines=filea.readlines();filea.close()
        line1=[];faceZones=[]
        for i in range(15,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)            
        for i in line1:
            b=(lines[i-1]).strip();faceZones.append(b)
        return faceZones
    #-- get sets-------------------------------------------------------------------------------------
    def getSets(self):
        aa=self.caseDir+'/constant/polyMesh/sets/*'
        sss=glob.glob(aa)
        sets=[]
        for jj in sss:bb=jj.split('/');sets.append(bb[-1])
        return sets
    #-- get boundary name Multi Region --------------------------------------------------------------------------
    def getBCNameMultiRegion(self,region):
        aa=self.caseDir+'/constant/'+region+'/polyMesh/boundary'
        filea=open(aa);lines=filea.readlines();filea.close()
        for ii in lines:
            if ii=='\n':lines.remove(ii)
        line1=[];bcname=[]
        f=open(aa,'r')
        for i in range(15,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)            
        for i in line1:
            b=(lines[i-1]).strip();bcname.append(b)
        return bcname
    #-- get boundary name---------------------------------------------------------------------------------------
    def getBCName(self):
        aa=self.caseDir+'/constant/polyMesh/boundary'
        if glob.glob(aa)==[]:
            self.makeDialog('Error!!! There might be some problem with mesh')
            return
        else:
            filea=open(aa);lines=filea.readlines();filea.close()
            for ii in lines:
	        if ii=='\n':lines.remove(ii)
            line1=[];bcname=[]
            f=open(aa,'r')
            for i in range(15,len(lines)):
                a=(lines[i]).strip()
                if a=='{':line1.append(i)            
            for i in line1:
                b=(lines[i-1]).strip();bcname.append(b)
            return bcname
    #-- get boundary type Multi Region ------------------------------------------------------------------
    def getBCTypeMultiRegion(self,region):
        aa=self.caseDir+'/constant/'+region+'/polyMesh/boundary'
        filea=open(aa,'r');lines=filea.readlines();filea.close()
        for ii in lines:
            if ii=='\n':lines.remove(ii)
        line1=[];bctype=[]
        f=open(aa,'r')
        for i in range(15,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)            
        for i in line1:
            bb=(lines[i+1]).split();bb1=(bb[1])[:-1];bctype.append(bb1)
        return bctype
    #-- get boundary type from polyMesh/boundary file ------------------------------------------------------------------
    def getBCType(self):
        aa=self.caseDir+'/constant/polyMesh/boundary'
        filea=open(aa,'r');lines=filea.readlines();filea.close()
        for ii in lines:
            if ii=='\n':lines.remove(ii)
        line1=[];bctype=[]
        f=open(aa,'r')
        for i in range(15,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)            
        for i in line1:
            bb=(lines[i+1]).split();bb1=(bb[1])[:-1];bctype.append(bb1)
        return bctype
    # ---create changeDictionaryDict file to change patch type-----------------------------------------------------------
    def changeDictionaryDictNoAMINoMappedWall(self,bcNameList,patchTypeList):

        aa=glob.glob(self.caseDir+'/system/settings/cyclicCondition')
        if len(aa)!=0:
            f=open(self.caseDir+'/system/settings/cyclicCondition','r');ff=f.readlines();f.close()
            rotCenter=ff[0][:-1]
            rotAxis=ff[1][:-1]
            if rotAxis=='x':raxis='(1 0 0)'
            elif rotAxis=='y':raxis='(0 1 0)'
            elif rotAxis=='z':raxis='(0 0 1)'           

        bb=glob.glob(self.caseDir+'/system/settings/amiFaces')
        amiface=[]
        if len(bb)!=0:
            f=open(self.caseDir+'/system/settings/amiFaces','r');ff=f.readlines();f.close()
            for ii in ff:amiface.append(ii[:-1])

        f=open(self.caseDir+'/system/changeDictionaryDict','w')
        f.write("/*--------------------------------*- C++ -*----------------------------------*\ \n")
        f.write('| =========                 |                                                 |\n')
        f.write('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |\n')
        f.write('|  \\    /   O peration     | Version:  2.3.0                                 |\n')
        f.write('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      |\n')
        f.write('|    \\/     M anipulation  |                                                 |\n')
        f.write('\*---------------------------------------------------------------------------*/\n')
        f.write('FoamFile\n')
        f.write('{\n')
        f.write('    version     2.0;\n')
        f.write('    format      ascii;\n')
        f.write('    class       dictionary;\n')
        f.write('    object      changeDictionaryDict;\n')
        f.write('}\n')

        f.write('dictionaryReplacement\n')
        f.write('{\n')
        f.write('    boundary\n')
        f.write('    {\n')
        for i in range(len(bcNameList)):
            if patchTypeList[i]!='cyclicAMI' and patchTypeList[i]!='mappedWall':
                f.write('        '+bcNameList[i]+'\n')
                f.write('        {\n')
                f.write('            type    '+patchTypeList[i]+';\n')
                f.write('        }\n')			
        f.write('    }\n')
        f.write('}\n')
        f.close()      
    # ---create changeDictionaryDict file to create interface-----------------------------------------------------
    def changeDictionaryDictSliding(self,amiface,weight,weightValue):
 	
        f=open(self.caseDir+'/system/changeDictionaryDictSliding','w')
        f.write("/*--------------------------------*- C++ -*----------------------------------*\ \n")
        f.write('| =========                 |                                                 |\n')
        f.write('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |\n')
        f.write('|  \\    /   O peration     | Version:  2.3.0                                 |\n')
        f.write('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      |\n')
        f.write('|    \\/     M anipulation  |                                                 |\n')
        f.write('\*---------------------------------------------------------------------------*/\n')
        f.write('FoamFile\n')
        f.write('{\n')
        f.write('    version     2.0;\n')
        f.write('    format      ascii;\n')
        f.write('    class       dictionary;\n')
        f.write('    object      changeDictionaryDict;\n')
        f.write('}\n')

        f.write('dictionaryReplacement\n')
        f.write('{\n')
        f.write('    boundary\n')
        f.write('    {\n')
        f.write('        '+amiface[0]+'\n')
        f.write('        {\n')
        f.write('            type              cyclicAMI;\n')
        f.write('            matchTolerance    0.0001;\n')
        f.write('            transform         noOrdering;\n')
        f.write('            neighbourPatch    '+amiface[1]+';\n')
        if weight==True:
            f.write('            lowWeightCorrection    '+weightValue+';\n')
        f.write('        }\n')
        f.write('        '+amiface[1]+'\n')
        f.write('        {\n')
        f.write('            type              cyclicAMI;\n')
        f.write('            matchTolerance    0.0001;\n')
        f.write('            transform         noOrdering;\n')
        f.write('            neighbourPatch    '+amiface[0]+';\n')
        if weight==True:
            f.write('            lowWeightCorrection    '+weightValue+';\n')
        f.write('        }\n')			
        f.write('    }\n')
        f.write('}\n')
        f.close()     
    #-------------------------------------------------------------------------------------
    def getLatestTime(self):
        res=glob.glob(self.caseDir+'/[0-9]*')
        resToInt=[]
        for i in range(len(res)):
            ss=res[i].split('/');sss=ss[-1]
            if sss!='2dplot.lpt' and sss!='0.org' and sss[-4:]!='foam':
        	resToInt.append(sss)
        resToInt.sort()
        finalRes=resToInt[-1]
        return finalRes
    #------------------------------------------------------------------------------
    def getValue(self,inputfile,key):
        f=open(inputfile,'r');ff=f.readlines();f.close()
        itemlines=[]
        for i in ff:itemlines.append(i[:-1])
        items={}
        for aa in itemlines:
            aaa=aa.split(';')
	    if len(aaa)==2:
	        keys=aaa[0].strip();values=aaa[1].strip()
                items[keys]=values
	    elif len(aaa)==1:
	        keys=aaa[0].strip();values='none'
                items[keys]=values
	    else:
	        print 'Error!!! Something is wrong in the inputFile at ',aa
        value=items[key]
        return value
    #-----------------------------------------------------------------------------------------------------
    def killjob(self,mainwindow):

        def closethis(widget):mwin.destroy()

        def applythis(widget):
            selec=[]
            for i in range(len(pid)):
                aa=cbentry[i].get_active()
                if aa==True:selec.append(pid[i])
            for ii in selec:os.system('kill -9 '+ii)
            mwin.destroy()

        os.system('ps -a > '+self.caseDir+'/psLog')
        f=open(self.caseDir+'/psLog','r');ff=f.readlines();f.close()
        pid=[];tty=[];time=[];cmd=[]
        for i in range(len(ff)-1):
            aa=ff[i+1].split()
            pid.append(aa[0]);tty.append(aa[1]);time.append(aa[2]);cmd.append(aa[3])

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('Mesh Information');mwin.set_position(gtk.WIN_POS_CENTER);mwin.set_transient_for(mainwindow)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)

        swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        mainbox.pack_start(swin,True,True,0);itembox=gtk.VBox(False,0);swin.add_with_viewport(itembox)
        scheight=len(ff)*50
        if scheight > 750:scheight=750
        swin.set_size_request(350,scheight)

        label=gtk.Label('       PID    TTY    TIME    CMD')
        lbox=gtk.HBox(False,5);itembox.pack_start(lbox,False,False,5);lbox.pack_start(label,False,False,5)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);itembox.pack_start(frame,True,True,5)
        box1=gtk.VBox(False,5);frame.add(box1)
        cbentry=[]
        for i in range(len(ff)-1):
            cbentry.append(gtk.CheckButton(pid[i]+'    '+tty[i]+'    '+time[i]+'    '+cmd[i]))
            box1.pack_start(cbentry[i],False,False,5)

        box2=gtk.HBox(False,5);mainbox.pack_start(box2,False,False,5)
        appB=gtk.Button('Kill');closeB=gtk.Button('Close')
        appB.set_size_request(100,28);closeB.set_size_request(100,28)
        appB.connect('clicked',applythis);closeB.connect('clicked',closethis)
        box2.pack_end(closeB,False,False,5);box2.pack_end(appB,False,False,5)

        mwin.show_all()        
    #-----------------------------------------------------------------------------------------------------
    def caseReport(self,mainwindow):

        def closethis(widget):mwin.destroy()

        os.system('pyFoamCaseReport.py --full-report '+self.caseDir+' > '+self.caseDir+'/caseReport')

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('Case Information');mwin.set_position(gtk.WIN_POS_CENTER);mwin.set_transient_for(mainwindow)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)
        hbox=gtk.HBox(False,5);hbox.set_size_request(750,600);mainbox.pack_start(hbox,True,True,5)
        sw=gtk.ScrolledWindow();sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        textview=gtk.TextView()
        textbuffer=textview.get_buffer()
        sw.add(textview)
        hbox.pack_start(sw,True,True,5)

        f=open(self.caseDir+'/caseReport','r');ff=f.readlines();f.close()
        string=''
        for ii in ff:string=string+ii
        textbuffer.set_text(string)

        buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
        closeB=gtk.Button(label='close');closeB.connect('clicked',closethis);closeB.set_size_request(140,28)
        buttonbox.pack_end(closeB,False,False,5)
        mwin.show_all()
    #-----------------------------------------------------------------------------------------------------
    def caseReportToPdf(self):
        os.system('pyFoamCaseReport.py --full-report '+self.caseDir+' | rst2pdf > '+self.caseDir+'/caseReport.pdf')
        os.system('evince '+self.caseDir+'/caseReport.pdf &')
    #-----------------------------------------------------------------------------------------------------
    def caseReportToTex(self):
        os.system('pyFoamCaseReport.py --full-report '+self.caseDir+' | rst2latex > '+self.caseDir+'/caseReport.tex')
        os.system('texworks '+self.caseDir+'/caseReport.tex &')
    #-----------------------------------------------------------------------------------------------------
    def getResult(self):
        resultSerial=[];resultParallel=[]
        os.system('foamListTimes -case '+self.caseDir+' -noZero > '+self.caseDir+'/system/settings/resultSerial')
        f=open(self.caseDir+'/system/settings/resultSerial','r');ff=f.readlines();f.close()
        for ii in ff:resultSerial.append(ii[:-1])
        os.system('rm '+self.caseDir+'/system/settings/resultSerial')

        aa=glob.glob(self.caseDir+'/processor*')
        if len(aa)!=0:
            os.system('foamListTimes -case '+self.caseDir+' -noZero -processor > '+self.caseDir+'/system/settings/resultParallel')
            f=open(self.caseDir+'/system/settings/resultParallel','r');ff=f.readlines();f.close()
            for ii in ff:resultParallel.append(ii[:-1])
            os.system('rm '+self.caseDir+'/system/settings/resultParallel')

        results=[resultSerial,resultParallel]
        return results
    #-----------------------------------------------------------------------------------------------------
    def clearResult(self,times,mode):
        # mode=1 : include parallel / # mode=0 : serial only / # times : list of time folder
        if mode=='0':
            for ii in times:os.system('rm -r '+self.caseDir+'/'+ii)
        else:
            for ii in times:os.system('rm -r '+self.caseDir+'/'+ii)
            procs=glob.glob(self.caseDir+'/processor*')
            for jj in procs:
        	for kk in times:os.system('rm -r '+jj+'/'+kk)
    #-----------------------------------------------------------------------------------------------------
    def clearParallel(self):
        aa=glob.glob(self.caseDir+'/processor*')
        if len(aa)!=0:
            os.system('rm -r '+self.caseDir+'/processor*')	
    #-----------------------------------------------------------------------------------------------------
    def Umag(self,mainwindow):

        def closethis(widget):
            mwin.destroy()
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')
            
        def applythis(widget):
            time=timeEntry.get_text();stime=stimeEntry.get_text();etime=etimeEntry.get_text()
            nozero=nozeroCB.get_active()
            if nozero==0:
                if self.selmethod=='All':os.system('foamCalc mag U -case '+self.caseDir)
                elif self.selmethod=='latestTime':os.system('foamCalc mag U -latestTime -case '+self.caseDir)
        	elif self.selmethod=='Time':os.system('foamCalc mag U -time '+time+' -case '+self.caseDir)
        	elif self.selmethod=='Time Range':os.system('foamCalc mag U -time '+stime+':'+etime+' -case '+self.caseDir)
            else:
                if self.selmethod=='All':os.system('foamCalc mag U -noZero -case '+self.caseDir)
                elif self.selmethod=='latestTime':os.system('foamCalc mag U -noZero -latestTime -case '+self.caseDir)
        	elif self.selmethod=='Time':os.system('foamCalc mag U -noZero -time '+time+' -case '+self.caseDir)
        	elif self.selmethod=='Time Range':os.system('foamCalc mag U -noZero -time '+stime+':'+etime+' -case '+self.caseDir)
            mwin.destroy()
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')
            
        def toggled(widget):
            aa=widget.child;self.selmethod=aa.get_text()
            if self.selmethod=='All':
                timeEntry.set_sensitive(0);stimeEntry.set_sensitive(0);etimeEntry.set_sensitive(0)
            elif self.selmethod=='latestTime':
                timeEntry.set_sensitive(0);stimeEntry.set_sensitive(0);etimeEntry.set_sensitive(0)
            elif self.selmethod=='Time':
                timeEntry.set_sensitive(1);stimeEntry.set_sensitive(0);etimeEntry.set_sensitive(0)
            elif self.selmethod=='Time Range':
                timeEntry.set_sensitive(0);stimeEntry.set_sensitive(1);etimeEntry.set_sensitive(1)

        if self.subWindowOpened()==False: 
        
            self.selmethod='All'

            mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
            mwin.set_title('magU');mwin.set_position(gtk.WIN_POS_CENTER);mwin.set_transient_for(mainwindow)
            mwin.connect("delete_event", self.delete_event)
            mainbox=gtk.VBox(False,0);mwin.add(mainbox)

            frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN)
            frame.set_label('    Select time to create magU    ');frame.set_label_align(0.1, 0.5)
            mainbox.pack_start(frame,True,True,5)

            box1=gtk.VBox(False,5);frame.add(box1)

            but0=gtk.RadioButton(None,'All');but0.connect('toggled',toggled)
            hbox0=gtk.HBox(False,5);box1.pack_start(hbox0,False,False,5)
            hbox0.pack_start(but0,False,False,5)

            but1=gtk.RadioButton(but0,'latestTime');but1.connect('toggled',toggled)
            hbox1=gtk.HBox(False,5);box1.pack_start(hbox1,False,False,5)
            hbox1.pack_start(but1,False,False,5)

            but2=gtk.RadioButton(but0,'Time');but2.set_size_request(120,28);but2.connect('toggled',toggled)
            timeEntry=gtk.Entry();timeEntry.set_size_request(60,28)
            hbox2=gtk.HBox(False,5);box1.pack_start(hbox2,False,False,5)
            hbox2.pack_start(but2,False,False,5);hbox2.pack_start(timeEntry,False,False,5)

            but3=gtk.RadioButton(but0,'Time Range');but3.set_size_request(120,28);but3.connect('toggled',toggled)
            stimeEntry=gtk.Entry();stimeEntry.set_size_request(60,28)
            label=gtk.Label('~')
            etimeEntry=gtk.Entry();etimeEntry.set_size_request(60,28)
            hbox3=gtk.HBox(False,5);box1.pack_start(hbox3,False,False,5)
            hbox3.pack_start(but3,False,False,5);hbox3.pack_start(stimeEntry,False,False,5)
            hbox3.pack_start(label,False,False,5);hbox3.pack_start(etimeEntry,False,False,5)

            nozeroCB=gtk.CheckButton('noZero Option')
            hbox4=gtk.HBox(False,5);box1.pack_start(hbox4,False,False,5)
            hbox4.pack_start(nozeroCB,False,False,5)

            box2=gtk.HBox(False,5);mainbox.pack_start(box2,False,False,5)
            appB=gtk.Button('Apply');closeB=gtk.Button('Close')
            appB.set_size_request(100,28);closeB.set_size_request(100,28)
            appB.connect('clicked',applythis);closeB.connect('clicked',closethis)
            box2.pack_end(closeB,False,False,5);box2.pack_end(appB,False,False,5)

            mwin.show_all()	
            
            f=open(self.caseDir+'/system/settings/openSubWindow','w');f.close()
    #-----------------------------------------------------------------------------------------------------
    def makeDictFromFile(self,fileName):
        dictionary={}
        aa=glob.glob(fileName)
        if len(aa)!=0:            
            f=open(fileName,'r');ff=f.readlines();f.close()
            for i in range(len(ff)):               
                bb=ff[i][:-1].split(';')
                if len(bb)==2:dictionary[bb[0]]=bb[1]            
        else:
            message='"makeDictFromFile" function error! \n"'+fileName+'" is not exist'
            md = gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, message)
            md.run();md.destroy()          
        return dictionary
    #-----------------------------------------------------------------------------------------------------
    def isThereInList(self,List,string):
        newlist=[]
        for ii in List:newlist.append(ii)
        newlist.append(string)
        if newlist.count(string)==1:answer='false'
        else:answer='true'
        return answer        
    #-----------------------------------------------------------------------------
    def savestop(self):
        f=open(self.caseDir+'/system/controlDict','r');ff=f.readlines();f.close()
        for i in range(len(ff)):
            if ff[i][:6]=='stopAt':ff[i]='stopAt          writeNow;\n'
        f=open(self.caseDir+'/system/controlDict','w');
        for jj in ff:f.write(jj)
        f.close()        
    #-----------------------------------------------------------------------------
    def isNumber(self,string):
        try:
            float(string)
            return True
        except ValueError:
            return False    
    #-----------------------------------------------------------------------------
    def helpdialog(self,image,mainwindow):
        def closethis(widget):win.destroy()        
        win=gtk.Window(gtk.WINDOW_TOPLEVEL);win.set_title('Help');win.set_border_width(5);win.set_position(gtk.WIN_POS_CENTER)
        win.set_transient_for(mainwindow)
        mbox=gtk.VBox(False,0);win.add(mbox)
        pic=gtk.Image();pic.set_from_file(image);mbox.pack_start(pic,False,False,0)            
        clsB=gtk.Button('Close');clsB.set_size_request(100,28);clsB.connect('clicked',closethis)
        mbox.pack_end(clsB,False,False,5)
        win.show_all()    
    #-----------------------------------------------------------------------------        
    def getDomainRange(self):
        #aa=glob.glob(self.caseDir+'/logfiles/log.checkMesh')
        #if len(aa)==0:os.system('checkMesh -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.checkMesh')
        os.system('checkMesh -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.checkMesh')            
        f=open(self.caseDir+'/logfiles/log.checkMesh','r');ff=f.readlines();f.close()
        for ii in ff:
            if ii!='\n':
                aa=ii.split()
                if aa[0]=='Overall':
                    if aa[1]=='domain':
                        Xmin=aa[4][1:];Ymin=aa[5];Zmin=aa[6][:-1]
                        Xmax=aa[7][1:];Ymax=aa[8];Zmax=aa[9][:-1]
        domainMin=[Xmin,Ymin,Zmin];domainMax=[Xmax,Ymax,Zmax]
        return [domainMin,domainMax] 
    #-----------------------------------------------------------------------------        
    def getSTLRange(self,stlfile):
        #aa=glob.glob(self.caseDir+'/logfiles/log.surfaceCheck')
        #if len(aa)==0:os.system('surfaceCheck '+stlfile+' > '+self.caseDir+'/logfiles/log.surfaceCheck')
        os.system('surfaceCheck '+stlfile+' > '+self.caseDir+'/logfiles/log.surfaceCheck')            
        f=open(self.caseDir+'/logfiles/log.surfaceCheck','r');ff=f.readlines();f.close()
        
        Xmin='none'        
        for ii in ff:
            if ii[:12]=='Bounding Box':
                aa=ii.split()
                Xmin=aa[3][1:];Ymin=aa[4];Zmin=aa[5][:-1]
                Xmax=aa[6][1:];Ymax=aa[7];Zmax=aa[8][:-1]
                
        if Xmin=='none':
            self.makeDialog('Error in surfaceCheck...')
            return
        else:
            domainMin=[Xmin,Ymin,Zmin];domainMax=[Xmax,Ymax,Zmax]
            return [domainMin,domainMax]               
    #-----------------------------------------------------------------------------        
    def messagebox(self,message):
        md=gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_CLOSE,message)
        md.run();md.destroy()  
    #-----------------------------------------------------------------------------        
    def advancedRANS(self,RANSModel,dic):    
        kk=dic.keys()
        if len(kk)>3:    
            if RANSModel=='kEpsilon':
                keys=['Cmu','C1','C2','sigmaEps']
                values=[dic['sKECmu'],dic['sKEC1'],dic['sKEC2'],dic['sKESigmaEps']]
            elif RANSModel=='realizableKE':
                keys=['sigmak','Cmu','C2','sigmaEps','A0']
                values=[dic['rKESigmak'],dic['rKECmu'],dic['rKEC2'],dic['rKESigmaEps'],dic['rKEA0']]
            elif RANSModel=='RNGKE':
                keys=['eta0','sigmak','Cmu','C1','C2','beta','sigmaEps']
                values=[dic['RNGKEEta0'],dic['RNGKESigmak'],dic['RNGKECmu'],dic['RNGKEC1'],dic['RNGKEC2'],dic['RNGKEBeta'],dic['RNGKESigmaEps']]
            elif RANSModel=='kOmega':
                keys=['Cmu','beta','alphak','alphaOmega','alpha']
                values=[dic['kOCmu'],dic['kOBeta'],dic['kOAlphaK'],dic['kOAlphaOmega'],dic['kOAlpha']]
            elif RANSModel=='kOmegaSST':
                keys=['beta1','beta2','c1','F3','betaStar','b1','alphaOmega1','gamma2','a1','alphaOmega2','gamma1','alphak2','alphak1']
                values=[dic['SSTBeta1'],dic['SSTBeta2'],dic['SSTC1'],dic['SSTF3'],dic['SSTBetaStar'],dic['SSTB1'],dic['SSTAlphaOmega1'],dic['SSTGamma2'],dic['SSTA1'],
                        dic['SSTAlphaOmega2'],dic['SSTGamma1'],dic['SSTAlphaK2'],dic['SSTAlphaK1']]
            elif RANSModel=='SpalartAllmaras':
                keys=['kappa','Cv2','Cw2','Cv1','Cw3','Cb2','Cb1','sigmaNut']
                values=[dic['SAKappa'],dic['SACv2'],dic['SACw2'],dic['SACv1'],dic['SACw3'],dic['SACb2'],dic['SACb1'],dic['SASigmaNut']]
        
            advDict={}
            for i in range(len(keys)):advDict[keys[i]]=values[i]
        else:
            advDict={}
        return advDict
    #-----------------------------------------------------------------------------        
    def advancedLES(self,LESModel,dic):    
        Smagorinsky={}
        Smagorinsky['ce']=dic['smagoCe']
        Smagorinsky['ck']=dic['smagoCk']
        cubeRootVol={}
        cubeRootVol['deltaCoeff']='1.0'
        oneEqEddy={}
        oneEqEddy['ce']=dic['oneCe']
        oneEqEddy['ck']=dic['oneCk']
        maxDeltaxyz={}
        maxDeltaxyz['deltaCoeff']='1.0'
        SpalartAllmaras={}
        SpalartAllmaras['kappa']=dic['SAleskappa']
        SpalartAllmaras['Cv2']=dic['SAlesCv2']
        SpalartAllmaras['Cw2']=dic['SAlesCw2']
        SpalartAllmaras['Cv1']=dic['SAlesCv1']
        SpalartAllmaras['Cw3']=dic['SAlesCw3']
        SpalartAllmaras['Cb2']=dic['SAlesCb2']
        SpalartAllmaras['Cb1']=dic['SAlesCb1']
        SpalartAllmaras['sigmaNut']=dic['SAlesSigmaNut']
        homogeneousDynOneEqEddy={}
        homogeneousDynOneEqEddy['ce']=dic['homoCe']
        homogeneousDynOneEqEddy['filter']=dic['homoFilter']
        
        advDictList=[Smagorinsky,cubeRootVol,oneEqEddy,maxDeltaxyz,SpalartAllmaras,homogeneousDynOneEqEddy]
        return advDictList
    #-----------------------------------------------------------------------------        
    def tailboxMessage(self,tvbox,message,window): 
        aa=tvbox.get_children()
        for ii in aa:tvbox.remove(ii)
        label=gtk.Label()
        label.set_markup('<span color="blue">   '+message+'</span>')
        label.set_alignment(0,0.5)
        tvbox.pack_start(label,False,False,5)
        window.show_all()
    #-----------------------------------------------------------------------------        
    def oriTailboxMessage(self,tvbox,window,caseDir): 
        aa=tvbox.get_children()
        for ii in aa:tvbox.remove(ii)
        label=gtk.Label(caseDir);label.set_alignment(0,0.5)
        tvbox.pack_start(label,False,False,5)
        window.show_all()               
    #-----------------------------------------------------------------------------        
    def makeDialog(self,text):
        md=gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, text)
        md.run();md.destroy()
    #-------------------------------------------------------------------------------------
    def showCheckMesh(self,mainwindow):
        def closethis(widget):mwin.destroy()

        aa=glob.glob(self.caseDir+'/checkMeshResult')
        if len(aa)!=0:
            mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
            mwin.set_title('Mesh Information');mwin.set_position(gtk.WIN_POS_CENTER)
            mwin.set_transient_for(mainwindow)
            mainbox=gtk.VBox(False,0);mwin.add(mainbox)
            hbox=gtk.HBox(False,5);hbox.set_size_request(750,600);mainbox.pack_start(hbox,True,True,5)
            sw=gtk.ScrolledWindow();sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
            textview=gtk.TextView()
            textbuffer=textview.get_buffer()
            sw.add(textview)
            hbox.pack_start(sw,True,True,5)

            f=open(self.caseDir+'/checkMeshResult','r');ff=f.readlines();f.close()
            res=ff[24:-2];string=''
            for ii in res:string=string+ii
            textbuffer.set_text(string)

            buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,5)
            closeB=gtk.Button(label='close');closeB.connect('clicked',closethis);closeB.set_size_request(140,28)
            buttonbox.pack_end(closeB,False,False,5)
            mwin.show_all() 
    #-------------------------------------------------------
    def subWindowOpened(self):    
        aa=glob.glob(self.caseDir+'/system/settings/openSubWindow')
        if len(aa)==0:subwin=False
        else:subwin=True
        return subwin
    #-----------------------------------------------------------------------------------------------------
    def jobStatusCheck(self,mainwindow):

        def closethis(widget):mwin.destroy()

        os.system('bjobs > '+self.caseDir+'/bjobsLog')
        f=open(self.caseDir+'/bjobsLog','r');ff=f.readlines();f.close()

        mwin=gtk.Window(gtk.WINDOW_TOPLEVEL);mwin.set_border_width(10)
        mwin.set_title('Job Control');mwin.set_position(gtk.WIN_POS_CENTER);mwin.set_transient_for(mainwindow)
        mainbox=gtk.VBox(False,0);mwin.add(mainbox)

        swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        mainbox.pack_start(swin,True,True,0);itembox=gtk.VBox(False,0);swin.add_with_viewport(itembox)
        scheight=len(ff)*50
        if scheight > 750:scheight=750
        swin.set_size_request(750,scheight)

        label=gtk.Label('       JOBID    USER    STAT    QUEUE    FROM_HOST    EXEC_HOST    JOB_NAME    SUBMIT_TIME')
        lbox=gtk.HBox(False,5);itembox.pack_start(lbox,False,False,5);lbox.pack_start(label,False,False,5)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);itembox.pack_start(frame,True,True,5)
        box1=gtk.VBox(False,5);frame.add(box1)
        clabel=[]
        for i in range(len(ff)-1):
            clabel.append(gtk.Label(ff[i+1][:-1]))
            box1.pack_start(clabel[i],False,False,5)

        box2=gtk.HBox(False,5);mainbox.pack_start(box2,False,False,5)
        closeB=gtk.Button('Close');closeB.set_size_request(100,28);closeB.connect('clicked',closethis)
        box2.pack_end(closeB,False,False,5)

        mwin.show_all()    
    #--------------------------------------------------------------------------------------  
    def selSTL(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                       (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_select_multiple(True)
        filter = gtk.FileFilter();filter.set_name("stl files")
        filter.add_mime_type("stl/STL");filter.add_mime_type("stl/stl")
        filter.add_pattern("*.STL");filter.add_pattern("*.stl")
        dialog.add_filter(filter)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:stlList=dialog.get_filenames()
        elif response == gtk.RESPONSE_CANCEL:stlList=[]
        dialog.destroy()
        return stlList
    #--------------------------------------------------------------------------------------  
    def mergeSTL(self,stlList):
        f=open(self.caseDir+'/mesh.stl','w')
        for ii in stlList:
            a1=ii.split('/');name=a1[-1][:-4]
            g=open(ii,'r');gg=g.readlines();g.close()
            f.write('solid '+name+'\n')
            for j in range(len(gg)-2):f.write(gg[j+1])
            f.write('endsolid '+name+'\n')
        f.close()                   
    #---------------------------------------------------------------------------------------------------------
    def findSTLRegion(self,stlfilename):
        f=open(stlfilename,'r');ff=f.readlines();f.close()
        regions=[]
        for i in range(len(ff)):
            if (ff[i].strip())[:5]=='solid' or (ff[i].strip())[:5]=='SOLID' or (ff[i].strip())[:5]=='Solid':
                aa=(ff[i].strip())[5:]
                regions.append(aa.strip())
        return regions
    #-----------------------------------------------------------------------------        
    def textbufferMessage(self,textbuffer,message,window): 
        textbuffer.insert_at_cursor(message)
        window.show_all()           
    #-----------------------------------------------------------------------------------------------------
    def isThereFile(self,folder,filename):
        aa=glob.glob(folder+'/'+filename)
        if len(aa)==0:answer=False
        else:answer=True
        return answer   
    #-----------------------------------------------------------------------------------------------------
    def createlog(self,logfile,textbuffer):
        f=open(self.caseDir+'/logfiles/'+logfile,'r');ff=f.readlines();f.close()
        res=ff;string='\n'
        for ii in res:string=string+ii
        string=string+'\n'
        textbuffer.insert_at_cursor(string)
        return textbuffer   
    #-----------------------------------------------------------------------------------------------------
    def checkRun(self):

        os.system('ps > '+self.caseDir+'/system/settings/checkRun')       
        f=open(self.caseDir+'/system/settings/checkRun','r');ff=f.readlines();f.close()
        for i in range(len(ff)):
            a1=ff[i].strip();a2=a1.split(' ')
            if a2[-1]=='simpleNFoam':runningid=a2[0]            
                  
        aa=1
        while aa:
            os.system('rm '+self.caseDir+'/system/settings/checkRun')            
            os.system('ps > '+self.caseDir+'/system/settings/checkRun')            
            time.sleep(10)
            
            g=open(self.caseDir+'/system/settings/checkRun','r');gg=g.readlines();g.close()

            pids=[]
            for i in range(len(gg)):
                b1=gg[i].strip();b2=b1.split(' ')
                pids.append(b2[0])
            
            if self.isThereInList(pids,runningid)=='false':break

        self.makeDialog('Simulation is finished')            
                
                
                
                
                
                
        
        
    
                                         	
