#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for miscellaneous functions
#
# Author
#    NEXTFOAM Inc. 
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *

class miscClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir):
	    self.caseDir=caseDir

    #-------------------------------------------------------------------------------------
    def foamComment(self):
        fc=[]
        fc.append('/*--------------------------------*- C++ -*----------------------------------*\ \n')
        fc.append('| =========                 |                                                 |\n')
        fc.append('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |\n')
        fc.append('|  \\    /   O peration     | Version:  2.3.0                                 |\n')
        fc.append('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      |\n')
        fc.append('|    \\/     M anipulation  |                                                 |\n')
        fc.append('\*---------------------------------------------------------------------------*/\n')	
        return fc
    #------------------------------------------------------------------------------
    def header(self,location,obj):
        he=[]
        he.append('FoamFile\n')
        he.append('{\n')
        he.append('    version     2.0;\n')
        he.append('    format      ascii;\n')
        he.append('    class       dictionary;\n')
        he.append('    location    "'+location+'";\n')
        he.append('    object      '+obj+';\n')
        he.append('}\n')
        he.append('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //\n')
        return he
    #------------------------------------------------------------------------------
    def BCheader(self,classtype,obj):
        he=[]
        he.append('FoamFile\n')
        he.append('{\n')
        he.append('    version     2.0;\n')
        he.append('    format      ascii;\n')
        he.append('    class       '+classtype+';\n')
        he.append('    object      '+obj+';\n')
        he.append('}\n')
        he.append('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //\n')
        return he	    
    #--------------------------------------------------------------------------------------  
    def basicfvsolution(self):
        fcom=self.foamComment();head=self.header('system','fvSolution');hhh=fcom+head
        f=open(self.caseDir+'/system/fvSolution','w')
        for aaa in hhh:f.write(aaa)
        f.write('solvers\n')
        f.write('{\n')
        f.write('    "rho.*"\n')
        f.write('    {\n')
        f.write('        solver          PCG;\n')
        f.write('        preconditioner  DIC;\n')
        f.write('        tolerance       1e-7;\n')
        f.write('        relTol          0;\n')
        f.write('    }\n')
        f.write('    "(p|p_rgh)"\n')
        f.write('    {\n')
       	f.write('        solver                GAMG;\n')
        f.write('        tolerance             1e-7;\n')
        f.write('        relTol                0.1;\n')
        f.write('        minIter               0;\n')
        f.write('        maxIter               50;\n')
        f.write('        smoother              symGaussSeidel;\n')
        f.write('        nPreSweeps            0;\n')
        f.write('        nPostSweeps           2;\n')
        f.write('        cacheAgglomeration    true;\n')
        f.write('        agglomerator          faceAreaPair;\n')
        f.write('        nCellsInCoarsestLevel 10;\n')
        f.write('        mergeLevels           1;\n')
        f.write('    };\n')
        f.write('    "(pFinal|p_rghFinal)"\n')
        f.write('    {\n')
       	f.write('        $p_rgh;\n')
        f.write('        relTol                0;\n')
        f.write('    };\n')
        f.write('    "(U|k|epsilon|omega)"\n')
        f.write('    {\n')
        f.write('        solver          smoothSolver;\n')
        f.write('        smoother        symGaussSeidel;\n')
        f.write('        tolerance       1e-7;\n')
        f.write('        relTol          0.1;\n')
        f.write('    };\n')
        f.write('    "(U|k|epsilon|omega)Final"\n')
        f.write('    {\n')
      	f.write('        $U;\n')
        f.write('        relTol                0;\n')
        f.write('    };\n')
        f.write('    h\n')
        f.write('    {\n')
        f.write('        solver          smoothSolver;\n')
        f.write('        smoother        symGaussSeidel;\n')
        f.write('        tolerance       1e-7;\n')
        f.write('        relTol          0.01;\n')
        f.write('    };\n')
        f.write('    hFinal\n')
        f.write('    {\n')
       	f.write('        $U;\n')
        f.write('        relTol                0;\n')
        f.write('    };\n')
        f.write('}\n')
        f.write('SIMPLE\n')
        f.write('{\n')
        f.write('    nNonOrthogonalCorrectors 0;\n')
        f.write('    pRefCell	0;\n')
        f.write('    pRefValue	0;\n')  
        f.write('    residualControl\n')
        f.write('    {\n')
        f.write('        p      1e-3;\n')
        f.write('        p_rgh  1e-3;\n')        
        f.write('        U      1e-3;\n')
        f.write('        h      1e-3;\n')        
        f.write('        "(k|epsilon|omega)"    1e-3;\n')
        f.write('    }\n')                
        f.write('}\n')
        f.write('PIMPLE\n')
        f.write('{\n')
        f.write('    nNonOrthogonalCorrectors 0;\n')
        f.write('    nOuterCorrectors 1;\n')
        f.write('    nCorrectors 2;\n')
        f.write('    pRefCell	0;\n')
        f.write('    pRefValue	0;\n')        
        f.write('}\n')
        f.write('relaxationFactors\n')
        f.write('{\n')
        f.write('    fields\n')
        f.write('    {\n')
        f.write('        "rho.*"      1.0;\n')
        f.write('        "p.*"        0.3;\n')        
        f.write('    }\n')
        f.write('    equations\n')
        f.write('    {\n')
        f.write('        "(U|k|epsilon|omega).*"    0.7;\n')
        f.write('        "h.*"         1.0;\n')
        f.write('    }\n')
        f.write('}\n')
        f.close()
    #--------------------------------------------------------------------------------------  
    def basicfvschemes(self,solver):
        if solver=='simpleNFoam' or solver=='buoyantSimpleNFoam':transientmode=0
        else:transientmode=1
        
        fcom=self.foamComment();head=self.header('system','fvSchemes');hhh=fcom+head
        f=open(self.caseDir+'/system/fvSchemes','w')
        for aaa in hhh:f.write(aaa)	
        f.write('ddtSchemes\n')
        f.write('{\n')
        if transientmode==0:f.write('    default         steadyState;\n')
        else:f.write('    default         Euler;\n')
        f.write('}\n')
        f.write('gradSchemes\n')
        f.write('{\n')
        f.write('    default         Gauss linear;\n')
        f.write('    limitedGrad     cellLimited Gauss linear 1;\n')
        f.write('}\n')
        f.write('divSchemes\n')
        f.write('{\n')
        f.write('    default	      Gauss linear;\n')
        f.write('    div(phi,U)       bounded Gauss upwind;\n')
        f.write('    div(phi,k)       bounded Gauss upwind;\n')
        f.write('    div(phi,K)       bounded Gauss upwind;\n')
        f.write('    div(phi,epsilon) bounded Gauss upwind;\n')
        f.write('    div(phi,omega)   bounded Gauss upwind;\n')
        f.write('    div(phi,h)       bounded Gauss upwind;\n')
        f.write('}\n')
        f.write('laplacianSchemes\n')
        f.write('{\n')
        f.write('    default         Gauss linear corrected;\n')
        f.write('}\n')
        f.write('interpolationSchemes\n')
        f.write('{\n')
        f.write('    default         linear;\n')
        f.write('}\n')
        f.write('snGradSchemes\n')
        f.write('{\n')
        f.write('    default         corrected;\n')
        f.write('}\n')
        f.write('fluxRequired\n')
        f.write('{\n')
        f.write('    default         no;\n')
        f.write('    p;\n')
        f.write('    p_rgh;\n')
        f.write('    pcorr;\n')
        f.write('}\n')
        f.close()
    #--------------------------------------------------------------------------------------  
    def basiccontroldict(self):
        fcom=self.foamComment();head=self.header('system','controlDict');hhh=fcom+head
        f=open(self.caseDir+'/system/controlDict','w')
        for aaa in hhh:f.write(aaa)	
        f.write('application     simpleFoam;\n')
        f.write('startFrom       latestTime;\n')
        f.write('startTime       0;\n')
        f.write('stopAt          endTime;\n')
        f.write('endTime         10000;\n')
        f.write('deltaT          1;\n')
        f.write('writeControl    runTime;\n')
        f.write('writeInterval   1000;\n')
        f.write('purgeWrite      10;\n')
        f.write('writeFormat     ascii;//binary;\n')
        f.write('writePrecision  6;\n')
        f.write('writeCompression uncompressed;\n')
        f.write('timeFormat      general;\n')
        f.write('timePrecision   6;\n')
        f.write('runTimeModifiable yes;\n')
        f.write('adjustTimeStep no;\n')
        f.write('maxCo 1.0;\n')
        f.write('maxDeltaT 1.0;\n')
        f.close()
    #------------------------------------------------------------------------------
    def UFileBasic(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volVectorField','U');hhh=fcom+head
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/U','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [0 1 -1 0 0 0 0];\n')
        f.write('internalField   uniform (0 0 0);\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':
                f.write('        type    fixedValue;\n')
                f.write('        value   uniform (0 0 0);\n')
            elif bctype[j]=='patch':
                f.write('        type    fixedValue;\n')
                f.write('        value   uniform (0 0 0);\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()
    #------------------------------------------------------------------------------
    def pFileBasic(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','p');hhh=fcom+head
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/p','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [0 2 -2 0 0 0 0];\n')
        f.write('internalField   uniform 0;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':f.write('        type    zeroGradient;\n')
            elif bctype[j]=='patch':
                f.write('        type    fixedValue;\n')
                f.write('        value   uniform 0;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()        
    #------------------------------------------------------------------------------
    def pFileBasicThermo(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','p');hhh=fcom+head
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/p','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [1 -1 -2 0 0 0 0];\n')
        f.write('internalField   uniform 101325;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':
                f.write('        type    calculated;\n')
                f.write('        value   $internalField;\n')
            elif bctype[j]=='patch':
                f.write('        type    calculated;\n')
                f.write('        value   $internalField;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()
    #------------------------------------------------------------------------------
    def p_rghFileBasicThermo(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','p_rgh');hhh=fcom+head
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/p_rgh','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [1 -1 -2 0 0 0 0];\n')
        f.write('internalField   uniform 0;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            #if bctype[j]=='wall' or bctype[j]=='mappedWall':f.write('        type    fixedFluxPressure;\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':f.write('        type    zeroGradient;\n')
            elif bctype[j]=='patch':
                f.write('        type    fixedValue;\n')
                f.write('        value   uniform 0;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()                
    #------------------------------------------------------------------------------
    def tFileBasic(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','T');hhh=fcom+head
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/T','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [0 0 0 1 0 0 0];\n')
        f.write('internalField   uniform 300;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall':f.write('        type    zeroGradient;\n')           
            elif bctype[j]=='patch':f.write('        type    zeroGradient;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            elif bctype[j]=='mappedWall':
                f.write('        type            compressible::turbulentTemperatureCoupledBaffleMixed;\n')
                f.write('        Tnbr            T;\n')
                f.write('        kappa           fluidThermo;\n')
                f.write('        kappaName       none;\n')
                f.write('        value           uniform 300;\n')                               
            f.write('    }\n')
        f.write('}\n')
        f.close()
    #------------------------------------------------------------------------------
    def kFileBasic(self,solver):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','k');hhh=fcom+head        
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/k','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [0 2 -2 0 0 0 0];\n')
        f.write('internalField   uniform 1;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':
                if solver=='simpleNFoam' or solver=='pimpleNFoam':f.write('        type    kqRWallFunction;\n')
                else:f.write('        type    compressible::kqRWallFunction;\n')                
                f.write('        value   $internalField;\n')
            elif bctype[j]=='patch':f.write('        type    zeroGradient;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()        
    #------------------------------------------------------------------------------
    def epsilonFileBasic(self,solver):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','epsilon');hhh=fcom+head
        
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/epsilon','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [0 2 -3 0 0 0 0];\n')
        f.write('internalField   uniform 1;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':
                if solver=='simpleNFoam' or solver=='pimpleNFoam':f.write('        type    epsilonWallFunction;\n')
                else:f.write('        type    compressible::epsilonWallFunction;\n')                
                f.write('        value   $internalField;\n')
            elif bctype[j]=='patch':f.write('        type    zeroGradient;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()        
    #------------------------------------------------------------------------------
    def omegaFileBasic(self,solver):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','omega');hhh=fcom+head
        
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/omega','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [0 0 -1 0 0 0 0];\n')
        f.write('internalField   uniform 1;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':
                if solver=='simpleNFoam' or solver=='pimpleNFoam':f.write('        type    omegaWallFunction;\n')
                else:f.write('        type    compressible::omegaWallFunction;\n')                
                f.write('        value   $internalField;\n')
            elif bctype[j]=='patch':f.write('        type    zeroGradient;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close() 
    #------------------------------------------------------------------------------
    def nutFileBasic(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','nut');hhh=fcom+head
        
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/nut','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [0 2 -1 0 0 0 0];\n')
        f.write('internalField   uniform 0;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':
                f.write('        type    nutStdWallFunction;\n')
                f.write('        value   $internalField;\n')
            elif bctype[j]=='patch':f.write('        type    calculated;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()  
    #------------------------------------------------------------------------------
    def mutFileBasic(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','mut');hhh=fcom+head
        
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/mut','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [1 -1 -1 0 0 0 0];\n')
        f.write('internalField   uniform 0;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':
                f.write('        type    mutkWallFunction;\n')
                f.write('        value   $internalField;\n')
            elif bctype[j]=='patch':f.write('        type    calculated;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()   
    #------------------------------------------------------------------------------
    def alphatFileBasic(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','alphat');hhh=fcom+head
        
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/alphat','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [1 -1 -1 0 0 0 0];\n')
        f.write('internalField   uniform 0;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':
                f.write('        type    compressible::alphatJayatillekeWallFunction;\n')
                f.write('        value   $internalField;\n')
            elif bctype[j]=='patch':f.write('        type    calculated;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()                           
    #------------------------------------------------------------------------------
    def fvSchemes_change_ddt(self,solver):
    
        if solver=='simpleNFoam' or solver=='buoyantSimpleNFoam':sline='    default        steadyState;\n'
        else:sline='    default        Euler;\n'    
        
        f=open(self.caseDir+'/system/fvSchemes','r');ff=f.readlines();f.close()
        for i in range(len(ff)):
            ll=ff[i].strip()
            if ll[:10]=='ddtSchemes':linenumber=i+2
            
        ff[linenumber]=sline
        
        f=open(self.caseDir+'/system/fvSchemes','w')
        for ii in ff:f.write(ii)
        f.close()
        
        

        
        
        
    
    
