#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for cellZone conditions
#
# Author
#    NEXTFOAM Inc.
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *
from boundaryConditionSub import *
from writeFileSub import *

class freepanelCellZoneClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow,solver,installpath):
        self.caseDir=caseDir
        self.solver=solver
        self.mainwindow=mainwindow
        self.installpath=installpath

    def cellZone(self,notebook,textbuffer):
        self.cellzonebox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('<b>  Cell zone Conditions  </b>')
        ebox=gtk.EventBox();self.cellzonebox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label)

        #separator=gtk.HSeparator();separator.set_size_request(285,5);self.cellzonebox.pack_start(separator,False,True,10)

        hbox=gtk.HBox(False,5);self.cellzonebox.pack_start(hbox,False,False,5)
        swin=gtk.ScrolledWindow();swin.set_border_width(0);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        hbox.pack_start(swin,True,True,0);itembox=gtk.VBox(False,0);swin.add_with_viewport(itembox)
        swin.set_size_request(200,150)

        GEN=generalClass(self.caseDir);cellzones=GEN.getCellZones()
        
        def cellzoneset(widget,i):
            namezone=self.zoneName[i].get_text()
            aa=self.zoneType[i].child;typezone=aa.get_text()            
            if typezone=='MRF':self.openMRF(namezone,typezone,cellsetvbox,self.cellzonebox,notebook,textbuffer)
            elif typezone=='Porous':self.openPorous(namezone,typezone,cellsetvbox,self.cellzonebox,notebook,textbuffer)
            elif typezone=='Fixed.U':self.openFixedU(namezone,typezone,cellsetvbox,self.cellzonebox,notebook,textbuffer)
            elif typezone=='None':self.openNone(namezone,typezone,cellsetvbox,self.cellzonebox,notebook,textbuffer)
            
        def chzonetype(widget,i):
            namezone=self.zoneName[i].get_text()
            aa=self.zoneType[i].child;typezone=aa.get_text()            
            if typezone=='MRF':self.openMRF(namezone,typezone,cellsetvbox,self.cellzonebox,notebook,textbuffer)
            elif typezone=='Porous':self.openPorous(namezone,typezone,cellsetvbox,self.cellzonebox,notebook,textbuffer)
            elif typezone=='Fixed.U':self.openFixedU(namezone,typezone,cellsetvbox,self.cellzonebox,notebook,textbuffer)
            elif typezone=='None':self.openNone(namezone,typezone,cellsetvbox,self.cellzonebox,notebook,textbuffer)            

        cellsetvbox=gtk.VBox(False,5);self.cellzonebox.pack_start(cellsetvbox,False,False,5)
        
        self.zoneName=[];self.zoneType=[];self.zoneSet=[];hbox=[]
        for i in range(len(cellzones)):
            hbox.append(gtk.HBox(False,2));itembox.pack_start(hbox[i],False,False,2)                
            self.zoneName.append(gtk.Entry());self.zoneName[i].set_size_request(100,28)
            self.zoneName[i].set_text(cellzones[i]);self.zoneName[i].set_editable(0);self.zoneName[i].set_has_frame(0)
            self.zoneType.append(gtk.combo_box_entry_new_text())
            self.zoneType[i].set_size_request(100,28)
            self.zoneTypeList=['None','Porous','MRF','Fixed.U']
            for jj in self.zoneTypeList:self.zoneType[i].append_text(jj)
            self.zoneType[i].set_active(0)
            
            self.zoneType[i].connect('changed',chzonetype,i)
            
            self.zoneSet.append(gtk.Button('Set'));self.zoneSet[i].set_size_request(60,28);self.zoneSet[i].connect('clicked',cellzoneset,i)
            hbox[i].pack_start(self.zoneName[i],True,True,0);hbox[i].pack_start(self.zoneType[i],False,False,0)
            hbox[i].pack_start(self.zoneSet[i],False,False,0)
            
            aa=glob.glob(self.caseDir+'/system/settings/cellZoneConditions:'+cellzones[i]+':*')
            if len(aa)!=0:
                bb=aa[0].split(':');celltype=bb[-1]
                self.zoneType[i].set_active(self.zoneTypeList.index(celltype))

        return self.cellzonebox        
    #--------------------------------------------------------------------------------------  
    def openMRF(self,namezone,typezone,cellsetvbox,cellzonebox,notebook,textbuffer):
        
        GEN=generalClass(self.caseDir);WFILE=writeFileClass(self.caseDir)

        def appmrf(widget):
            norot=[]
            for i in range(len(setName)):
                if setName[i].get_active()==1:norot.append(bcname[i])
            norotstr=''
            for ii in norot:norotstr=ii+' '+norotstr
            norotstr=norotstr[:-1]            
            cellZoneDict={}
            cellZoneDict['cellZoneName']=namezone;cellZoneDict['cellZoneType']=typezone
            cellZoneDict['orix']=orixEntry.get_text()
            cellZoneDict['oriy']=oriyEntry.get_text()
            cellZoneDict['oriz']=orizEntry.get_text()
            aa=eCombo.child;cellZoneDict['axis']=aa.get_text()            
            cellZoneDict['rpm']=rpmEntry.get_text()
            cellZoneDict['nonRotPatchList']=norotstr                        
            if hsourceCheck.get_active()==1:cellZoneDict['energySourceOnOff']='true'
            else:cellZoneDict['energySourceOnOff']='false'
            aa=cellCombo.child;cellZoneDict['eSourceMethod']=aa.get_text()            
            cellZoneDict['eSource']=mrfhsourceEntry.get_text()
            
            if GEN.isNumber(cellZoneDict['orix'])==False:GEN.makeDialog('Error!!! x-ori is not number')                        
            if GEN.isNumber(cellZoneDict['oriy'])==False:GEN.makeDialog('Error!!! y-ori is not number')
            if GEN.isNumber(cellZoneDict['oriz'])==False:GEN.makeDialog('Error!!! z-ori is not number')                                    
            if GEN.isNumber(cellZoneDict['rpm'])==False:GEN.makeDialog('Error!!! rpm is not number')                                    
            if GEN.isNumber(cellZoneDict['eSource'])==False:GEN.makeDialog('Error!!! Energy source is not number') 
                       
            aa=glob.glob(self.caseDir+'/system/settings/cellZoneConditions:'+namezone+':*')
            if len(aa)!=0:os.system('rm '+aa[0])
                        
            keys=cellZoneDict.keys()
            f=open(self.caseDir+'/system/settings/cellZoneConditions:'+namezone+':'+typezone,'w')
            for ii in keys:f.write(ii+';'+cellZoneDict[ii]+'\n')
            f.close()
            
            aa=glob.glob(self.caseDir+'/system/cellZoneConditions:'+namezone+':*')
            if len(aa)!=0:
                for ii in aa:os.system('rm '+ii)
            WFILE.mrfFile(cellZoneDict)

            message='\n [  MRF setup for "'+namezone+'" is saved  ]\n'
            message=message+'\n    - Origin is ( '+cellZoneDict['orix']+' '+cellZoneDict['oriy']+' '+cellZoneDict['oriz']+' )\n'
            message=message+'\n    - Axis is '+cellZoneDict['axis']+'\n'
            message=message+'\n    - RPM is '+cellZoneDict['rpm']+'\n'
            message=message+'\n    - nonRotating Patches are '+norotstr+'\n'
            if hsourceCheck.get_active()==1:
                message=message+'\n    - Energy source method is '+cellZoneDict['eSourceMethod']+'\n'
                message=message+'\n    - Energy source is '+cellZoneDict['eSource']+'\n'
             
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            notebook.set_current_page(0) 
                        
        def MRFSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/cellZoneConditions:'+namezone+':'+typezone)
            if len(aa)!=0:
                dic=GEN.makeDictFromFile(aa[0])
                orixEntry.set_text(dic['orix']);oriyEntry.set_text(dic['oriy']);orizEntry.set_text(dic['oriz'])
                eCombo.set_active(axisList.index(dic['axis']));rpmEntry.set_text(dic['rpm'])                
                norotstrlist=dic['nonRotPatchList'].split(' ')                
                for i in range(len(setName)):
                    inlist=GEN.isThereInList(norotstrlist,bcname[i])
                    if inlist=='true':setName[i].set_active(1)
                    elif inlist=='false':setName[i].set_active(0)                                
                if dic['energySourceOnOff']=='true':hsourceCheck.set_active(1)
                else:hsourceCheck.set_active(0)                
                cellCombo.set_active(methods.index(dic['eSourceMethod']))
                mrfhsourceEntry.set_text(dic['eSource'])      
            
        MRFbox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('MRF condition of <b> "'+namezone+'" </b> zone')        
        hbox=gtk.HBox(False,5);hbox.pack_start(label,False,False,5);MRFbox.pack_start(hbox,False,False,5)

        label=gtk.Label('Origin')
        orixEntry=gtk.Entry();orixEntry.set_size_request(55,28);orixEntry.set_text('0')
        oriyEntry=gtk.Entry();oriyEntry.set_size_request(55,28);oriyEntry.set_text('0')
        orizEntry=gtk.Entry();orizEntry.set_size_request(55,28);orizEntry.set_text('0')
        hbox=gtk.HBox(False,5);MRFbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(orizEntry,False,False,2);hbox.pack_end(oriyEntry,False,False,0);hbox.pack_end(orixEntry,False,False,2)
        label=gtk.Label('Axis')
        eCombo=gtk.combo_box_entry_new_text();eCombo.set_size_request(80,28)
        axisList=['x','y','z','-x','-y','-z']
        for ii in axisList:eCombo.append_text(ii)
        eCombo.set_active(2)
        hbox=gtk.HBox(False,5);MRFbox.pack_start(hbox,False,False,2);hbox.pack_start(label,False,False,5);hbox.pack_end(eCombo,False,False,5)
        label=gtk.Label('RPM')
        rpmEntry=gtk.Entry();rpmEntry.set_size_request(80,28);rpmEntry.set_text('100')
        hbox=gtk.HBox(False,5);MRFbox.pack_start(hbox,False,False,2);hbox.pack_start(label,False,False,5);hbox.pack_end(rpmEntry,False,False,5)
        nonframe=gtk.Frame();nonframe.set_label('  Select nonRotatingPatches  ');nonframe.set_label_align(0.1, 0.5)
        nonframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);MRFbox.pack_start(nonframe,True,True,5)
        patchbox=gtk.VBox(False,5);nonframe.add(patchbox)

        aa=glob.glob(self.caseDir+'/constant/polyMesh')
        if len(aa)!=0:bcname=GEN.getBCName()
        else:bcname=[]

        mrfswin=gtk.ScrolledWindow();mrfswin.set_border_width(5);mrfswin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        patchbox.pack_start(mrfswin,True,True,5);self.mrfitembox=gtk.VBox(False,0);mrfswin.add_with_viewport(self.mrfitembox);mrfswin.set_size_request(150,200)
        setName=[]
        for i in range(len(bcname)):
            self.nonrotbox=gtk.HBox(False,5);self.mrfitembox.pack_start(self.nonrotbox,False,False,2)                
            setName.append(gtk.CheckButton(bcname[i]));setName[i].set_size_request(180,28)
            self.nonrotbox.pack_start(setName[i],False,False,0)

        def checkhsourceMRF(widget):
            aa=mrfhsourcebox.get_children()
            for ii in aa:mrfhsourcebox.remove(ii)
            if widget.get_active()==True:
                mrfhsourcebox.pack_start(mrfmethodhbox,False,False,0);mrfhsourcebox.pack_start(mrfsourcehbox,False,False,0)
            self.cellzonebox.show_all()

        hbox=gtk.HBox(False,5);MRFbox.pack_start(hbox,False,False,5)
        hsourceCheck=gtk.CheckButton('Energy source');hbox.pack_start(hsourceCheck,False,False,5)
        hsourceCheck.connect('toggled',checkhsourceMRF)
        mrfhsourcebox=gtk.VBox(False,5);MRFbox.pack_start(mrfhsourcebox,False,False,0)
        label=gtk.Label('	Method')
        cellCombo=gtk.combo_box_entry_new_text();cellCombo.set_size_request(120,28)
        methods=['specific','absolute','fixed.T']
        for ii in methods:cellCombo.append_text(ii)
        cellCombo.set_active(0)
        mrfmethodhbox=gtk.HBox(False,5);mrfmethodhbox.pack_start(label,False,False,5);mrfmethodhbox.pack_end(cellCombo,False,False,5)
        label=gtk.Label('	Source')
        mrfhsourceEntry=gtk.Entry();mrfhsourceEntry.set_size_request(120,28);mrfhsourceEntry.set_text('300')
        mrfsourcehbox=gtk.HBox(False,5);mrfsourcehbox.pack_start(label,False,False,5);mrfsourcehbox.pack_end(mrfhsourceEntry,False,False,5)

        hbox=gtk.HBox(False,5);MRFbox.pack_start(hbox,False,False,5)
        MRFAppB=gtk.Button('Apply');MRFAppB.set_size_request(120,28);MRFAppB.connect('clicked',appmrf)
        hbox.pack_end(MRFAppB,True,True,5)                
        
        aa=cellsetvbox.get_children()
        for ii in aa:cellsetvbox.remove(ii)
        cellsetvbox.pack_start(MRFbox,False,False,5)
                
        MRFSavedValue()
        
        if self.solver=='simpleNFoam' or self.solver=='pimpleNFoam':hsourceCheck.set_sensitive(0)
        
        cellzonebox.show_all()
    #--------------------------------------------------------------------------------------  
    def openPorous(self,namezone,typezone,cellsetvbox,cellzonebox,notebook,textbuffer):
    
        GEN=generalClass(self.caseDir);WFILE=writeFileClass(self.caseDir)

        def appporous(widget):
            cellZoneDict={}
            cellZoneDict['cellZoneName']=namezone;cellZoneDict['cellZoneType']=typezone
            cellZoneDict['xDarcy']=alphaXEntry.get_text()
            cellZoneDict['yDarcy']=alphaYEntry.get_text()
            cellZoneDict['zDarcy']=alphaZEntry.get_text()
            cellZoneDict['xForch']=betaXEntry.get_text()
            cellZoneDict['yForch']=betaYEntry.get_text()
            cellZoneDict['zForch']=betaZEntry.get_text()
            cellZoneDict['e1x']=e1XEntry.get_text()
            cellZoneDict['e1y']=e1YEntry.get_text()
            cellZoneDict['e1z']=e1ZEntry.get_text()
            cellZoneDict['e2x']=e2XEntry.get_text()
            cellZoneDict['e2y']=e2YEntry.get_text()
            cellZoneDict['e2z']=e2ZEntry.get_text()
            cellZoneDict['porousType']=porousCombo.child.get_text()
            cellZoneDict['powerC0']=powerc0Entry.get_text()
            cellZoneDict['powerC1']=powerc1Entry.get_text()
            if hsourceCheck.get_active()==1:cellZoneDict['energySourceOnOff']='true'
            else:cellZoneDict['energySourceOnOff']='false'
            aa=cellCombo.child;cellZoneDict['eSourceMethod']=aa.get_text()            
            cellZoneDict['eSource']=poroushsourceEntry.get_text()

            if GEN.isNumber(cellZoneDict['xDarcy'])==False:GEN.makeDialog('Error!!! xDarcy is not number')              
            if GEN.isNumber(cellZoneDict['yDarcy'])==False:GEN.makeDialog('Error!!! yDarcy is not number')            
            if GEN.isNumber(cellZoneDict['zDarcy'])==False:GEN.makeDialog('Error!!! zDarcy is not number')            
            if GEN.isNumber(cellZoneDict['xForch'])==False:GEN.makeDialog('Error!!! xForch is not number')            
            if GEN.isNumber(cellZoneDict['yForch'])==False:GEN.makeDialog('Error!!! yForch is not number')            
            if GEN.isNumber(cellZoneDict['zForch'])==False:GEN.makeDialog('Error!!! zForch is not number')            
            if GEN.isNumber(cellZoneDict['e1x'])==False:GEN.makeDialog('Error!!! e1x is not number')            
            if GEN.isNumber(cellZoneDict['e1y'])==False:GEN.makeDialog('Error!!! e1y is not number')            
            if GEN.isNumber(cellZoneDict['e1z'])==False:GEN.makeDialog('Error!!! e1z is not number')            
            if GEN.isNumber(cellZoneDict['e2x'])==False:GEN.makeDialog('Error!!! e2x is not number')            
            if GEN.isNumber(cellZoneDict['e2y'])==False:GEN.makeDialog('Error!!! e2y is not number')            
            if GEN.isNumber(cellZoneDict['e2z'])==False:GEN.makeDialog('Error!!! e2z is not number')                        
            if GEN.isNumber(cellZoneDict['powerC0'])==False:GEN.makeDialog('Error!!! powerC0 is not number')                        
            if GEN.isNumber(cellZoneDict['powerC1'])==False:GEN.makeDialog('Error!!! powerC1 is not number')                                    
            if GEN.isNumber(cellZoneDict['eSource'])==False:GEN.makeDialog('Error!!! Energy source is not number')
            
            aa=glob.glob(self.caseDir+'/system/settings/cellZoneConditions:'+namezone+':*')
            if len(aa)!=0:os.system('rm '+aa[0])
            
            keys=cellZoneDict.keys()
            f=open(self.caseDir+'/system/settings/cellZoneConditions:'+namezone+':'+typezone,'w')
            for ii in keys:f.write(ii+';'+cellZoneDict[ii]+'\n')
            f.close()
            
            aa=glob.glob(self.caseDir+'/system/cellZoneConditions:'+namezone+':*')
            if len(aa)!=0:
                for ii in aa:os.system('rm '+ii)            
            WFILE.porousFile(cellZoneDict)
            
            message='\n [  Porous setup for "'+namezone+'" is saved  ]\n'         
            message=message+'\n    - Direction vector e1 is ( '+cellZoneDict['e1x']+' '+cellZoneDict['e1y']+' '+cellZoneDict['e1z']+' )\n'
            message=message+'\n    - Direction vector e2 is ( '+cellZoneDict['e2x']+' '+cellZoneDict['e2y']+' '+cellZoneDict['e2z']+' )\n'
            if cellZoneDict['porousType']=='DarcyForchheimer':            
                message=message+'\n    - Darcy coeff. d is ( '+cellZoneDict['xDarcy']+' '+cellZoneDict['yDarcy']+' '+cellZoneDict['zDarcy']+' )\n'
                message=message+'\n    - Forchheimer coeff. f is ( '+cellZoneDict['xForch']+' '+cellZoneDict['yForch']+' '+cellZoneDict['zForch']+' )\n'
            else:            
                message=message+'\n    - C0 is '+cellZoneDict['powerC0']+'\n'
                message=message+'\n    - C1 is '+cellZoneDict['powerC1']+'\n'
            if hsourceCheck.get_active()==1:
                message=message+'\n    - Energy source method is '+cellZoneDict['eSourceMethod']+'\n'
                message=message+'\n    - Energy source is '+cellZoneDict['eSource']+'\n'
                            
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            notebook.set_current_page(0) 
                        
        def porousSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/cellZoneConditions:'+namezone+':'+typezone)
            if len(aa)!=0:
                dic=GEN.makeDictFromFile(aa[0])
                alphaXEntry.set_text(dic['xDarcy']);alphaYEntry.set_text(dic['yDarcy']);alphaZEntry.set_text(dic['zDarcy'])
                betaXEntry.set_text(dic['xForch']);betaYEntry.set_text(dic['yForch']);betaZEntry.set_text(dic['zForch'])
                e1XEntry.set_text(dic['e1x']);e1YEntry.set_text(dic['e1y']);e1ZEntry.set_text(dic['e1z'])
                e2XEntry.set_text(dic['e2x']);e2YEntry.set_text(dic['e2y']);e2ZEntry.set_text(dic['e2z'])
                porousCombo.set_active(porousType.index(dic['porousType']))
                powerc0Entry.set_text(dic['powerC0']);powerc1Entry.set_text(dic['powerC1'])
                
                if dic['energySourceOnOff']=='true':hsourceCheck.set_active(1)
                else:hsourceCheck.set_active(0)                
                cellCombo.set_active(methods.index(dic['eSourceMethod']))
                poroushsourceEntry.set_text(dic['eSource'])
                
        def chporous(widget):
            aa=widget.child;potype=aa.get_text()
            bb=poroustypebox.get_children()
            for ii in bb:poroustypebox.remove(ii)
            if potype=='powerLaw':poroustypebox.pack_start(powerbox,False,False,5)
            else:poroustypebox.pack_start(darcybox,False,False,5)
            cellzonebox.show_all()            

        def porousq(widget):
            GEN=generalClass(self.caseDir);GEN.helpdialog(self.installpath+'/pic/cellzone_porous_media.png',self.mainwindow)
                            
        porousbox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('Porous condition of <b> "'+namezone+'" </b> zone') 
        hbox=gtk.HBox(False,5);hbox.pack_start(label,False,False,5);porousbox.pack_start(hbox,False,False,15)
        
        label=gtk.Label('Direction vector');hbox=gtk.HBox(False,5);porousbox.pack_start(hbox,False,False,2);hbox.pack_start(label,False,False,5)	

        label=gtk.Label('	e1');e1XEntry=gtk.Entry();e1YEntry=gtk.Entry();e1ZEntry=gtk.Entry()
        e1XEntry.set_size_request(60,28);e1YEntry.set_size_request(60,28);e1ZEntry.set_size_request(60,28)
        e1XEntry.set_text('1');e1YEntry.set_text('0');e1ZEntry.set_text('0')
        hbox=gtk.HBox(False,5);porousbox.pack_start(hbox,False,False,2)	
        hbox.pack_start(label,False,False,5);hbox.pack_end(e1ZEntry,False,False,2);hbox.pack_end(e1YEntry,False,False,0);hbox.pack_end(e1XEntry,False,False,2)
        label=gtk.Label('	e2');e2XEntry=gtk.Entry();e2YEntry=gtk.Entry();e2ZEntry=gtk.Entry()
        e2XEntry.set_size_request(60,28);e2YEntry.set_size_request(60,28);e2ZEntry.set_size_request(60,28)
        e2XEntry.set_text('0');e2YEntry.set_text('1');e2ZEntry.set_text('0')
        hbox=gtk.HBox(False,5);porousbox.pack_start(hbox,False,False,2)	
        hbox.pack_start(label,False,False,5);hbox.pack_end(e2ZEntry,False,False,2);hbox.pack_end(e2YEntry,False,False,0);hbox.pack_end(e2XEntry,False,False,2)

        label=gtk.Label('Porous type')
        porousCombo=gtk.combo_box_entry_new_text();porousCombo.set_size_request(150,28)
        porousType=['powerLaw','DarcyForchheimer']
        for ii in porousType:porousCombo.append_text(ii)
        porousCombo.set_active(1)
        porousCombo.connect('changed',chporous)
        hbox=gtk.HBox(False,5);porousbox.pack_start(hbox,False,False,10)
        hbox.pack_start(label,False,False,5)
        hbox.pack_end(porousCombo,False,False,2)

        poroustypebox=gtk.VBox(False,5);porousbox.pack_start(poroustypebox,False,False,5)
        darcybox=gtk.VBox(False,5);poroustypebox.pack_start(darcybox,False,False,5)

        label=gtk.Label('       Darcy coeff. d [1/m2]')
        hbox=gtk.HBox(False,5);darcybox.pack_start(hbox,False,False,2);hbox.pack_start(label,False,False,5)
        alphaXEntry=gtk.Entry();alphaYEntry=gtk.Entry();alphaZEntry=gtk.Entry()
        alphaXEntry.set_size_request(60,28);alphaYEntry.set_size_request(60,28);alphaZEntry.set_size_request(60,28)
        alphaXEntry.set_text('500');alphaYEntry.set_text('1e10');alphaZEntry.set_text('1e10')
        hbox=gtk.HBox(False,5);darcybox.pack_start(hbox,False,False,2)	
        hbox.pack_end(alphaZEntry,False,False,2);hbox.pack_end(alphaYEntry,False,False,0);hbox.pack_end(alphaXEntry,False,False,2)
        
        label=gtk.Label('       Forchheimer coeff. f [1/m]')
        hbox=gtk.HBox(False,5);darcybox.pack_start(hbox,False,False,2);hbox.pack_start(label,False,False,5)
        betaXEntry=gtk.Entry();betaYEntry=gtk.Entry();betaZEntry=gtk.Entry()
        betaXEntry.set_size_request(60,28);betaYEntry.set_size_request(60,28);betaZEntry.set_size_request(60,28)
        betaXEntry.set_text('0');betaYEntry.set_text('0');betaZEntry.set_text('0')
        hbox=gtk.HBox(False,5);darcybox.pack_start(hbox,False,False,2)	
        hbox.pack_end(betaZEntry,False,False,2);hbox.pack_end(betaYEntry,False,False,0);hbox.pack_end(betaXEntry,False,False,2)

        powerbox=gtk.VBox(False,5)
        label0=gtk.Label('C0');label1=gtk.Label('C1');label0.set_size_request(100,28);label1.set_size_request(100,28)
        powerc0Entry=gtk.Entry();powerc0Entry.set_size_request(80,28);powerc0Entry.set_text('0.5')
        powerc1Entry=gtk.Entry();powerc1Entry.set_size_request(80,28);powerc1Entry.set_text('2.0')        
        hbox=gtk.HBox(False,5);powerbox.pack_start(hbox,False,False,2)	
        hbox.pack_end(powerc0Entry,False,False,2);hbox.pack_end(label0,False,False,0)
        hbox=gtk.HBox(False,5);powerbox.pack_start(hbox,False,False,2)	
        hbox.pack_end(powerc1Entry,False,False,2);hbox.pack_end(label1,False,False,0)

        def checkhsourcePorous(widget):
            aa=poroushsourcebox.get_children()
            for ii in aa:poroushsourcebox.remove(ii)
            if widget.get_active()==True:
        	poroushsourcebox.pack_start(porousmethodhbox,False,False,0);poroushsourcebox.pack_start(poroussourcehbox,False,False,0)
            self.cellzonebox.show_all()

        hbox=gtk.HBox(False,5);porousbox.pack_start(hbox,False,False,5)
        hsourceCheck=gtk.CheckButton('Energy source');hbox.pack_start(hsourceCheck,False,False,5)
        hsourceCheck.connect('toggled',checkhsourcePorous)
        poroushsourcebox=gtk.VBox(False,5);porousbox.pack_start(poroushsourcebox,False,False,0)
        label=gtk.Label('	Method')
        cellCombo=gtk.combo_box_entry_new_text();cellCombo.set_size_request(120,28)
        methods=['specific','absolute','fixed.T']
        for ii in methods:cellCombo.append_text(ii)
        cellCombo.set_active(0)
        porousmethodhbox=gtk.HBox(False,5);porousmethodhbox.pack_start(label,False,False,5);porousmethodhbox.pack_end(cellCombo,False,False,5)
        label=gtk.Label('	Source')
        poroushsourceEntry=gtk.Entry();poroushsourceEntry.set_size_request(120,28);poroushsourceEntry.set_text('300')
        poroussourcehbox=gtk.HBox(False,5);poroussourcehbox.pack_start(label,False,False,5);poroussourcehbox.pack_end(poroushsourceEntry,False,False,5)

        hbox=gtk.HBox(False,5);porousbox.pack_start(hbox,False,False,5)
        porousAppB=gtk.Button('Apply');porousAppB.set_size_request(120,28);porousAppB.connect('clicked',appporous)
        hbox.pack_end(porousAppB,True,True,5)
        
        aa=cellsetvbox.get_children()
        for ii in aa:cellsetvbox.remove(ii)
        cellsetvbox.pack_start(porousbox,False,False,5)
                
        porousSavedValue()
        
        if self.solver=='simpleNFoam' or self.solver=='pimpleNFoam':hsourceCheck.set_sensitive(0)
        
        cellzonebox.show_all()
    #--------------------------------------------------------------------------------------  
    def openFixedU(self,namezone,typezone,cellsetvbox,cellzonebox,notebook,textbuffer):
    
        GEN=generalClass(self.caseDir);WFILE=writeFileClass(self.caseDir)
        
        def appfixedu(widget):
            cellZoneDict={}
            cellZoneDict['cellZoneName']=namezone
            cellZoneDict['cellZoneType']=typezone
            cellZoneDict['fixedUx']=msourceuxEntry.get_text()
            cellZoneDict['fixedUy']=msourceuyEntry.get_text()
            cellZoneDict['fixedUz']=msourceuzEntry.get_text()
            if hsourceCheck.get_active()==1:cellZoneDict['energySourceOnOff']='true'
            else:cellZoneDict['energySourceOnOff']='false'
            aa=cellCombo.child;cellZoneDict['eSourceMethod']=aa.get_text()
            cellZoneDict['eSource']=fixuhsourceEntry.get_text()

            if GEN.isNumber(cellZoneDict['fixedUx'])==False:GEN.makeDialog('Error!!! Ux is not number')            
            if GEN.isNumber(cellZoneDict['fixedUy'])==False:GEN.makeDialog('Error!!! Uy is not number')                        
            if GEN.isNumber(cellZoneDict['fixedUz'])==False:GEN.makeDialog('Error!!! Uz is not number')                                    
            if GEN.isNumber(cellZoneDict['eSource'])==False:GEN.makeDialog('Error!!! Energy source is not number')
            
            aa=glob.glob(self.caseDir+'/system/settings/cellZoneConditions:'+namezone+':*')
            if len(aa)!=0:os.system('rm '+aa[0])
            
            keys=cellZoneDict.keys()
            f=open(self.caseDir+'/system/settings/cellZoneConditions:'+namezone+':'+typezone,'w')
            for ii in keys:f.write(ii+';'+cellZoneDict[ii]+'\n')
            f.close()

            aa=glob.glob(self.caseDir+'/system/cellZoneConditions:'+namezone+':*')
            if len(aa)!=0:
                for ii in aa:os.system('rm '+ii)            
            WFILE.fixedUFile(cellZoneDict)

            message='\n [  Fixed velocity setup for "'+namezone+'" is saved  ]\n'
            message=message+'\n    - Velocity is ( '+cellZoneDict['fixedUx']+' '+cellZoneDict['fixedUy']+' '+cellZoneDict['fixedUz']+' )\n'
            if hsourceCheck.get_active()==1:
                message=message+'\n    - Energy source method is '+cellZoneDict['eSourceMethod']+'\n'
                message=message+'\n    - Energy source is '+cellZoneDict['eSource']+'\n'
                            
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            notebook.set_current_page(0) 
                        
        def fixeduSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/cellZoneConditions:'+namezone+':'+typezone)
            if len(aa)!=0:
                dic=GEN.makeDictFromFile(aa[0])
                msourceuxEntry.set_text(dic['fixedUx'])
                msourceuyEntry.set_text(dic['fixedUy'])
                msourceuzEntry.set_text(dic['fixedUz'])
                
                if dic['energySourceOnOff']=='true':hsourceCheck.set_active(1)
                else:hsourceCheck.set_active(0)                
                cellCombo.set_active(methods.index(dic['eSourceMethod']))
                fixuhsourceEntry.set_text(dic['eSource'])
                
        fixedubox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('Fixed U condition of <b> "'+namezone+'" </b> zone')
        hbox=gtk.HBox(False,5);hbox.pack_start(label,False,False,5);fixedubox.pack_start(hbox,False,False,5)

        label=gtk.Label('U vector [m/s]');hbox=gtk.HBox(False,5);fixedubox.pack_start(hbox,False,False,5);hbox.pack_start(label,False,False,5)
        msourceuxEntry=gtk.Entry();msourceuyEntry=gtk.Entry();msourceuzEntry=gtk.Entry()
        msourceuxEntry.set_size_request(60,28);msourceuyEntry.set_size_request(60,28);msourceuzEntry.set_size_request(60,28)
        msourceuxEntry.set_text('0');msourceuyEntry.set_text('0');msourceuzEntry.set_text('0')
        hbox=gtk.HBox(False,5);fixedubox.pack_start(hbox,False,False,5)	
        hbox.pack_end(msourceuzEntry,False,False,2);hbox.pack_end(msourceuyEntry,False,False,0);hbox.pack_end(msourceuxEntry,False,False,2)

        def checkhsourceFixedU(widget):
            aa=fixeduhsourcebox.get_children()
            for ii in aa:fixeduhsourcebox.remove(ii)
            if widget.get_active()==True:
        	fixeduhsourcebox.pack_start(fixedumethodhbox,False,False,0);fixeduhsourcebox.pack_start(fixedusourcehbox,False,False,0)
            self.cellzonebox.show_all()

        hbox=gtk.HBox(False,5);fixedubox.pack_start(hbox,False,False,5)
        hsourceCheck=gtk.CheckButton('Energy source');hbox.pack_start(hsourceCheck,False,False,5)
        hsourceCheck.connect('toggled',checkhsourceFixedU)
        fixeduhsourcebox=gtk.VBox(False,5);fixedubox.pack_start(fixeduhsourcebox,False,False,0)
        label=gtk.Label('	Method')
        cellCombo=gtk.combo_box_entry_new_text();cellCombo.set_size_request(120,28)
        methods=['specific','absolute','fixed.T']
        for ii in methods:cellCombo.append_text(ii)
        cellCombo.set_active(0)
        fixedumethodhbox=gtk.HBox(False,5);fixedumethodhbox.pack_start(label,False,False,5);fixedumethodhbox.pack_end(cellCombo,False,False,5)
        label=gtk.Label('	Source')
        fixuhsourceEntry=gtk.Entry();fixuhsourceEntry.set_size_request(120,28);fixuhsourceEntry.set_text('300')
        fixedusourcehbox=gtk.HBox(False,5);fixedusourcehbox.pack_start(label,False,False,5);fixedusourcehbox.pack_end(fixuhsourceEntry,False,False,5)

        hbox=gtk.HBox(False,5);fixedubox.pack_start(hbox,False,False,5)
        fixeduAppB=gtk.Button('Apply');fixeduAppB.set_size_request(120,28);fixeduAppB.connect('clicked',appfixedu)
        hbox.pack_end(fixeduAppB,True,True,5)
        
        aa=cellsetvbox.get_children()
        for ii in aa:cellsetvbox.remove(ii)
        cellsetvbox.pack_start(fixedubox,False,False,5)
        
        fixeduSavedValue()
        
        if self.solver=='simpleNFoam' or self.solver=='pimpleNFoam':hsourceCheck.set_sensitive(0)
        
        cellzonebox.show_all()           
    #--------------------------------------------------------------------------------------  
    def openNone(self,namezone,typezone,cellsetvbox,cellzonebox,notebook,textbuffer):
    
        GEN=generalClass(self.caseDir);WFILE=writeFileClass(self.caseDir)        
                
        def appnone(widget):
            cellZoneDict={}
            cellZoneDict['cellZoneName']=namezone
            cellZoneDict['cellZoneType']=typezone
            if hsourceCheck.get_active()==1:cellZoneDict['energySourceOnOff']='true'
            else:cellZoneDict['energySourceOnOff']='false'
            aa=cellCombo.child;cellZoneDict['eSourceMethod']=aa.get_text()
            cellZoneDict['eSource']=nonehsourceEntry.get_text()
            if GEN.isNumber(cellZoneDict['eSource'])==False:GEN.makeDialog('Error!!! Energy source is not number')  
            
            aa=glob.glob(self.caseDir+'/system/settings/cellZoneConditions:'+namezone+':*')
            if len(aa)!=0:os.system('rm '+aa[0])

            if cellZoneDict['energySourceOnOff']=='true':
                keys=cellZoneDict.keys()
                f=open(self.caseDir+'/system/settings/cellZoneConditions:'+namezone+':'+typezone,'w')
                for ii in keys:f.write(ii+';'+cellZoneDict[ii]+'\n')
                f.close()
                aa=glob.glob(self.caseDir+'/system/cellZoneConditions:'+namezone+':*')
                if len(aa)!=0:
                    for ii in aa:os.system('rm '+ii)                            
                WFILE.noneFile(cellZoneDict)
            else:
                aa=glob.glob(self.caseDir+'/system/cellZoneConditions:'+namezone+':*')
                if len(aa)!=0:
                    for ii in aa:os.system('rm '+ii)                                   

            message='\n [  Energy source setup for "'+namezone+'" is saved  ]\n'
            if hsourceCheck.get_active()==1:
                message=message+'\n    - Energy source method is '+cellZoneDict['eSourceMethod']+'\n'
                message=message+'\n    - Energy source is '+cellZoneDict['eSource']+'\n'
                            
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            notebook.set_current_page(0) 
                        
        def noneSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/cellZoneConditions:'+namezone+':'+typezone)
            if len(aa)!=0:
                dic=GEN.makeDictFromFile(aa[0])
                if dic['energySourceOnOff']=='true':hsourceCheck.set_active(1)
                else:hsourceCheck.set_active(0)
                cellCombo.set_active(methods.index(dic['eSourceMethod']))
                nonehsourceEntry.set_text(dic['eSource'])
        
        def checkhsourceNone(widget):
            aa=nonehsourcebox.get_children()
            for ii in aa:nonehsourcebox.remove(ii)
            if widget.get_active()==True:
        	nonehsourcebox.pack_start(nonemethodhbox,False,False,0);nonehsourcebox.pack_start(nonesourcehbox,False,False,0)
            self.cellzonebox.show_all()

        nonebox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('Heat source condition of <b> "'+namezone+'" </b> zone')
        hbox=gtk.HBox(False,5);hbox.pack_start(label,False,False,5);nonebox.pack_start(hbox,False,False,5)

        hbox=gtk.HBox(False,5);nonebox.pack_start(hbox,False,False,5)
        hsourceCheck=gtk.CheckButton('Energy source');hbox.pack_start(hsourceCheck,False,False,5)
        hsourceCheck.connect('toggled',checkhsourceNone)
        nonehsourcebox=gtk.VBox(False,5);nonebox.pack_start(nonehsourcebox,False,False,0)
        label=gtk.Label('	Method')
        cellCombo=gtk.combo_box_entry_new_text();cellCombo.set_size_request(120,28)
        methods=['specific','absolute','fixed.T']
        for ii in methods:cellCombo.append_text(ii)
        cellCombo.set_active(0)
        nonemethodhbox=gtk.HBox(False,5);nonemethodhbox.pack_start(label,False,False,5);nonemethodhbox.pack_end(cellCombo,False,False,5)
        label=gtk.Label('	Source')
        nonehsourceEntry=gtk.Entry();nonehsourceEntry.set_size_request(120,28);nonehsourceEntry.set_text('300')
        nonesourcehbox=gtk.HBox(False,5);nonesourcehbox.pack_start(label,False,False,5);nonesourcehbox.pack_end(nonehsourceEntry,False,False,5)        
        
        hbox=gtk.HBox(False,5);nonebox.pack_start(hbox,False,False,5)
        noneAppB=gtk.Button('Apply');noneAppB.set_size_request(120,28);noneAppB.connect('clicked',appnone)
        hbox.pack_end(noneAppB,True,True,5)
        
        aa=cellsetvbox.get_children()
        for ii in aa:cellsetvbox.remove(ii)
        cellsetvbox.pack_start(nonebox,False,False,5)
        
        noneSavedValue()
        
        if self.solver=='simpleNFoam' or self.solver=='pimpleNFoam':hsourceCheck.set_sensitive(0)
        
        cellzonebox.show_all()     
        


