#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for cfMesh
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk,gobject;import glob
import pickle
import time

from generalSub import *
from boundaryConditionSub import *
from VTKStuffClass import *
from writeFileBasicFlow import *

class freepanelCfMeshClass:

    def delete_event(self,widget,event,data=None):
        aa=glob.glob(self.caseDir+'/system/settings/openSubWindow')
        for ii in aa:os.system('rm '+ii)
        aa=glob.glob(self.caseDir+'/system/settings/showstlmode')
        for ii in aa:os.system('rm '+ii)

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow,solver,installpath,rr,gg,bb):
        self.caseDir=caseDir
        self.mainwindow=mainwindow
        self.solver=solver
        self.installpath=installpath
        self.openSubWindow=False
        self.rr=rr;self.gg=gg;self.bb=bb

    def cfMesh(self,gvtk,notebook,textbuffer,terminal,displayOptCombo):

        aa=glob.glob(self.caseDir+'/mesh.stl')
        if aa==[]:self.stlfile='None'
        else:self.stlfile=aa[0]
        
        GEN=generalClass(self.caseDir);VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb);WFILE=writeFileClassBasicFlow(self.caseDir)

        def applythis(widget):            
            cfmeshDict={}            
            
            cfmeshDict['maxCellSize']=self.maxcellEntry.get_text()
            #-------------------------------
            inbox=vbox.get_children()
            cfmeshDict['npatch']=len(inbox)
            
            stlregionList=[];stllevelList=[];stltypeList=[]            
            
            for i in range(len(inbox)):                
                cfmeshDict['patchrefine:'+self.namelabel[i].get_text()]=[self.levelEntry[i].get_text(),self.typeCombo[i].child.get_text()]
                
                bb=self.namelabel[i].get_text();cc=self.levelEntry[i].get_text()
                cfmeshDict['localrefine:'+bb]=cc                                   
                stlregionList.append(bb);stllevelList.append(cc)
                dd=self.typeCombo[i].child
                stltypeList.append(dd.get_text())
                
            rstring='';lstring='';tstring=''
            for i in range(len(stlregionList)):
                rstring=rstring+stlregionList[i]+' '
                lstring=lstring+stllevelList[i]+' '
                tstring=tstring+stltypeList[i]+' '
                
            cfmeshDict['stlRegions']=rstring[:-1];cfmeshDict['stlLevels']=lstring[:-1];cfmeshDict['stlTypes']=tstring[:-1];cfmeshDict['stlTypes']=tstring[:-1]
            #---------------------------
            cfmeshDict['nobj']=self.nobjCombo.child.get_text() 
                
            inboxobj=vboxobj.get_children()
            for i in range(len(inboxobj)):                
                cfmeshDict['objectrefine:'+self.objlabel[i].get_text()]=a2=self.objtypeCombo[i].child.get_text()      
                
            cfmeshDict['boundaryLayer']=self.blayerCB.get_active()
            cfmeshDict['layerNo']=self.nlayerEntry.get_text() 
            cfmeshDict['layerRatio']=self.ratioEntry.get_text() 
            cfmeshDict['layerHeight']=self.heightEntry.get_text()                              

            if GEN.isNumber(self.maxcellEntry.get_text())==False:GEN.makeDialog('Error!!! maxCellSize is not number')             
            for i in range(len(inbox)):
                if GEN.isNumber(self.levelEntry[i].get_text())==False:GEN.makeDialog('Error!!! Local refinement of '+self.namelabel[i].get_text()+' is not number')
            if GEN.isNumber(self.nlayerEntry.get_text())==False:GEN.makeDialog('Error!!! Number of layers is not number')
            if GEN.isNumber(self.ratioEntry.get_text())==False:GEN.makeDialog('Error!!! Thickness ratio is not number')
            if GEN.isNumber(self.heightEntry.get_text())==False:GEN.makeDialog('Error!!! First cell Height is not number')
                        
            f=open(self.caseDir+'/system/settings/cfMeshConditions','w');pickle.dump(cfmeshDict,f);f.close()

            notebook.set_current_page(2)
            
            cf=open(self.caseDir+'/cfMeshRun','w')
            cf.write('surfaceFeatureEdges -case '+self.caseDir+' -angle 30 '+self.caseDir+'/mesh.stl '+self.caseDir+'/mesh.fms\n')                                   
            self.writeCfMeshDict(cfmeshDict)            
            cf.write('cartesianMesh -case '+self.caseDir+'\n')                        
            # ----- to create cell zone ---------------------------------------------                        
            """minc=[minx.get_text(),miny.get_text(),minz.get_text()]
            maxc=[maxx.get_text(),maxy.get_text(),maxz.get_text()]
            WFILE.topoSetDict(minc,maxc)
            os.system('topoSet -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.topoSet')

            f=open(self.caseDir+'/logfiles/log.topoSet','r');ff=f.readlines();f.close()
            res=ff;string=''
            for ii in res:string=string+ii
            textbuffer.insert_at_cursor(string)
                        
            os.system('setsToZones -noFlipMap -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.setsToZones')
            """
            #------------------------------------------------------------------------                       
            #cf.write('checkMesh -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.checkMesh\n')
            cf.write('foamToVTK -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.foamToVTK\n')
            cf.close()
            os.system('chmod +x '+self.caseDir+'/cfMeshRun')
            
            notebook.set_current_page(2)
            
            time.sleep(1)
            
            cmd=self.caseDir+'/cfMeshRun\n'
            length=len(cmd)
            terminal.feed_child(cmd,length)
            
            stime=time.asctime(time.localtime(time.time()))
            message='\n [  cfMesh is started  at '+stime +'  ]\n\n\n'         
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)                   

        def setSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/cfMeshConditions')
            if len(aa)!=0:
                f=open(aa[0],'r');dic=pickle.load(f);f.close()
                self.maxcellEntry.set_text(dic['maxCellSize'])  
                showitembox()
                self.nobjCombo.set_active(self.nobjList.index(dic['nobj']))
                if dic['boundaryLayer']==1:self.blayerCB.set_active(1)
                else:self.blayerCB.set_active(0)
                self.nlayerEntry.set_text(dic['layerNo'])
                self.ratioEntry.set_text(dic['layerRatio'])
                self.heightEntry.set_text(dic['layerHeight'])
                
                inbox=vbox.get_children()
                for i in range(len(inbox)):
                    level=dic['patchrefine:'+self.namelabel[i].get_text()][0]
                    ptype=dic['patchrefine:'+self.namelabel[i].get_text()][1]
                    self.levelEntry[i].set_text(level)
                    self.typeCombo[i].set_active(self.btypeList.index(ptype))

        def selectstl(widget):
        
            displayOpt=displayOptCombo.child.get_text()        
           
            stls=GEN.selSTL()
            if len(stls)==1:os.system('cp '+stls[0]+' '+self.caseDir+'/mesh.stl')
            elif len(stls)==0:return
            else:GEN.mergeSTL(stls)
                
            self.stlfile=self.caseDir+'/mesh.stl'
                
            f=open(self.caseDir+'/system/settings/stlfile','w')
            for ii in stls:f.write(ii+'\n')
            f.close()            
            
            showitembox() 
            
            notebook.set_current_page(1)
            
            os.system('surfaceCheck -noFunctionObjects '+self.caseDir+'/mesh.stl > '+self.caseDir+'/logfiles/log.surfaceCheck')
                                              
            viewposition=[1,1,1] 
            renderer=VTK.showSTL(self.stlfile,viewposition,displayOpt)
            gvtk.GetRenderWindow().AddRenderer(renderer)
            gvtk.Initialize();gvtk.Start()
            
            f=open(self.caseDir+'/system/settings/displaymode','w')
            f.write('stl');f.close()                          
               
        def autoPatch(widget):
        
            displayOpt=displayOptCombo.child.get_text()
            
            angle=self.angleEntry.get_text()
            cmd='surfaceAutoPatch -case '+self.caseDir+' '+self.caseDir+'/mesh.stl '+self.caseDir+'/mesh.stl '+angle+'\n'
            length=len(cmd)
            terminal.feed_child(cmd,length)
                    
            showitembox()   
            
            #notebook.set_current_page(2)
                                                
            viewposition=[1,1,1]             
            renderer=VTK.showSTL(self.stlfile,viewposition,displayOpt)
            gvtk.GetRenderWindow().AddRenderer(renderer)
            gvtk.Initialize();gvtk.Start()

        def showpatch(widget):
        
            displayOpt=displayOptCombo.child.get_text()
            
            notebook.set_current_page(1)
            self.openSTL(gvtk,displayOptCombo)
            
        def showitembox():
            bb=vbox.get_children()
            for ii in bb:vbox.remove(ii)            
            stlregion=GEN.findSTLRegion(self.caseDir+'/mesh.stl')
            shbox=[];self.namelabel=[];self.levelEntry=[];self.typeCombo=[]
            for i in range(len(stlregion)):
                shbox.append(gtk.HBox(False,5))
                self.namelabel.append(gtk.Entry())                
                self.namelabel[i].set_text(stlregion[i])                
                self.namelabel[i].set_size_request(80,28)
                self.namelabel[i].set_editable(0)
                self.typeCombo.append(gtk.combo_box_entry_new_text())
                self.typeCombo[i].set_size_request(100,28)
                self.btypeList=['wall','patch','symmetry']
                for jj in self.btypeList:self.typeCombo[i].append_text(jj) 
                self.typeCombo[i].set_active(0)                                
                self.levelEntry.append(gtk.Entry())
                self.levelEntry[i].set_size_request(40,28)
                self.levelEntry[i].set_text('0')                
                vbox.pack_start(shbox[i],False,False,0)
                shbox[i].pack_end(self.typeCombo[i],False,False,5)                
                shbox[i].pack_end(self.levelEntry[i],False,False,0)
                shbox[i].pack_end(self.namelabel[i],True,True,5)                
            self.cfmeshbox.show_all()
            
        def changeObjNo(widget):
        
            def setobj(widget,i):
                self.openObjectWindow(self.objlabel[i].get_label(),self.objtypeCombo[i].child.get_text(),gvtk,notebook)
        
            nobj=widget.child.get_text()                       
            
            bb=vboxobj.get_children()
            for ii in bb:vboxobj.remove(ii)
                        
            objhbox=[];self.objlabel=[];self.objButton=[];self.objtypeCombo=[]
            for i in range(int(nobj)):
                objhbox.append(gtk.HBox(False,5))
                self.objlabel.append(gtk.Label('object-'+str(i+1)))
                self.objlabel[i].set_size_request(80,28)
                self.objlabel[i].set_alignment(0,0.5)
                self.objtypeCombo.append(gtk.combo_box_entry_new_text())
                self.objtypeCombo[i].set_size_request(100,28)
                self.objtypeList=['box','sphere']
                for jj in self.objtypeList:self.objtypeCombo[i].append_text(jj) 
                self.objtypeCombo[i].set_active(0)                                
                self.objButton.append(gtk.Button('Set'))
                self.objButton[i].set_size_request(60,28)
                self.objButton[i].connect('clicked',setobj,i)                
                vboxobj.pack_start(objhbox[i],False,False,0)
                objhbox[i].pack_end(self.objButton[i],False,False,5)
                objhbox[i].pack_end(self.objtypeCombo[i],False,False,5)                                
                objhbox[i].pack_end(self.objlabel[i],True,True,5)
                
                        
            aa=glob.glob(self.caseDir+'/system/settings/cfMeshConditions')
            if len(aa)!=0:
                f=open(aa[0],'r');dic=pickle.load(f);f.close()                    
                for i in range(int(nobj)):
                    if i+1 <= int(dic['nobj']):
                        if dic['objectrefine:object-'+str(i+1)]=='box':self.objtypeCombo[i].set_active(0)
                        else:self.objtypeCombo[i].set_active(1)
            
            self.cfmeshbox.show_all()      
            
        def toggleBlayer(widget):
            if widget.get_active()==0:self.nlayerEntry.set_sensitive(0);self.ratioEntry.set_sensitive(0);self.heightEntry.set_sensitive(0)
            else:self.nlayerEntry.set_sensitive(1);self.ratioEntry.set_sensitive(1);self.heightEntry.set_sensitive(1)

        def scalestl(widget):
            self.scalestl(notebook,textbuffer,terminal)                  
        #-----------------------------------------------------------------                                                
        self.cfmeshbox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('<b>  cfMesh  </b>')
        ebox=gtk.EventBox();self.cfmeshbox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label)

        self.selstlB=gtk.Button('Select STL Files');self.selstlB.connect('clicked',selectstl)
        hbox=gtk.HBox(False,5);self.cfmeshbox.pack_start(hbox,False,False,2)
        hbox.pack_start(self.selstlB,True,True,5)                      
       
        self.scalestlB=gtk.Button('Scale STL Files');self.scalestlB.connect('clicked',scalestl)
        hbox=gtk.HBox(False,5);self.cfmeshbox.pack_start(hbox,False,False,2)
        hbox.pack_start(self.scalestlB,True,True,5)
        
        patchframe=gtk.Frame();patchframe.set_label(' autoPatch ');patchframe.set_label_align(0.1, 0.5);patchframe.set_shadow_type(gtk.SHADOW_IN)
        self.cfmeshbox.pack_start(patchframe,False,False,5)
        patchvbox=gtk.VBox(False,5);patchframe.add(patchvbox)
        
        label=gtk.Label('autoPatch Angle')
        self.angleEntry=gtk.Entry();self.angleEntry.set_size_request(60,28);self.angleEntry.set_text('160')
        hbox=gtk.HBox(False,5);patchvbox.pack_start(hbox,False,False,2);hbox.pack_start(label,False,False,5);hbox.pack_start(self.angleEntry,False,False,5)
        self.autopatchB=gtk.Button('autoPatch');self.autopatchB.set_size_request(120,28);self.autopatchB.connect('clicked',autoPatch)
        self.showstlB=gtk.Button('Display patch');self.showstlB.set_size_request(120,28);self.showstlB.connect('clicked',showpatch)
        hbox=gtk.HBox(False,5);patchvbox.pack_start(hbox,False,False,2);hbox.pack_start(self.autopatchB,True,True,5);hbox.pack_end(self.showstlB,True,True,5)

        label=gtk.Label('maxCellSize');label.set_alignment(0,0.5)
        self.maxcellEntry=gtk.Entry();self.maxcellEntry.set_size_request(60,28);self.maxcellEntry.set_text('0.05')        
        hbox=gtk.HBox(False,5);self.cfmeshbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.maxcellEntry,False,False,5)
        #--------------
        label=gtk.Label('Patch Refinement - size level');label.set_alignment(0,0.5)
        hbox=gtk.HBox(False,5);self.cfmeshbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5)

        scwin=gtk.ScrolledWindow();scwin.set_border_width(0);scwin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        scwin.set_size_request(250,130)
        hbox=gtk.HBox(False,5);self.cfmeshbox.pack_start(hbox,False,False,5)
        hbox.pack_start(scwin,True,True,0)

        vbox=gtk.VBox(False,5);scwin.add_with_viewport(vbox)
        
        separator=gtk.HSeparator();separator.set_size_request(285,5);self.cfmeshbox.pack_start(separator,False,True,5)            
        #------------
        label=gtk.Label('  Object Refinement');label.set_alignment(0,0.5);self.cfmeshbox.pack_start(label,False,False,2)        
        
        label=gtk.Label('Number of Objects');label.set_alignment(0,0.5)
        self.nobjCombo=gtk.combo_box_entry_new_text()
        self.nobjList=['0','1','2','3','4','5','6','7','8','9','10']  
        for ii in self.nobjList:self.nobjCombo.append_text(ii)
        self.nobjCombo.set_active(0)
        self.nobjCombo.set_size_request(80,28)
        self.nobjCombo.connect('changed',changeObjNo)
        
        self.nobjCombo.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'))        
        
        hbox=gtk.HBox(False,5);self.cfmeshbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.nobjCombo,False,False,5)

        scwinobj=gtk.ScrolledWindow();scwinobj.set_border_width(0);scwinobj.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        scwinobj.set_size_request(250,70)
        hbox=gtk.HBox(False,5);self.cfmeshbox.pack_start(hbox,False,False,5)
        hbox.pack_start(scwinobj,True,True,0)

        vboxobj=gtk.VBox(False,5);scwinobj.add_with_viewport(vboxobj)        
        
        separator=gtk.HSeparator();separator.set_size_request(285,5);self.cfmeshbox.pack_start(separator,False,True,5)                    
        #--- To create cell zone ------------------------------------------------        
        """separator=gtk.HSeparator();separator.set_size_request(285,5);self.cfmeshbox.pack_start(separator,False,True,5)            

        label=gtk.Label('Define Cell Zone - 2 points');label.set_alignment(0,0.5);self.cfmeshbox.pack_start(label,False,False,2)

        label=gtk.Label('Min.')
        minx=gtk.Entry();minx.set_size_request(60,28);minx.set_text('-4.82')
        miny=gtk.Entry();miny.set_size_request(60,28);miny.set_text('0')
        minz=gtk.Entry();minz.set_size_request(60,28);minz.set_text('-5.39')
        minbox=gtk.HBox(False,5);self.cfmeshbox.pack_start(minbox,False,False,5)
        minbox.pack_start(label,False,False,5);minbox.pack_end(minz,False,False,5);minbox.pack_end(miny,False,False,0);minbox.pack_end(minx,False,False,5)

        label=gtk.Label('Max.')
        maxx=gtk.Entry();maxx.set_size_request(60,28);maxx.set_text('-0.37')
        maxy=gtk.Entry();maxy.set_size_request(60,28);maxy.set_text('3.12')
        maxz=gtk.Entry();maxz.set_size_request(60,28);maxz.set_text('5.39')
        maxbox=gtk.HBox(False,5);self.cfmeshbox.pack_start(maxbox,False,False,5)
        maxbox.pack_start(label,False,False,5);maxbox.pack_end(maxz,False,False,5);maxbox.pack_end(maxy,False,False,0);maxbox.pack_end(maxx,False,False,5)
        """
        #--------------------------------------------------------------------------
        self.blayerCB=gtk.CheckButton(' Boundary Layer')        
        self.blayerCB.set_active(1)
        self.cfmeshbox.pack_start(self.blayerCB,False,False,2)       
        
        label=gtk.Label('Number of layers');label.set_alignment(0,0.5)
        self.nlayerEntry=gtk.Entry();self.nlayerEntry.set_size_request(60,28);self.nlayerEntry.set_text('3')
        nlayerbox=gtk.HBox(False,5);self.cfmeshbox.pack_start(nlayerbox,False,False,1)
        nlayerbox.pack_end(self.nlayerEntry,False,False,5);nlayerbox.pack_end(label,False,False,5)
        
        label=gtk.Label('Thickness ratio');label.set_alignment(0,0.5)
        self.ratioEntry=gtk.Entry();self.ratioEntry.set_size_request(60,28);self.ratioEntry.set_text('1.1')
        ratiobox=gtk.HBox(False,5);self.cfmeshbox.pack_start(ratiobox,False,False,1)
        ratiobox.pack_end(self.ratioEntry,False,False,5);ratiobox.pack_end(label,False,False,5)
        
        label=gtk.Label('First cell Height');label.set_alignment(0,0.01)
        self.heightEntry=gtk.Entry();self.heightEntry.set_size_request(60,28);self.heightEntry.set_text('0.01')
        heightbox=gtk.HBox(False,5);self.cfmeshbox.pack_start(heightbox,False,False,1)
        heightbox.pack_end(self.heightEntry,False,False,5);heightbox.pack_end(label,False,False,5)
        
        self.blayerCB.connect('toggled',toggleBlayer)          
        #--------------
        self.applyB=gtk.Button('Create Mesh');self.applyB.connect('clicked',applythis)
        hbox=gtk.HBox(False,5);self.cfmeshbox.pack_start(hbox,False,False,10)
        hbox.pack_end(self.applyB,True,True,5)          
       
        setSavedValue()

        return self.cfmeshbox
    #--------------------------------------------------------------
    def writeCfMeshDict(self,dic):
    
        f=open(self.caseDir+'/system/meshDict','w')
        f.write('/*--------------------------------*- C++ -*----------------------------------*\\n')
        f.write('| =========                 |                                                |\n')
        f.write('| \\      /  F ield         | OpenFOAM GUI Project: creativeFields           |\n')
        f.write('|  \\    /   O peration     | Version:  0.8.9.0                              |\n')
        f.write('|   \\  /    A nd           | Web: www.c-fields.com                          |\n')
        f.write('|    \\/     M anipulation  |                                                |\n')
        f.write('\*---------------------------------------------------------------------------*/\n')
        f.write('\n')
        f.write('FoamFile\n')
        f.write('{\n')
        f.write('version	2;\n')
        f.write('format	ascii;\n')
        f.write('class	dictionary;\n')
        f.write('location	"system";\n')
        f.write('object	meshDict;\n')
        f.write('}\n')
        f.write('\n')
        f.write('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //\n')
        f.write('surfaceFile	"mesh.fms";\n')
        f.write('maxCellSize	'+dic['maxCellSize']+';\n')
        f.write('\n')
        #---------------------                
        f.write('localRefinement\n')
        f.write('{\n')
        regs=dic['stlRegions'].split(' ')
        levs=dic['stlLevels'].split(' ')
        typs=dic['stlTypes'].split(' ')
        for i in range(len(regs)):
            f.write('    '+regs[i]+'\n')
            f.write('    {\n')
            f.write('        additionalRefinementLevels '+levs[i]+';\n')
            f.write('    }\n')           
        f.write('}\n')
        #---------------------        
        f.write('objectRefinements\n')
        f.write('{\n')
        
        for i in range(int(dic['nobj'])):          
            objname='object-'+str(i+1)
            g=open(self.caseDir+'/system/settings/objectRefine-'+objname,'r');objdic=pickle.load(g);g.close()

            f.write('    '+objname+'\n')
            f.write('    {\n')
            f.write('        type '+objdic['objecttype']+';\n')            
            f.write('        additionalRefinementLevels '+objdic['refineLevel']+';\n')
            f.write('        centre    ('+objdic['centerx']+' '+objdic['centery']+' '+objdic['centerz']+');\n')
            if objdic['objecttype']=='box':
                f.write('        lengthX   '+objdic['lengthx']+';\n')
                f.write('        lengthY   '+objdic['lengthy']+';\n')
                f.write('        lengthZ   '+objdic['lengthz']+';\n')
            elif objdic['objecttype']=='sphere':
                f.write('        radius    '+objdic['radius']+';\n')
                f.write('        refinementThickness    '+objdic['thick']+';\n')
            f.write('    }\n')

        f.write('}\n')
        #---------------------        
        f.write('renameBoundary\n')
        f.write('{\n')
        f.write('    newPatchNames\n')
        f.write('    {\n')
        for i in range(len(regs)):
            f.write('        "'+regs[i]+'"\n')
            f.write('        {\n')
            f.write('            newName     '+regs[i]+';\n')
            f.write('            type        '+typs[i]+';\n')
            f.write('        }\n')
        f.write('    }\n')
        f.write('}\n') 
        #---------------------        
        f.write('boundaryLayers\n')
        f.write('{\n')
        if dic['boundaryLayer']==1:
            f.write('    nLayers    '+dic['layerNo']+';\n')
            f.write('    thicknessRatio    '+dic['layerRatio']+';\n')
            f.write('    maxFirstLayerThickness    '+dic['layerHeight']+';\n')
        f.write('}\n')         

        f.close()
    #---------------------------------------------------------------------------------------------------------                    
    def openSTL(self,gvtk,displayOptCombo):

        GEN=generalClass(self.caseDir);VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb)

        def viewbc(stlnamelist):
        
            def get_model(tree_store):
                if tree_store:return tree_store 
                else:return None                
            def col1_toggled_cb( cell, path, model ):
                model[path][1] = not model[path][1]
                for i in range(len(stlnamelist)):
                    if model[path][0]==stlnamelist[i]:
                        if model[path][1]==True:self.onOff[i]=1
                        else:self.onOff[i]=0
            def make_view( model ):
                view = gtk.TreeView(model)
                renderer = gtk.CellRendererText()
                renderer1 = gtk.CellRendererToggle()
                renderer1.set_property('activatable', True)
                renderer1.connect( 'toggled', col1_toggled_cb, model )
                column0 = gtk.TreeViewColumn("Patch Name", renderer, text=0)
                column1 = gtk.TreeViewColumn("On/Off", renderer1 )
                column1.add_attribute( renderer1, "active", 1)
                view.append_column( column0 )
                view.append_column( column1 )
                return view

            self.onOff=[]
            for i in range(len(stlnamelist)):self.onOff.append(0)            
            tree_store=gtk.TreeStore(gobject.TYPE_STRING,gobject.TYPE_BOOLEAN)
            for item in stlnamelist:
                parent=tree_store.append(None,(item,None))
            mdl=get_model(tree_store)
            view=make_view(mdl)        
            return view   

        def showMesh(widget):
        
            displayOpt=displayOptCombo.child.get_text()
            
            stlfiles=[]                             
            for i in range(len(self.onOff)):
                if self.onOff[i]==1:stlfiles.append(stlnamelist[i])                
            viewposition=[1,1,1]           
            renderer=VTK.showSTLMulti(stlfiles,viewposition,displayOpt)
            gvtk.GetRenderWindow().AddRenderer(renderer)
            gvtk.Initialize()
            gvtk.Start()
                
            f=open(self.caseDir+'/system/settings/displayedSTL','w')
            for ii in self.onOff:f.write(str(ii)+'\n')
            f.close()
            
            f=open(self.caseDir+'/system/settings/displaymode','w')
            f.write('stlpatch');f.close()                  
                
        def closethis(widget):
            window.destroy();self.openSubWindow=False
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')
            os.system('rm '+self.caseDir+'/system/settings/showstlmode')

        def splitstl():
            aa=glob.glob(self.caseDir+'/mesh.stl')
            if len(aa)!=0:
                bb=glob.glob(self.caseDir+'/system/settings/*.stl')
                for jj in bb:os.system('rm '+jj)
                f=open(aa[0],'r');ff=f.readlines();f.close()
                solidnames=[]
                startlines=[]
                endline=len(ff)
                for i in range(len(ff)):
                    if ff[i][:5]=='solid':
                        b1=ff[i].split(' ');solidnames.append(b1[1].strip());startlines.append(i)
                for j in range(len(solidnames)):
                    g=open(self.caseDir+'/system/settings/'+solidnames[j]+'.stl','w')
                    if j!=len(solidnames)-1:
                        for k in range (startlines[j+1]-startlines[j]):
                            ss=startlines[j]
                            g.write(ff[ss+k])
                        g.close()
                    else:
                        for k in range (endline-startlines[j]):
                            ss=startlines[j]
                            g.write(ff[ss+k])
                        g.close()

        openSubWindow=GEN.subWindowOpened()
        
        if openSubWindow==False:
            
            window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_border_width(10);window.set_title('Mesh')
            window.set_position(gtk.WIN_POS_CENTER);window.set_transient_for(self.mainwindow)
            window.connect("delete_event", self.delete_event)
            self.vbox=gtk.VBox(False,5);window.add(self.vbox)  
            
            self.scwin=gtk.ScrolledWindow();self.scwin.set_border_width(0);self.scwin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
            self.scwin.set_size_request(250,450);self.smbox=gtk.VBox(False,0)
            self.bdbox=gtk.HBox(False,5);self.smeshbox=gtk.HBox(False,5)
            
            self.okbutton=gtk.Button(label='Show Mesh');self.okbutton.connect('clicked',showMesh)      
            self.closeB=gtk.Button(label='Close');self.closeB.connect('clicked',closethis)

            self.vbox.pack_start(self.smbox,True,True,0);self.smbox.pack_start(self.scwin,True,True,0)
            self.scwin.add_with_viewport(self.bdbox);self.smbox.pack_start(self.smeshbox,False,False,5)       
            
            self.vbox.pack_start(self.okbutton,False,False,5)        
            self.vbox.pack_start(self.closeB,False,False,5)
           
            splitstl()
            
            mmm=glob.glob(self.caseDir+'/system/settings/*.stl')
            if len(mmm)!=0:
                stlnamelist=[]
                for ii in mmm:
                    a1=ii.split('/');stlnamelist.append(a1[-1][:-4])

                view=viewbc(stlnamelist)
                self.bdbox.pack_start(view,True,True,5)
                window.show_all()
                
            window.show_all()
            
            os.system('touch '+self.caseDir+'/system/settings/openSubWindow')
            os.system('touch '+self.caseDir+'/system/settings/showstlmode')
    #---------------------------------------------------------------------------------------------------------                    
    def openObjectWindow(self,objectname,objecttype,gvtk,notebook):
    
        def applythis(widget):
            objectDict={}
            objectDict['objectname']=objectname
            objectDict['objecttype']=objecttype
            objectDict['refineLevel']=refinelevelEntry.get_text()
            objectDict['centerx']=centerxEntry.get_text()
            objectDict['centery']=centeryEntry.get_text()
            objectDict['centerz']=centerzEntry.get_text()
            objectDict['lengthx']=lengthxEntry.get_text()
            objectDict['lengthy']=lengthyEntry.get_text()
            objectDict['lengthz']=lengthzEntry.get_text()            
            objectDict['radius']=radiusEntry.get_text()
            objectDict['thick']=thickEntry.get_text()
                        
            f=open(self.caseDir+'/system/settings/objectRefine-'+objectname,'w')
            pickle.dump(objectDict,f)
            f.close()            
            
            window.destroy()
            
        def closethis(widget):window.destroy()
        
        def displayobj(widget):
            cx=centerxEntry.get_text();cy=centeryEntry.get_text();cz=centerzEntry.get_text()
            lx=lengthxEntry.get_text();ly=lengthyEntry.get_text();lz=lengthzEntry.get_text()            
            radius=radiusEntry.get_text()
            
            notebook.set_current_page(1)
            
            VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb)
            viewposition=[1,1,1]           
            renderer=VTK.showHexaSphere(cx,cy,cz,lx,ly,lz,radius,objecttype,viewposition,self.stlfile)
            gvtk.GetRenderWindow().AddRenderer(renderer)
            gvtk.Initialize()
            gvtk.Start()
            
        def setSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/objectRefine-'+objectname)
            if aa!=[]:
                f=open(aa[0],'r');dic=pickle.load(f);f.close()
                refinelevelEntry.set_text(dic['refineLevel'])
                centerxEntry.set_text(dic['centerx'])
                centeryEntry.set_text(dic['centery'])
                centerzEntry.set_text(dic['centerz'])
                if objecttype=='box':
                    lengthxEntry.set_text(dic['lengthx'])
                    lengthyEntry.set_text(dic['lengthy'])
                    lengthzEntry.set_text(dic['lengthz'])
                elif objecttype=='sphere':
                    radiusEntry.set_text(dic['radius'])
                    thickEntry.set_text(dic['thick'])
    
        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_border_width(10);window.set_title('Object setup window')
        window.set_position(gtk.WIN_POS_CENTER);window.set_transient_for(self.mainwindow)
        mbox=gtk.VBox(False,5);window.add(mbox)      
    
        label=gtk.Label('Refinement level');label.set_alignment(0,0.5)
        refinelevelEntry=gtk.Entry();refinelevelEntry.set_size_request(60,28);refinelevelEntry.set_text('1')        
        hbox=gtk.HBox(False,5);mbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(refinelevelEntry,False,False,5)
        
        separator=gtk.HSeparator();separator.set_size_request(285,5);mbox.pack_start(separator,False,True,5)                    
                
        label=gtk.Label('Centre');label.set_alignment(0,0.5)
        centerxEntry=gtk.Entry();centerxEntry.set_size_request(60,28);centerxEntry.set_text('0') 
        centeryEntry=gtk.Entry();centeryEntry.set_size_request(60,28);centeryEntry.set_text('0') 
        centerzEntry=gtk.Entry();centerzEntry.set_size_request(60,28);centerzEntry.set_text('0')        
        hbox=gtk.HBox(False,5);mbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5)
        hbox.pack_end(centerzEntry,False,False,5);hbox.pack_end(centeryEntry,False,False,0);hbox.pack_end(centerxEntry,False,False,5)
                    
        lengthlabel=gtk.Label('Length');lengthlabel.set_alignment(0,0.5)
        lengthxEntry=gtk.Entry();lengthxEntry.set_size_request(60,28);lengthxEntry.set_text('0') 
        lengthyEntry=gtk.Entry();lengthyEntry.set_size_request(60,28);lengthyEntry.set_text('0') 
        lengthzEntry=gtk.Entry();lengthzEntry.set_size_request(60,28);lengthzEntry.set_text('0')
        
        radiuslabel=gtk.Label('Radius');radiuslabel.set_alignment(0,0.5)
        radiusEntry=gtk.Entry();radiusEntry.set_size_request(60,28);radiusEntry.set_text('1')
        
        thicklabel=gtk.Label('refinementThickness');thicklabel.set_alignment(0,0.5)
        thickEntry=gtk.Entry();thickEntry.set_size_request(60,28);thickEntry.set_text('1') 
                    
        if objecttype=='box':
            lengthhbox=gtk.HBox(False,5);mbox.pack_start(lengthhbox,False,False,2)
            lengthhbox.pack_start(lengthlabel,False,False,5)
            lengthhbox.pack_end(lengthzEntry,False,False,5);lengthhbox.pack_end(lengthyEntry,False,False,0);lengthhbox.pack_end(lengthxEntry,False,False,5) 
        elif objecttype=='sphere':                                    
            radiushbox=gtk.HBox(False,5);mbox.pack_start(radiushbox,False,False,2)
            radiushbox.pack_start(radiuslabel,False,False,5);radiushbox.pack_end(radiusEntry,False,False,5)                              
            thickhbox=gtk.HBox(False,5);mbox.pack_start(thickhbox,False,False,2)
            thickhbox.pack_start(thicklabel,False,False,5);thickhbox.pack_end(thickEntry,False,False,5)   

        separator=gtk.HSeparator();separator.set_size_request(285,5);mbox.pack_start(separator,False,True,5)                                
        #--------------
        dispB=gtk.Button('Show Object');dispB.connect('clicked',displayobj)
        hbox=gtk.HBox(False,5);mbox.pack_start(hbox,False,False,2)
        hbox.pack_end(dispB,True,True,0)
        
        applyB=gtk.Button('Apply');applyB.connect('clicked',applythis)
        closeB=gtk.Button('Close');closeB.connect('clicked',closethis)        
        hbox=gtk.HBox(False,5);mbox.pack_start(hbox,False,False,2)
        hbox.pack_end(closeB,True,True,0);hbox.pack_end(applyB,True,True,0)   
        
        setSavedValue()
        
        window.show_all()     
    #---------------------------------------------------------------------------------------------------------            
    def scalestl(self,notebook,textbuffer,terminal):
        
        GEN=generalClass(self.caseDir)
    
        def closethis(widget):            
            window.destroy();self.openSubWindow=False
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')            

        def applythis(widget):
            xscale=scalex.get_text();yscale=scaley.get_text();zscale=scalez.get_text()
            
            if GEN.isNumber(xscale)==False:
                GEN.makeDialog('Error!!! x-scale is not number')
                return
            if GEN.isNumber(yscale)==False:
                GEN.makeDialog('Error!!! y-scale is not number')
                return
            if GEN.isNumber(zscale)==False:
                GEN.makeDialog('Error!!! z-scale is not number') 
                return

            cmd="surfaceTransformPoints -case "+self.caseDir+" -scale '("+xscale+' '+yscale+' '+zscale+")' "+self.caseDir+'/mesh.stl'+' '+self.caseDir+'/mesh.stl\n'
            length=len(cmd)
            terminal.feed_child(cmd,length)

            window.destroy();self.openSubWindow=False
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')            

            message='\n [  Scale STL file is Completed with ( '+xscale+' '+yscale+' '+zscale+' )  ]\n\n'                     
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            
        self.openSubWindow=True
        
        aa=glob.glob(self.caseDir+'/mesh.stl')
        if aa!=[]:
            stlrange=GEN.getSTLRange(aa[0])
        else:
            GEN.makeDialog('Error!!! Select STL File First');return                      
        
        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Scale mesh')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER);window.set_transient_for(self.mainwindow)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_ETCHED_OUT);mainbox.pack_start(frame,False,False,5)

        vbox=gtk.VBox(False,5);frame.add(vbox)
        
        label=gtk.Label('Bounding box Max. : ('+stlrange[0][0]+' '+stlrange[0][1]+' '+stlrange[0][2]+')')
        hbox=gtk.HBox(False,5);vbox.pack_start(hbox,False,False,5);hbox.pack_start(label,False,False,5)        

        label=gtk.Label('Bounding box Min. : ('+stlrange[1][0]+' '+stlrange[1][1]+' '+stlrange[1][2]+')')
        hbox=gtk.HBox(False,5);vbox.pack_start(hbox,False,False,5);hbox.pack_start(label,False,False,5) 
        
        label=gtk.Label('Set scale factor for x,y,z')
        labelbox=gtk.HBox(False,5);vbox.pack_start(labelbox,False,False,5)
        labelbox.pack_start(label,False,False,5)

        scalex=gtk.Entry();scalex.set_size_request(80,28);scalex.set_text('0.001')
        scaley=gtk.Entry();scaley.set_size_request(80,28);scaley.set_text('0.001')
        scalez=gtk.Entry();scalez.set_size_request(80,28);scalez.set_text('0.001')
        scalebox=gtk.HBox(False,5);vbox.pack_start(scalebox,False,False,5)
        scalebox.pack_start(scalex,False,False,5);scalebox.pack_start(scaley,False,False,5);scalebox.pack_start(scalez,False,False,5)

        appB=gtk.Button('Apply');clsB=gtk.Button('Close')
        appB.connect('clicked',applythis);clsB.connect('clicked',closethis)
        appB.set_size_request(100,28);clsB.set_size_request(100,28)
        bubox=gtk.HBox(False,5);vbox.pack_start(bubox,False,False,5)
        bubox.pack_end(clsB,False,False,5);bubox.pack_end(appB,False,False,5)
        window.show_all()     
        
                                    

