#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for postprocessing functions
#
# Author
#    NEXTFOAM Inc. 
##############################################################################

import os,math,glob,sys,time;import pygtk;pygtk.require('2.0');import gtk
import pickle

from generalSub import * 
from VTKStuffClass import *

class freepanelCuttingPlaneClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()
                
    def __init__(self,caseDir,mainwindow,solver,installpath,rr,gg,bb):
        self.caseDir=caseDir
        self.installpath=installpath
        self.mainwindow=mainwindow
        self.solver=solver
        self.openSubWindow=False
        self.rr=rr;self.gg=gg;self.bb=bb
        
        aa=glob.glob(self.caseDir+'/system/settings/simulationConditions')
        if aa!=[]:
            GEN=generalClass(self.caseDir);dic=GEN.makeDictFromFile(aa[0])
            self.turmodel=dic['turmodel']
        else:self.turmodel='standardKEpsilon'
    #------------------------------------------------------------------------------------------
    def cuttingPlane(self,gvtk,notebook,maintextbuffer):
    
        GEN=generalClass(self.caseDir);VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb)

        def displayPlane(widget):
            originlist=[];normallist=[]                
            dic={}
            dic['number']=self.numCombo.child.get_text()
            dic['scalar']=self.scalarCombo.child.get_text()
            dic['selectedTime']=self.timeCombo.child.get_text()
            for i in range(int(dic['number'])):
                dic['axis'+str(i)]=self.axisCombo[i].child.get_text()
                dic['value'+str(i)]=self.points[i].get_text()
                if dic['axis'+str(i)]=='x':
                    originlist.append([dic['value'+str(i)],0,0]);normallist.append([1,0,0])
                elif dic['axis'+str(i)]=='y':
                    originlist.append([0,dic['value'+str(i)],0]);normallist.append([0,1,0])
                else:
                    originlist.append([0,0,dic['value'+str(i)]]);normallist.append([0,0,1])
            aa=glob.glob(self.caseDir+'/processor*')
            if aa==[]:caseType=1
            else:caseType=0
            viewposition=[1,1,1]               
            renderer=VTK.cutPlane(normallist,originlist,dic['scalar'],caseType,dic['selectedTime'],viewposition)
            gvtk.GetRenderWindow().AddRenderer(renderer)
            notebook.set_current_page(1)
            
            dic['normallist']=normallist;dic['originlist']=originlist;dic['caseType']=caseType   
            f=open(self.caseDir+'/system/settings/cuttingPlaneSet','w')
            pickle.dump(dic,f);f.close()
            
            f=open(self.caseDir+'/system/settings/displaymode','w')
            f.write('cuttingPlane');f.close()            
                
        def setEntry(widget):

            def checkPosition(widget,i):            
                minmax=GEN.getDomainRange()
                delx=float(minmax[1][0])-float(minmax[0][0])
                dely=float(minmax[1][1])-float(minmax[0][1])
                delz=float(minmax[1][2])-float(minmax[0][2])
        
                if self.axisCombo[i].child.get_text()=='x':
                    p0=[float(self.points[i].get_text()),float(minmax[0][1])-dely*0.1,float(minmax[0][2])-delz*0.1]
                    p1=[float(self.points[i].get_text()),float(minmax[1][1])+dely*0.1,float(minmax[0][2])-delz*0.1]
                    p2=[float(self.points[i].get_text()),float(minmax[1][1])+dely*0.1,float(minmax[1][2])+delz*0.1]
                    p3=[float(self.points[i].get_text()),float(minmax[0][1])-dely*0.1,float(minmax[1][2])+delz*0.1]
                elif self.axisCombo[i].child.get_text()=='y':
                    p0=[float(minmax[0][0])-delx*0.1,float(self.points[i].get_text()),float(minmax[0][2])-delz*0.1]
                    p1=[float(minmax[1][0])+delx*0.1,float(self.points[i].get_text()),float(minmax[0][2])-delz*0.1]
                    p2=[float(minmax[1][0])+delx*0.1,float(self.points[i].get_text()),float(minmax[1][2])+delz*0.1]
                    p3=[float(minmax[0][0])-delx*0.1,float(self.points[i].get_text()),float(minmax[1][2])+delz*0.1]
                else:
                    p0=[float(minmax[0][0])-delx*0.1,float(minmax[0][1])-dely*0.1,float(self.points[i].get_text())]
                    p1=[float(minmax[1][0])+delx*0.1,float(minmax[0][1])-dely*0.1,float(self.points[i].get_text())]
                    p2=[float(minmax[1][0])+delx*0.1,float(minmax[1][1])+dely*0.1,float(self.points[i].get_text())]
                    p3=[float(minmax[0][0])-delx*0.1,float(minmax[1][1])+dely*0.1,float(self.points[i].get_text())]
                   
                renderer=VTK.showCuttingPlane(p0,p1,p2,p3)
                gvtk.GetRenderWindow().AddRenderer(renderer)
                gvtk.Initialize();gvtk.Start()
                notebook.set_current_page(1)
            
            old=self.itembox.get_children();oldnumber=len(old)
            oldaxis=[];oldpoint=[]
            for i in range(oldnumber/3):
                oldaxis.append(self.axisCombo[i].child.get_text());oldpoint.append(self.points[i].get_text())

            pointnumber=int(self.numCombo.child.get_text())
            self.axisCombo=[];self.points=[];self.checkB=[]
            self.axisList=['x','y','z']
            self.scalarList=['Umag','p','T','gas1']
            for i in range(len(old)):self.itembox.remove(old[i])
            for i in range(pointnumber):            
                label=gtk.Label('Plane'+str(i+1))
                hbox=gtk.HBox(False,5);self.itembox.pack_start(hbox,False,False,10);hbox.pack_start(label,False,False,5)
                label=gtk.Label('Normal axis / Value')
                self.axisCombo.append(gtk.combo_box_entry_new_text());self.axisCombo[i].set_size_request(60,28)
                for ii in self.axisList:self.axisCombo[i].append_text(ii)
                self.axisCombo[i].set_active(0)                                                
                self.points.append(gtk.Entry());self.points[i].set_size_request(60,28);self.points[i].set_text('0')                
                hbox=gtk.HBox(False,5);self.itembox.pack_start(hbox,False,False,2)     
                hbox.pack_end(self.points[i],False,False,2);hbox.pack_end(self.axisCombo[i],False,False,2);hbox.pack_end(label,False,False,5)                
                self.checkB.append(gtk.Button('Check position'));self.checkB[i].set_size_request(140,28);self.checkB[i].connect('clicked',checkPosition,i)		                
                hbox=gtk.HBox(False,5);self.itembox.pack_start(hbox,False,False,3);hbox.pack_end(self.checkB[i],False,False,2)
            if oldnumber > pointnumber*3:
                for i in range(pointnumber):
                    self.axisCombo[i].set_active(self.axisList.index(oldaxis[i]));self.points[i].set_text(oldpoint[i])
            else:
                for i in range(oldnumber/3):
                    self.axisCombo[i].set_active(self.axisList.index(oldaxis[i]));self.points[i].set_text(oldpoint[i]) 
                    
            self.swin.show_all()   

        def setSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/cuttingPlaneSet')
            if aa!=[]:
                f=open(aa[0],'r');dic=pickle.load(f);f.close()
                self.numCombo.set_active(self.numList.index(dic['number']))
                self.scalarCombo.set_active(self.scalarList.index(dic['scalar']))
                self.timeCombo.set_active(self.results.index(dic['selectedTime']))
                for i in range(int(dic['number'])):
                    self.axisCombo[i].set_active(self.axisList.index(dic['axis'+str(i)]))
                    self.points[i].set_text(dic['value'+str(i)])
                                            
        self.cuttingPlanebox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('<b>  Cutting Plane  </b>')
        ebox=gtk.EventBox();self.cuttingPlanebox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label)
                
        label=gtk.Label();label.set_markup('<i>Define cutting plane  </i>');self.cuttingPlanebox.pack_start(label,False,False,5);label.set_alignment(0,0)

        label=gtk.Label('Number of Planes')
        self.numCombo=gtk.combo_box_entry_new_text()
        self.numCombo.set_size_request(120,28)
        self.numList=['0','1','2','3','4','5','6','7','8','9','10']
        for jj in self.numList:self.numCombo.append_text(jj)
        self.numCombo.set_active(0)
        self.numCombo.connect('changed',setEntry)       
        hbox=gtk.HBox(False,5);self.cuttingPlanebox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.numCombo,False,False,5)            

        label=gtk.Label('Scalar')
        self.scalarCombo=gtk.combo_box_entry_new_text();self.scalarCombo.set_size_request(120,28)
        self.scalarList=['Umag','p','p_rgh','T','k','epsilon','omega']
        for ii in self.scalarList:self.scalarCombo.append_text(ii)
        self.scalarCombo.set_active(0)
        hbox=gtk.HBox(False,5);self.cuttingPlanebox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.scalarCombo,False,False,5)

        label=gtk.Label('Select Time')
        self.timeCombo=gtk.combo_box_entry_new_text()
        self.timeCombo.set_size_request(120,28)        
        savedResult=GEN.getResult()
        if len(savedResult[0]) >= len(savedResult[1]):self.results=savedResult[0]
        else:self.results=savedResult[1]    
        self.results.append('latestTime')
        for jj in self.results:self.timeCombo.append_text(jj)
        self.timeCombo.set_active(self.results.index('latestTime'))        
        hbox=gtk.HBox(False,5);self.cuttingPlanebox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.timeCombo,False,False,5)
        #------------------------------
        self.swin=gtk.ScrolledWindow();self.swin.set_border_width(0);self.swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        self.cuttingPlanebox.pack_start(self.swin)
        self.itembox=gtk.VBox(False,0)
        self.swin.add_with_viewport(self.itembox)
        self.swin.set_size_request(280,570)
        #-----------------------------------        
        self.createB=gtk.Button('Display');self.createB.set_size_request(150,28);self.createB.connect('clicked',displayPlane)
        hbox=gtk.HBox(False,5);self.cuttingPlanebox.pack_start(hbox,False,False,5)
        hbox.pack_end(self.createB,True,True,5)
        
        setSavedValue()
    
        return self.cuttingPlanebox      
    #------------------------------------------------------------------------------------------
    def writeFileCuttingPlane(self,number,scalarlist,axislist,pointlist):
        
        f=open(self.caseDir+'/system/cuttingPlaneDict','w')
        f.write('FoamFile\n')
        f.write('{\n')
        f.write('    version     2.0;\n')
        f.write('    format      ascii;\n')
        f.write('    class       dictionary;\n')
        f.write('    location    "system";\n')
        f.write('    object      cuttingPlaneDict;\n')
        f.write('}\n')
        f.write('functions\n')
        f.write('{\n')
        for i in range(int(number)):
            if axislist[i]=='x':
                normal='(1 0 0)';base='('+pointlist[i]+' 0 0)'
            elif axislist[i]=='y':
                normal='(0 1 0)';base='(0 '+pointlist[i]+' 0)'
            else:
                normal='(0 0 1)';base='(0 0 '+pointlist[i]+')'
                    
            f.write('cuttingPlane'+str(i+1)+'\n')
            f.write('{\n')
            f.write('    type            surfaces;\n')
            f.write('    functionObjectLibs ("libsampling.so");\n')
            f.write('    outputControl   outputTime;\n')
            f.write('    surfaceFormat   vtk;\n')
            f.write('    fields          ( '+scalarlist[i]+');\n')
            f.write('    interpolationScheme cellPoint;\n')
            f.write('    surfaces\n')
            f.write('    (\n')
            f.write('        yNormal\n')
            f.write('        {\n')
            f.write('            type            cuttingPlane;\n')
            f.write('            planeType       pointAndNormal;\n')
            f.write('            pointAndNormalDict\n')
            f.write('            {\n')
            f.write('                basePoint       '+base+';\n')
            f.write('                normalVector    '+normal+';\n')
            f.write('            }\n')
            f.write('            interpolate     true;\n')
            f.write('        }\n')
            f.write('    );\n')
            f.write('}\n')
            f.write('\n')
        f.write('}\n')            
        f.close()
    #------------------------------------------------------------------------------------------
    def changeRASProperties(self): 
    
        def kEpsilonRASProperties():
            f=open(self.caseDir+'/constant/RASProperties','w')
            f.write('FoamFile\n')
            f.write('{\n')
            f.write('    version     2.0;\n')
            f.write('    format      ascii;\n')
            f.write('    class       dictionary;\n')
            f.write('    location    "constant";\n')
            f.write('    object      RASProperties;\n')
            f.write('}\n')
            f.write('RASModel        kEpsilon;\n')
            f.write('turbulence      on;\n')
            f.write('printCoeffs     on;\n')
            f.close()

        os.system('cp '+self.caseDir+'/constant/RASProperties '+self.caseDir+'/constant/oriRASProperties')
        kEpsilonRASProperties()
    #----------------------------------------------------------------------------------
    def main(self):
        gtk.main()

if __name__=='__main__':
    solverwin=Win()
    solverwin.main()
