#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for fvSchemes setup
#
# Author
#    NEXTFOAM Inc. 
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *
from boundaryConditionSub import *

class freepanelFvSchemesClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow,solver,installpath):
        self.caseDir=caseDir
        self.mainwindow=mainwindow
        self.solver=solver

    def fvSchemes(self,solver,notebook,textbuffer):
    
        GEN=generalClass(self.caseDir)
        
        def applythis(widget):
            GEN=generalClass(self.caseDir)
            ddtSchemes=ddtCombo.child.get_text();ddtcoeff=ddtCoeffEntry.get_text()                       
            interpolationSchemes=interpolCombo.child.get_text()
            gradSchemes=gradCombo.child.get_text();gradcoeff=gradCoeffEntry.get_text()                        
            snGradSchemes=snCombo.child.get_text();sngradcoeff=sngradCoeffEntry.get_text()                       
            laplacianSchemes=laplaceCombo.child.get_text();laplacecoeff=laplaceCoeffEntry.get_text()                        
            divUSchemes=divUCombo.child.get_text();divUcoeff=divUCoeffEntry.get_text()            
            divturSchemes=divturCombo.child.get_text();divturcoeff=divturCoeffEntry.get_text()                        
            divhSchemes=divhCombo.child.get_text();divhcoeff=divhCoeffEntry.get_text()                        
            bounded=boundCombo.child.get_text()
            
            if GEN.isNumber(ddtcoeff)==False:GEN.makeDialog('Error!!! ddt coeff. is not number')
            if GEN.isNumber(gradcoeff)==False:GEN.makeDialog('Error!!! gradc coeff. is not number')
            if GEN.isNumber(sngradcoeff)==False:GEN.makeDialog('Error!!! sngrad coeff. is not number')
            if GEN.isNumber(laplacecoeff)==False:GEN.makeDialog('Error!!! laplace coeff. is not number')
            if GEN.isNumber(divUcoeff)==False:GEN.makeDialog('Error!!! divU coeff. is not number')
            if GEN.isNumber(divturcoeff)==False:GEN.makeDialog('Error!!! divtur coeff. is not number')
            if GEN.isNumber(divhcoeff)==False:GEN.makeDialog('Error!!! divh coeff. is not number')
            
            if limitedgradU.get_active()==1:limitgradU='True'
            else:limitgradU='False'
            if limitedgradtur.get_active()==1:limitgradtur='True'
            else:limitgradtur='False'
            if limitedgradh.get_active()==1:limitgradh='True'
            else:limitgradh='False'

            fvSchemesDict={}
            fvSchemesDict['ddtSchemes']=[ddtSchemes,ddtcoeff];fvSchemesDict['interpolationSchemes']=[interpolationSchemes]
            fvSchemesDict['gradSchemes']=[gradSchemes,gradcoeff];fvSchemesDict['snGradSchemes']=[snGradSchemes,sngradcoeff]
            fvSchemesDict['laplacianSchemes']=[laplacianSchemes,laplacecoeff];fvSchemesDict['divUSchemes']=[divUSchemes,divUcoeff,limitgradU]
            fvSchemesDict['divhSchemes']=[divhSchemes,divhcoeff,limitgradh]
            fvSchemesDict['divturSchemes']=[divturSchemes,divturcoeff,limitgradtur]
            fvSchemesDict['boundedScheme']=[bounded]
            
            self.createFvSchemesFile(fvSchemesDict)

            f=open(self.caseDir+'/system/settings/fvSchemesSetup','w')
            f.write('ddtSchemes;'+ddtSchemes+','+ddtcoeff+'\n');f.write('interpolationSchemes;'+interpolationSchemes+'\n')
            f.write('gradSchemes;'+gradSchemes+','+gradcoeff+'\n');f.write('snGradSchemes;'+snGradSchemes+','+sngradcoeff+'\n')
            f.write('laplacianSchemes;'+laplacianSchemes+','+laplacecoeff+'\n');f.write('divUSchemes;'+divUSchemes+','+divUcoeff+','+limitgradU+'\n')
            f.write('divhSchemes;'+divhSchemes+','+divhcoeff+','+limitgradh+'\n')
            f.write('divturSchemes;'+divturSchemes+','+divturcoeff+','+limitgradtur+'\n')
            f.write('boundedScheme;'+bounded+'\n')
            f.close()
            
            message='\n [  fvSchemes is saved  ]\n'            
            message=message+'\n    - ddt scheme is '+fvSchemesDict['ddtSchemes'][0]+'\n'
            message=message+'\n    - interpolation scheme is '+fvSchemesDict['interpolationSchemes'][0]+'\n'
            message=message+'\n    - gradient scheme is '+fvSchemesDict['gradSchemes'][0]+'\n'
            message=message+'\n    - surface normal gradient scheme is '+fvSchemesDict['snGradSchemes'][0]+'\n'
            message=message+'\n    - laplacian scheme is '+fvSchemesDict['laplacianSchemes'][0]+'\n'
            message=message+'\n    - divergence U scheme is '+fvSchemesDict['divUSchemes'][0]+'\n'
            message=message+'\n    - divergence turbulence scheme is '+fvSchemesDict['divturSchemes'][0]+'\n'
            if self.solver=='buoyantSimpleNFoam' or self.solver=='buoyantPimpleNFoam': 
                message=message+'\n    - divergence h scheme is '+fvSchemesDict['divhSchemes'][0]+'\n'
                
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            notebook.set_current_page(0)             

        def chddt(widget):
            aa=widget.child;ddts=aa.get_text()
            if ddts=='CrankNicolson':ddtCoeffEntry.set_sensitive(1)
            else:ddtCoeffEntry.set_sensitive(0)

        def chgrad(widget):
            aa=widget.child;ddts=aa.get_text()
            if ddts=='cellLimited Gauss linear':gradCoeffEntry.set_sensitive(1)
            else:gradCoeffEntry.set_sensitive(0)

        def chsngrad(widget):
            aa=widget.child;ddts=aa.get_text()
            if ddts=='limited' or ddts=='limited corrected' or ddts=='relaxed':sngradCoeffEntry.set_sensitive(1)
            else:sngradCoeffEntry.set_sensitive(0)

        def chlaplace(widget):
            aa=widget.child;ddts=aa.get_text()
            if ddts=='Gauss linear limited' or ddts=='Gauss linear limited corrected' or ddts=='Gauss linear relaxed':laplaceCoeffEntry.set_sensitive(1)
            else:laplaceCoeffEntry.set_sensitive(0)

        def chdivu(widget):
            opts=widget.child.get_text()
            if opts[:7]=='limited':
                divUCoeffEntry.set_sensitive(1);limitedgradU.set_sensitive(0);limitedgradU.set_active(0)
            elif opts=='upwind':
                divUCoeffEntry.set_sensitive(0);limitedgradU.set_sensitive(0);limitedgradU.set_active(0)
            else:
                divUCoeffEntry.set_sensitive(0);limitedgradU.set_sensitive(1)

        def chdivtur(widget):
            opts=widget.child.get_text()
            if opts[:7]=='limited':
                divturCoeffEntry.set_sensitive(1);limitedgradtur.set_sensitive(0);limitedgradtur.set_active(0)
            elif opts=='upwind':
                divturCoeffEntry.set_sensitive(0);limitedgradtur.set_sensitive(0);limitedgradtur.set_active(0)
            else:
                divturCoeffEntry.set_sensitive(0);limitedgradtur.set_sensitive(1)

        def chdivh(widget):
            opts=widget.child.get_text()
            if opts[:7]=='limited':
                divhCoeffEntry.set_sensitive(1);limitedgradh.set_sensitive(0);limitedgradh.set_active(0)
            elif opts=='upwind':
                divhCoeffEntry.set_sensitive(0);limitedgradh.set_sensitive(0);limitedgradh.set_active(0)
            else:
                divhCoeffEntry.set_sensitive(0);limitedgradh.set_sensitive(1)
                
        def setSavedValue():
            sfile=glob.glob(self.caseDir+'/system/settings/fvSchemesSetup')
            if len(sfile)!=0:
                aa=GEN.getValue(sfile[0],'interpolationSchemes');aaa=interpol.index(aa);interpolCombo.set_active(aaa)
                aa=GEN.getValue(sfile[0],'gradSchemes');aa1=aa.split(',');aaa=gradient.index(aa1[0]);gradCombo.set_active(aaa)
                gradCoeffEntry.set_text(aa1[1])
                aa=GEN.getValue(sfile[0],'snGradSchemes');aa1=aa.split(',');aaa=snGradient.index(aa1[0]);snCombo.set_active(aaa)
                sngradCoeffEntry.set_text(aa1[1])
                aa=GEN.getValue(sfile[0],'laplacianSchemes');aa1=aa.split(',');aaa=laplacian.index(aa1[0]);laplaceCombo.set_active(aaa)
                laplaceCoeffEntry.set_text(aa1[1])
                aa=GEN.getValue(sfile[0],'divUSchemes');aa1=aa.split(',');aaa=divergenceU.index(aa1[0]);divUCombo.set_active(aaa)
                divUCoeffEntry.set_text(aa1[1])
                if aa1[2]=='True':limitedgradU.set_active(1)
                else:limitedgradU.set_active(0)
                aa=GEN.getValue(sfile[0],'divturSchemes');aa1=aa.split(',');aaa=divergencetur.index(aa1[0]);divturCombo.set_active(aaa)
                divturCoeffEntry.set_text(aa1[1])
                if aa1[2]=='True':limitedgradtur.set_active(1)
                else:limitedgradtur.set_active(0)                
                aa=GEN.getValue(sfile[0],'divhSchemes');aa1=aa.split(',');aaa=divergenceh.index(aa1[0]);divhCombo.set_active(aaa)
                divhCoeffEntry.set_text(aa1[1])
                if aa1[2]=='True':limitedgradh.set_active(1)
                else:limitedgradh.set_active(0)                  
                
                aa=GEN.getValue(sfile[0],'boundedScheme');aaa=boundedList.index(aa);boundCombo.set_active(aaa)

        def setDefault(widget):
            if self.solver=='simpleNFoam' or self.solver=='buoyantSimpleNFoam':ddtCombo.set_active(0)
            else:ddtCombo.set_active(1)
            interpolCombo.set_active(0)   
            gradCombo.set_active(0);gradCoeffEntry.set_text('1')
            snCombo.set_active(0);sngradCoeffEntry.set_text('0.333')
            laplaceCombo.set_active(0);laplaceCoeffEntry.set_text('0.333')
            boundCombo.set_active(0)
            divUCombo.set_active(0);divUCoeffEntry.set_text('1');limitedgradU.set_active(0)
            divturCombo.set_active(0);divturCoeffEntry.set_text('1');limitedgradtur.set_active(0)
            divhCombo.set_active(0);divhCoeffEntry.set_text('1');limitedgradh.set_active(0)
        #---------------------------------------------------------------------------------------------
        schbox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('<b>  fvSchemes  </b>')
        ebox=gtk.EventBox();schbox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label)  
                
        #separator=gtk.HSeparator();separator.set_size_request(285,5);schbox.pack_start(separator,True,True,5)
        # ddtSchemes                 
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,2)
        label=gtk.Label('ddtSchemes')
        ddtCombo=gtk.combo_box_entry_new_text();ddtCombo.set_size_request(180,28)
        ddtList=['steadyState','Euler','backward','localEuler rDeltaT','CrankNicolson']
        for ii in ddtList:ddtCombo.append_text(ii)
        if self.solver=='simpleNFoam' or self.solver=='buoyantSimpleNFoam':ddtCombo.set_active(0)
        else:ddtCombo.set_active(1)
        ddtCombo.connect('changed',chddt)
        hbox.pack_start(label,False,False,5);hbox.pack_end(ddtCombo,False,False,0)
        
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,0)
        label=gtk.Label('off-centering coeff.')
        ddtCoeffEntry=gtk.Entry();ddtCoeffEntry.set_size_request(60,28);ddtCoeffEntry.set_text('1')
        ddtCoeffEntry.set_sensitive(0)
        hbox.pack_end(ddtCoeffEntry,False,False,0);hbox.pack_end(label,False,False,5)
        
        # interpolationSchemes                 
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,2)
        label=gtk.Label('interpolation')
        interpolCombo=gtk.combo_box_entry_new_text();interpolCombo.set_size_request(180,28)
        interpol=['linear','cubicCorrection','midPoint']
        for i in range(len(interpol)):interpolCombo.append_text(interpol[i])            
        interpolCombo.set_active(0)
        hbox.pack_start(label,False,False,5);hbox.pack_end(interpolCombo,False,False,0)
        
        # gradSchemes                 
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,2)
        label=gtk.Label('gradient')
        gradCombo=gtk.combo_box_entry_new_text();gradCombo.set_size_request(180,28)
        gradient=['Gauss linear','leastSquares','fourth','cellLimited Gauss linear']
        for i in range(len(gradient)):gradCombo.append_text(gradient[i])                
        gradCombo.set_active(0)
        gradCombo.connect('changed',chgrad)
        hbox.pack_start(label,False,False,5);hbox.pack_end(gradCombo,False,False,0)
        
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,0)
        label=gtk.Label('limited coeff.')
        gradCoeffEntry=gtk.Entry();gradCoeffEntry.set_size_request(60,28);gradCoeffEntry.set_text('1')
        gradCoeffEntry.set_sensitive(0)
        hbox.pack_end(gradCoeffEntry,False,False,0);hbox.pack_end(label,False,False,5)
        
        # snGradSchemes                 
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,2)
        label=gtk.Label('snGradient')
        snCombo=gtk.combo_box_entry_new_text();snCombo.set_size_request(180,28)
        snGradient=['corrected','relaxed','uncorrected','limited','limited corrected','bounded','fourth']
        for i in range(len(snGradient)):snCombo.append_text(snGradient[i])
        snCombo.set_active(0)
        snCombo.connect('changed',chsngrad)
        hbox.pack_start(label,False,False,5);hbox.pack_end(snCombo,False,False,0)
        
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,0)
        label=gtk.Label('limited/relaxed coeff.')
        sngradCoeffEntry=gtk.Entry();sngradCoeffEntry.set_size_request(60,28);sngradCoeffEntry.set_text('0.333')
        sngradCoeffEntry.set_sensitive(0)
        hbox.pack_end(sngradCoeffEntry,False,False,0);hbox.pack_end(label,False,False,5)
        
        # laplacianSchemes                 
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,2)
        label=gtk.Label('laplacian')
        laplaceCombo=gtk.combo_box_entry_new_text();laplaceCombo.set_size_request(180,28)
        laplacian=['Gauss linear corrected','Gauss linear relaxed','Gauss linear limited','Gauss linear limited corrected','Gauss linear uncorrected']
        for i in range(len(laplacian)):laplaceCombo.append_text(laplacian[i])               
        laplaceCombo.set_active(0)
        laplaceCombo.connect('changed',chlaplace)
        hbox.pack_start(label,False,False,5);hbox.pack_end(laplaceCombo,False,False,0)
        
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,0)
        label=gtk.Label('limited/relaxed coeff.')
        laplaceCoeffEntry=gtk.Entry();laplaceCoeffEntry.set_size_request(60,28);laplaceCoeffEntry.set_text('0.333')
        laplaceCoeffEntry.set_sensitive(0)
        hbox.pack_end(laplaceCoeffEntry,False,False,0);hbox.pack_end(label,False,False,5)

        # --- divergence -------------------------------------
        separator=gtk.HSeparator();separator.set_size_request(285,5);schbox.pack_start(separator,True,True,2)        

        label=gtk.Label();label.set_markup('<i>  divergenceSchemes  </i>');schbox.pack_start(label,False,False,0);label.set_alignment(0,0.5)        
        
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,2)
        label=gtk.Label('bounded scheme')
        boundCombo=gtk.combo_box_entry_new_text();boundCombo.set_size_request(140,28)
        boundedList=['None','bounded']
        for i in range(len(boundedList)):boundCombo.append_text(boundedList[i])     
        if self.solver=='simpleNFoam' or self.solver=='buoyantSimpleNFoam':boundCombo.set_active(1)
        else:boundCombo.set_active(0)
        hbox.pack_start(label,False,False,5);hbox.pack_end(boundCombo,False,False,0)        
        
        # U                 
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,2)
        label=gtk.Label('U    ')
        divUCombo=gtk.combo_box_entry_new_text();divUCombo.set_size_request(130,28)
        divergenceU=['upwind','linearUpwindV','limitedLinearV','vanLeerV','SFCDV','GammaV','limitedCubicV','linear','skewLinear','cubicCorrected','QUICK','MUSCL']
        for i in range(len(divergenceU)):divUCombo.append_text(divergenceU[i])
        divUCombo.set_active(0)    
        divUCombo.connect('changed',chdivu)
        label1=gtk.Label('coeff.')           
        divUCoeffEntry=gtk.Entry();divUCoeffEntry.set_size_request(50,28);divUCoeffEntry.set_text('1');divUCoeffEntry.set_sensitive(0)
        hbox.pack_start(label,False,False,5);hbox.pack_start(divUCombo,False,False,0);hbox.pack_end(divUCoeffEntry,False,False,0);hbox.pack_end(label1,False,False,5)
        
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,0)
        limitedgradU=gtk.CheckButton('Use limited grad. scheme');limitedgradU.set_active(0);limitedgradU.set_sensitive(0)
        hbox.pack_end(limitedgradU,False,False,0)
        
        # turbulence                
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,2)
        label=gtk.Label('tur.')
        divturCombo=gtk.combo_box_entry_new_text();divturCombo.set_size_request(130,28)
        divergencetur=['upwind','linearUpwind','limitedLinear','vanLeer','SFCD','Gamma','limitedCubic','linear','skewLinear','cubicCorrected','QUICK','MUSCL']
        for i in range(len(divergencetur)):divturCombo.append_text(divergencetur[i])      
        divturCombo.set_active(0)  
        divturCombo.connect('changed',chdivtur)
        label1=gtk.Label('coeff.')           
        divturCoeffEntry=gtk.Entry();divturCoeffEntry.set_size_request(50,28);divturCoeffEntry.set_text('1');divturCoeffEntry.set_sensitive(0)
        hbox.pack_start(label,False,False,5);hbox.pack_start(divturCombo,False,False,0);hbox.pack_end(divturCoeffEntry,False,False,0);hbox.pack_end(label1,False,False,5)
        
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,0)
        limitedgradtur=gtk.CheckButton('Use limited grad. scheme');limitedgradtur.set_active(0);limitedgradtur.set_sensitive(0)
        hbox.pack_end(limitedgradtur,False,False,0)
        
        # h                
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,2)
        label=gtk.Label('h    ')
        divhCombo=gtk.combo_box_entry_new_text();divhCombo.set_size_request(130,28)
        divergenceh=['upwind','linearUpwind','limitedLinear','vanLeer','SFCD','Gamma','limitedCubic','linear','skewLinear','cubicCorrected','QUICK','MUSCL']
        for i in range(len(divergenceh)):divhCombo.append_text(divergenceh[i])      
        divhCombo.set_active(0)  
        divhCombo.connect('changed',chdivh)
        label1=gtk.Label('coeff.')           
        divhCoeffEntry=gtk.Entry();divhCoeffEntry.set_size_request(50,28);divhCoeffEntry.set_text('1');divhCoeffEntry.set_sensitive(0)
        hbox.pack_start(label,False,False,5);hbox.pack_start(divhCombo,False,False,0);hbox.pack_end(divhCoeffEntry,False,False,0);hbox.pack_end(label1,False,False,5)
        if self.solver=='simpleNFoam' or self.solver=='pimpleNFoam':divhCombo.set_sensitive(0)
        else:divhCombo.set_sensitive(1)
        
        hbox=gtk.HBox(False,5);schbox.pack_start(hbox,False,False,0)
        limitedgradh=gtk.CheckButton('Use limited grad. scheme');limitedgradh.set_active(0);limitedgradh.set_sensitive(0)
        hbox.pack_end(limitedgradh,False,False,0)
                
        # --- button -------------------
        hbox=gtk.HBox(True,5);schbox.pack_end(hbox,False,False,2)
        appB=gtk.Button(label='Apply');appB.connect('clicked',applythis)
        defaultB=gtk.Button('Set Default');defaultB.connect('clicked',setDefault)
        hbox.pack_start(appB,True,True,2);hbox.pack_start(defaultB,True,True,2)

        setSavedValue()        
        return schbox
    #--------------------------------------------------------------------------------------  
    def foamComment(self):
        fc=[]
        fc.append('/*--------------------------------*- C++ -*----------------------------------*\ \n')
        fc.append('| =========                 |                                                 |\n')
        fc.append('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |\n')
        fc.append('|  \\    /   O peration     | Version:  2.3.0                                 |\n')
        fc.append('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      |\n')
        fc.append('|    \\/     M anipulation  |                                                 |\n')
        fc.append('\*---------------------------------------------------------------------------*/\n')	
        return fc
    #------------------------------------------------------------------------------
    def header(self,location,obj):
        he=[]
        he.append('FoamFile\n')
        he.append('{\n')
        he.append('    version     2.0;\n')
        he.append('    format      ascii;\n')
        he.append('    class       dictionary;\n')
        he.append('    location    "'+location+'";\n')
        he.append('    object      '+obj+';\n')
        he.append('}\n')
        he.append('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //\n')
        return he                       
    #------------------------------------------------------------------------------
    def createFvSchemesFile(self,fvSchemesDict):

        fcom=self.foamComment()
        head=self.header('system','fvSchemes')
        hhh=fcom+head
        f=open(self.caseDir+'/system/fvSchemes','w')
        for aaa in hhh:f.write(aaa)

        f.write('ddtSchemes\n')
        f.write('{\n')
        if fvSchemesDict['ddtSchemes'][0]=='CrankNicolson':
            f.write('    default         '+fvSchemesDict['ddtSchemes'][0]+' '+fvSchemesDict['ddtSchemes'][1]+';\n')
        else:
            f.write('    default         '+fvSchemesDict['ddtSchemes'][0]+';\n')
        f.write('}\n')
        f.write('gradSchemes\n')
        f.write('{\n')
        if fvSchemesDict['gradSchemes'][0]=='cellLimited Gauss linear':
            f.write('    default         '+fvSchemesDict['gradSchemes'][0]+' '+fvSchemesDict['gradSchemes'][1]+';\n')
        else:
            f.write('    default         '+fvSchemesDict['gradSchemes'][0]+';\n')
        #f.write('    limitedGrad     cellLimited Gauss linear 1 ;\n')
        f.write('    limitedGrad     VKLimited Gauss linear 1 0.15;\n')
        f.write('    linearGrad      Gauss linear;\n')
        f.write('}\n')

        f.write('divSchemes\n')
        f.write('{\n')
        f.write('    default          Gauss linear;\n')
        if fvSchemesDict['boundedScheme'][0]=='None':
            if fvSchemesDict['divUSchemes'][0]=='upwind':
                f.write('    div(phi,U)       Gauss '+fvSchemesDict['divUSchemes'][0]+';\n')
            elif fvSchemesDict['divUSchemes'][0][:7]=='limited':
                f.write('    div(phi,U)       Gauss '+fvSchemesDict['divUSchemes'][0]+' '+fvSchemesDict['divUSchemes'][1]+';\n')
            else:
                if fvSchemesDict['divUSchemes'][2]=='False':
                    f.write('    div(phi,U)       Gauss '+fvSchemesDict['divUSchemes'][0]+' linearGrad;\n')
                else:
                    f.write('    div(phi,U)       Gauss '+fvSchemesDict['divUSchemes'][0]+' limitedGrad;\n')

            if fvSchemesDict['divhSchemes'][0]=='upwind':
                f.write('    div(phi,K)       Gauss '+fvSchemesDict['divhSchemes'][0]+';\n')
                f.write('    div(phi,h)       Gauss '+fvSchemesDict['divhSchemes'][0]+';\n')
                f.write('    div(phi,T)       Gauss '+fvSchemesDict['divhSchemes'][0]+';\n')
            elif fvSchemesDict['divhSchemes'][0][:7]=='limited':
                f.write('    div(phi,K)       Gauss '+fvSchemesDict['divhSchemes'][0]+' '+fvSchemesDict['divhSchemes'][1]+';\n')
                f.write('    div(phi,h)       Gauss '+fvSchemesDict['divhSchemes'][0]+' '+fvSchemesDict['divhSchemes'][1]+';\n')
                f.write('    div(phi,T)       Gauss '+fvSchemesDict['divhSchemes'][0]+' '+fvSchemesDict['divhSchemes'][1]+';\n')
            else:
                if fvSchemesDict['divhSchemes'][2]=='False':
                    f.write('    div(phi,K)       Gauss '+fvSchemesDict['divhSchemes'][0]+' linearGrad;\n')
                    f.write('    div(phi,h)       Gauss '+fvSchemesDict['divhSchemes'][0]+' linearGrad;\n')
                    f.write('    div(phi,T)       Gauss '+fvSchemesDict['divhSchemes'][0]+' linearGrad;\n')
                else:
                    f.write('    div(phi,K)       Gauss '+fvSchemesDict['divhSchemes'][0]+' limitedGrad;\n')
                    f.write('    div(phi,h)       Gauss '+fvSchemesDict['divhSchemes'][0]+' limitedGrad;\n')
                    f.write('    div(phi,T)       Gauss '+fvSchemesDict['divhSchemes'][0]+' limitedGrad;\n')

            if fvSchemesDict['divturSchemes'][0]=='upwind':
                f.write('    div(phi,k)       Gauss '+fvSchemesDict['divturSchemes'][0]+';\n')
                f.write('    div(phi,epsilon)       Gauss '+fvSchemesDict['divturSchemes'][0]+';\n')
                f.write('    div(phi,omega)       Gauss '+fvSchemesDict['divturSchemes'][0]+';\n')
                f.write('    div(phi,nuTilda)       Gauss '+fvSchemesDict['divturSchemes'][0]+';\n')
            elif fvSchemesDict['divturSchemes'][0][:7]=='limited':
                f.write('    div(phi,k)       Gauss '+fvSchemesDict['divturSchemes'][0]+' '+fvSchemesDict['divturSchemes'][1]+';\n')
                f.write('    div(phi,epsilon)       Gauss '+fvSchemesDict['divturSchemes'][0]+' '+fvSchemesDict['divturSchemes'][1]+';\n')
                f.write('    div(phi,omega)       Gauss '+fvSchemesDict['divturSchemes'][0]+' '+fvSchemesDict['divturSchemes'][1]+';\n')
                f.write('    div(phi,nuTilda)       Gauss '+fvSchemesDict['divturSchemes'][0]+' '+fvSchemesDict['divturSchemes'][1]+';\n')
            else:
                if fvSchemesDict['divturSchemes'][2]=='False':
                    f.write('    div(phi,k)       Gauss '+fvSchemesDict['divturSchemes'][0]+' linearGrad;\n')
                    f.write('    div(phi,epsilon)       Gauss '+fvSchemesDict['divturSchemes'][0]+' linearGrad;\n')
                    f.write('    div(phi,omega)       Gauss '+fvSchemesDict['divturSchemes'][0]+' linearGrad;\n')
                    f.write('    div(phi,nuTilda)       Gauss '+fvSchemesDict['divturSchemes'][0]+' linearGrad;\n')
                else:
                    f.write('    div(phi,k)       Gauss '+fvSchemesDict['divturSchemes'][0]+' limitedGrad;\n')
                    f.write('    div(phi,epsilon)       Gauss '+fvSchemesDict['divturSchemes'][0]+' limitedGrad;\n')
                    f.write('    div(phi,omega)       Gauss '+fvSchemesDict['divturSchemes'][0]+' limitedGrad;\n')
                    f.write('    div(phi,nuTilda)       Gauss '+fvSchemesDict['divturSchemes'][0]+' limitedGrad;\n')
        else:
            bound=fvSchemesDict['boundedScheme'][0]
            if fvSchemesDict['divUSchemes'][0]=='upwind':
                f.write('    div(phi,U)           '+bound+' Gauss '+fvSchemesDict['divUSchemes'][0]+';\n')
            elif fvSchemesDict['divUSchemes'][0][:7]=='limited':
                f.write('    div(phi,U)           '+bound+' Gauss '+fvSchemesDict['divUSchemes'][0]+' '+fvSchemesDict['divUSchemes'][1]+';\n')
            else:
                if fvSchemesDict['divUSchemes'][2]=='False':
                    f.write('    div(phi,U)           '+bound+' Gauss '+fvSchemesDict['divUSchemes'][0]+' linearGrad;\n')
                else:
                    f.write('    div(phi,U)           '+bound+' Gauss '+fvSchemesDict['divUSchemes'][0]+' limitedGrad;\n')

            if fvSchemesDict['divhSchemes'][0]=='upwind':
                f.write('    div(phi,K)       '+bound+' Gauss '+fvSchemesDict['divhSchemes'][0]+';\n')
                f.write('    div(phi,h)       '+bound+' Gauss '+fvSchemesDict['divhSchemes'][0]+';\n')
                f.write('    div(phi,T)       '+bound+' Gauss '+fvSchemesDict['divhSchemes'][0]+';\n')
            elif fvSchemesDict['divhSchemes'][0][:7]=='limited':
                f.write('    div(phi,K)       '+bound+' Gauss '+fvSchemesDict['divhSchemes'][0]+' '+fvSchemesDict['divhSchemes'][1]+';\n')
                f.write('    div(phi,h)       '+bound+' Gauss '+fvSchemesDict['divhSchemes'][0]+' '+fvSchemesDict['divhSchemes'][1]+';\n')
                f.write('    div(phi,T)       '+bound+' Gauss '+fvSchemesDict['divhSchemes'][0]+' '+fvSchemesDict['divhSchemes'][1]+';\n')
            else:
                if fvSchemesDict['divhSchemes'][2]=='False':
                    f.write('    div(phi,K)       '+bound+' Gauss '+fvSchemesDict['divhSchemes'][0]+' linearGrad;\n')
                    f.write('    div(phi,h)       '+bound+' Gauss '+fvSchemesDict['divhSchemes'][0]+' linearGrad;\n')
                    f.write('    div(phi,T)       '+bound+' Gauss '+fvSchemesDict['divhSchemes'][0]+' linearGrad;\n')
                else:
                    f.write('    div(phi,K)       '+bound+' Gauss '+fvSchemesDict['divhSchemes'][0]+' limitedGrad;\n')
                    f.write('    div(phi,h)       '+bound+' Gauss '+fvSchemesDict['divhSchemes'][0]+' limitedGrad;\n')
                    f.write('    div(phi,T)       '+bound+' Gauss '+fvSchemesDict['divhSchemes'][0]+' limitedGrad;\n')

            if fvSchemesDict['divturSchemes'][0]=='upwind':
                f.write('    div(phi,k)           '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+';\n')
                f.write('    div(phi,epsilon)     '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+';\n')
                f.write('    div(phi,omega)       '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+';\n')
                f.write('    div(phi,nuTilda)     '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+';\n')
            elif fvSchemesDict['divturSchemes'][0][:7]=='limited':
                f.write('    div(phi,k)           '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+' '+fvSchemesDict['divturSchemes'][1]+';\n')
                f.write('    div(phi,epsilon)     '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+' '+fvSchemesDict['divturSchemes'][1]+';\n')
                f.write('    div(phi,omega)       '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+' '+fvSchemesDict['divturSchemes'][1]+';\n')
                f.write('    div(phi,nuTilda)     '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+' '+fvSchemesDict['divturSchemes'][1]+';\n')
            else:
                if fvSchemesDict['divturSchemes'][2]=='False':
                    f.write('    div(phi,k)           '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+' linearGrad;\n')
                    f.write('    div(phi,epsilon)     '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+' linearGrad;\n')
                    f.write('    div(phi,omega)       '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+' linearGrad;\n')
                    f.write('    div(phi,nuTilda)     '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+' linearGrad;\n')
                else:
                    f.write('    div(phi,k)           '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+' limitedGrad;\n')
                    f.write('    div(phi,epsilon)     '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+' limitedGrad;\n')
                    f.write('    div(phi,omega)       '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+' limitedGrad;\n')
                    f.write('    div(phi,nuTilda)     '+bound+' Gauss '+fvSchemesDict['divturSchemes'][0]+' limitedGrad;\n')

        f.write('    div(phid,p)      Gauss upwind;\n')

        f.write('}\n')

        f.write('laplacianSchemes\n')
        f.write('{\n')
        lapsch=fvSchemesDict['laplacianSchemes'][0]
        if lapsch=='Gauss linear limited' or lapsch=='Gauss linear limited corrected' or lapsch=='Gauss linear relaxed':
            f.write('    default         '+lapsch+' '+fvSchemesDict['laplacianSchemes'][1]+';\n')
        else:
            f.write('    default         '+lapsch+';\n')
        f.write('}\n')

        f.write('interpolationSchemes\n')
        f.write('{\n')
        f.write('    default         '+fvSchemesDict['interpolationSchemes'][0]+';\n')
        f.write('}\n')

        f.write('snGradSchemes\n')
        f.write('{\n')
        snsch=fvSchemesDict['snGradSchemes'][0]
        if snsch=='limited' or snsch=='limited corrected' or snsch=='relaxed':
            f.write('    default         '+snsch+' '+fvSchemesDict['snGradSchemes'][1]+';\n')
        else:
            f.write('    default         '+snsch+';\n')
        f.write('}\n')

        f.write('fluxRequired\n')
        f.write('{\n')
        f.write('    default         no;\n')
        f.write('    p_rgh             ;\n')
        f.write('    p             ;\n')
        f.write('}\n')
        f.close()
    #------------------------------------------------------------------------------
