#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for fvSolution setup
#
# Author
#    NEXTFOAM Inc. 
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *
from boundaryConditionSub import *
from VTKStuffClass import *

class freepanelFvSolutionClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow,solver,installpath):
        self.caseDir=caseDir
        self.mainwindow=mainwindow
        self.solver=solver
        self.openSubWindow=False

    def fvSolution(self,solver,notebook,textbuffer):
    
        GEN=generalClass(self.caseDir)

        def psolverAdv(widget):
            if self.openSubWindow==False:
                aa=psolverCombo.child;psolver=aa.get_text()
                self.psolverAdv(solver,psolver)
            
        def usolverAdv(widget,field):
            if self.openSubWindow==False:
                aa=usolverCombo.child;usolver=aa.get_text()
                self.usolverAdv(solver,usolver,field)
            
        def applythis(widget):
            GEN=generalClass(self.caseDir)
            fvSolutionDict={}
            fvSolutionDict['psolver']=psolverCombo.child.get_text();fvSolutionDict['ptolerance']=ptolEntry.get_text();fvSolutionDict['prelTol']=preltolEntry.get_text()
            fvSolutionDict['usolver']=usolverCombo.child.get_text();fvSolutionDict['utolerance']=utolEntry.get_text();fvSolutionDict['urelTol']=ureltolEntry.get_text()
            fvSolutionDict['tursolver']=tursolverCombo.child.get_text();fvSolutionDict['turtolerance']=turtolEntry.get_text();fvSolutionDict['turrelTol']=turreltolEntry.get_text()
            fvSolutionDict['hsolver']=hsolverCombo.child.get_text();fvSolutionDict['htolerance']=htolEntry.get_text();fvSolutionDict['hrelTol']=hreltolEntry.get_text()
            fvSolutionDict['nNonOrtho']=nonorthoEntry.get_text();fvSolutionDict['nOuterCorrectors']=noutEntry.get_text();fvSolutionDict['nCorrectors']=ncorrEntry.get_text()
            fvSolutionDict['relaxp']=prelaxEntry.get_text();fvSolutionDict['relaxu']=urelaxEntry.get_text();fvSolutionDict['relaxtur']=turrelaxEntry.get_text()
            fvSolutionDict['relaxh']=hrelaxEntry.get_text()
            
            fvSolutionDict['convergencep']=pconvEntry.get_text();fvSolutionDict['convergenceu']=uconvEntry.get_text()
            fvSolutionDict['convergencetur']=turconvEntry.get_text();fvSolutionDict['convergenceh']=hconvEntry.get_text()            
            if refCB.get_active()==1:fvSolutionDict['useRefPoint']='true'
            else:fvSolutionDict['useRefPoint']='false'
            fvSolutionDict['refx']=refxEntry.get_text();fvSolutionDict['refy']=refyEntry.get_text();fvSolutionDict['refz']=refzEntry.get_text()
            fvSolutionDict['refvalue']=refvalueEntry.get_text()

            if GEN.isNumber(fvSolutionDict['ptolerance'])==False:GEN.makeDialog('Error!!! ptolerance is not number')            
            if GEN.isNumber(fvSolutionDict['prelTol'])==False:GEN.makeDialog('Error!!! prelTol is not number')            
            if GEN.isNumber(fvSolutionDict['utolerance'])==False:GEN.makeDialog('Error!!! utolerance is not number')            
            if GEN.isNumber(fvSolutionDict['urelTol'])==False:GEN.makeDialog('Error!!! urelTol is not number')            
            if GEN.isNumber(fvSolutionDict['turtolerance'])==False:GEN.makeDialog('Error!!! turtolerance is not number')            
            if GEN.isNumber(fvSolutionDict['turrelTol'])==False:GEN.makeDialog('Error!!! turrelTol is not number')            
            if GEN.isNumber(fvSolutionDict['htolerance'])==False:GEN.makeDialog('Error!!! htolerance is not number')            
            if GEN.isNumber(fvSolutionDict['hrelTol'])==False:GEN.makeDialog('Error!!! hrelTol is not number') 
            if GEN.isNumber(fvSolutionDict['nNonOrtho'])==False:GEN.makeDialog('Error!!! nNonOrtho is not number')            
            if GEN.isNumber(fvSolutionDict['nOuterCorrectors'])==False:GEN.makeDialog('Error!!! nOuterCorrectors is not number')            
            if GEN.isNumber(fvSolutionDict['nCorrectors'])==False:GEN.makeDialog('Error!!! nCorrectors is not number')            
            if GEN.isNumber(fvSolutionDict['relaxp'])==False:GEN.makeDialog('Error!!! relaxp is not number')            
            if GEN.isNumber(fvSolutionDict['relaxu'])==False:GEN.makeDialog('Error!!! relaxu is not number')                        
            if GEN.isNumber(fvSolutionDict['relaxtur'])==False:GEN.makeDialog('Error!!! relaxtur is not number')                        
            if GEN.isNumber(fvSolutionDict['relaxh'])==False:GEN.makeDialog('Error!!! relaxh is not number')
            if GEN.isNumber(fvSolutionDict['convergencep'])==False:GEN.makeDialog('Error!!! convergence p is not number')
            if GEN.isNumber(fvSolutionDict['convergenceu'])==False:GEN.makeDialog('Error!!! convergence U is not number') 
            if GEN.isNumber(fvSolutionDict['convergencetur'])==False:GEN.makeDialog('Error!!! convergence tur is not number') 
            if GEN.isNumber(fvSolutionDict['convergenceh'])==False:GEN.makeDialog('Error!!! convergence h is not number')                         
            if GEN.isNumber(fvSolutionDict['refx'])==False:GEN.makeDialog('Error!!! reference point x is not number')
            if GEN.isNumber(fvSolutionDict['refy'])==False:GEN.makeDialog('Error!!! reference point y is not number') 
            if GEN.isNumber(fvSolutionDict['refz'])==False:GEN.makeDialog('Error!!! reference point z is not number') 
            if GEN.isNumber(fvSolutionDict['refvalue'])==False:GEN.makeDialog('Error!!! reference value is not number')  
            
            if float(fvSolutionDict['relaxp'])>1.0:
                GEN.makeDialog('Warning!!! p relaxation factor is larger than 1. Value is set to default value');prelaxEntry.set_text('0.3')
            if float(fvSolutionDict['relaxu'])>1.0:
                GEN.makeDialog('Warning!!! U relaxation factor is larger than 1. Value is set to default value');urelaxEntry.set_text('0.7')
            if float(fvSolutionDict['relaxtur'])>1.0:
                GEN.makeDialog('Warning!!! Turb. relaxation factor is larger than 1. Value is set to default value');turrelaxEntry.set_text('0.7')
            if float(fvSolutionDict['relaxh'])>1.0:
                GEN.makeDialog('Warning!!! h relaxation factor is larger than 1. Value is set to default value');hrelaxEntry.set_text('1.0')
            
            keys=fvSolutionDict.keys()
            f=open(self.caseDir+'/system/settings/fvSolutionSetup','w')
            for ii in keys:f.write(ii+';'+fvSolutionDict[ii]+'\n')
            f.close()

            pAdvDict={}
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_pAdv')
            if len(sfile)!=0:
                pAdvDict=GEN.makeDictFromFile(sfile[0])
            else:
                pAdvDict['minIter']='0';pAdvDict['maxIter']='50';pAdvDict['PCGPreconditioner']='DIC'
                pAdvDict['GAMGSmoother']='symGaussSeidel';pAdvDict['GAMGnPreSweeps']='0';pAdvDict['GAMGnPostSweeps']='2'
                pAdvDict['GAMGcache']='true';pAdvDict['GAMGagglomerator']='faceAreaPair';pAdvDict['GAMGnCellsInCoarsestLevel']='10'
                pAdvDict['GAMGmergeLevels']='1';pAdvDict['pFinalTol']='1e-7';pAdvDict['pFinalRelTol']='0';pAdvDict['pcorrTol']='1e-7';pAdvDict['pcorrRelTol']='0'

            UAdvDict={}
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_UAdv')
            if len(sfile)!=0:
                UAdvDict=GEN.makeDictFromFile(sfile[0])
            else:
                UAdvDict['minIter']='0';UAdvDict['maxIter']='500';UAdvDict['PCGPreconditioner']='DILU';UAdvDict['smoothSmoother']='GaussSeidel'
                UAdvDict['GAMGSmoother']='symGaussSeidel';UAdvDict['GAMGnPreSweeps']='0';UAdvDict['GAMGnPostSweeps']='2'
                UAdvDict['GAMGcache']='true';UAdvDict['GAMGagglomerator']='faceAreaPair';UAdvDict['GAMGnCellsInCoarsestLevel']='10'
                UAdvDict['GAMGmergeLevels']='1';UAdvDict['finalTol']='1e-7';UAdvDict['finalRelTol']='0'

            turAdvDict={}
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_turAdv')
            if len(sfile)!=0:
                turAdvDict=GEN.makeDictFromFile(sfile[0])
            else:
                turAdvDict['minIter']='0';turAdvDict['maxIter']='500';turAdvDict['PCGPreconditioner']='DILU';turAdvDict['smoothSmoother']='GaussSeidel'
                turAdvDict['GAMGSmoother']='symGaussSeidel';turAdvDict['GAMGnPreSweeps']='0';turAdvDict['GAMGnPostSweeps']='2'
                turAdvDict['GAMGcache']='true';turAdvDict['GAMGagglomerator']='faceAreaPair';turAdvDict['GAMGnCellsInCoarsestLevel']='10'
                turAdvDict['GAMGmergeLevels']='1';turAdvDict['finalTol']='1e-7';turAdvDict['finalRelTol']='0'
                
            hAdvDict={}
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_hAdv')
            if len(sfile)!=0:
                hAdvDict=GEN.makeDictFromFile(sfile[0])
            else:
                hAdvDict['minIter']='0';hAdvDict['maxIter']='500';hAdvDict['PCGPreconditioner']='DILU';hAdvDict['smoothSmoother']='GaussSeidel'
                hAdvDict['GAMGSmoother']='symGaussSeidel';hAdvDict['GAMGnPreSweeps']='0';hAdvDict['GAMGnPostSweeps']='2'
                hAdvDict['GAMGcache']='true';hAdvDict['GAMGagglomerator']='faceAreaPair';hAdvDict['GAMGnCellsInCoarsestLevel']='10'
                hAdvDict['GAMGmergeLevels']='1';hAdvDict['finalTol']='1e-7';hAdvDict['finalRelTol']='0'

            self.createFvSolutionFile(fvSolutionDict,pAdvDict,UAdvDict,turAdvDict,hAdvDict)
            
            message='\n [  fvSolution is saved  ]\n'
            message=message+'\n    - nNonOrthogonalCorrectors is '+fvSolutionDict['nNonOrtho']+'\n'            
            if self.solver=='pimpleNFoam' or self.solver=='buoyantPimpleNFoam':
                message=message+'\n    - nOuterCorrectors is '+fvSolutionDict['nOuterCorrectors']+'\n' 
                message=message+'\n    - nCorrectors is '+fvSolutionDict['nCorrectors']+'\n' 
            message=message+'\n    - relaxation factor of p is '+fvSolutionDict['relaxp']+'\n' 
            message=message+'\n    - relaxation factor of U is '+fvSolutionDict['relaxu']+'\n' 
            message=message+'\n    - relaxation factor of turbulence is '+fvSolutionDict['relaxtur']+'\n' 
            if self.solver=='buoyantSimpleNFoam' or self.solver=='buoyantPimpleNFoam': 
                message=message+'\n    - relaxation factor of h is '+fvSolutionDict['relaxh']+'\n' 
                
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            notebook.set_current_page(0)             

        def setDefault(widget):
            psolverCombo.set_active(0);ptolEntry.set_text('1e-7');preltolEntry.set_text('0.1');prelaxEntry.set_text('0.3')
            usolverCombo.set_active(0);utolEntry.set_text('1e-7');ureltolEntry.set_text('0.1');urelaxEntry.set_text('0.7')
            tursolverCombo.set_active(0);turtolEntry.set_text('1e-7');turreltolEntry.set_text('0.1');turrelaxEntry.set_text('0.7')            
            hsolverCombo.set_active(0);htolEntry.set_text('1e-7');hreltolEntry.set_text('0.1');hrelaxEntry.set_text('0.7')
            nonorthoEntry.set_text('0');noutEntry.set_text('1');ncorrEntry.set_text('2')
            pconvEntry.set_text('1e-3');uconvEntry.set_text('1e-3');turconvEntry.set_text('1e-3');hconvEntry.set_text('1e-3')
            refCB.set_active(0);refxEntry.set_text('0');refyEntry.set_text('0');refzEntry.set_text('0');refvalueEntry.set_text('0')

        def setSavedValue():
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolutionSetup')
            if len(sfile)!=0:
                dic=GEN.makeDictFromFile(sfile[0])
                psolverCombo.set_active(psolverList.index(dic['psolver']));ptolEntry.set_text(dic['ptolerance']);preltolEntry.set_text(dic['prelTol'])
                usolverCombo.set_active(usolverList.index(dic['usolver']));utolEntry.set_text(dic['utolerance']);ureltolEntry.set_text(dic['urelTol'])
                tursolverCombo.set_active(tursolverList.index(dic['tursolver']));turtolEntry.set_text(dic['turtolerance']);turreltolEntry.set_text(dic['turrelTol'])
                hsolverCombo.set_active(hsolverList.index(dic['hsolver']));htolEntry.set_text(dic['htolerance']);hreltolEntry.set_text(dic['hrelTol']) 
                nonorthoEntry.set_text(dic['nNonOrtho']);noutEntry.set_text(dic['nOuterCorrectors']);ncorrEntry.set_text(dic['nCorrectors'])
                prelaxEntry.set_text(dic['relaxp']);urelaxEntry.set_text(dic['relaxu']);turrelaxEntry.set_text(dic['relaxtur'])
                hrelaxEntry.set_text(dic['relaxh'])
                pconvEntry.set_text(dic['convergencep']);uconvEntry.set_text(dic['convergenceu']);turconvEntry.set_text(dic['convergencetur']);hconvEntry.set_text(dic['convergenceh'])
                if dic['useRefPoint']=='true':refCB.set_active(1)
                else:refCB.set_active(0)
                refxEntry.set_text(dic['refx']);refyEntry.set_text(dic['refy']);refzEntry.set_text(dic['refz']);refvalueEntry.set_text(dic['refvalue'])
                                     
        #---------------------------------------------------------------------------------------------
        solbox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('<b>  fvSolution  </b>')
        ebox=gtk.EventBox();solbox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label)        

        #separator=gtk.HSeparator();separator.set_size_request(285,5);solbox.pack_start(separator,True,True,5)
        # ----- Solvers----------------                 
        #label=gtk.Label();label.set_markup('<i>  solver  </i>');solbox.pack_start(label,False,False,0);label.set_alignment(0,0.5)

        table=gtk.Table(5,3,False);table.set_row_spacings(3);table.set_col_spacings(2)
        solbox.pack_start(table,False,False,5)

        # p
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,0,1);label=gtk.Label('  p');hbox.pack_start(label,False,False,0)        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,0,1)
        psolverCombo=gtk.combo_box_entry_new_text();psolverCombo.set_size_request(140,28)
        psolverList=['GAMG','PCG','smoothSolver']
        for ii in psolverList:psolverCombo.append_text(ii) 
        psolverCombo.set_active(0)
        hbox.pack_start(psolverCombo,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,0,1)
        psolverB=gtk.Button('more');psolverB.set_size_request(80,28);psolverB.connect('clicked',psolverAdv)                
        hbox.pack_start(psolverB,False,False,0)
        # U
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,1,2);label=gtk.Label('  U');hbox.pack_start(label,False,False,0)        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,1,2)
        usolverCombo=gtk.combo_box_entry_new_text();usolverCombo.set_size_request(140,28)
        usolverList=['smoothSolver','PBiCG','GAMG']
        for ii in usolverList:usolverCombo.append_text(ii) 
        usolverCombo.set_active(0)
        hbox.pack_start(usolverCombo,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,1,2)
        usolverB=gtk.Button('more');usolverB.set_size_request(80,28);usolverB.connect('clicked',usolverAdv,'U')                
        hbox.pack_start(usolverB,False,False,0)
        # turbulence
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,2,3);label=gtk.Label('  tur.');hbox.pack_start(label,False,False,0)        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,2,3)
        tursolverCombo=gtk.combo_box_entry_new_text();tursolverCombo.set_size_request(140,28)
        tursolverList=['smoothSolver','PBiCG','GAMG']
        for ii in tursolverList:tursolverCombo.append_text(ii) 
        tursolverCombo.set_active(0)
        hbox.pack_start(tursolverCombo,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,2,3)
        tursolverB=gtk.Button('more');tursolverB.set_size_request(80,28);tursolverB.connect('clicked',usolverAdv,'tur')                
        hbox.pack_start(tursolverB,False,False,0)
        # h
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,3,4);label=gtk.Label('  h');hbox.pack_start(label,False,False,0)        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,3,4)
        hsolverCombo=gtk.combo_box_entry_new_text();hsolverCombo.set_size_request(140,28)
        hsolverList=['smoothSolver','PBiCG','GAMG']
        for ii in hsolverList:hsolverCombo.append_text(ii) 
        hsolverCombo.set_active(0)
        hbox.pack_start(hsolverCombo,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,3,4)
        hsolverB=gtk.Button('more');hsolverB.set_size_request(80,28);hsolverB.connect('clicked',usolverAdv,'h')                
        hbox.pack_start(hsolverB,False,False,0)        

        # Tolerance
        separator=gtk.HSeparator();separator.set_size_request(285,5);solbox.pack_start(separator,True,True,2)
                
        label=gtk.Label();label.set_markup('<i>  tolerance / relTol / convergence  </i>');solbox.pack_start(label,False,False,0);label.set_alignment(0,0.5)
                                 
        table=gtk.Table(5,4,False);table.set_row_spacings(3);table.set_col_spacings(2)
        solbox.pack_start(table,False,False,10)

        # p
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,0,1);label=gtk.Label('  p');hbox.pack_start(label,False,False,0)        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,0,1)
        ptolEntry=gtk.Entry();ptolEntry.set_size_request(70,28);ptolEntry.set_text('1e-7')
        hbox.pack_start(ptolEntry,False,False,0)        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,0,1)
        preltolEntry=gtk.Entry();preltolEntry.set_size_request(70,28);preltolEntry.set_text('0.1')             
        hbox.pack_start(preltolEntry,False,False,0)
        hbox=gtk.HBox(False,5);table.attach(hbox,3,4,0,1)
        pconvEntry=gtk.Entry();pconvEntry.set_size_request(70,28);pconvEntry.set_text('1e-3')             
        hbox.pack_start(pconvEntry,False,False,0)

        # U
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,1,2);label=gtk.Label('  U');hbox.pack_start(label,False,False,0)
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,1,2)
        utolEntry=gtk.Entry();utolEntry.set_size_request(70,28);utolEntry.set_text('1e-7')
        hbox.pack_start(utolEntry,False,False,0)
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,1,2)
        ureltolEntry=gtk.Entry();ureltolEntry.set_size_request(70,28);ureltolEntry.set_text('0.1')             
        hbox.pack_start(ureltolEntry,False,False,0)
        hbox=gtk.HBox(False,5);table.attach(hbox,3,4,1,2)
        uconvEntry=gtk.Entry();uconvEntry.set_size_request(70,28);uconvEntry.set_text('1e-3')             
        hbox.pack_start(uconvEntry,False,False,0)        

        # turbulence
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,2,3);label=gtk.Label('  tur.');hbox.pack_start(label,False,False,0)        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,2,3)
        turtolEntry=gtk.Entry();turtolEntry.set_size_request(70,28);turtolEntry.set_text('1e-7')
        hbox.pack_start(turtolEntry,False,False,0)        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,2,3)
        turreltolEntry=gtk.Entry();turreltolEntry.set_size_request(70,28);turreltolEntry.set_text('0.1')             
        hbox.pack_start(turreltolEntry,False,False,0)
        hbox=gtk.HBox(False,5);table.attach(hbox,3,4,2,3)
        turconvEntry=gtk.Entry();turconvEntry.set_size_request(70,28);turconvEntry.set_text('1e-3')             
        hbox.pack_start(turconvEntry,False,False,0)

        # h
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,3,4);label=gtk.Label('  h');hbox.pack_start(label,False,False,0)        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,3,4)
        htolEntry=gtk.Entry();htolEntry.set_size_request(70,28);htolEntry.set_text('1e-7')
        hbox.pack_start(htolEntry,False,False,0)        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,3,4)
        hreltolEntry=gtk.Entry();hreltolEntry.set_size_request(70,28);hreltolEntry.set_text('0.1')             
        hbox.pack_start(hreltolEntry,False,False,0)
        hbox=gtk.HBox(False,5);table.attach(hbox,3,4,3,4)
        hconvEntry=gtk.Entry();hconvEntry.set_size_request(70,28);hconvEntry.set_text('1e-3')             
        hbox.pack_start(hconvEntry,False,False,0)
        
        separator=gtk.HSeparator();separator.set_size_request(285,5);solbox.pack_start(separator,True,True,2)
        # --- SIMPLE / PIMPLE  ----------------------------
        #label=gtk.Label();label.set_markup('<i>  SIMPLE / PIMPLE  </i>');solbox.pack_start(label,False,False,0);label.set_alignment(0,0.5)
                
        hbox=gtk.HBox(False,5);solbox.pack_start(hbox,False,False,1)
        label=gtk.Label('nNonOrthogonalCorrectors')
        nonorthoEntry=gtk.Entry();nonorthoEntry.set_size_request(60,28);nonorthoEntry.set_text('0')
        hbox.pack_start(label,False,False,5);hbox.pack_end(nonorthoEntry,False,False,5)

        hbox=gtk.HBox(False,5);solbox.pack_start(hbox,False,False,1)
        label=gtk.Label('nOuterCorrectors')
        noutEntry=gtk.Entry();noutEntry.set_size_request(60,28);noutEntry.set_text('1')
        hbox.pack_start(label,False,False,5);hbox.pack_end(noutEntry,False,False,5)
        
        hbox=gtk.HBox(False,5);solbox.pack_start(hbox,False,False,1)
        label=gtk.Label('nCorrectors')
        ncorrEntry=gtk.Entry();ncorrEntry.set_size_request(60,28);ncorrEntry.set_text('2')
        hbox.pack_start(label,False,False,5);hbox.pack_end(ncorrEntry,False,False,5)
        
        separator=gtk.HSeparator();separator.set_size_request(285,5);solbox.pack_start(separator,True,True,2)        
        # --- relaxation factor  ----------------------------
        label=gtk.Label();label.set_markup('<i>  Relaxation factors  </i>');solbox.pack_start(label,False,False,0);label.set_alignment(0,0.5)        

        table=gtk.Table(5,6,False);table.set_row_spacings(3);table.set_col_spacings(2)
        hhbox=gtk.HBox(False,5);solbox.pack_start(hhbox,False,False,5)
        hhbox.pack_end(table,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,0,1);label=gtk.Label('p');hbox.pack_start(label,False,False,5)
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,0,1)
        prelaxEntry=gtk.Entry();prelaxEntry.set_size_request(60,28);prelaxEntry.set_text('0.3');hbox.pack_start(prelaxEntry,False,False,2)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,0,1);label=gtk.Label('U');hbox.pack_start(label,False,False,5)
        hbox=gtk.HBox(False,5);table.attach(hbox,3,4,0,1)
        urelaxEntry=gtk.Entry();urelaxEntry.set_size_request(60,28);urelaxEntry.set_text('0.7');hbox.pack_start(urelaxEntry,False,False,2)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,4,5,0,1);label=gtk.Label('tur.');hbox.pack_start(label,False,False,5)
        hbox=gtk.HBox(False,5);table.attach(hbox,5,6,0,1)
        turrelaxEntry=gtk.Entry();turrelaxEntry.set_size_request(60,28);turrelaxEntry.set_text('0.7');hbox.pack_start(turrelaxEntry,False,False,2)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,1,2);label=gtk.Label('h');hbox.pack_start(label,False,False,5)
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,1,2)
        hrelaxEntry=gtk.Entry();hrelaxEntry.set_size_request(60,28);hrelaxEntry.set_text('1.0');hbox.pack_start(hrelaxEntry,False,False,2)
        
        separator=gtk.HSeparator();separator.set_size_request(285,5);solbox.pack_start(separator,True,True,2)                
        # --- reference point  ----------------------------
        def toggleRef(widget):
            if widget.get_active()==1:
                refxEntry.set_sensitive(1);refyEntry.set_sensitive(1);refzEntry.set_sensitive(1);refvalueEntry.set_sensitive(1)
            else:
                refxEntry.set_sensitive(0);refyEntry.set_sensitive(0);refzEntry.set_sensitive(0);refvalueEntry.set_sensitive(0)
        
        refCB=gtk.CheckButton('Use reference point')
        hhbox=gtk.HBox(False,5);solbox.pack_start(hhbox,False,False,2);hhbox.pack_start(refCB,False,False,0)
        refCB.connect('toggled',toggleRef) 

        label=gtk.Label('point')
        refxEntry=gtk.Entry();refxEntry.set_size_request(60,28);refxEntry.set_text('0')
        refyEntry=gtk.Entry();refyEntry.set_size_request(60,28);refyEntry.set_text('0')
        refzEntry=gtk.Entry();refzEntry.set_size_request(60,28);refzEntry.set_text('0')
        hhbox=gtk.HBox(False,5);solbox.pack_start(hhbox,False,False,2)
        hhbox.pack_start(label,False,False,10)
        hhbox.pack_end(refzEntry,False,False,0);hhbox.pack_end(refyEntry,False,False,0);hhbox.pack_end(refxEntry,False,False,0)
        refxEntry.set_sensitive(0);refyEntry.set_sensitive(0);refzEntry.set_sensitive(0)        
        
        label=gtk.Label('value')
        refvalueEntry=gtk.Entry();refvalueEntry.set_size_request(100,28);refvalueEntry.set_text('0')
        hhbox=gtk.HBox(False,5);solbox.pack_start(hhbox,False,False,2)
        hhbox.pack_start(label,False,False,10)
        hhbox.pack_end(refvalueEntry,False,False,0)
        refvalueEntry.set_sensitive(0)
        #------------------------------------------------------                 
        defaultB=gtk.Button('Set Default');defaultB.connect('clicked',setDefault)
        appB=gtk.Button('Apply');appB.connect('clicked',applythis)
        hbox=gtk.HBox(True,5);solbox.pack_start(hbox,False,False,5)
        hbox.pack_start(appB,True,True,5);hbox.pack_start(defaultB,True,True,5)
                    
        setSavedValue()
        
        if self.solver=='simpleNFoam' or self.solver=='pimpleNFoam':
            hsolverCombo.set_sensitive(0);hsolverB.set_sensitive(0);htolEntry.set_sensitive(0);hreltolEntry.set_sensitive(0);hrelaxEntry.set_sensitive(0)
            hconvEntry.set_sensitive(0)  
            
        return solbox
    #-------------------------------------------------------------------------------------------------      
    def psolverAdv(self,solver,psolver):
    
        GEN=generalClass(self.caseDir)
       
        def applythis(widget):
            pAdvDict={}
            pAdvDict['minIter']=paminIterEntry.get_text()
            if GEN.isNumber(pAdvDict['minIter'])==False:GEN.makeDialog('Error!!! minIter is not number')            
            pAdvDict['maxIter']=pamaxIterEntry.get_text()
            if GEN.isNumber(pAdvDict['maxIter'])==False:GEN.makeDialog('Error!!! maxIter is not number')            
            aa=papreconCombo.child;pAdvDict['PCGPreconditioner']=aa.get_text()
            aa=pagamgsmootherCombo.child;pAdvDict['GAMGSmoother']=aa.get_text()
            pAdvDict['GAMGnPreSweeps']=papresweepEntry.get_text()
            if GEN.isNumber(pAdvDict['GAMGnPreSweeps'])==False:GEN.makeDialog('Error!!! GAMGnPreSweeps is not number')            
            pAdvDict['GAMGnPostSweeps']=papostsweepEntry.get_text()
            if GEN.isNumber(pAdvDict['GAMGnPostSweeps'])==False:GEN.makeDialog('Error!!! GAMGnPostSweeps is not number')            
            if pacacheCB.get_active()==True:pAdvDict['GAMGcache']='true'
            else:pAdvDict['GAMGcache']='false'
            aa=paaggloCombo.child;pAdvDict['GAMGagglomerator']=aa.get_text()
            pAdvDict['GAMGnCellsInCoarsestLevel']=pancellsEntry.get_text()
            if GEN.isNumber(pAdvDict['GAMGnCellsInCoarsestLevel'])==False:GEN.makeDialog('Error!!! GAMGnCellsInCoarsestLevel is not number')            
            pAdvDict['GAMGmergeLevels']=pamergeEntry.get_text()
            if GEN.isNumber(pAdvDict['GAMGmergeLevels'])==False:GEN.makeDialog('Error!!! GAMGmergeLevels is not number')            
            aa=pasmootherCombo.child;pAdvDict['smoothSolverSmoother']=aa.get_text()
            pAdvDict['pFinalTol']=pafinaltolEntry.get_text()
            if GEN.isNumber(pAdvDict['pFinalTol'])==False:GEN.makeDialog('Error!!! pFinalTol is not number')            
            pAdvDict['pFinalRelTol']=pafinalreltolEntry.get_text()
            if GEN.isNumber(pAdvDict['pFinalRelTol'])==False:GEN.makeDialog('Error!!! pFinalRelTol is not number')
            
            keys=pAdvDict.keys()
            f=open(self.caseDir+'/system/settings/fvSolution_pAdv','w')
            for ii in keys:f.write(ii+';'+pAdvDict[ii]+'\n')
            f.close()
            win.destroy();self.openSubWindow=False

        def closethis(widget):
            win.destroy();self.openSubWindow=False

        def setSavedValueAdv():
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_pAdv')
            if len(sfile)!=0:
                dic=GEN.makeDictFromFile(sfile[0])
                paminIterEntry.set_text(dic['minIter']);pamaxIterEntry.set_text(dic['maxIter'])
                aaa=papreconList.index(dic['PCGPreconditioner']);papreconCombo.set_active(aaa)
                aaa=pasmootherList.index(dic['GAMGSmoother']);pagamgsmootherCombo.set_active(aaa)
                papresweepEntry.set_text(dic['GAMGnPreSweeps']);papostsweepEntry.set_text(dic['GAMGnPostSweeps'])
                if dic['GAMGcache']=='true':pacacheCB.set_active(1)
                else:pacacheCB.set_active(0)
                aaa=paaggloList.index(dic['GAMGagglomerator']);paaggloCombo.set_active(aaa)
                pancellsEntry.set_text(dic['GAMGnCellsInCoarsestLevel']);pamergeEntry.set_text(dic['GAMGmergeLevels'])
                aaa=pasmootherList.index(dic['smoothSolverSmoother']);pasmootherCombo.set_active(aaa)
                pafinaltolEntry.set_text(dic['pFinalTol']);pafinalreltolEntry.set_text(dic['pFinalRelTol'])

        def setDefaultp(widget):
            paminIterEntry.set_text('0');pamaxIterEntry.set_text('50')
            papreconCombo.set_active(0);pagamgsmootherCombo.set_active(1)
            papresweepEntry.set_text('0');papostsweepEntry.set_text('2');pacacheCB.set_active(1)
            paaggloCombo.set_active(0);pancellsEntry.set_text('10');pamergeEntry.set_text('1')
            pasmootherCombo.set_active(1);pafinaltolEntry.set_text('1e-7');pafinalreltolEntry.set_text('0')

        def changePre(widget):
            aa=widget.child;precon=aa.get_text()
            if precon=='GAMG':
                pagamgsmootherCombo.set_sensitive(1);papresweepEntry.set_sensitive(1)
                papostsweepEntry.set_sensitive(1);paaggloCombo.set_sensitive(1)
                pancellsEntry.set_sensitive(1);pamergeEntry.set_sensitive(1);pacacheCB.set_sensitive(1)
            else:		    
                pasmootherCombo.set_sensitive(1);papresweepEntry.set_sensitive(0)
                papostsweepEntry.set_sensitive(0);paaggloCombo.set_sensitive(0)
                pancellsEntry.set_sensitive(0);pamergeEntry.set_sensitive(0);pacacheCB.set_sensitive(0)

        self.openSubWindow=True
        
        win=gtk.Window(gtk.WINDOW_TOPLEVEL);win.set_title('p solver advanced')
        win.set_border_width(5);win.set_position(gtk.WIN_POS_CENTER);win.set_transient_for(self.mainwindow)
        vbox=gtk.VBox(False,5);win.add(vbox)
        paframe=gtk.Frame();paframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);vbox.pack_start(paframe,False,False,5)
        pahbox=gtk.HBox(True,5);paframe.add(pahbox)
        pavbox=gtk.VBox(False,5);pahbox.pack_start(pavbox,True,True,5)

        label=gtk.Label('minIter')
        paminIterEntry=gtk.Entry();paminIterEntry.set_size_request(100,28);paminIterEntry.set_text('0')	    
        paminIterbox=gtk.HBox(False,5);pavbox.pack_start(paminIterbox,False,False,5)
        paminIterbox.pack_start(label,False,False,5);paminIterbox.pack_end(paminIterEntry,False,False,5)	    

        label=gtk.Label('maxIter')
        pamaxIterEntry=gtk.Entry();pamaxIterEntry.set_size_request(100,28);pamaxIterEntry.set_text('50')	    
        pamaxIterbox=gtk.HBox(False,5);pavbox.pack_start(pamaxIterbox,False,False,5)
        pamaxIterbox.pack_start(label,False,False,5);pamaxIterbox.pack_end(pamaxIterEntry,False,False,5)	
        # PCG
        pcgframe=gtk.Frame();pcgframe.set_label('  PCG  ');pcgframe.set_label_align(0.1, 0.5)
        pcgframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);pavbox.pack_start(pcgframe,False,False,5)

        pcghbox=gtk.HBox(True,5);pcgframe.add(pcghbox)
        pcgvbox=gtk.VBox(False,5);pcghbox.pack_start(pcgvbox,True,True,5)

        label=gtk.Label('preconditioner')
        papreconCombo=gtk.combo_box_entry_new_text();papreconCombo.set_size_request(120,28)
        papreconList=['DIC','FDIC','GAMG','diagonal','none']
        for ii in papreconList:papreconCombo.append_text(ii) 
        papreconCombo.set_active(0);papreconCombo.connect('changed',changePre)
        papreconbox=gtk.HBox(False,5);pcgvbox.pack_start(papreconbox,False,False,5)
        papreconbox.pack_start(label,False,False,5);papreconbox.pack_end(papreconCombo,False,False,5)
        # GAMG
        gamgframe=gtk.Frame();gamgframe.set_label('  GAMG  ');gamgframe.set_label_align(0.1, 0.5)
        gamgframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);pavbox.pack_start(gamgframe,False,False,5)

        gamghbox=gtk.HBox(True,5);gamgframe.add(gamghbox)
        gamgvbox=gtk.VBox(False,5);gamghbox.pack_start(gamgvbox,False,False,5)

        label=gtk.Label('smoother')
        pagamgsmootherCombo=gtk.combo_box_entry_new_text();pagamgsmootherCombo.set_size_request(120,28)
        pasmootherList=['GaussSeidel','symGaussSeidel','DIC','DICGaussSeidel','FDIC','nonBlockingGaussSeidel']
        for ii in pasmootherList:pagamgsmootherCombo.append_text(ii) 
        pagamgsmootherCombo.set_active(1)
        pasmootherbox=gtk.HBox(False,5);gamgvbox.pack_start(pasmootherbox,False,False,5)
        pasmootherbox.pack_start(label,False,False,5);pasmootherbox.pack_end(pagamgsmootherCombo,False,False,5)	

        label=gtk.Label('nPreSweeps')
        papresweepEntry=gtk.Entry();papresweepEntry.set_size_request(100,28);papresweepEntry.set_text('0')	    
        papresweepbox=gtk.HBox(False,5);gamgvbox.pack_start(papresweepbox,False,False,5)
        papresweepbox.pack_start(label,False,False,5);papresweepbox.pack_end(papresweepEntry,False,False,5)	

        label=gtk.Label('nPostSweeps')
        papostsweepEntry=gtk.Entry();papostsweepEntry.set_size_request(100,28);papostsweepEntry.set_text('2')	    
        papostsweepbox=gtk.HBox(False,5);gamgvbox.pack_start(papostsweepbox,False,False,5)
        papostsweepbox.pack_start(label,False,False,5);papostsweepbox.pack_end(papostsweepEntry,False,False,5)

        pacacheCB=gtk.CheckButton('cacheAgglomeration');pacacheCB.set_active(1)	    
        pacachebox=gtk.HBox(False,5);gamgvbox.pack_start(pacachebox,False,False,5)
        pacachebox.pack_start(pacacheCB,False,False,5)

        label=gtk.Label('agglomerator')
        paaggloCombo=gtk.combo_box_entry_new_text();paaggloCombo.set_size_request(120,28)
        paaggloList=['faceAreaPair']
        for ii in paaggloList:paaggloCombo.append_text(ii) 
        paaggloCombo.set_active(0)
        paagglobox=gtk.HBox(False,5);gamgvbox.pack_start(paagglobox,False,False,5)
        paagglobox.pack_start(label,False,False,5);paagglobox.pack_end(paaggloCombo,False,False,5)

        label=gtk.Label('nCellsInCoarsestLevel')
        pancellsEntry=gtk.Entry();pancellsEntry.set_size_request(100,28);pancellsEntry.set_text('10')	    
        pancellsbox=gtk.HBox(False,5);gamgvbox.pack_start(pancellsbox,False,False,5)
        pancellsbox.pack_start(label,False,False,5);pancellsbox.pack_end(pancellsEntry,False,False,5)

        label=gtk.Label('mergeLevels')
        pamergeEntry=gtk.Entry();pamergeEntry.set_size_request(100,28);pamergeEntry.set_text('1')	    
        pamergebox=gtk.HBox(False,5);gamgvbox.pack_start(pamergebox,False,False,5)
        pamergebox.pack_start(label,False,False,5);pamergebox.pack_end(pamergeEntry,False,False,5)
        # smoothSolver
        smoothframe=gtk.Frame();smoothframe.set_label('  smoothSolver  ');smoothframe.set_label_align(0.1, 0.5)
        smoothframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);pavbox.pack_start(smoothframe,False,False,5)

        smoothhbox=gtk.HBox(True,5);smoothframe.add(smoothhbox)
        smoothvbox=gtk.VBox(False,5);smoothhbox.pack_end(smoothvbox,True,True,5)

        label=gtk.Label('smoother')
        pasmootherCombo=gtk.combo_box_entry_new_text();pasmootherCombo.set_size_request(120,28)
        pasmootherList=['GaussSeidel','symGaussSeidel','DILU','DILUGaussSeidel','nonBlockingGaussSeidel']
        for ii in pasmootherList:pasmootherCombo.append_text(ii) 
        pasmootherCombo.set_active(1)
        pasmootherbox=gtk.HBox(False,5);smoothvbox.pack_start(pasmootherbox,False,False,5)
        pasmootherbox.pack_start(label,False,False,5);pasmootherbox.pack_end(pasmootherCombo,False,False,5)	

        finalframe=gtk.Frame();finalframe.set_label('  pFinal  ');finalframe.set_label_align(0.1, 0.5)
        finalframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);pavbox.pack_start(finalframe,False,False,5)

        finalbox=gtk.HBox(True,5);finalframe.add(finalbox)
        finalvbox=gtk.VBox(False,5);finalbox.pack_start(finalvbox,True,True,5)

        label=gtk.Label('tolerance')
        pafinaltolEntry=gtk.Entry();pafinaltolEntry.set_size_request(100,28);pafinaltolEntry.set_text('1e-7')
        pafinaltolbox=gtk.HBox(False,5);finalvbox.pack_start(pafinaltolbox,False,False,2)
        pafinaltolbox.pack_start(label,False,False,5);pafinaltolbox.pack_end(pafinaltolEntry,False,False,5)

        label=gtk.Label('relTol')
        pafinalreltolEntry=gtk.Entry();pafinalreltolEntry.set_size_request(100,28);pafinalreltolEntry.set_text('0')
        pafinalreltolbox=gtk.HBox(False,5);finalvbox.pack_start(pafinalreltolbox,False,False,2)
        pafinalreltolbox.pack_start(label,False,False,5);pafinalreltolbox.pack_end(pafinalreltolEntry,False,False,5)
        # button box
        buttonbox=gtk.HBox(False,5)
        pavbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(80,30)
        cll=gtk.Button(label='Close');cll.set_size_request(80,30)
        default=gtk.Button('Default');default.set_size_request(80,30)
        app.connect('clicked',applythis);cll.connect('clicked',closethis);default.connect('clicked',setDefaultp)
        buttonbox.pack_end(cll,True,True,5);buttonbox.pack_end(default,True,True,5);buttonbox.pack_end(app,True,True,5)

        if psolver=='PCG':  
            pasmootherCombo.set_sensitive(0);papresweepEntry.set_sensitive(0)
            papostsweepEntry.set_sensitive(0);paaggloCombo.set_sensitive(0)
            pancellsEntry.set_sensitive(0);pamergeEntry.set_sensitive(0);pacacheCB.set_sensitive(0)
            papreconCombo.set_sensitive(1);pasmootherCombo.set_sensitive(0)		
        elif psolver=='GAMG':
            pasmootherCombo.set_sensitive(1);papresweepEntry.set_sensitive(1)
            papostsweepEntry.set_sensitive(1);paaggloCombo.set_sensitive(1)
            pancellsEntry.set_sensitive(1);pamergeEntry.set_sensitive(1);pacacheCB.set_sensitive(1)
            papreconCombo.set_sensitive(0);pasmootherCombo.set_sensitive(0)
        elif psolver=='smoothSolver':
            pasmootherCombo.set_sensitive(0);papresweepEntry.set_sensitive(0)
            papostsweepEntry.set_sensitive(0);paaggloCombo.set_sensitive(0)
            pancellsEntry.set_sensitive(0);pamergeEntry.set_sensitive(0);pacacheCB.set_sensitive(0)
            papreconCombo.set_sensitive(0);pasmootherCombo.set_sensitive(1)

        setSavedValueAdv()
        
        if solver=='simpleFoam' or solver=='buoyantSimpleFoam' or solver=='buoyantBoussinesqSimpleFoam' or solver=='DPMFoam' or solver=='coalFoam':
            pafinaltolEntry.set_sensitive(0);pafinalreltolEntry.set_sensitive(0)

        win.show_all()
    #-------------------------------------------------------------------------------------------------      
    def usolverAdv(self,solver,usolver,field):
    
        GEN=generalClass(self.caseDir)
        
        def applythis(widget):
            UAdvDict={}
            UAdvDict['minIter']=paminIterEntry.get_text()
            if GEN.isNumber(UAdvDict['minIter'])==False:GEN.makeDialog('Error!!! minIter is not number')            
            UAdvDict['maxIter']=pamaxIterEntry.get_text()
            if GEN.isNumber(UAdvDict['maxIter'])==False:GEN.makeDialog('Error!!! maxIter is not number')            
            aa=papreconCombo.child;UAdvDict['PCGPreconditioner']=aa.get_text()
            aa=pasmootherCombo.child;UAdvDict['smoothSmoother']=aa.get_text()
            aa=pagamgsmootherCombo.child;UAdvDict['GAMGSmoother']=aa.get_text()
            UAdvDict['GAMGnPreSweeps']=papresweepEntry.get_text()
            if GEN.isNumber(UAdvDict['GAMGnPreSweeps'])==False:GEN.makeDialog('Error!!! GAMGnPreSweeps is not number')            
            UAdvDict['GAMGnPostSweeps']=papostsweepEntry.get_text()
            if GEN.isNumber(UAdvDict['GAMGnPostSweeps'])==False:GEN.makeDialog('Error!!! GAMGnPostSweeps is not number')            
            if pacacheCB.get_active()==True:UAdvDict['GAMGcache']='true'
            else:UAdvDict['GAMGcache']='False'
            aa=paaggloCombo.child;UAdvDict['GAMGagglomerator']=aa.get_text()
            UAdvDict['GAMGnCellsInCoarsestLevel']=pancellsEntry.get_text()
            if GEN.isNumber(UAdvDict['GAMGnCellsInCoarsestLevel'])==False:GEN.makeDialog('Error!!! GAMGnCellsInCoarsestLevel is not number')            
            UAdvDict['GAMGmergeLevels']=pamergeEntry.get_text()
            if GEN.isNumber(UAdvDict['GAMGmergeLevels'])==False:GEN.makeDialog('Error!!! GAMGmergeLevels is not number')            
            UAdvDict['finalTol']=pafinaltolEntry.get_text()
            if GEN.isNumber(UAdvDict['finalTol'])==False:GEN.makeDialog('Error!!! finalTol is not number')            
            UAdvDict['finalRelTol']=pafinalreltolEntry.get_text()
            if GEN.isNumber(UAdvDict['finalRelTol'])==False:GEN.makeDialog('Error!!! finalRelTol is not number')
            
            keys=UAdvDict.keys()
            f=open(self.caseDir+'/system/settings/fvSolution_'+field+'Adv','w')
            for ii in keys:f.write(ii+';'+UAdvDict[ii]+'\n')
            f.close()
            win.destroy();self.openSubWindow=False

        def closethis(widget):
            win.destroy();self.openSubWindow=False

        def setSavedValueAdv():
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_'+field+'Adv')
            if len(sfile)!=0:
                dic=GEN.makeDictFromFile(sfile[0])
                paminIterEntry.set_text(dic['minIter']);pamaxIterEntry.set_text(dic['maxIter'])
                aaa=papreconList.index(dic['PCGPreconditioner']);papreconCombo.set_active(aaa)
                aaa=pasmootherList.index(dic['smoothSmoother']);pasmootherCombo.set_active(aaa)
                aaa=pasmootherList.index(dic['GAMGSmoother']);pagamgsmootherCombo.set_active(aaa)
                papresweepEntry.set_text(dic['GAMGnPreSweeps']);papostsweepEntry.set_text(dic['GAMGnPostSweeps'])
                if dic['GAMGcache']=='true':pacacheCB.set_active(1)
                else:pacacheCB.set_active(0)
                aaa=paaggloList.index(dic['GAMGagglomerator']);paaggloCombo.set_active(aaa)
                pancellsEntry.set_text(dic['GAMGnCellsInCoarsestLevel']);pamergeEntry.set_text(dic['GAMGmergeLevels'])
                pafinaltolEntry.set_text(dic['finalTol']);pafinalreltolEntry.set_text(dic['finalRelTol'])

        def setDefaultU(widget):
            paminIterEntry.set_text('0');pamaxIterEntry.set_text('500')
            papreconCombo.set_active(0);pasmootherCombo.set_active(1)
            pagamgsmootherCombo.set_active(1);papresweepEntry.set_text('0');papostsweepEntry.set_text('2')
            pacacheCB.set_active(1);paaggloCombo.set_active(0);pancellsEntry.set_text('10');pamergeEntry.set_text('1') 

        self.openSubWindow=True
        
        win=gtk.Window(gtk.WINDOW_TOPLEVEL);win.set_title('u solver advanced')
        win.set_border_width(5);win.set_position(gtk.WIN_POS_CENTER);win.set_transient_for(self.mainwindow)
        vbox=gtk.VBox(False,5);win.add(vbox)
        paframe=gtk.Frame();paframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);vbox.pack_start(paframe,False,False,5)
        pahbox=gtk.HBox(True,5);paframe.add(pahbox)
        pavbox=gtk.VBox(False,5);pahbox.pack_start(pavbox,False,False,5)

        label=gtk.Label('minIter')
        paminIterEntry=gtk.Entry();paminIterEntry.set_size_request(100,28);paminIterEntry.set_text('0')	    
        paminIterbox=gtk.HBox(False,5);pavbox.pack_start(paminIterbox,False,False,5)
        paminIterbox.pack_start(label,False,False,5);paminIterbox.pack_end(paminIterEntry,False,False,5)	    

        label=gtk.Label('maxIter')
        pamaxIterEntry=gtk.Entry();pamaxIterEntry.set_size_request(100,28);pamaxIterEntry.set_text('500')	    
        pamaxIterbox=gtk.HBox(False,5);pavbox.pack_start(pamaxIterbox,False,False,5)
        pamaxIterbox.pack_start(label,False,False,5);pamaxIterbox.pack_end(pamaxIterEntry,False,False,5)	
        # PBiCG
        pbicgframe=gtk.Frame();pbicgframe.set_label('  PBiCG  ');pbicgframe.set_label_align(0.1, 0.5)
        pbicgframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);pavbox.pack_start(pbicgframe,False,False,5)

        pbicghbox=gtk.HBox(True,5);pbicgframe.add(pbicghbox)
        pbicgvbox=gtk.VBox(False,5);pbicghbox.pack_end(pbicgvbox,True,True,5)

        label=gtk.Label('preconditioner')
        papreconCombo=gtk.combo_box_entry_new_text();papreconCombo.set_size_request(120,28)
        papreconList=['DILU','GAMG','diagonal','none']
        for ii in papreconList:papreconCombo.append_text(ii) 
        papreconCombo.set_active(0)
        papreconbox=gtk.HBox(False,5);pbicgvbox.pack_start(papreconbox,False,False,5)
        papreconbox.pack_start(label,False,False,5);papreconbox.pack_end(papreconCombo,False,False,5)
        # smoothSolver
        smoothframe=gtk.Frame();smoothframe.set_label('  smoothSolver  ');smoothframe.set_label_align(0.1, 0.5)
        smoothframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);pavbox.pack_start(smoothframe,False,False,5)

        smoothhbox=gtk.HBox(True,5);smoothframe.add(smoothhbox)
        smoothvbox=gtk.VBox(False,5);smoothhbox.pack_end(smoothvbox,True,True,5)

        label=gtk.Label('smoother')
        pasmootherCombo=gtk.combo_box_entry_new_text();pasmootherCombo.set_size_request(120,28)
        pasmootherList=['GaussSeidel','symGaussSeidel','DILU','DILUGaussSeidel','nonBlockingGaussSeidel']
        for ii in pasmootherList:pasmootherCombo.append_text(ii) 
        pasmootherCombo.set_active(1)
        pasmootherbox=gtk.HBox(False,5);smoothvbox.pack_start(pasmootherbox,False,False,5)
        pasmootherbox.pack_start(label,False,False,5);pasmootherbox.pack_end(pasmootherCombo,False,False,5)	
        # GAMG
        gamgframe=gtk.Frame();gamgframe.set_label('  GAMG  ');gamgframe.set_label_align(0.1, 0.5)
        gamgframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);pavbox.pack_start(gamgframe,False,False,5)

        gamghbox=gtk.HBox(True,5);gamgframe.add(gamghbox)
        gamgvbox=gtk.VBox(False,5);gamghbox.pack_start(gamgvbox,False,False,5)

        label=gtk.Label('smoother')
        pagamgsmootherCombo=gtk.combo_box_entry_new_text();pagamgsmootherCombo.set_size_request(120,28)
        pasmootherList=['GaussSeidel','symGaussSeidel','DILU','DILUGaussSeidel','nonBlockingGaussSeidel']
        for ii in pasmootherList:pagamgsmootherCombo.append_text(ii) 
        pagamgsmootherCombo.set_active(1)
        pasmootherbox=gtk.HBox(False,5);gamgvbox.pack_start(pasmootherbox,False,False,5)
        pasmootherbox.pack_start(label,False,False,5);pasmootherbox.pack_end(pagamgsmootherCombo,False,False,5)	

        label=gtk.Label('nPreSweeps')
        papresweepEntry=gtk.Entry();papresweepEntry.set_size_request(100,28);papresweepEntry.set_text('0')	    
        papresweepbox=gtk.HBox(False,5);gamgvbox.pack_start(papresweepbox,False,False,5)
        papresweepbox.pack_start(label,False,False,5);papresweepbox.pack_end(papresweepEntry,False,False,5)	

        label=gtk.Label('nPostSweeps')
        papostsweepEntry=gtk.Entry();papostsweepEntry.set_size_request(100,28);papostsweepEntry.set_text('2')	    
        papostsweepbox=gtk.HBox(False,5);gamgvbox.pack_start(papostsweepbox,False,False,5)
        papostsweepbox.pack_start(label,False,False,5);papostsweepbox.pack_end(papostsweepEntry,False,False,5)

        pacacheCB=gtk.CheckButton('cacheAgglomeration');pacacheCB.set_active(1)    
        pacachebox=gtk.HBox(False,5);gamgvbox.pack_start(pacachebox,False,False,5)
        pacachebox.pack_start(pacacheCB,False,False,5)

        label=gtk.Label('agglomerator')
        paaggloCombo=gtk.combo_box_entry_new_text();paaggloCombo.set_size_request(120,28)
        paaggloList=['faceAreaPair']
        for ii in paaggloList:paaggloCombo.append_text(ii) 
        paaggloCombo.set_active(0)
        paagglobox=gtk.HBox(False,5);gamgvbox.pack_start(paagglobox,False,False,5)
        paagglobox.pack_start(label,False,False,5);paagglobox.pack_end(paaggloCombo,False,False,5)

        label=gtk.Label('nCellsInCoarsestLevel')
        pancellsEntry=gtk.Entry();pancellsEntry.set_size_request(100,28);pancellsEntry.set_text('10')	    
        pancellsbox=gtk.HBox(False,5);gamgvbox.pack_start(pancellsbox,False,False,5)
        pancellsbox.pack_start(label,False,False,5);pancellsbox.pack_end(pancellsEntry,False,False,5)

        label=gtk.Label('mergeLevels')
        pamergeEntry=gtk.Entry();pamergeEntry.set_size_request(100,28);pamergeEntry.set_text('1')	    
        pamergebox=gtk.HBox(False,5);gamgvbox.pack_start(pamergebox,False,False,5)
        pamergebox.pack_start(label,False,False,5);pamergebox.pack_end(pamergeEntry,False,False,5)

        finalframe=gtk.Frame();finalframe.set_label('  UFinal  ');finalframe.set_label_align(0.1, 0.5)
        finalframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);pavbox.pack_start(finalframe,False,False,5)

        finalbox=gtk.HBox(True,5);finalframe.add(finalbox)
        finalvbox=gtk.VBox(False,5);finalbox.pack_start(finalvbox,True,True,5)

        label=gtk.Label('tolerance')
        pafinaltolEntry=gtk.Entry();pafinaltolEntry.set_size_request(100,28);pafinaltolEntry.set_text('1e-7')
        pafinaltolbox=gtk.HBox(False,5);finalvbox.pack_start(pafinaltolbox,False,False,2)
        pafinaltolbox.pack_start(label,False,False,5);pafinaltolbox.pack_end(pafinaltolEntry,False,False,5)

        label=gtk.Label('relTol')
        pafinalreltolEntry=gtk.Entry();pafinalreltolEntry.set_size_request(100,28);pafinalreltolEntry.set_text('0')
        pafinalreltolbox=gtk.HBox(False,5);finalvbox.pack_start(pafinalreltolbox,False,False,2)
        pafinalreltolbox.pack_start(label,False,False,5);pafinalreltolbox.pack_end(pafinalreltolEntry,False,False,5)

        buttonbox=gtk.HBox(False,5)
        pavbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(80,30)
        cll=gtk.Button(label='Close');cll.set_size_request(80,30)
        default=gtk.Button('Default');default.set_size_request(80,30)
        app.connect('clicked',applythis);cll.connect('clicked',closethis);default.connect('clicked',setDefaultU)
        buttonbox.pack_end(cll,True,True,5);buttonbox.pack_end(default,True,True,5);buttonbox.pack_end(app,True,True,5)  

        if usolver=='smoothSolver':  
            pasmootherCombo.set_sensitive(1)
            pagamgsmootherCombo.set_sensitive(0);papresweepEntry.set_sensitive(0)
            papostsweepEntry.set_sensitive(0);paaggloCombo.set_sensitive(0)
            pancellsEntry.set_sensitive(0);pamergeEntry.set_sensitive(0);pacacheCB.set_sensitive(0)
            papreconCombo.set_sensitive(0)
        elif usolver=='PBiCG':
            pasmootherCombo.set_sensitive(0)
            pagamgsmootherCombo.set_sensitive(0);papresweepEntry.set_sensitive(0)
            papostsweepEntry.set_sensitive(0);paaggloCombo.set_sensitive(0)
            pancellsEntry.set_sensitive(0);pamergeEntry.set_sensitive(0);pacacheCB.set_sensitive(0)
            papreconCombo.set_sensitive(1)  
        else:
            pasmootherCombo.set_sensitive(0)
            pagamgsmootherCombo.set_sensitive(1);papresweepEntry.set_sensitive(1)
            papostsweepEntry.set_sensitive(1);paaggloCombo.set_sensitive(1)
            pancellsEntry.set_sensitive(1);pamergeEntry.set_sensitive(1);pacacheCB.set_sensitive(1)
            papreconCombo.set_sensitive(0) 

        setSavedValueAdv()
        
        if solver=='simpleFoam' or solver=='buoyantSimpleFoam' or solver=='buoyantBoussinesqSimpleFoam' or solver=='DPMFoam' or solver=='coalFoam':
            pafinaltolEntry.set_sensitive(0);pafinalreltolEntry.set_sensitive(0)

        win.show_all()
    #-------------------------------------------------------------------------------------------------      
    def foamComment(self):
        fc=[]
        fc.append('/*--------------------------------*- C++ -*----------------------------------*\ \n')
        fc.append('| =========                 |                                                 |\n')
        fc.append('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |\n')
        fc.append('|  \\    /   O peration     | Version:  2.3.0                                 |\n')
        fc.append('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      |\n')
        fc.append('|    \\/     M anipulation  |                                                 |\n')
        fc.append('\*---------------------------------------------------------------------------*/\n')	
        return fc
    #------------------------------------------------------------------------------
    def header(self,location,obj):
        he=[]
        he.append('FoamFile\n')
        he.append('{\n')
        he.append('    version     2.0;\n')
        he.append('    format      ascii;\n')
        he.append('    class       dictionary;\n')
        he.append('    location    "'+location+'";\n')
        he.append('    object      '+obj+';\n')
        he.append('}\n')
        he.append('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //\n')
        return he                       
    #------------------------------------------------------------------------------
    def createFvSolutionFile(self,fvSolutionDict,pAdvDict,UAdvDict,turAdvDict,hAdvDict):

        fcom=self.foamComment();head=self.header('system','fvSolution');hhh=fcom+head

        f=open(self.caseDir+'/system/fvSolution','w')
        for aaa in hhh:f.write(aaa)

        f.write('solvers\n')
        f.write('{\n')

        f.write('    "rho.*"\n')
        f.write('    {\n')
        f.write('        solver          PCG;\n')
        f.write('        preconditioner  DIC;\n')
        f.write('        tolerance       1e-7;\n')
        f.write('        relTol          0;\n')
        f.write('    }\n')
        # p-------------
        f.write('    "(p|p_rgh)" \n')
        f.write('    {\n')
        f.write('        solver                '+fvSolutionDict['psolver']+';\n')
        f.write('        tolerance             '+fvSolutionDict['ptolerance']+';\n')
        f.write('        relTol                '+fvSolutionDict['prelTol']+';\n')
        f.write('        minIter               '+pAdvDict['minIter']+';\n')
        f.write('        maxIter               '+pAdvDict['maxIter']+';\n')
        if fvSolutionDict['psolver']=='GAMG':
            f.write('        smoother              '+pAdvDict['GAMGSmoother']+';\n')
            f.write('        nPreSweeps            '+pAdvDict['GAMGnPreSweeps']+';\n')
            f.write('        nPostSweeps           '+pAdvDict['GAMGnPostSweeps']+';\n')
            f.write('        cacheAgglomeration    '+pAdvDict['GAMGcache']+';\n')
            f.write('        agglomerator          '+pAdvDict['GAMGagglomerator']+';\n')
            f.write('        nCellsInCoarsestLevel '+pAdvDict['GAMGnCellsInCoarsestLevel']+';\n')
            f.write('        mergeLevels           '+pAdvDict['GAMGmergeLevels']+';\n')
        elif fvSolutionDict['psolver']=='PCG':
            if pAdvDict['PCGPreconditioner']!='GAMG':
                f.write('        preconditioner        '+pAdvDict['PCGPreconditioner']+';\n')
            elif pAdvDict['PCGPreconditioner']=='GAMG':
                f.write('        preconditioner\n')
        	f.write('        {\n')
        	f.write('            preconditioner        '+pAdvDict['PCGPreconditioner']+';\n')
        	f.write('            tolerance             '+fvSolutionDict['ptolerance']+';\n')
        	f.write('            relTol                '+fvSolutionDict['prelTol']+';\n')
        	f.write('            smoother              '+pAdvDict['GAMGSmoother']+';\n')
        	f.write('            nPreSweeps            '+pAdvDict['nPreSweeps']+';\n')
        	f.write('            nPostSweeps           '+pAdvDict['nPostSweeps']+';\n')
        	f.write('            cacheAgglomeration    '+pAdvDict['cacheAgglomeration']+';\n')
        	f.write('            agglomerator          '+pAdvDict['agglomerator']+';\n')
        	f.write('            nCellsInCoarsestLevel '+pAdvDict['nCellsInCoarsestLevel']+';\n')
        	f.write('            mergeLevels           '+pAdvDict['mergeLevels']+';\n')
        	f.write('        }\n')
        elif fvSolutionDict['psolver']=='smoothSolver':
            f.write('        smoother              '+pAdvDict['smoothSolverSmoother']+';\n')
        f.write('    }\n')

        f.write('    "(pFinal|p_rghFinal)"\n')
        f.write('    {\n')
        f.write('        $p;\n')
        f.write('        tolerance             '+pAdvDict['pFinalTol']+';\n')
        f.write('        relTol                '+pAdvDict['pFinalRelTol']+';\n')
        f.write('    }\n')	
        # U-------------
        f.write('    U \n')
        f.write('    { \n')
        f.write('        solver        '+fvSolutionDict['usolver']+';\n')
        f.write('        tolerance     '+fvSolutionDict['utolerance']+';\n')
        f.write('        relTol        '+fvSolutionDict['urelTol']+';\n')
        f.write('        minIter       '+UAdvDict['minIter']+';\n')
        f.write('        maxIter       '+UAdvDict['maxIter']+';\n')
        if fvSolutionDict['usolver']=='smoothSolver':
            f.write('        smoother      '+UAdvDict['smoothSmoother']+';\n')
        elif fvSolutionDict['usolver']=='PBiCG' or fvSolutionDict['usolver']=='NEXT::PBiCG':
            f.write('        preconditioner '+UAdvDict['PCGPreconditioner']+';\n')
        elif fvSolutionDict['usolver']=='GAMG':
            f.write('        smoother              '+UAdvDict['GAMGSmoother']+';\n')
            f.write('        nPreSweeps            '+UAdvDict['GAMGnPreSweeps']+';\n')
            f.write('        nPostSweeps           '+UAdvDict['GAMGnPostSweeps']+';\n')
            f.write('        cacheAgglomeration    '+UAdvDict['GAMGcache']+';\n')
            f.write('        agglomerator          '+UAdvDict['GAMGagglomerator']+';\n')
            f.write('        nCellsInCoarsestLevel '+UAdvDict['GAMGnCellsInCoarsestLevel']+';\n')
            f.write('        mergeLevels           '+UAdvDict['GAMGmergeLevels']+';\n')
        f.write('    } \n')

        f.write('    UFinal \n')
        f.write('    { \n')
        f.write('        $U; \n')
        f.write('        tolerance             '+UAdvDict['finalTol']+';\n')
        f.write('        relTol                '+UAdvDict['finalRelTol']+';\n')
        f.write('    } \n')
        # tur-------------
        f.write('    "(k|epsilon|omega)" \n')
        f.write('    { \n')
        f.write('        solver        '+fvSolutionDict['tursolver']+';\n')
        f.write('        tolerance     '+fvSolutionDict['turtolerance']+';\n')
        f.write('        relTol        '+fvSolutionDict['turrelTol']+';\n')
        f.write('        minIter       '+turAdvDict['minIter']+';\n')
        f.write('        maxIter       '+turAdvDict['maxIter']+';\n')
        if fvSolutionDict['tursolver']=='smoothSolver' or fvSolutionDict['tursolver']=='NEXT::smoothSolver':
            f.write('        smoother      '+turAdvDict['smoothSmoother']+';\n')
        elif fvSolutionDict['tursolver']=='PBiCG' or fvSolutionDict['tursolver']=='NEXT::PBiCG':
            f.write('        preconditioner '+turAdvDict['PCGPreconditioner']+';\n')
        elif fvSolutionDict['tursolver']=='GAMG':
            f.write('        smoother              '+turAdvDict['GAMGSmoother']+';\n')
            f.write('        nPreSweeps            '+turAdvDict['GAMGnPreSweeps']+';\n')
            f.write('        nPostSweeps           '+turAdvDict['GAMGnPostSweeps']+';\n')
            f.write('        cacheAgglomeration    '+turAdvDict['GAMGcache']+';\n')
            f.write('        agglomerator          '+turAdvDict['GAMGagglomerator']+';\n')
            f.write('        nCellsInCoarsestLevel '+turAdvDict['GAMGnCellsInCoarsestLevel']+';\n')
            f.write('        mergeLevels           '+turAdvDict['GAMGmergeLevels']+';\n')
        f.write('    } \n')

        f.write('    "(k|epsilon|omega)Final" \n')
        f.write('    { \n')
        f.write('        $k; \n')
        f.write('        tolerance             '+turAdvDict['finalTol']+';\n')
        f.write('        relTol                '+turAdvDict['finalRelTol']+';\n')
        f.write('    } \n')
        # h-------------
        f.write('    h \n')
        f.write('    { \n')
        f.write('        solver        '+fvSolutionDict['hsolver']+';\n')
        f.write('        tolerance     '+fvSolutionDict['htolerance']+';\n')
        f.write('        relTol        '+fvSolutionDict['hrelTol']+';\n')
        f.write('        minIter       '+hAdvDict['minIter']+';\n')
        f.write('        maxIter       '+hAdvDict['maxIter']+';\n')
        if fvSolutionDict['hsolver']=='smoothSolver' or fvSolutionDict['hsolver']=='NEXT::smoothSolver':
            f.write('        smoother      '+hAdvDict['smoothSmoother']+';\n')
        elif fvSolutionDict['hsolver']=='PBiCG' or fvSolutionDict['hsolver']=='NEXT::PBiCG':
            f.write('        preconditioner '+hAdvDict['PCGPreconditioner']+';\n')
        elif fvSolutionDict['hsolver']=='GAMG':
            f.write('        smoother              '+hAdvDict['GAMGSmoother']+';\n')
            f.write('        nPreSweeps            '+hAdvDict['GAMGnPreSweeps']+';\n')
            f.write('        nPostSweeps           '+hAdvDict['GAMGnPostSweeps']+';\n')
            f.write('        cacheAgglomeration    '+hAdvDict['GAMGcache']+';\n')
            f.write('        agglomerator          '+hAdvDict['GAMGagglomerator']+';\n')
            f.write('        nCellsInCoarsestLevel '+hAdvDict['GAMGnCellsInCoarsestLevel']+';\n')
            f.write('        mergeLevels           '+hAdvDict['GAMGmergeLevels']+';\n')
        f.write('    } \n')

        f.write('    hFinal \n')
        f.write('    { \n')
        f.write('        $h; \n')
        f.write('        tolerance             '+hAdvDict['finalTol']+';\n')
        f.write('        relTol                '+hAdvDict['finalRelTol']+';\n')
        f.write('    } \n')        
                
        f.write('} \n')
        #---------------------------------------
        f.write('SIMPLE\n')
        f.write('{\n')
        f.write('    nNonOrthogonalCorrectors  '+fvSolutionDict['nNonOrtho']+';\n')        
        if fvSolutionDict['useRefPoint']=='false':f.write('    pRefCell                  0;\n')
        else:f.write('    pRefPoint                 ('+fvSolutionDict['refx']+' '+fvSolutionDict['refy']+' '+fvSolutionDict['refz']+');\n')
        f.write('    pRefValue                 '+fvSolutionDict['refvalue']+';\n')               
        f.write('    residualControl\n')
        f.write('    {\n')
        f.write('        p      '+fvSolutionDict['convergencep']+';\n')
        f.write('        p_rgh  '+fvSolutionDict['convergencep']+';\n')        
        f.write('        U      '+fvSolutionDict['convergenceu']+';\n')
        f.write('        h      '+fvSolutionDict['convergenceh']+';\n')        
        f.write('        "(k|epsilon|omega)"    '+fvSolutionDict['convergencetur']+';\n')
        f.write('    }\n')   
        f.write('}\n')        
        #---------------------------------------
        f.write('PIMPLE\n')
        f.write('{\n')
        f.write('    nOuterCorrectors          '+fvSolutionDict['nOuterCorrectors']+';\n')
        f.write('    nCorrectors               '+fvSolutionDict['nCorrectors']+';\n')
        f.write('    nNonOrthogonalCorrectors  '+fvSolutionDict['nNonOrtho']+';\n')
        f.write('    nNonOrthogonalCorrectors  '+fvSolutionDict['nNonOrtho']+';\n')
        if fvSolutionDict['useRefPoint']=='false':f.write('    pRefCell                  0;\n')
        else:f.write('    pRefPoint                 ('+fvSolutionDict['refx']+' '+fvSolutionDict['refy']+' '+fvSolutionDict['refz']+');\n')
        f.write('    pRefValue                 '+fvSolutionDict['refvalue']+';\n')          
        f.write('}\n')
        #---------------------------------------
        f.write('relaxationFactors\n')
        f.write('{\n')
        f.write('    fields\n')
        f.write('    {\n')
        f.write('        "rho.*"        1.0;\n')
        f.write('        "p.*"          '+fvSolutionDict['relaxp']+';\n')
        f.write('    }\n')
        f.write('    equations\n')
        f.write('    {\n')
        f.write('        "U.*"          '+fvSolutionDict['relaxu']+';\n')
        f.write('        "k.*"          '+fvSolutionDict['relaxtur']+';\n')
        f.write('        "epsilon.*"    '+fvSolutionDict['relaxtur']+';\n')        
        f.write('        "omega.*"      '+fvSolutionDict['relaxtur']+';\n')                
        f.write('        "h.*"          '+fvSolutionDict['relaxh']+';\n')
        f.write('    }\n')
        f.write('}\n')

        f.close()
    #------------------------------------------------------------------------------                 
