#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for internalField value
#
# Author
#    NEXTFOAM Inc. 
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *
from boundaryConditionSub import *

class freepanelInitialClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow,solver,installpath):
        self.caseDir=caseDir
        self.mainwindow=mainwindow
        self.solver=solver
        self.installpath=installpath
    #--------------------------------------------------------------------------------------  
    def initialCondition(self,notebook,textbuffer):

        def applyini(widget):

            GEN=generalClass(self.caseDir)
            initialDict={}
            
            initvalue=[]
            model=self.treeview.get_model()
            for i in range(len(valuelist)):
                iter=model.get_iter(i)
                initvalue.append(model.get_value(iter,1))           
            
            initialDict['uxini']=initvalue[0];initialDict['uyini']=initvalue[1];initialDict['uzini']=initvalue[2]
            initialDict['pini']=initvalue[3];initialDict['kini']=initvalue[4];initialDict['eini']=initvalue[5]
            initialDict['Tini']=initvalue[6]
                    
            if GEN.isNumber(initialDict['uxini'])==False:GEN.makeDialog('Error!!! ux is not number')
            if GEN.isNumber(initialDict['uyini'])==False:GEN.makeDialog('Error!!! uy is not number')
            if GEN.isNumber(initialDict['uzini'])==False:GEN.makeDialog('Error!!! uz is not number')
            if GEN.isNumber(initialDict['pini'])==False:GEN.makeDialog('Error!!! p is not number')
            if GEN.isNumber(initialDict['Tini'])==False:GEN.makeDialog('Error!!! T is not number')
            if GEN.isNumber(initialDict['kini'])==False:GEN.makeDialog('Error!!! k is not number')
            if GEN.isNumber(initialDict['eini'])==False:GEN.makeDialog('Error!!! epsilon is not number')
            
            keys=initialDict.keys()
            f=open(self.caseDir+'/system/settings/initialConditions','w')
            for ii in keys:f.write(ii+';'+initialDict[ii]+'\n')
            f.close()

            message='\n [  Internal field is saved  ]\n'
            message=message+'\n    - internalField of U is ( '+initialDict['uxini']+' '+initialDict['uyini']+' '+initialDict['uzini']+' ) \n'  
            message=message+'\n    - internalField of p is '+initialDict['pini']+'\n'
            message=message+'\n    - internalField of k is '+initialDict['kini']+'\n'
            message=message+'\n    - internalField of epsilon/omega is '+initialDict['eini']+'\n'
            if self.solver=='buoyantSimpleNFoam' or self.solver=='buoyantPimpleNFoam':
                message=message+'\n    - internalField of T is '+initialDict['Tini']+'\n'                 
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            notebook.set_current_page(0) 
                        
        def setSavedValue():
            GEN=generalClass(self.caseDir)
            aa=glob.glob(self.caseDir+'/system/settings/initialConditions')
            if len(aa)!=0:
                dic=GEN.makeDictFromFile(aa[0])
                keys=dic.keys()
                savedlist=[dic['uxini'],dic['uyini'],dic['uzini'],dic['pini'],dic['kini'],dic['eini'],dic['Tini']]
                for i in range(len(valuelist)):
                    self.liststore[i][1]=savedlist[i]
                                
        def changeValue(widget,path,text):
            self.liststore[path][1]=text
        
        
        self.initialbox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('<b>  Initial Conditions  </b>')
        ebox=gtk.EventBox();self.initialbox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label)
        
        #separator=gtk.HSeparator();separator.set_size_request(285,5);self.initialbox.pack_start(separator,False,True,0)

        swin=gtk.ScrolledWindow();swin.set_border_width(0);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        self.initialbox.pack_start(swin,True,True,0);itembox=gtk.VBox(False,0);swin.add_with_viewport(itembox)
        swin.set_size_request(200,228)
        
        self.liststore = gtk.ListStore(str,str)
        fieldlist=['Ux','Uy','Uz','p','k','epsilon/omega','T']
        valuelist=['0','0','0','0','1','1','300']
        for i in range(len(fieldlist)):
            self.liststore.append([fieldlist[i],valuelist[i]])
                            
        self.treeview = gtk.TreeView(self.liststore)        
        
        self.cell = gtk.CellRendererText()
        self.cell1 = gtk.CellRendererText()
        self.cell1.set_property("editable", True)   
        self.cell1.connect('edited',changeValue)

        self.tvcolumn = gtk.TreeViewColumn('Field                       ',self.cell,text=0)
        self.tvcolumn1 = gtk.TreeViewColumn('Value',self.cell1,text=1)

        self.treeview.append_column(self.tvcolumn)
        self.treeview.append_column(self.tvcolumn1)
                
        itembox.pack_start(self.treeview,False,False,5)
        
        hbox=gtk.HBox(False,5);self.initialbox.pack_start(hbox,False,False,5)
        self.initialAppB=gtk.Button('Apply');self.initialAppB.connect('clicked',applyini);hbox.pack_end(self.initialAppB,True,True,5)
                            
        setSavedValue()

        return self.initialbox
    #--------------------------------------------------------------------------------------  




