#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for manipulate mesh
#
# Author
#    NEXTFOAM Inc. 
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk,gobject
import glob
import time

from generalSub import *
from boundaryConditionSub import *
from VTKStuffClass import *
from writeFileSub import *

class freepanelMeshClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow,solver,installpath,rr,gg,bb):
        self.caseDir=caseDir
        self.mainwindow=mainwindow
        self.solver=solver
        self.installpath=installpath
        self.openSubWindow=False
        self.rr=rr;self.gg=gg;self.bb=bb

    def mesh(self,gvtk,notebook,textbuffer,terminal,displayOptCombo):    
    
        GEN=generalClass(self.caseDir);WFILE=writeFileClass(self.caseDir);VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb)
    
        def togglemesh(widget):
            whatradio=widget.get_label()
            if whatradio=='OpenFOAM':self.ccombo.set_sensitive(0)
            else:self.ccombo.set_sensitive(1)
        
        def selectmesh(widget):

            util=self.ccombo.child.get_text()
            if util=='OpenFOAM':
                meshfile=self.readMesh(gvtk,notebook,textbuffer,terminal)
            else:
                filename=self.importMeshutil(util,gvtk,notebook,textbuffer,terminal)
                meshfile=filename
                self.convertm(meshfile,gvtk,notebook,textbuffer,terminal,util,displayOptCombo)
             
            if meshfile!='None':
                f=open(self.caseDir+'/system/settings/importedMesh','w');f.write(meshfile);f.close()
                aa=glob.glob(self.caseDir+'/system/settings/cellZoneConditions*')
                if len(aa)!=0:
                    for ii in aa:os.system('rm '+ii)
                bb=glob.glob(self.caseDir+'/system/cellZoneConditions*')
                if len(bb)!=0:
                    for ii in bb:os.system('rm '+ii)
                
                if util=='OpenFOAM':message='\n [ OpenFOAM Mesh is Read  ]\n\n'                
                else:message='\n [ Mesh File is Converted using '+util+'  ]\n\n'
                message=message+'\n   -- Mesh file : '+meshfile+' \n\n'
                enditer=textbuffer.get_end_iter()
                textbuffer.insert(enditer,message)      
               
                self.patchzone=self.viewbc(self.bdbox)                
        
        def showmesh(widget):
            viewposition=[1,1,1] 
            renderer=VTK.unsgeometry(self.patchzone,self.onOff,viewposition,displayOptCombo.child.get_text())
            gvtk.GetRenderWindow().AddRenderer(renderer)
            #gvtk.Initialize();gvtk.Start()
            
            notebook.set_current_page(1)
                
            f=open(self.caseDir+'/system/settings/displayedPatch','w')
            for ii in self.onOff:f.write(str(ii)+'\n')
            f.close()
            f=open(self.caseDir+'/system/settings/displaymode','w')
            f.write('mesh');f.close()   
            
        def createBaffle(widget):
        
            def closethis(widget,data=None):window.destroy();self.openSubWindow=False
        
            def makeBaffle(widget,data=None):
                mode=scombo.get_active()
                if mode==0: 
                    selectedSet=[];tf=[]
                    for i in range(len(sets)):
                        aa=setName[i].get_active()		   
                        if aa==True:selectedSet.append(sets[i])		
                    WFILE.topoSetDict(selectedSet);WFILE.createBafflesDict(selectedSet)
                    os.system('topoSet -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.topoSet')
                    cmd='cat  '+self.caseDir+'/logfiles/log.setsToZones'+'\n'
                    length=len(cmd)
                    terminal.feed_child(cmd,length)
            
                    os.system('createBaffles -case '+self.caseDir+' -overwrite > '+self.caseDir+'/logfiles/log.createBaffles')
                    cmd='cat '+self.caseDir+'/logfiles/log.createBaffles'+'\n'
                    length=len(cmd)
                    terminal.feed_child(cmd,length)
                    
                    os.system('rm -r '+self.caseDir+'/VTK')
                    os.system('foamToVTK -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.foamToVTK')
                    window.destroy()
                    
                    message='\n [  Create Baffle for "'+selectedSet[0]+'" is Completed  ]\n\n'                     
                    enditer=textbuffer.get_end_iter()
                    textbuffer.insert(enditer,message)
            
                else:
                    selectedZone=[];tff=[]
                    for i in range(len(zones)):
                        aa=zoneName[i].get_active()		   
                        if aa==True:selectedZone.append(zones[i])		
                    WFILE.createBafflesDict(selectedZone)
                    cmd='createBaffles -case '+self.caseDir+' -overwrite'+'\n'
                    length=len(cmd)
                    terminal.feed_child(cmd,length)
                    window.destroy()
                    
                    message='\n [  Create Baffle for '+selectedZone[0]+' is Completed  ]\n\n'                     
                    enditer=textbuffer.get_end_iter()
                    textbuffer.insert(enditer,message)
                                                   
                os.system('foamToVTK -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.foamToVTK')
                
                self.patchzone=self.viewbc(self.bdbox)
                
                self.openSubWindow=False 
                
            def chscombo(widget,sets,zones,hbox1,hbox11,setName,zoneName):
                sss=scombo.get_active()
                if sss==1:
                    for i in range(len(sets)):itembox.remove(hbox1[i])
                    for i in range(len(zones)):itembox.pack_start(hbox11[i],False,False,2)
                    scombo.set_active(1);window.show_all()
                else: 
                    for i in range(len(zones)):itembox.remove(hbox11[i])
                    for i in range(len(sets)):itembox.pack_start(hbox1[i],False,False,2)
                    scombo.set_active(0);window.show_all()

            if self.openSubWindow==False:            
                sets=GEN.getSets();zones=GEN.getfaceZones();sets.sort();zones.sort()

                window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('create baffle')
                window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER);window.set_transient_for(self.mainwindow)
                mainbox=gtk.VBox(False,5);window.add(mainbox)
                scombo=gtk.combo_box_entry_new_text();scombo.set_size_request(200,28)
                scombo.append_text('use faceSet');scombo.append_text('use faceZone');scombo.set_active(0)
                hbox0=gtk.HBox(False,5);mainbox.pack_start(hbox0,False,False,5);hbox0.pack_start(scombo,False,False,5)
                swin=gtk.ScrolledWindow();swin.set_border_width(5);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
                mainbox.pack_start(swin,True,True,5);itembox=gtk.VBox(False,0);swin.add_with_viewport(itembox);scheight=len(sets)*38
                if scheight > 750:scheight=750        
                swin.set_size_request(300,500)
                setName=[];hbox1=[]                
                for i in range(len(sets)):
                    hbox1.append(gtk.HBox(False,5));itembox.pack_start(hbox1[i],False,False,2)                
                    setName.append(gtk.CheckButton(sets[i],use_underline=False));setName[i].set_size_request(180,28)
                    hbox1[i].pack_start(setName[i],False,False,0)
                zoneName=[];hbox11=[]
                for i in range(len(zones)):
                    hbox11.append(gtk.HBox(False,5))              
                    zoneName.append(gtk.CheckButton(zones[i],use_underline=False));zoneName[i].set_size_request(180,28)
                    hbox11[i].pack_start(zoneName[i],False,False,0)
                scombo.connect('changed',chscombo,sets,zones,hbox1,hbox11,setName,zoneName)
                hbox2=gtk.HBox(False,5);mainbox.pack_start(hbox2,False,False,5)
                app=gtk.Button(label='Apply');app.set_size_request(100,28);cll=gtk.Button(label='Cancel');cll.set_size_request(100,28)
                app.connect('clicked',makeBaffle);cll.connect('clicked',closethis)
                hbox2.pack_end(cll,False,False,5);hbox2.pack_end(app,False,False,5)  
                window.show_all()      
                self.openSubWindow=True                         
        #---------------------------------------------------------------------------------------------
        self.meshbox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('<b>  Mesh  </b>')
        ebox=gtk.EventBox();self.meshbox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label)
        
        label=gtk.Label('Mesh type')        
        self.ccombo=gtk.combo_box_entry_new_text();self.ccombo.set_size_request(180,28)
        utils=['OpenFOAM','fluentMeshToFoam','fluent3DMeshToFoam','ideasUnvToFoam','gmshToFoam','ccm26ToFoam']
        for ii in utils:self.ccombo.append_text(ii)
        self.ccombo.set_active(0)
        hbox=gtk.HBox(False,5);self.meshbox.pack_start(hbox,False,False,15);hbox.pack_end(self.ccombo,False,False,5);hbox.pack_start(label,False,False,10)
        
        self.selmeshB=gtk.Button('Select Mesh File');self.selmeshB.set_size_request(180,28);self.selmeshB.connect('clicked',selectmesh)
        hbox=gtk.HBox(False,5);self.meshbox.pack_start(hbox,False,False,5);hbox.pack_end(self.selmeshB,True,True,5)
        
        self.crbaffleB=gtk.Button('Create Baffle');self.crbaffleB.set_size_request(100,28);self.crbaffleB.connect('clicked',createBaffle)
        hbox=gtk.HBox(False,5);self.meshbox.pack_start(hbox,False,False,0);hbox.pack_end(self.crbaffleB,True,True,5)
        # --- display boundary -----------------------------------------
        self.viewbox=gtk.VBox(False,5);self.meshbox.pack_start(self.viewbox,False,False,5)
        
        self.scwin=gtk.ScrolledWindow();self.scwin.set_border_width(0);self.scwin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        self.scwin.set_size_request(250,550);self.smbox=gtk.VBox(False,0)
        self.bdbox=gtk.HBox(False,5);self.smeshbox=gtk.HBox(False,5)

        self.viewbox.pack_start(self.smbox,True,True,0);self.smbox.pack_start(self.scwin,True,True,0)
        self.scwin.add_with_viewport(self.bdbox);self.smbox.pack_start(self.smeshbox,False,False,5)       

        self.displaybutton=gtk.Button(label='Display Mesh');self.displaybutton.connect('clicked',showmesh)
        hbox=gtk.HBox(False,5);self.viewbox.pack_start(hbox,False,False,5);hbox.pack_start(self.displaybutton,True,True,5)
        
        self.patchzone=self.viewbc(self.bdbox)

        return self.meshbox
    #-------------------------------------------------------------------------------------------------      
    def importMeshutil(self,util,gvtk,notebook,textbuffer,terminal): 
    
        GEN=generalClass(self.caseDir)
            
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                       (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                        gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        filter = gtk.FileFilter();filter.set_name("All files");filter.add_pattern("*")
        dialog.add_filter(filter)
        filter = gtk.FileFilter();filter.set_name("Meshes")
        filter.add_mime_type("mesh/msh");filter.add_mime_type("mesh/cas");filter.add_mime_type("mesh/ccm")
        filter.add_pattern("*.msh");filter.add_pattern("*.cas");filter.add_pattern("*.ccm")
        dialog.add_filter(filter)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            filename=dialog.get_filename()
        elif response == gtk.RESPONSE_CANCEL:
            filename='None'
        dialog.destroy()
               
        return filename
    #-------------------------------------------------------------------------------------------------      
    def convertm(self,filename,gvtk,notebook,textbuffer,terminal,util,displayOptCombo): 
    
        if filename!='None':

            os.system('pyFoamClearCase.py '+self.caseDir)
            if len(glob.glob(self.caseDir+'/0/*'))!=0:os.system('rm -r '+self.caseDir+'/0/*')

            mf=open(self.caseDir+'/system/settings/meshconvert','w')
  
            if util=='fluent3DMeshToFoam':mf.write('fluent3DMeshToFoam -case '+self.caseDir+' '+filename+'\n')
            elif util=='fluentMeshToFoam':mf.write('fluentMeshToFoam -writeSets -writeZones -case '+self.caseDir+' '+filename+'\n')
            elif util=='cfx4ToFoam':mf.write('cfx4ToFoam -case '+self.caseDir+' '+filename+'\n')
            elif util=='ideasUnvToFoam':mf.write('ideasUnvToFoam -case '+self.caseDir+' '+filename+'\n')
            elif util=='gambitToFoam':mf.write('gambitToFoam -case '+self.caseDir+' '+filename+'\n')
            elif util=='gmshToFoam':mf.write('gmshToFoam -case '+self.caseDir+' '+filename+'\n')
            elif util=='ccm26ToFoam':mf.write('ccm26ToFoam -case '+self.caseDir+' '+filename+'\n')
            else:
                md=gtk.MessageDialog(None,gtk.DIALOG_MODAL,gtk.MESSAGE_INFO,gtk.BUTTONS_CLOSE,"Error! Mesh Converting Failed. Wrong type...")
                md.run();md.destroy()
                return
            
            mf.write('foamToVTK -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.foamToVTK\n')                
            mf.close()
            
            os.system('chmod +x '+self.caseDir+'/system/settings/meshconvert') 
            os.system(self.caseDir+'/system/settings/meshconvert > '+self.caseDir+'/logfiles/log.meshConvert')            
           
            GEN=generalClass(self.caseDir);VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb)
            bcname=GEN.getBCName()
            onOff=[]
            for ii in bcname:onOff.append(1)
            onOff.append(0)
            viewposition=[1,1,1]
            meshrenderer=VTK.unsgeometry(bcname,onOff,viewposition,displayOptCombo.child.get_text())
            gvtk.GetRenderWindow().AddRenderer(meshrenderer)
            gvtk.Initialize();gvtk.Start()
            notebook.set_current_page(1)
            
            cmd='cat '+self.caseDir+'/logfiles/log.meshConvert\n'
            length=len(cmd)
            terminal.feed_child(cmd,length)
    #---------------------------------------------------------------------------------------------------------
    def readMesh(self,gvtk,notebook,textbuffer,terminal):
    
        GEN=generalClass(self.caseDir)
            
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                       (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                        gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_action(gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            stmesh=dialog.get_filename()
        elif response == gtk.RESPONSE_CANCEL:
            stmesh='None'
        dialog.destroy()        

        GEN=generalClass(self.caseDir);VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb)
        bb=stmesh.split('/')
        if bb[-1]!='polyMesh':
            filename='None'
            GEN.messagebox('Error!!! polyMesh folder should be selected.')
            return
        else:        
            if len(glob.glob(self.caseDir+'/0/*'))!=0:os.system('rm -r '+self.caseDir+'/0/*')
            
            if glob.glob(self.caseDir+'/constant/polyMesh')!=[]:os.system('rm -r '+self.caseDir+'/constant/polyMesh')
            if glob.glob(self.caseDir+'/VTK')!=[]:os.system('rm -r '+self.caseDir+'/VTK')
                    
            os.system('cp -r '+stmesh+' '+self.caseDir+'/constant/polyMesh')
            os.system('foamToVTK -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.foamToVTK')

            GEN=generalClass(self.caseDir);VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb)
            bcname=GEN.getBCName()
            onOff=[]
            for ii in bcname:onOff.append(1)
            onOff.append(0)
            viewposition=[1,1,1]
            meshrenderer=VTK.unsgeometry(bcname,onOff,viewposition)
            gvtk.GetRenderWindow().AddRenderer(meshrenderer)
            gvtk.Initialize();gvtk.Start()
            notebook.set_current_page(1)
                
        return stmesh
    #---------------------------------------------------------------------------------------------------------            
    def scaleMesh(self,notebook,textbuffer,terminal):
        
        GEN=generalClass(self.caseDir)
    
        def closethis(widget):            
            window.destroy();self.openSubWindow=False

        def applythis(widget):
            xscale=scalex.get_text();yscale=scaley.get_text();zscale=scalez.get_text()
            
            if GEN.isNumber(xscale)==False:
                GEN.makeDialog('Error!!! x-scale is not number')
                return
            if GEN.isNumber(yscale)==False:
                GEN.makeDialog('Error!!! y-scale is not number')
                return
            if GEN.isNumber(zscale)==False:
                GEN.makeDialog('Error!!! z-scale is not number') 
                return

            f=open(self.caseDir+'/system/settings/runscalemesh','w')
            f.write("transformPoints -case "+self.caseDir+" -scale '("+xscale+' '+yscale+' '+zscale+")'"+'\n')
            f.write('foamToVTK -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.foamToVTK'+'\n')
            f.close()
            os.system('chmod +x '+self.caseDir+'/system/settings/runscalemesh')
            cmd=self.caseDir+'/system/settings/runscalemesh\n'
            length=len(cmd)
            terminal.feed_child(cmd,length)
                        
            window.destroy();self.openSubWindow=False

            notebook.set_current_page(0)
            
            message='\n [  Scale Mesh is Completed with ( '+xscale+' '+yscale+' '+zscale+' )  ]\n\n'                     
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            
        self.openSubWindow=True
        
        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Scale mesh')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER);window.set_transient_for(self.mainwindow)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_ETCHED_OUT);mainbox.pack_start(frame,False,False,5)

        vbox=gtk.VBox(False,5);frame.add(vbox)

        label=gtk.Label('Set scale factor for x,y,z')
        labelbox=gtk.HBox(False,5);vbox.pack_start(labelbox,False,False,5)
        labelbox.pack_start(label,False,False,5)

        scalex=gtk.Entry();scalex.set_size_request(80,28);scalex.set_text('0.001')
        scaley=gtk.Entry();scaley.set_size_request(80,28);scaley.set_text('0.001')
        scalez=gtk.Entry();scalez.set_size_request(80,28);scalez.set_text('0.001')
        scalebox=gtk.HBox(False,5);vbox.pack_start(scalebox,False,False,5)
        scalebox.pack_start(scalex,False,False,5);scalebox.pack_start(scaley,False,False,5);scalebox.pack_start(scalez,False,False,5)

        appB=gtk.Button('Apply');clsB=gtk.Button('Close')
        appB.connect('clicked',applythis);clsB.connect('clicked',closethis)
        appB.set_size_request(100,28);clsB.set_size_request(100,28)
        bubox=gtk.HBox(False,5);vbox.pack_start(bubox,False,False,5)
        bubox.pack_end(clsB,False,False,5);bubox.pack_end(appB,False,False,5)
        window.show_all()       
    #---------------------------------------------------------------------------------------------------------            
    def translateMesh(self,notebook,textbuffer,terminal):
    
        GEN=generalClass(self.caseDir)
    
        def closethis(widget):
            window.destroy();self.openSubWindow=False

        def applythis(widget):
            xscale=scalex.get_text();yscale=scaley.get_text();zscale=scalez.get_text()
            
            if GEN.isNumber(xscale)==False:
                GEN.makeDialog('Error!!! vector-x is not number')
                return
            if GEN.isNumber(yscale)==False:
                GEN.makeDialog('Error!!! vector-y is not number')
                return
            if GEN.isNumber(zscale)==False:
                GEN.makeDialog('Error!!! vector-z is not number') 
                return

            f=open(self.caseDir+'/system/settings/runtranslatemesh','w')
            f.write("transformPoints -case "+self.caseDir+" -translate '("+xscale+' '+yscale+' '+zscale+")'"+'\n')
            f.write('foamToVTK -case '+self.caseDir+' > '+self.caseDir+'/logfiles/logfiles/log.foamToVTK'+'\n')
            f.close()
            os.system('chmod +x '+self.caseDir+'/system/settings/runtranslatemesh')
            cmd=self.caseDir+'/system/settings/runtranslatemesh\n'
            length=len(cmd)
            terminal.feed_child(cmd,length)
                                        
            window.destroy();self.openSubWindow=False

            notebook.set_current_page(0)
            
            message='\n [  Translate Mesh is Completed with ( '+xscale+' '+yscale+' '+zscale+' )  ]\n\n'                     
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            
        self.openSubWindow=True
        
        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Translate mesh')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER);window.set_transient_for(self.mainwindow)
        mainbox=gtk.VBox(False,5);window.add(mainbox)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_ETCHED_OUT);mainbox.pack_start(frame,False,False,5)

        vbox=gtk.VBox(False,5);frame.add(vbox)

        label=gtk.Label('Set vector for x,y,z [m]')
        labelbox=gtk.HBox(False,5);vbox.pack_start(labelbox,False,False,5)
        labelbox.pack_start(label,False,False,5)

        scalex=gtk.Entry();scalex.set_size_request(80,28);scalex.set_text('1')
        scaley=gtk.Entry();scaley.set_size_request(80,28);scaley.set_text('0')
        scalez=gtk.Entry();scalez.set_size_request(80,28);scalez.set_text('0')
        scalebox=gtk.HBox(False,5);vbox.pack_start(scalebox,False,False,5)
        scalebox.pack_start(scalex,False,False,5);scalebox.pack_start(scaley,False,False,5);scalebox.pack_start(scalez,False,False,5)

        appB=gtk.Button('Apply');clsB=gtk.Button('Close')
        appB.connect('clicked',applythis);clsB.connect('clicked',closethis)
        appB.set_size_request(100,28);clsB.set_size_request(100,28)
        bubox=gtk.HBox(False,5);vbox.pack_start(bubox,False,False,5)
        bubox.pack_end(clsB,False,False,5);bubox.pack_end(appB,False,False,5)
        window.show_all()  
    #---------------------------------------------------------------------------------------------------------                    
    def viewbc(self,bdbox):    
    
        GEN=generalClass(self.caseDir)
    
        if glob.glob(self.caseDir+'/constant/polyMesh/boundary')!=[]:        
            self.bcname=GEN.getBCName();cellzones=GEN.getCellZones();patchzone=self.bcname+cellzones
            aa=bdbox.get_children()
            for ii in aa:bdbox.remove(ii)
            
            def get_model(tree_store):
                if tree_store:return tree_store 
                else:return None                
            def col1_toggled_cb( cell, path, model ):
                model[path][1] = not model[path][1]
                for i in range(len(patchzone)):
                    if model[path][0]==patchzone[i]:
                        if model[path][1]==True:self.onOff[i]=1
                        else:self.onOff[i]=0
                                    
            def make_view( model ):
                view = gtk.TreeView( model )
                renderer = gtk.CellRendererText()
                renderer1 = gtk.CellRendererToggle();renderer1.set_property('activatable', True);renderer1.connect( 'toggled', col1_toggled_cb, model )

                column0 = gtk.TreeViewColumn("Boundary Name", renderer, text=0)
                column1 = gtk.TreeViewColumn("          Display", renderer1 )
                column1.add_attribute( renderer1, "active", 1)
                view.append_column( column0 );view.append_column( column1 )
                return view

            self.onOff=[]
            for i in range(len(patchzone)):self.onOff.append(0)            
            tree_store=gtk.TreeStore(gobject.TYPE_STRING,gobject.TYPE_BOOLEAN)
            for item in patchzone:
                parent=tree_store.append(None,(item,None))
            mdl=get_model(tree_store)
            view=make_view(mdl)        
            
            bdbox.pack_start(view,True,True,5)
            
            self.meshbox.show_all()

        else:patchzone='none'  
            
        return patchzone  
    #---------------------------------------------------------------------------------------------------------                            
    def checkMesh(self,notebook,textbuffer,terminal):
        GEN=generalClass(self.caseDir)
        os.system('checkMesh -case '+self.caseDir+' > '+self.caseDir+'/logfiles/log.checkMesh')
        cmd='cat  '+self.caseDir+'/logfiles/log.checkMesh'+'\n'
        length=len(cmd)
        terminal.feed_child(cmd,length)
        notebook.set_current_page(2)
            
        az=self.caseDir+'/constant/polyMesh/boundary'
        filea=open(az,'r');lines=filea.readlines();filea.close()
        line1=[]  
        for i in range(16,len(lines)):
            a=(lines[i]).strip()
            if a=='{':line1.append(i)
        for i in line1:
            bb=(lines[i-1]).strip();b=bb[0]
            if GEN.isNumber(b):GEN.makeDialoge('Warning!!! Some patch name begin with number\n It might have some problem')            
            
            
