#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for manipulate mesh
#
# Author
#    NEXTFOAM Inc. 
##############################################################################
import os,math,sys;import pygtk;pygtk.require('2.0');import gtk,gobject
import glob
import time
import pickle

from generalSub import *
from boundaryConditionSub import *
from VTKStuffClass import *
from writeFileSub import *

class freepanelPatchScalarClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow,solver,installpath,rr,gg,bb):
        self.caseDir=caseDir
        self.mainwindow=mainwindow
        self.solver=solver
        self.installpath=installpath
        self.openSubWindow=False
        self.rr=rr;self.gg=gg;self.bb=bb

    def patchScalar(self,gvtk,notebook,textbuffer,displayOptCombo):    
    
        GEN=generalClass(self.caseDir);WFILE=writeFileClass(self.caseDir);VTK=VTKStuff(self.caseDir,self.rr,self.gg,self.bb)
    
        def togglemesh(widget):
            whatradio=widget.get_label()
            if whatradio=='OpenFOAM':self.ccombo.set_sensitive(0)
            else:self.ccombo.set_sensitive(1)
        
        def showpatch(widget):
            viewposition=[1,1,1]
            scalar=self.scalarCombo.child.get_text()
            stime=self.timeCombo.child.get_text()
            aa=glob.glob(self.caseDir+'/processor*')
            if aa==[]:caseType=1
            else:caseType=0
             
            renderer=VTK.patchField(self.patchzone,self.onOff,scalar,stime,caseType,viewposition,displayOptCombo.child.get_text())
            gvtk.GetRenderWindow().AddRenderer(renderer)
            
            notebook.set_current_page(1)
                            
            dic={}
            dic['scalar']=scalar;dic['time']=stime;dic['onOff']=self.onOff;dic['caseType']=caseType;dic['patchzone']=self.patchzone
            f=open(self.caseDir+'/system/settings/displayedPatchScalar','w')
            pickle.dump(dic,f);f.close()

            f.close()
            f=open(self.caseDir+'/system/settings/displaymode','w')
            f.write('patchScalar');f.close()   
        #---------------------------------------------------------------------------------------------
        self.patchScalarbox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('<b>  patch Scalar  </b>')
        ebox=gtk.EventBox();self.patchScalarbox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label)
        
        label=gtk.Label('Select Scalar')        
        self.scalarCombo=gtk.combo_box_entry_new_text();self.scalarCombo.set_size_request(120,28)
        scalars=['Umag','p','p_rgh','T','k','epsilon','omega']
        for ii in scalars:self.scalarCombo.append_text(ii)
        self.scalarCombo.set_active(0)
        hbox=gtk.HBox(False,5);self.patchScalarbox.pack_start(hbox,False,False,15)
        hbox.pack_end(self.scalarCombo,False,False,5);hbox.pack_start(label,False,False,10)

        label=gtk.Label('Select Time')
        self.timeCombo=gtk.combo_box_entry_new_text();self.timeCombo.set_size_request(120,28)        
        savedResult=GEN.getResult()
        if len(savedResult[0]) >= len(savedResult[1]):self.results=savedResult[0]
        else:self.results=savedResult[1]    
        self.results.append('latestTime')
        for jj in self.results:self.timeCombo.append_text(jj)
        self.timeCombo.set_active(self.results.index('latestTime'))        
        hbox=gtk.HBox(False,5);self.patchScalarbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.timeCombo,False,False,5)
        # --- display boundary -----------------------------------------
        self.viewbox=gtk.VBox(False,5);self.patchScalarbox.pack_start(self.viewbox,False,False,5)
        
        self.scwin=gtk.ScrolledWindow();self.scwin.set_border_width(0);self.scwin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        self.scwin.set_size_request(250,550);self.smbox=gtk.VBox(False,0)
        self.bdbox=gtk.HBox(False,5);self.smeshbox=gtk.HBox(False,5)

        self.viewbox.pack_start(self.smbox,True,True,0);self.smbox.pack_start(self.scwin,True,True,0)
        self.scwin.add_with_viewport(self.bdbox);self.smbox.pack_start(self.smeshbox,False,False,5)       

        self.displaybutton=gtk.Button(label='Display ');self.displaybutton.connect('clicked',showpatch)
        hbox=gtk.HBox(False,5);self.viewbox.pack_start(hbox,False,False,5);hbox.pack_start(self.displaybutton,True,True,5)
        
        self.patchzone=self.viewbc(self.bdbox)

        return self.patchScalarbox
    #-------------------------------------------------------------------------------------------------      
    def viewbc(self,bdbox):    
    
        GEN=generalClass(self.caseDir)
    
        if glob.glob(self.caseDir+'/constant/polyMesh/boundary')!=[]:        
            self.bcname=GEN.getBCName();patchzone=self.bcname
            aa=bdbox.get_children()
            for ii in aa:bdbox.remove(ii)
            
            def get_model(tree_store):
                if tree_store:return tree_store 
                else:return None                
            def col1_toggled_cb( cell, path, model ):
                model[path][1] = not model[path][1]
                for i in range(len(patchzone)):
                    if model[path][0]==patchzone[i]:
                        if model[path][1]==True:self.onOff[i]=1
                        else:self.onOff[i]=0
                                    
            def make_view( model ):
                view = gtk.TreeView( model )
                renderer = gtk.CellRendererText()
                renderer1 = gtk.CellRendererToggle();renderer1.set_property('activatable', True);renderer1.connect( 'toggled', col1_toggled_cb, model )

                column0 = gtk.TreeViewColumn("Boundary Name", renderer, text=0)
                column1 = gtk.TreeViewColumn("          Display", renderer1 )
                column1.add_attribute( renderer1, "active", 1)
                view.append_column( column0 );view.append_column( column1 )
                return view

            self.onOff=[]
            for i in range(len(patchzone)):self.onOff.append(0)            
            tree_store=gtk.TreeStore(gobject.TYPE_STRING,gobject.TYPE_BOOLEAN)
            for item in patchzone:
                parent=tree_store.append(None,(item,None))
            mdl=get_model(tree_store)
            view=make_view(mdl)        
            
            bdbox.pack_start(view,True,True,5)
            
            self.patchScalarbox.show_all()

        else:patchzone='none'  
            
        return patchzone  
    #---------------------------------------------------------------------------------------------------------                            

            
