#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for radiation model
#
# Author
#    NEXTFOAM Inc. 
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *
from boundaryConditionSub import *
from writeFileSub import *

class freepanelRadiationClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow,solver,installpath):
        self.caseDir=caseDir
        self.mainwindow=mainwindow
        self.solver=solver
        self.installpath=installpath
        self.openSubWindow=False

    def radiation(self,tvbox):
        GEN=generalClass(self.caseDir);WFILE=writeFileClass(self.caseDir)
        
        def saveRadiation(widget):            
            radiationDict={}
            if self.radiationCheck.get_active()==0:radiationDict['radOnOff']='false'
            else:radiationDict['radOnOff']='true'
            radiationDict['radFreq']=self.radfreqEntry.get_text()
            aa=self.radCombo.child;radiationDict['radModel']=aa.get_text()
            radiationDict['radDONPhi']=self.nphiEntry.get_text()
            radiationDict['radDONTheta']=self.nthetaEntry.get_text()
            radiationDict['radDOConv']=self.convEntry.get_text()
            radiationDict['radDOMaxiter']=self.maxiterEntry.get_text()
            if self.cachedivCheck.get_active()==1:radiationDict['radDOCache']='true'
            else:radiationDict['radDOCache']='false'
            aa=self.aeCombo.child;radiationDict['radAEModel']=aa.get_text()
            radiationDict['radAEConstAbs']=self.constabsEntry.get_text()
            radiationDict['radAEConstEmi']=self.constemiEntry.get_text()
            radiationDict['radAEConstE']=self.constEEntry.get_text()
            radiationDict['radAEGreyEhrr']=self.greyehrrEntry.get_text()
            aa=self.scatterCombo.child;radiationDict['radScatterModel']=aa.get_text()

            if GEN.isNumber(radiationDict['radFreq'])==False:GEN.makeDialog('Error!!! frequency is not number')            
            if GEN.isNumber(radiationDict['radDONPhi'])==False:GEN.makeDialog('Error!!! nphi is not number')            
            if GEN.isNumber(radiationDict['radDONTheta'])==False:GEN.makeDialog('Error!!! ntheta is not number')            
            if GEN.isNumber(radiationDict['radDOConv'])==False:GEN.makeDialog('Error!!! convergence is not number')            
            if GEN.isNumber(radiationDict['radDOMaxiter'])==False:GEN.makeDialog('Error!!! maxIter is not number')            
            if GEN.isNumber(radiationDict['radAEConstAbs'])==False:GEN.makeDialog('Error!!! abs.coeff. is not number')            
            if GEN.isNumber(radiationDict['radAEConstEmi'])==False:GEN.makeDialog('Error!!! emi.coeff is not number')            
            if GEN.isNumber(radiationDict['radAEConstE'])==False:GEN.makeDialog('Error!!! emissivity is not number')            
            if GEN.isNumber(radiationDict['radAEGreyEhrr'])==False:GEN.makeDialog('Error!!! Ehrr is not number')            
                        
            keys=radiationDict.keys()
            f=open(self.caseDir+'/system/settings/radiationConditions','w')
            for ii in keys:f.write(ii+';'+radiationDict[ii]+'\n')         
            f.close() 
            
            WFILE.radiationProperties(radiationDict,self.installpath)
            
            message='Radiation condition is saved'
            GEN.tailboxMessage(tvbox,message,self.mainwindow)
            
        def setSavedValue():
            fileName=self.caseDir+'/system/settings/radiationConditions';aa=glob.glob(fileName)            
            if len(aa)!=0:
                GEN=generalClass(self.caseDir);radiationDict=GEN.makeDictFromFile(fileName)
                if radiationDict['radOnOff']=='false':self.radiationCheck.set_active(0);disablerad()
                else:
                    enablerad()
                    self.radiationCheck.set_active(1)
                    self.radfreqEntry.set_text(radiationDict['radFreq'])
                    self.radCombo.set_active(self.radiationModel.index(radiationDict['radModel']))                            
                    self.nphiEntry.set_text(radiationDict['radDONPhi'])
                    self.nthetaEntry.set_text(radiationDict['radDONTheta'])
                    self.convEntry.set_text(radiationDict['radDOConv'])
                    self.maxiterEntry.set_text(radiationDict['radDOMaxiter'])
                    if radiationDict['radDOCache']=='false':self.cachedivCheck.set_active(0)
                    else:self.cachedivCheck.set_active(1)
                    self.aeCombo.set_active(self.aeModel.index(radiationDict['radAEModel']))
                    self.constabsEntry.set_text(radiationDict['radAEConstAbs'])
                    self.constemiEntry.set_text(radiationDict['radAEConstEmi'])
                    self.constEEntry.set_text(radiationDict['radAEConstE'])
                    self.greyehrrEntry.set_text(radiationDict['radAEGreyEhrr'])
                    self.scatterCombo.set_active(self.scatterModel.index(radiationDict['radScatterModel']))                          

        def checkRad(widget):
            radonoff=widget.get_active()
            if radonoff==1:enablerad()
            else:disablerad()

        def disablerad():
            self.radfreqEntry.set_sensitive(0);self.radCombo.set_sensitive(0);self.nphiEntry.set_sensitive(0);self.nthetaEntry.set_sensitive(0)
            self.convEntry.set_sensitive(0);self.maxiterEntry.set_sensitive(0);self.cachedivCheck.set_sensitive(0);self.aeCombo.set_sensitive(0)
            self.constabsEntry.set_sensitive(0);self.constemiEntry.set_sensitive(0);self.constEEntry.set_sensitive(0);self.greyehrrEntry.set_sensitive(0)
            self.binaryButton.set_sensitive(0);self.scatterCombo.set_sensitive(0);self.selCloudButton.set_sensitive(0)            
        def enablerad():
            self.radfreqEntry.set_sensitive(1);self.radCombo.set_sensitive(1);self.nphiEntry.set_sensitive(1);self.nthetaEntry.set_sensitive(1)
            self.convEntry.set_sensitive(1);self.maxiterEntry.set_sensitive(1);self.cachedivCheck.set_sensitive(1);self.aeCombo.set_sensitive(1)
            self.constabsEntry.set_sensitive(1);self.constemiEntry.set_sensitive(1);self.constEEntry.set_sensitive(1);self.greyehrrEntry.set_sensitive(1)
            self.binaryButton.set_sensitive(1);self.scatterCombo.set_sensitive(1)#;self.selCloudButton.set_sensitive(1)  

        def chRadModel(widget):
            aa=self.radCombo.child;radmodel=aa.get_text()
            aa=self.modelbox.get_children()
            for ii in aa:self.modelbox.remove(ii)
            if radmodel=='fvDOM':self.modelbox.pack_start(self.dombox,False,False,5)
            elif radmodel=='viewFactor':self.modelbox.pack_start(self.viewfactorbox,False,False,5)
            self.radbox.show_all()
    
        def chAEModel(widget):
            aa=self.aeCombo.child;aemodel=aa.get_text()	
            aa=self.abembox.get_children()
            for ii in aa:self.abembox.remove(ii)
            if aemodel=='constant':self.abembox.pack_start(self.constAEbox,False,False,5)
            elif aemodel=='greyMean':self.abembox.pack_start(self.greyAEbox,False,False,5)
            elif aemodel=='binary':self.abembox.pack_start(self.binaryAEbox,False,False,5)
            self.radbox.show_all()

        def chscatter(widget):
            aa=self.scatterCombo.child;scattermodel=aa.get_text()	
            aa=self.scatbox.get_children()
            for ii in aa:self.scatbox.remove(ii)
            if scattermodel=='cloud':
                self.scatbox.pack_start(self.selcloudbox,False,False,5)
                self.selCloudButton.set_sensitive(1)
            self.radbox.show_all()
            
        def openviewfactor(wiget):
            if self.openSubWindow==False:self.viewfactordictwindow()

        self.radbox=gtk.VBox(False,5)        
        self.radsetbox=gtk.VBox(False,5);self.radbox.pack_start(self.radsetbox,False,False,5)
        
        self.radiationCheck=gtk.CheckButton('Radiation');self.radsetbox.pack_start(self.radiationCheck,False,False,5)
        self.radiationCheck.connect('toggled',checkRad)
        separator=gtk.HSeparator();separator.set_size_request(285,5);self.radsetbox.pack_start(separator,False,True,10)        

        self.radfreqEntry=gtk.Entry();self.radfreqEntry.set_text('10');self.radfreqEntry.set_size_request(100,28)
        hbox=gtk.HBox(False,5);self.radsetbox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.radfreqEntry,False,False,2)
        label=gtk.Label('Solver frequency');hbox.pack_start(label,False,False,2)
        self.radfreqEntry.set_sensitive(0)

        self.radCombo=gtk.combo_box_entry_new_text();self.radCombo.set_size_request(100,28)
        self.radiationModel=['none','P1','fvDOM','viewFactor']  
        for ii in self.radiationModel:self.radCombo.append_text(ii)
        self.radCombo.set_active(1);self.radCombo.connect('changed',chRadModel)
        hbox=gtk.HBox(False,5);self.radsetbox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.radCombo,False,False,2)
        label=gtk.Label('Radiation model');hbox.pack_start(label,False,False,2)
        self.radCombo.set_sensitive(0)
        # fvDOM
        self.modelbox=gtk.VBox(False,5);self.radsetbox.pack_start(self.modelbox,False,False,5)
        self.dombox=gtk.VBox(False,5)
        self.nphiEntry=gtk.Entry();self.nphiEntry.set_text('2');self.nphiEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.dombox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.nphiEntry,False,False,2)
        label=gtk.Label('nPhi');hbox.pack_end(label,False,False,2);label.set_size_request(80,28);label.set_alignment(0,0.5)	
        self.nthetaEntry=gtk.Entry();self.nthetaEntry.set_text('2');self.nthetaEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.dombox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.nthetaEntry,False,False,2)
        label=gtk.Label('nTheta');hbox.pack_end(label,False,False,2);label.set_size_request(80,28);label.set_alignment(0,0.5)
        self.convEntry=gtk.Entry();self.convEntry.set_text('1e-3');self.convEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.dombox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.convEntry,False,False,2)
        label=gtk.Label('converge.');hbox.pack_end(label,False,False,2);label.set_size_request(80,28);label.set_alignment(0,0.5)
        self.maxiterEntry=gtk.Entry();self.maxiterEntry.set_text('100');self.maxiterEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.dombox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.maxiterEntry,False,False,2)
        label=gtk.Label('maxIter');hbox.pack_end(label,False,False,2);label.set_size_request(80,28);label.set_alignment(0,0.5)
        self.cachedivCheck=gtk.CheckButton('cacheDiv');self.cachedivCheck.set_active(0)
        hbox=gtk.HBox(False,5);self.dombox.pack_start(hbox,False,False,2)
        label=gtk.Label('');hbox.pack_end(label,False,False,2);label.set_size_request(80,28);label.set_alignment(0,0.5)
        hbox.pack_end(self.cachedivCheck,False,False,2)
        # viewFactor
        self.viewfactorbox=gtk.VBox(False,5)
        self.vfdictB=gtk.Button('Set viewFactorDict');self.vfdictB.set_size_request(200,28);self.vfdictB.connect('clicked',openviewfactor)
        hbox=gtk.HBox(False,5);self.viewfactorbox.pack_start(hbox,False,False,5);hbox.pack_end(self.vfdictB,False,False,5)        
        
        # A-E
        def binaryAE(widget):self.binaryAEModel()
                    
        hbox=gtk.HBox(False,5);self.radsetbox.pack_start(hbox,False,False,2)
        label=gtk.Label('Absorp./Emission');hbox.pack_start(label,False,False,2)
        self.aeCombo=gtk.combo_box_entry_new_text();self.aeCombo.set_size_request(100,28)
        if self.solver=='DPMFoam' or self.solver=='coalFoam':
            self.aeModel=['constant','greyMean','binary'] 
        else:
            self.aeModel=['constant']
        for ii in self.aeModel:self.aeCombo.append_text(ii)
        self.aeCombo.set_active(0);self.aeCombo.connect('changed',chAEModel)
        hbox.pack_end(self.aeCombo,False,False,2)
        self.aeCombo.set_sensitive(0)

        self.abembox=gtk.VBox(False,5);self.radsetbox.pack_start(self.abembox,False,False,0)
        # const
        self.constAEbox=gtk.VBox(False,5);self.abembox.pack_start(self.constAEbox,False,False,5)
        self.caebox=gtk.VBox(False,5);self.constAEbox.pack_start(self.caebox,False,False,5)
        self.constabsEntry=gtk.Entry();self.constabsEntry.set_text('0.5');self.constabsEntry.set_size_request(60,28)
        hbox=gtk.HBox(False,5);self.caebox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.constabsEntry,False,False,2)
        self.constabsEntry.set_sensitive(0)        
        label=gtk.Label('absorptivity');hbox.pack_end(label,False,False,2);label.set_size_request(100,28);label.set_alignment(0,0.5)	
        self.constemiEntry=gtk.Entry();self.constemiEntry.set_text('0.5');self.constemiEntry.set_size_request(60,28)
        hbox=gtk.HBox(False,5);self.caebox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.constemiEntry,False,False,2)
        self.constemiEntry.set_sensitive(0)        
        label=gtk.Label('emissivity');hbox.pack_end(label,False,False,2);label.set_size_request(100,28);label.set_alignment(0,0.5)
        self.constEEntry=gtk.Entry();self.constEEntry.set_text('0');self.constEEntry.set_size_request(60,28)
        hbox=gtk.HBox(False,5);self.caebox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.constEEntry,False,False,2)
        self.constEEntry.set_sensitive(0)        
        label=gtk.Label('E');hbox.pack_end(label,False,False,2);label.set_size_request(100,28);label.set_alignment(0,0.5)
        # greyMean
        self.greyAEbox=gtk.VBox(False,5)
        hbox=gtk.HBox(False,5);self.greyAEbox.pack_start(hbox,False,False,5)
        label=gtk.Label('EhrrCoeff');label.set_size_request(100,28);label.set_alignment(0,0.5)	
        self.greyehrrEntry=gtk.Entry();self.greyehrrEntry.set_text('0');self.greyehrrEntry.set_size_request(60,28)
        hbox.pack_end(self.greyehrrEntry,False,False,2);hbox.pack_end(label,False,False,2)
        hbox=gtk.HBox(False,5);self.greyAEbox.pack_start(hbox,False,False,2)
        # binary
        self.binaryAEbox=gtk.VBox(False,5)
        hbox=gtk.HBox(False,5);self.binaryAEbox.pack_start(hbox,False,False,2)
        self.binaryButton=gtk.Button('Set binary');self.binaryButton.set_size_request(120,28);self.binaryButton.connect('clicked',binaryAE)
        hbox.pack_end(self.binaryButton,False,False,5)
        # scatter
        def openCloudScatter(widget):
            aa=glob.glob(self.caseDir+'/system/settings/coalProperties-*')
            if len(aa)==0:
                md = gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, "Error!!! - Coal is not set yet")
                md.run();md.destroy()
            else:
                if self.openSubWindow==False:
                    coals=[]
                    for ii in aa:
                        dic=GEN.makeDictFromFile(ii)
                        coals.append(dic['coalName'])                    
                    #for ii in aa:a1=ii.split('/');a2=a1[-1];coals.append(a2[15:])
                    self.selectCloudWindow(coals,'scattering')

        #def chscatter(widget):
        #    aa=widget.child;scmodel=aa.get_text()
        #    if scmodel=='none':self.selCloudButton.set_sensitive(0)
        #    else:self.selCloudButton.set_sensitive(1)
                
        self.scatterCombo=gtk.combo_box_entry_new_text();self.scatterCombo.set_size_request(100,28)
        if self.solver=='DPMFoam' or self.solver=='coalFoam':        
            self.scatterModel=['none','cloud']
        else:
            self.scatterModel=['none']
        
        for ii in self.scatterModel:self.scatterCombo.append_text(ii)
        self.scatterCombo.set_active(0);self.scatterCombo.connect('changed',chscatter)
        hbox=gtk.HBox(False,5);self.radsetbox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.scatterCombo,False,False,2)
        label=gtk.Label('Scattering model');hbox.pack_start(label,False,False,2)
        self.scatterCombo.connect('changed',chscatter)

        self.scatbox=gtk.VBox(False,5);self.radsetbox.pack_start(self.scatbox,False,False,0)
        self.selcloudbox=gtk.VBox(False,5);self.scatbox.pack_start(self.selcloudbox,False,False,2)
        hbox=gtk.HBox(False,5);self.selcloudbox.pack_start(hbox,False,False,2)
        self.selCloudButton=gtk.Button('clousNames');self.selCloudButton.set_size_request(120,28)
        self.selCloudButton.connect('clicked',openCloudScatter)
        self.selCloudButton.set_sensitive(0)
        if self.solver=='DPMFoam' or self.solver=='coalFoam':        
            hbox.pack_end(self.selCloudButton,False,False,2)

        self.buttonhbox=gtk.HBox(False,5);self.radsetbox.pack_start(self.buttonhbox,False,False,5)
        self.radAppB=gtk.Button('Apply');self.buttonhbox.pack_end(self.radAppB,True,True,2)
        self.radAppB.connect('clicked',saveRadiation)
        
        setSavedValue()
        
        return self.radbox
    #---------------------------------------------
    def viewfactordictwindow(self):
    
        GEN=generalClass(self.caseDir);bcname=GEN.getBCName()
        
        def applythis(widget):
            viewfactorDict={}            
            #sname=[];sface=[];sfeat=[]
            for i in range(len(bcname)):
                sn=names[i].get_text();sf=nface[i].get_text();sa=feat[i].get_text()
                viewfactorDict['nFace:'+sn]=sf;viewfactorDict['feature:'+sn]=sa
            keys=viewfactorDict.keys()
            f=open(self.caseDir+'/system/settings/viewfactordict','w')            
            for ii in keys:f.write(ii+';'+viewfactorDict[ii]+'\n')
            f.close()            
            
            WFILE=writeFileClass(self.caseDir);WFILE.viewFactorsDict(bcname,viewfactorDict)
            
            vwin.destroy();self.openSubWindow=False
        
        def closethis(widget):
            vwin.destroy();self.openSubWindow=False
        
        def setSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/viewfactordict')
            if len(aa)!=0:                
                vfdict=GEN.makeDictFromFile(aa[0])
                for i in range(len(bcname)):
                    nface[i].set_text(vfdict['nFace:'+bcname[i]])
                    feat[i].set_text(vfdict['feature:'+bcname[i]])
        
        self.openSubWindow=True
            
        vwin=gtk.Window(gtk.WINDOW_TOPLEVEL);vwin.set_title('viewFactorsDict setup')
        vwin.set_border_width(5);vwin.set_position(gtk.WIN_POS_CENTER);vwin.set_transient_for(self.mainwindow)
        vmainbox=gtk.VBox(False,0);vwin.add(vmainbox)

        label=gtk.Label();label.set_markup('<b>Set values for viewFactorsDict file  </b>')
        hbox=gtk.HBox(False,5);vmainbox.pack_start(hbox,False,False,5);hbox.pack_start(label,False,False,15)

        label1=gtk.Label('patchName / nFacesInCoarsestLevel / featureAngle')
        hbox=gtk.HBox(False,5);vmainbox.pack_start(hbox,False,False,5);hbox.pack_start(label1,False,False,5)

        vscwin=gtk.ScrolledWindow();vscwin.set_border_width(0);vscwin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        vscwin.set_size_request(400,400)
        hbox=gtk.HBox(False,5);vmainbox.pack_start(hbox,False,False,5);hbox.pack_start(vscwin,True,True,0)
        vbox=gtk.VBox(False,0);vscwin.add_with_viewport(vbox)
              
        hhbox=[];names=[];nface=[];feat=[]
        for i in range(len(bcname)):
            hhbox.append(gtk.HBox(False,5))
            names.append(gtk.Entry())
            nface.append(gtk.Entry())
            feat.append(gtk.Entry())
            names[i].set_size_request(150,28);names[i].set_text(bcname[i]);names[i].set_editable(0);names[i].set_has_frame(0)
            nface[i].set_size_request(100,28);nface[i].set_text('30')
            feat[i].set_size_request(100,28);feat[i].set_text('10')
            vbox.pack_start(hhbox[i],False,False,5)
            hhbox[i].pack_start(names[i],False,False,5);hhbox[i].pack_start(nface[i],False,False,0);hhbox[i].pack_start(feat[i],False,False,5)
            
        appB=gtk.Button('Apply');appB.set_size_request(80,28);appB.connect('clicked',applythis)
        clsB=gtk.Button('Close');clsB.set_size_request(80,28);clsB.connect('clicked',closethis)
        hbox=gtk.HBox(False,5);vmainbox.pack_start(hbox,False,False,5)
        hbox.pack_end(clsB,False,False,5);hbox.pack_end(appB,False,False,5)
        
        setSavedValue()
        
        vwin.show_all()
    #------------------------------------------
    def selectCloudWindow(self,coals,mode):  

        GEN=generalClass(self.caseDir);bcname=GEN.getBCName()
        
        def applythis(widget):        
            selected=[]
            for i in range(len(coals)):
                if chks[i].get_active()==1:selected.append(coals[i])
            if len(selected)!=0:
                f=open(self.caseDir+'/system/settings/cloudCoal-'+mode,'w')            
                for ii in selected:f.write(ii+'\n')
                f.close()            
            else:
                md = gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, "Error!!! - Selected coal")
                md.run();md.destroy()
            cwin.destroy();self.openSubWindow=False
        
        def closethis(widget):
            cwin.destroy();self.openSubWindow=False
        
        def setSavedValue():            
            aa=glob.glob(self.caseDir+'/system/settings/cloudCoal-'+mode)
            if len(aa)!=0:                
                f=open(aa[0],'r');ff=f.readlines();f.close()
                sel=[]
                for ii in ff:sel.append(ii[:-1])
                for i in range(len(coals)):
                    for jj in sel:
                        if jj==coals[i]:chks[i].set_active(1)                    
        
        self.openSubWindow=True
                        
        cwin=gtk.Window(gtk.WINDOW_TOPLEVEL);cwin.set_title('Select coal')
        cwin.set_border_width(5);cwin.set_position(gtk.WIN_POS_CENTER)
        cmainbox=gtk.VBox(False,0);cwin.add(cmainbox)

        label=gtk.Label();label.set_markup('<b>Select coals for could   </b>')
        hbox=gtk.HBox(False,5);cmainbox.pack_start(hbox,False,False,5);hbox.pack_start(label,False,False,15)            
        
        cscwin=gtk.ScrolledWindow();cscwin.set_border_width(0);cscwin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        cscwin.set_size_request(250,200)
        hbox=gtk.HBox(False,5);cmainbox.pack_start(hbox,False,False,5);hbox.pack_start(cscwin,True,True,0)
        vbox=gtk.VBox(False,0);cscwin.add_with_viewport(vbox)
              
        hhbox=[];chks=[]
        for i in range(len(coals)):
            hhbox.append(gtk.HBox(False,5))
            chks.append(gtk.CheckButton(coals[i]))
            vbox.pack_start(hhbox[i],False,False,5)
            hhbox[i].pack_start(chks[i],False,False,5)
       
        appB=gtk.Button('Apply');appB.set_size_request(100,28);appB.connect('clicked',applythis)
        clsB=gtk.Button('Close');clsB.set_size_request(100,28);clsB.connect('clicked',closethis)
        hbox=gtk.HBox(False,5);cmainbox.pack_start(hbox,False,False,5)
        hbox.pack_end(clsB,False,False,5);hbox.pack_end(appB,False,False,5)
        
        setSavedValue()
        
        cwin.show_all()
    #--------------------------------------------------------------------------------------  
    def binaryAEModel(self):          
     
        GEN=generalClass(self.caseDir)

        def applythis(widget):
            binaryAbsDict={}
            aa=model1Combo.child;binaryAbsDict['model1']=aa.get_text()
            binaryAbsDict['model1constAb']=model1constabEntry.get_text()
            if GEN.isNumber(binaryAbsDict['model1constAb'])==False:GEN.makeDialog('Error!!! abs.-1 is not number')            
            binaryAbsDict['model1constEm']=model1constemEntry.get_text()
            if GEN.isNumber(binaryAbsDict['model1constEm'])==False:GEN.makeDialog('Error!!! emi.-1 is not number')            
            binaryAbsDict['model1constE']=model1consteEntry.get_text()
            if GEN.isNumber(binaryAbsDict['model1constE'])==False:GEN.makeDialog('Error!!! emissivity-1 is not number')            
            binaryAbsDict['model1greyEhrr']=model1greyehrrEntry.get_text()            
            if GEN.isNumber(binaryAbsDict['model1greyEhrr'])==False:GEN.makeDialog('Error!!! Ehrr-1 is not number')            
            aa=model2Combo.child;binaryAbsDict['model2']=aa.get_text()
            binaryAbsDict['model2constAb']=model2constabEntry.get_text()
            if GEN.isNumber(binaryAbsDict['model2constAb'])==False:GEN.makeDialog('Error!!! abs.-2 is not number')            
            binaryAbsDict['model2constEm']=model2constemEntry.get_text()
            if GEN.isNumber(binaryAbsDict['model2constEm'])==False:GEN.makeDialog('Error!!! emi.-2 is not number')            
            binaryAbsDict['model2constE']=model2consteEntry.get_text()
            if GEN.isNumber(binaryAbsDict['model2constE'])==False:GEN.makeDialog('Error!!! emissivity-2 is not number')            
            binaryAbsDict['model2greyEhrr']=model2greyehrrEntry.get_text()
            if GEN.isNumber(binaryAbsDict['model2greyEhrr'])==False:GEN.makeDialog('Error!!! Ehrr-2 is not number')
            
            keys=binaryAbsDict.keys()
            f=open(self.caseDir+'/system/settings/binaryAbsorptionCondition','w')
            for ii in keys:f.write(ii+';'+binaryAbsDict[ii]+'\n')
            f.close()
            
            window.destroy()

        def closethis(widget):window.destroy()

        def chaetype1(widget):
            aa=widget.child;whattype=aa.get_text()
            aa=model1valuebox.get_children()
            for ii in aa:model1valuebox.remove(ii)
            if whattype=='constant':model1valuebox.pack_start(model1constbox,False,False,0)
            elif whattype=='greyMean':model1valuebox.pack_start(model1greybox,False,False,0)
            elif whattype=='cloud':model1valuebox.pack_start(model1cloudbox,False,False,0)
            window.show_all()

        def chaetype2(widget):
            aa=widget.child;whattype=aa.get_text()
            aa=model2valuebox.get_children()
            for ii in aa:model2valuebox.remove(ii)
            if whattype=='constant':model2valuebox.pack_start(model2constbox,False,False,0)
            elif whattype=='greyMean':model2valuebox.pack_start(model2greybox,False,False,0)
            elif whattype=='cloud':model2valuebox.pack_start(model2cloudbox,False,False,0)
            window.show_all()

        def setgreyprop(widget):
            self.greyPropertyWindow()
            
        def setCloud1(widget):
            aa=glob.glob(self.caseDir+'/system/settings/coalProperties-*')
            if len(aa)==0:
                md = gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, "Error!!! - Coal is not set yet")
                md.run();md.destroy()
            else:
                if self.openSubWindow==False:
                    coals=[]
                    for ii in aa:
                        dic=GEN.makeDictFromFile(ii)
                        coals.append(dic['coalName'])
                    #for ii in aa:a1=ii.split('/');a2=a1[-1];coals.append(a2[15:])
                    self.selectCloudWindow(coals,'absorption1')
        
        def setCloud2(widget):
            aa=glob.glob(self.caseDir+'/system/settings/coalProperties-*')
            if len(aa)==0:
                md = gtk.MessageDialog(None,gtk.DIALOG_DESTROY_WITH_PARENT,gtk.MESSAGE_ERROR,gtk.BUTTONS_CLOSE, "Error!!! - Coal is not set yet")
                md.run();md.destroy()
            else:
                if self.openSubWindow==False:
                    coals=[]
                    for ii in aa:
                        dic=GEN.makeDictFromFile(ii)
                        coals.append(dic['coalName'])                    
                    #for ii in aa:a1=ii.split('/');a2=a1[-1];coals.append(a2[15:])
                    self.selectCloudWindow(coals,'absorption2')
                
        def setSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/binaryAbsorptionCondition')
            if len(aa)!=0:
                bidict=GEN.makeDictFromFile(aa[0])
                model1Combo.set_active(models.index(bidict['model1']))
                model1constabEntry.set_text(bidict['model1constAb'])
                model1constemEntry.set_text(bidict['model1constEm'])
                model1consteEntry.set_text(bidict['model1constE'])
                model1greyehrrEntry.set_text(bidict['model1greyEhrr'])
                model2Combo.set_active(models.index(bidict['model2']))
                model2constabEntry.set_text(bidict['model2constAb'])
                model2constemEntry.set_text(bidict['model2constEm'])
                model2consteEntry.set_text(bidict['model2constE'])
                model2greyehrrEntry.set_text(bidict['model2greyEhrr'])                

        window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Binary AbsorptionEmission Model')
        window.set_border_width(5);window.set_position(gtk.WIN_POS_CENTER);window.set_transient_for(self.mainwindow)
        mainbox=gtk.VBox(False,0);window.add(mainbox)

        label=gtk.Label('binaryAbsorptionEmissionCoeffs')
        hbox=gtk.HBox(False,5);mainbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5)

        swin=gtk.ScrolledWindow();swin.set_border_width(0);swin.set_policy(gtk.POLICY_ALWAYS,gtk.POLICY_ALWAYS)
        swin.set_size_request(350,500);mainbox.pack_start(swin)
        injsetbox=gtk.VBox(False,0);swin.add_with_viewport(injsetbox)

        vbox=gtk.VBox(False,5);injsetbox.pack_start(vbox,False,False,5)
        # mode1 ----------------------
        frame1=gtk.Frame();frame1.set_label('  Model-1  ');frame1.set_label_align(0.1, 0.5)
        frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        hbox=gtk.HBox(False,5);vbox.pack_start(hbox,False,False,5);hbox.pack_end(frame1,True,True,5)
        model1box=gtk.VBox(False,5);frame1.add(model1box)

        label=gtk.Label('absorptionEmissionModel')
        model1Combo=gtk.combo_box_entry_new_text();model1Combo.set_size_request(120,28)
        models=['constant','greyMean','cloud']  
        for ii in models:model1Combo.append_text(ii)
        model1Combo.set_active(0);model1Combo.connect('changed',chaetype1)
        hbox=gtk.HBox(False,5);model1box.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5);hbox.pack_end(model1Combo,False,False,5)

        model1valuebox=gtk.VBox(False,5);model1box.pack_start(model1valuebox,False,False,5)

        #	constant
        model1constbox=gtk.VBox(False,5);model1valuebox.pack_start(model1constbox,False,False,0)
        label=gtk.Label('	absorptivity')
        model1constabEntry=gtk.Entry();model1constabEntry.set_size_request(80,28);model1constabEntry.set_text('0.5')
        hbox=gtk.HBox(False,5);model1constbox.pack_start(hbox,False,False,1)
        hbox.pack_start(label,False,False,5);hbox.pack_end(model1constabEntry,False,False,5)
        label=gtk.Label('	emissivity')
        model1constemEntry=gtk.Entry();model1constemEntry.set_size_request(80,28);model1constemEntry.set_text('0.5')
        hbox=gtk.HBox(False,5);model1constbox.pack_start(hbox,False,False,1)
        hbox.pack_start(label,False,False,5);hbox.pack_end(model1constemEntry,False,False,5)

        label=gtk.Label('	E')
        model1consteEntry=gtk.Entry();model1consteEntry.set_size_request(80,28);model1consteEntry.set_text('0.5')
        hbox=gtk.HBox(False,5);model1constbox.pack_start(hbox,False,False,1)
        hbox.pack_start(label,False,False,5);hbox.pack_end(model1consteEntry,False,False,5)
        #	greyMean
        model1greybox=gtk.VBox(False,5)
        label=gtk.Label('	EhrrCoeff')
        model1greyehrrEntry=gtk.Entry();model1greyehrrEntry.set_size_request(80,28);model1greyehrrEntry.set_text('0.2')
        hbox=gtk.HBox(False,5);model1greybox.pack_start(hbox,False,False,1)
        hbox.pack_start(label,False,False,5);hbox.pack_end(model1greyehrrEntry,False,False,5)
        #	cloud
        model1cloudbox=gtk.VBox(False,5)
        model1cloudB=gtk.Button('cloudNames');model1cloudB.set_size_request(140,28);model1cloudB.connect('clicked',setCloud1)
        hbox=gtk.HBox(False,5);model1cloudbox.pack_start(hbox,False,False,1);hbox.pack_end(model1cloudB,False,False,5)

        # model2 ---------------------
        frame2=gtk.Frame();frame2.set_label('  Model-2  ');frame2.set_label_align(0.1, 0.5)
        frame2.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        hbox=gtk.HBox(False,5);vbox.pack_start(hbox,False,False,5);hbox.pack_end(frame2,True,True,5)
        model2box=gtk.VBox(False,5);frame2.add(model2box)

        label=gtk.Label('absorptionEmissionModel')
        model2Combo=gtk.combo_box_entry_new_text();model2Combo.set_size_request(120,28)
        for ii in models:model2Combo.append_text(ii)
        model2Combo.set_active(0);model2Combo.connect('changed',chaetype2)
        hbox=gtk.HBox(False,5);model2box.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5);hbox.pack_end(model2Combo,False,False,5)

        model2valuebox=gtk.VBox(False,5);model2box.pack_start(model2valuebox,False,False,5)

        #	constant
        model2constbox=gtk.VBox(False,5);model2valuebox.pack_start(model2constbox,False,False,0)
        label=gtk.Label('	absorptivity')
        model2constabEntry=gtk.Entry();model2constabEntry.set_size_request(80,28);model2constabEntry.set_text('0.5')
        hbox=gtk.HBox(False,5);model2constbox.pack_start(hbox,False,False,1)
        hbox.pack_start(label,False,False,5);hbox.pack_end(model2constabEntry,False,False,5)
        label=gtk.Label('	emissivity')
        model2constemEntry=gtk.Entry();model2constemEntry.set_size_request(80,28);model2constemEntry.set_text('0.5')
        hbox=gtk.HBox(False,5);model2constbox.pack_start(hbox,False,False,1)
        hbox.pack_start(label,False,False,5);hbox.pack_end(model2constemEntry,False,False,5)

        label=gtk.Label('	E')
        model2consteEntry=gtk.Entry();model2consteEntry.set_size_request(80,28);model2consteEntry.set_text('0.5')
        hbox=gtk.HBox(False,5);model2constbox.pack_start(hbox,False,False,1)
        hbox.pack_start(label,False,False,5);hbox.pack_end(model2consteEntry,False,False,5)
        #	greyMean
        model2greybox=gtk.VBox(False,5)
        label=gtk.Label('	EhrrCoeff')
        model2greyehrrEntry=gtk.Entry();model2greyehrrEntry.set_size_request(80,28);model2greyehrrEntry.set_text('0.2')
        hbox=gtk.HBox(False,5);model2greybox.pack_start(hbox,False,False,1)
        hbox.pack_start(label,False,False,5);hbox.pack_end(model2greyehrrEntry,False,False,5)
        #	cloud
        model2cloudbox=gtk.VBox(False,5)
        model2cloudB=gtk.Button('cloudNames');model2cloudB.set_size_request(140,28);model2cloudB.connect('clicked',setCloud2)
        hbox=gtk.HBox(False,5);model2cloudbox.pack_start(hbox,False,False,1);hbox.pack_end(model2cloudB,False,False,5)

        #-------------------------------
        buttonbox=gtk.HBox(False,5);mainbox.pack_end(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(120,30)
        cll=gtk.Button(label='Close');cll.set_size_request(120,30)
        app.connect('clicked',applythis);cll.connect('clicked',closethis)
        buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(app,False,False,5) 
        
        setSavedValue()

        window.show_all()


