#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for controlDict setup
#
# Author
#    NEXTFOAM Inc. 
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *
from boundaryConditionSub import *
from basicFlow import *

class freepanelRunConditionClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow,solver,installpath):
        self.caseDir=caseDir
        self.mainwindow=mainwindow
        self.installpath=installpath
        self.solver=solver

    def runCondition(self,notebook,textbuffer,terminal):
    
        GEN=generalClass(self.caseDir);RUN=basicFlowSolvingClass(self.caseDir,self.solver,self.installpath,terminal) 
    
        def initialize(widget):
                
            def applythis(widget):
                aa=self.startCombo.child;startfrom=aa.get_text()
                runControlDict=getControl()
                inputDictList=self.collectDicts(runControlDict)
                
                message='\n [  Initialize Data....  ]\n'
                enditer=textbuffer.get_end_iter()
                textbuffer.insert(enditer,message)                
                
                RUN.runSolver(inputDictList,'initialize',notebook,textbuffer)                        
                
                message='\n    ***     Initialization is completed     ********** \n\n'
                enditer=textbuffer.get_end_iter()
                textbuffer.insert(enditer,message)
                notebook.set_current_page(0)                             
                win.destroy()
                
            def closethis(widget):win.destroy()

            GEN=generalClass(self.caseDir)
            savedResult=GEN.getResult()
            if len(savedResult[0])!=0 or len(savedResult[1])!=0:
                imagefile=self.installpath+'/pic/question.png'                
                win=gtk.Window(gtk.WINDOW_TOPLEVEL);win.set_border_width(5);win.set_position(gtk.WIN_POS_CENTER)
                win.set_title('Warning');win.set_transient_for(self.mainwindow)
                mbox=gtk.VBox(False,0);win.add(mbox)
                frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);mbox.pack_start(frame,False,False,5)
                hbox=gtk.HBox(False,5);frame.add(hbox)
                ibox=gtk.VBox(False,5);hbox.pack_start(ibox,False,False,5)
                pic=gtk.Image();pic.set_from_file(imagefile);ibox.pack_start(pic,False,False,0)
                lbox=gtk.HBox(False,5);hbox.pack_start(lbox,False,False,5)            
                label=gtk.Label();label.set_markup(' <b> All the saved data will be deleted. OK? </b> ')            
                lbox.pack_start(label,False,False,5)
                bbox=gtk.HBox(False,5);mbox.pack_start(bbox,False,False,5)
                newB=gtk.Button('Yes');newB.set_size_request(120,28);newB.connect('clicked',applythis)
                clsB=gtk.Button('Cancel');clsB.set_size_request(120,28);clsB.connect('clicked',closethis)
                bbox.pack_end(clsB,False,False,5);bbox.pack_end(newB,False,False,5)		
                win.show_all()
            else:
                runControlDict=getControl()
                inputDictList=self.collectDicts(runControlDict)
                
                message='\n [  Initialize Data....  ]\n\n'
                enditer=textbuffer.get_end_iter()
                textbuffer.insert(enditer,message)
                
                RUN.runSolver(inputDictList,'initialize',notebook,textbuffer)
                
                message='\n\n    ************* Initialization is completed  ************* \n\n'
                enditer=textbuffer.get_end_iter()
                textbuffer.insert(enditer,message)
                notebook.set_current_page(0)    
                self.startCombo.set_active(1)
                
            f=open(self.caseDir+'/system/settings/solver','w')
            f.write(self.solver)
            f.close()            
        
        def applyrun(widget):            
            runControlDict=getControl()                       
            inputDictList=self.collectDicts(runControlDict)
            RUN.runSolver(inputDictList,'runSolver',notebook,textbuffer)        
                        
        def getControl():
            runControlDict={}
            runControlDict['startFrom']=self.startCombo.child.get_text()
            runControlDict['startTime']=self.startTimeEntry.get_text()
            runControlDict['endTime']=self.endTimeEntry.get_text()
            runControlDict['timeStepSize']=self.dtEntry.get_text()
            runControlDict['writeInterval']=self.wintervalEntry.get_text()
            runControlDict['purgeWrite']=self.purgeEntry.get_text()
            runControlDict['writePrecision']=self.wprecisionEntry.get_text()
            runControlDict['writeControl']=self.wcontrolCombo.child.get_text()
            runControlDict['writeFormat']=self.wformatCombo.child.get_text()
            if self.compressCheck.get_active()==1:runControlDict['dataCompression']='compressed'
            else:runControlDict['dataCompression']='uncompressed'
            if self.adjustCheck.get_active()==1:runControlDict['adjustTimeStep']='yes'
            else:runControlDict['adjustTimeStep']='no'
            runControlDict['maxCo']=self.maxcoEntry.get_text()
            if self.plotresCheck.get_active()==1:runControlDict['plotResidual']='true'
            else:runControlDict['plotResidual']='false'
            runControlDict['nCores']=self.ncoreEntry.get_text()            
            aa=self.partypeCombo.child;runControlDict['parallelType']=aa.get_text()
            aa=glob.glob(self.caseDir+'/system/settings/hostfilename')
            if len(aa)!=0:
                hh=GEN.makeDictFromFile(aa[0]);runControlDict['hostfile']=hh['hostfile']
            else:runControlDict['hostfile']='None'
            
            if GEN.isNumber(runControlDict['startTime'])==False:GEN.makeDialog('Error!!! startTime is not number')            
            if GEN.isNumber(runControlDict['endTime'])==False:GEN.makeDialog('Error!!! endTime is not number')            
            if GEN.isNumber(runControlDict['timeStepSize'])==False:GEN.makeDialog('Error!!! timeStepSize is not number')            
            if GEN.isNumber(runControlDict['writeInterval'])==False:GEN.makeDialog('Error!!! writeInterval is not number')            
            if GEN.isNumber(runControlDict['purgeWrite'])==False:GEN.makeDialog('Error!!! purgeWrite is not number')            
            if GEN.isNumber(runControlDict['writePrecision'])==False:GEN.makeDialog('Error!!! writePrecision is not number')            
            if GEN.isNumber(runControlDict['maxCo'])==False:GEN.makeDialog('Error!!! maxCo is not number')            
            if GEN.isNumber(runControlDict['nCores'])==False:GEN.makeDialog('Error!!! nCores is not number')            
            
            keys=runControlDict.keys()
            f=open(self.caseDir+'/system/settings/runConditions','w')
            for ii in keys:f.write(ii+';'+runControlDict[ii]+'\n')
            f.close()
            
            return runControlDict
            
        def setSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/runConditions')
            if len(aa)!=0:
                GEN=generalClass(self.caseDir);dic=GEN.makeDictFromFile(aa[0])
                self.startTimeEntry.set_text(dic['startTime'])
                self.endTimeEntry.set_text(dic['endTime']);self.dtEntry.set_text(dic['timeStepSize'])
                self.wintervalEntry.set_text(dic['writeInterval']);self.purgeEntry.set_text(dic['purgeWrite'])
                self.wprecisionEntry.set_text(dic['writePrecision']);self.wcontrolCombo.set_active(self.wcontrol.index(dic['writeControl']))
                self.wformatCombo.set_active(self.wformat.index(dic['writeFormat']))
                if dic['dataCompression']=='true':self.compressCheck.set_active(1)
                else:self.compressCheck.set_active(0)
                if dic['adjustTimeStep']=='yes':self.adjustCheck.set_active(1)
                else:self.adjustCheck.set_active(0)                
                self.maxcoEntry.set_text(dic['maxCo'])
                if dic['plotResidual']=='true':self.plotresCheck.set_active(1)
                else:self.plotresCheck.set_active(0)  
                self.ncoreEntry.set_text(dic['nCores'])
                
        def selhostfile(widget):
            aa=widget.child;partype=aa.get_text()
            if partype=='Cluster':
                hostfilename=self.selectHostFile()
                if hostfilename=='None':widget.set_active(0) 
            else:hostfilename='None'
            f=open(self.caseDir+'/system/settings/hostfilename','w')
            f.write('hostfile;'+hostfilename+'\n')
            f.close()    

        def toggleAdjust(widget):
            if widget.get_active()==1:self.maxcoEntry.set_sensitive(1)
            else:self.maxcoEntry.set_sensitive(0)
                                          
        self.runbox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('<b>  Run Conditions  </b>')
        ebox=gtk.EventBox();self.runbox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label)
                
        #separator=gtk.HSeparator();separator.set_size_request(285,5);self.runbox.pack_start(separator,False,True,10)

        label=gtk.Label('Start from')
        self.startCombo=gtk.combo_box_entry_new_text();self.startCombo.set_size_request(120,28)
        self.startFrom=['startTime','latestTime']  
        for ii in self.startFrom:self.startCombo.append_text(ii)
        self.startCombo.set_active(1);self.startCombo.set_sensitive(0)                
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.startCombo,False,False,2)        
        
        self.startTimeEntry=gtk.Entry();self.startTimeEntry.set_text('0');self.startTimeEntry.set_size_request(80,28)
        
        label=gtk.Label('End time')
        self.endTimeEntry=gtk.Entry();self.endTimeEntry.set_text('1000');self.endTimeEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.endTimeEntry,False,False,2)        
        
        label=gtk.Label('Time step size')        
        self.dtEntry=gtk.Entry();self.dtEntry.set_text('1');self.dtEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.dtEntry,False,False,2)
        
        label=gtk.Label('Write interval')
        self.wintervalEntry=gtk.Entry();self.wintervalEntry.set_text('100');self.wintervalEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.wintervalEntry,False,False,2)
        
        label=gtk.Label('Purge write')
        self.purgeEntry=gtk.Entry();self.purgeEntry.set_text('0');self.purgeEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.purgeEntry,False,False,2)
        
        label=gtk.Label('Write precision')
        self.wprecisionEntry=gtk.Entry();self.wprecisionEntry.set_text('6');self.wprecisionEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.wprecisionEntry,False,False,2)
        
        label=gtk.Label('Write control')
        self.wcontrolCombo=gtk.combo_box_entry_new_text();self.wcontrolCombo.set_size_request(120,28)
        self.wcontrol=['timeStep','runTime','adjustableRunTime','clockTime','cpuTime']  
        for ii in self.wcontrol:self.wcontrolCombo.append_text(ii)
        self.wcontrolCombo.set_active(2)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.wcontrolCombo,False,False,2)
        
        label=gtk.Label('Write format')
        self.wformatCombo=gtk.combo_box_entry_new_text();self.wformatCombo.set_size_request(120,28)
        self.wformat=['ascii','binary']  
        for ii in self.wformat:self.wformatCombo.append_text(ii)
        self.wformatCombo.set_active(0)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.wformatCombo,False,False,2)
        
        self.compressCheck=gtk.CheckButton('Data compression')
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2);hbox.pack_start(self.compressCheck,False,False,2)
        
        self.adjustCheck=gtk.CheckButton('Adjust time step')
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,0)
        hbox.pack_start(self.adjustCheck,False,False,2);self.adjustCheck.connect('toggled',toggleAdjust)
        
        label=gtk.Label('Max Co.');label.set_size_request(80,28);label.set_alignment(0,0.5)
        self.maxcoEntry=gtk.Entry();self.maxcoEntry.set_text('1');self.maxcoEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,0)
        hbox.pack_end(self.maxcoEntry,False,False,2);hbox.pack_end(label,False,False,5)                       
        
        self.plotresCheck=gtk.CheckButton('Plot residual');self.plotresCheck.set_active(1)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,00);hbox.pack_start(self.plotresCheck,False,False,2)
        
        label=gtk.Label('No. of cores')
        self.ncoreEntry=gtk.Entry();self.ncoreEntry.set_text('1');self.ncoreEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.ncoreEntry,False,False,2)
        
        label=gtk.Label('Parallel type');label.set_size_request(100,28);label.set_alignment(0,0.5)
        self.partypeCombo=gtk.combo_box_entry_new_text();self.partypeCombo.set_size_request(100,28)
        self.partype=['SMP','Cluster']  
        for ii in self.partype:self.partypeCombo.append_text(ii)
        self.partypeCombo.set_active(0)
        self.partypeCombo.connect('changed',selhostfile)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.partypeCombo,False,False,2)

        self.initializeB=gtk.Button('Initialize');self.initializeB.connect('clicked',initialize)#;self.initializeB.set_size_request(100,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,5);hbox.pack_start(self.initializeB,True,True,5)
        
        self.runAppB=gtk.Button('Start Run');self.runAppB.connect('clicked',applyrun)#;self.runAppB.set_size_request(100,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,5);hbox.pack_start(self.runAppB,True,True,5)
            
        setSavedValue()
        
        if self.solver=='simpleNFoam' or self.solver=='buoyantSimpleNFoam':
            self.adjustCheck.set_sensitive(0);self.maxcoEntry.set_sensitive(0)
        
        return self.runbox
    #------------------------------------------------------------------------
    def collectDicts(self,runControlDict):
        
        GEN=generalClass(self.caseDir)
        
        aa=glob.glob(self.caseDir+'/system/settings/simulationConditions')
        if len(aa)!=0:
            simDict=GEN.makeDictFromFile(aa[0])
        else:
            simDict={}
            simDict['turmodel']='standardKEpsilon';simDict['gravx']='0';simDict['gravy']='0';simDict['gravz']='0'
            simDict['densitymode']='Perfect gas';simDict['mw']='28';simDict['Hf']='0'
            simDict['Sf']='0';simDict['Cp']='1004';simDict['As']='1.67212e-6';simDict['Ts']='170.672';simDict['mu']='1e-5';simDict['k']='0.0245'
           
        aa=glob.glob(self.caseDir+'/system/settings/initialConditions')
        if len(aa)!=0:
            initialDict=GEN.makeDictFromFile(aa[0])
        else:
            initialDict={};initialDict['uxini']='0';initialDict['uyini']='0';initialDict['uzini']='0'
            initialDict['pini']='0';initialDict['kini']='1';initialDict['eini']='1';initialDict['Tini']='288';initialDict['gasini']='0'
            
        aa=glob.glob(self.caseDir+'/system/settings/BCDict:*')
        bcDictList=[]
        for i in range(len(aa)):
            bcDict=GEN.makeDictFromFile(aa[i])
            bcDictList.append(bcDict)

        if self.solver=='smokeDispersionFoam':
            aa=glob.glob(self.caseDir+'/system/settings/fireConditions')
            if len(aa)!=0:
                fireDict=GEN.makeDictFromFile(aa[0])
            else:
                GEN.makeDialog('Error!!! Fire zone is not set.')
                return
        else:
            fireDict=[]
            
        inputDictList=[simDict,initialDict,runControlDict,bcDictList,fireDict]
        return inputDictList
    #------------------------------------------------------------------------
    def selectHostFile(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:hostfilename=dialog.get_filename()
        elif response == gtk.RESPONSE_CANCEL:hostfilename='None'
        dialog.destroy()
        return hostfilename
  
    
    


