#-*-coding:utf8-*-
#############################################################################
#    Baram : Graphic User Interface for OpenFOAM
#    Copyright held by original author
#############################################################################
# License                                                                       
#    This file is part of Baram.                                            
#
#    Baram is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    Baram is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Baram.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for simulation conditions
#
# Author
#    NEXTFOAM Inc. 
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *
from boundaryConditionSub import *

class freepanelSimulationClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow,solver,installpath):
        self.caseDir=caseDir
        self.mainwindow=mainwindow
        self.solver=solver
        self.installpath=installpath

    def simulation(self,notebook,textbuffer,energy):
    
        GEN=generalClass(self.caseDir)

        def applythis(widget):
            GEN=generalClass(self.caseDir)
            simulationDict={}
            simulationDict['turmodel']=self.turCombo.child.get_text()
            simulationDict['gravx']=self.gravxEntry.get_text();simulationDict['gravy']=self.gravyEntry.get_text();simulationDict['gravz']=self.gravzEntry.get_text()
            simulationDict['operatingPressure']=self.opEntry.get_text()
            simulationDict['densitymode']=self.densityCombo.child.get_text()
            simulationDict['transmode']=self.transCombo.child.get_text()
            
            matvalue=[]
            model=self.treeview.get_model()
            for i in range(len(valuelist)):
                iter=model.get_iter(i)
                matvalue.append(model.get_value(iter,1))   
            
            simulationDict['rho']=matvalue[0];simulationDict['mu']=matvalue[1];simulationDict['mw']=matvalue[2];simulationDict['cp']=matvalue[3]
            simulationDict['conductivity']=matvalue[4];simulationDict['As']=matvalue[5];simulationDict['Ts']=matvalue[6]

            if GEN.isNumber(simulationDict['operatingPressure'])==False:GEN.makeDialog('Error!!! Operating Pressure가 숫자가 아닙니다.')
            if GEN.isNumber(simulationDict['rho'])==False:GEN.makeDialog('Error!!! 밀도가 숫자가 아닙니다.')
            if GEN.isNumber(simulationDict['mu'])==False:GEN.makeDialog('Error!!! mu가 숫자가 아닙니다.')
            if GEN.isNumber(simulationDict['cp'])==False:GEN.makeDialog('Error!!! Cp가 숫자가 아닙니다.')
            if GEN.isNumber(simulationDict['conductivity'])==False:GEN.makeDialog('Error!!! k가 숫자가 아닙니다.')            
            if GEN.isNumber(simulationDict['mw'])==False:GEN.makeDialog('Error!!! 분자량이 숫자가 아닙니다.')
            if GEN.isNumber(simulationDict['As'])==False:GEN.makeDialog('Error!!! As가 숫자가 아닙니다.')
            if GEN.isNumber(simulationDict['Ts'])==False:GEN.makeDialog('Error!!! Ts가 숫자가 아닙니다.')
            if GEN.isNumber(simulationDict['gravx'])==False:GEN.makeDialog('Error!!! gravity-x가 숫자가 아닙니다.')
            if GEN.isNumber(simulationDict['gravy'])==False:GEN.makeDialog('Error!!! gravity-y가 숫자가 아닙니다.')
            if GEN.isNumber(simulationDict['gravz'])==False:GEN.makeDialog('Error!!! gravity-z가 숫자가 아닙니다.')

            keys=simulationDict.keys()
            f=open(self.caseDir+'/system/settings/simulationConditions','w')
            for ii in keys:f.write(ii+';'+simulationDict[ii]+'\n')         
            f.close()
            
            message='\n [  Simulation Conditions are saved  ]\n' 
            
            message=message+'\n    - Turbulence model is '+simulationDict['turmodel']+'\n'
            message=message+'\n    - Gravity direction is ('+simulationDict['gravx']+' '+simulationDict['gravy']+' '+simulationDict['gravz']+')\n'
            message=message+'\n    - Operating pressure is '+simulationDict['operatingPressure']+'\n'
            if energy==False:
                message=message+'\n    - Density is '+simulationDict['rho']+'\n'
                message=message+'\n    - Viscosity is '+simulationDict['mu']+'\n'
            else:
                if simulationDict['densitymode']=='Constant':
                    message=message+'\n    - Density is '+simulationDict['rho']+'\n'
                    message=message+'\n    - Viscosity is '+simulationDict['mu']+'\n'
                    message=message+'\n    - Cp is '+simulationDict['cp']+'\n'
                    message=message+'\n    - Conductivity is '+simulationDict['conductivity']+'\n'
                elif simulationDict['densitymode']=='Perfect gas':
                    message=message+'\n    - Molecular weight is '+simulationDict['mw']+'\n'
                    message=message+'\n    - Cp is '+simulationDict['cp']+'\n'
                    if simulationDict['transmode']=='sutherland':
                        message=message+'\n    - As is '+simulationDict['As']+'\n'
                        message=message+'\n    - Ts is '+simulationDict['Ts']+'\n'
                    else:
                        message=message+'\n    - Viscosity is '+simulationDict['mu']+'\n'
                        message=message+'\n    - Conductivity is '+simulationDict['conductivity']+'\n'

            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            notebook.set_current_page(0) 
             
            self.mainwindow.show_all()
            
        def setSavedValue():
            fileName=self.caseDir+'/system/settings/simulationConditions';aa=glob.glob(fileName)
            if len(aa)!=0:
                GEN=generalClass(self.caseDir);dic=GEN.makeDictFromFile(aa[0])
                self.turCombo.set_active(self.turModels.index(dic['turmodel']))
                self.gravxEntry.set_text(dic['gravx']);self.gravyEntry.set_text(dic['gravy']);self.gravzEntry.set_text(dic['gravz'])
                self.opEntry.set_text(dic['operatingPressure'])
                self.densityCombo.set_active(self.densityMode.index(dic['densitymode']))
                self.transCombo.set_active(self.visModels.index(dic['transmode']))                           
                
                keys=dic.keys()
                savedlist=[dic['rho'],dic['mu'],dic['mw'],dic['cp'],dic['conductivity'],dic['As'],dic['Ts']]
                for i in range(len(valuelist)):
                    self.liststore[i][1]=savedlist[i]

        def changeValue(widget,path,text):self.liststore[path][1]=text

        self.simulationbox=gtk.VBox(False,0)
        label=gtk.Label();label.set_markup('<b>  Simulation Conditions  </b>')
        ebox=gtk.EventBox();self.simulationbox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label)
        
        #separator=gtk.HSeparator();separator.set_size_request(285,5);self.simulationbox.pack_start(separator,True,True,10)

        label=gtk.Label('Turbulence ')
        self.turCombo=gtk.combo_box_entry_new_text()
        self.turModels=['standardKEpsilon','realizableKE','RNGkEpsilon','kOmegaSST','laminar']  
        for ii in self.turModels:self.turCombo.append_text(ii)
        self.turCombo.set_active(0)
        self.turCombo.set_size_request(160,28)
        hbox=gtk.HBox(False,5);self.simulationbox.pack_start(hbox,False,False,10)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.turCombo,False,False,5) 
                        
        label=gtk.Label('Gravity')
        self.gravxEntry=gtk.Entry();self.gravxEntry.set_size_request(60,28);self.gravxEntry.set_text('0')
        self.gravyEntry=gtk.Entry();self.gravyEntry.set_size_request(60,28);self.gravyEntry.set_text('0')
        self.gravzEntry=gtk.Entry();self.gravzEntry.set_size_request(60,28);self.gravzEntry.set_text('0')
        hbox=gtk.HBox(False,5);self.simulationbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5)
        hbox.pack_end(self.gravzEntry,False,False,5);hbox.pack_end(self.gravyEntry,False,False,0);hbox.pack_end(self.gravxEntry,False,False,5)
        if energy==False:
            self.gravxEntry.set_sensitive(0);self.gravyEntry.set_sensitive(0);self.gravzEntry.set_sensitive(0)
        
        label=gtk.Label('Operating Pressure [Pa]')
        self.opEntry=gtk.Entry();self.opEntry.set_size_request(80,28);self.opEntry.set_text('101325')
        hbox=gtk.HBox(False,5);self.simulationbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.opEntry,False,False,5)
        # ---------------------
        separator=gtk.HSeparator();separator.set_size_request(285,5);self.simulationbox.pack_start(separator,False,True,10)

        label=gtk.Label();label.set_markup('<i>  Material Properties  </i>');label.set_alignment(0,0)
        hbox=gtk.HBox(False,5);self.simulationbox.pack_start(hbox,False,False,5);hbox.pack_start(label,False,False,5)

        label=gtk.Label('       Density')
        self.densityCombo=gtk.combo_box_entry_new_text()
        self.densityMode=['Constant','Perfect gas']  
        for ii in self.densityMode:self.densityCombo.append_text(ii)
        self.densityCombo.set_active(0)
        self.densityCombo.set_size_request(150,28)
        hbox=gtk.HBox(False,5);self.simulationbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.densityCombo,False,False,5)
        if energy==False:self.densityCombo.set_sensitive(0)
        
        hbox=gtk.HBox(False,5);self.simulationbox.pack_start(hbox,False,False,2)
        self.transCombo=gtk.combo_box_entry_new_text();self.transCombo.set_size_request(150,28)
        self.visModels=['Constant','Sutherland']  
        for ii in self.visModels:self.transCombo.append_text(ii)
        self.transCombo.set_active(0)       
        hbox.pack_end(self.transCombo,False,False,5)
        label=gtk.Label('       Viscosity');hbox.pack_end(label,False,False,5);label.set_size_request(120,28);label.set_alignment(0,0.5)

        self.matbox=gtk.VBox(False,5);self.simulationbox.pack_start(self.matbox,False,False,5)
        #----------------------------        
        self.rhoConstbox=gtk.VBox(False,5);self.matbox.pack_start(self.rhoConstbox,False,False,5)

        swin=gtk.ScrolledWindow();swin.set_border_width(0);swin.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        self.rhoConstbox.pack_start(swin,True,True,0);itembox=gtk.VBox(False,0);swin.add_with_viewport(itembox)
        swin.set_size_request(200,230)
        
        self.liststore = gtk.ListStore(str,str)
        fieldlist=['density [kg/m3]','viscosity [kg/ms]','M.W [g/mol]','Cp [j/kg]','conductivity [W/mK]','Sutherland As','Sutherland Ts']
        valuelist=['1.225','1e-5','28','1004','0.0245','1.67212e-6','170.672']
        for i in range(len(fieldlist)):
            self.liststore.append([fieldlist[i],valuelist[i]])
                            
        self.treeview = gtk.TreeView(self.liststore)        
        
        self.cell = gtk.CellRendererText();self.cell1 = gtk.CellRendererText()
        self.cell1.set_property("editable", True);self.cell1.connect('edited',changeValue)

        self.tvcolumn = gtk.TreeViewColumn('Field                       ',self.cell,text=0)
        self.tvcolumn1 = gtk.TreeViewColumn('Value',self.cell1,text=1)

        self.treeview.append_column(self.tvcolumn);self.treeview.append_column(self.tvcolumn1)
                
        itembox.pack_start(self.treeview,False,False,5)
        #--------------------------------
        if energy==False:
            self.densityCombo.set_sensitive(0);self.densityCombo.set_active(0)
            self.transCombo.set_sensitive(0);self.transCombo.set_active(0)
        else:
            self.densityCombo.set_sensitive(1)
        #--------------------------------
        separator=gtk.HSeparator();separator.set_size_request(285,5);self.simulationbox.pack_start(separator,False,True,10)
        
        hbox=gtk.HBox(False,5);self.simulationbox.pack_start(hbox,False,False,5)
        self.AppB=gtk.Button('Apply');hbox.pack_end(self.AppB,True,True,5);self.AppB.connect('clicked',applythis)

        #separator=gtk.HSeparator();separator.set_size_request(285,5);self.simulationbox.pack_start(separator,False,True,10)
                
        setSavedValue()
        
        return self.simulationbox




