{
    forAll(scalarFluid, i)
    {
        volScalarField& S = scalarFluid[i];
        scalarTransportModel& ST = scalarTransportFluid[i];

        OStringStream buffer;
        buffer << i;

        Info << nl
             << "\33[92m" << "updating diffusivity for "
             << "\33[95m" << S.name()
             << "\33[92m" << " using "
             << "\33[95m" << ST.subDict
                             (
                                 "scalar" + buffer.str()
                             ).lookup("diffusivityModel")[0]
             << "\33[0m"  << endl;

        ST.correct();

        Info << nl
             << "\33[92m" << "solving "
             << "\33[95m" << S.name()
             << "\33[0m"  << endl;

        tmp<fvScalarMatrix> SEqn
        (
            fvm::ddt(rho, S)
          + fvm::div(phi, S)
          - fvm::laplacian(ST.d(), S)
         ==
            fvOptions(rho, S)
        );

        SEqn().relax();

        fvOptions.constrain(SEqn());

        SEqn().solve();
    }
}
