{
    volScalarField rAU(1.0/UEqn().A());
    surfaceScalarField rhorAUf("rhorAUf", fvc::interpolate(rho*rAU));

    volVectorField HbyA("HbyA", U);
    HbyA = rAU*UEqn().H();
    UEqn.clear();

    phi = fvc::interpolate(rho*HbyA) & mesh.Sf();

    fvOptions.makeRelative(fvc::interpolate(rho), phi);

    adjustPhi(phi, U, p_rgh);

    // Update the fixedFluxPressure BCs to ensure flux consistency
    setSnGrad<fixedFluxPressureFvPatchScalarField>
    (
        p_rgh.boundaryField(),
        (
            phi.boundaryField()
          - fvOptions.relative(mesh.Sf().boundaryField() & U.boundaryField())
           *rho.boundaryField()
        )/(mesh.magSf().boundaryField()*rhorAUf.boundaryField())
    );

    while (simple.correctNonOrthogonal())
    {
        fvScalarMatrix p_rghEqn
        (
            fvm::laplacian(rhorAUf, p_rgh) == fvc::div(phi)
        );

        p_rghEqn.solve();

        if (simple.finalNonOrthogonalIter())
        {
            phi -= p_rghEqn.flux();
        }
    }

    U = HbyA - rAU*fvc::grad(p_rgh);

    U.correctBoundaryConditions();
    fvOptions.correct(U);

    // Explicitly relax pressure for next momentum predictor
    p_rgh.relax();

    p = p_rgh + Op;
}
