    // Solve the Momentum equation
    tmp<fvVectorMatrix> UEqn
    (
        fvm::div(phi, U)
      + turbulence->divDevRhoReff(U)
     ==
        (rho - rho0)*g
      + fvOptions(rho, U)
    );

    UEqn().relax(1.0);

    volScalarField rAU("rAU", 1.0/UEqn().A());

    surfaceScalarField rhorAUf
    (
        "rhorAUf", 
        fvc::interpolate(rho)*fvc::interpolate(rAU)
    );

    UEqn().relax();

    fvOptions.constrain(UEqn());

    volVectorField gradp_rgh = fvc::div(fvc::interpolate(p_rgh) * mesh.Sf());

    solve(UEqn() == -gradp_rgh);

    fvOptions.correct(U);

    U += rAU*gradp_rgh;

    phi = fvc::interpolate(rho)*(fvc::interpolate(U) & mesh.Sf());

    UEqn.clear();
