{
    fvOptions.makeRelative(fvc::interpolate(rho), phi);

    adjustPhi(phi, U, p_rgh);

    while (simple.correctNonOrthogonal())
    {
        fvScalarMatrix p_rghEqn
        (
            fvm::laplacian(rhorAUf, p_rgh) == fvc::div(phi)
        );

        relaxSnGradCorr(p_rghEqn, surfaceScalarField);

        p_rghEqn.setReference(pRefCell, getRefCellValue(p_rgh, pRefCell));
        p_rghEqn.solve();

        if (simple.finalNonOrthogonalIter())
        {
            phi -= p_rghEqn.flux();
        }
    }

    U -= rAU*fvc::div(fvc::interpolate(p_rgh) * mesh.Sf());

    U.correctBoundaryConditions();
    fvOptions.correct(U);

    // Update reconstruction gradient for velocity
    rcGradU = fvc::grad(U, "rcGrad(U)");

    // Explicitly relax pressure for next momentum predictor
    p_rgh.relax();

    p = p_rgh + Op + rho0*gh; 

    // Update reconstruction gradient for pressure
    rcGradp_rgh = fvc::grad(p_rgh, "rcGrad(p_rgh)");
}
