rho.storePrevIter();
p_rgh.storePrevIter();

if (finalIter)
{
    mesh.data::add("finalIteration", true);
}

// --- Momentum predictor
#include "UEqn.H"

// --- Pressure corrector loop
for (int corr=0; corr<nCorr; corr++)
{
    #include "pEqn.H"
}

// --- Solve energy equation
#include "EEqn.H"

// --- Solve turbulence equation
if (!turbOnFinalIterOnly || finalIter)
{
    turbulence.correct();
}

#include "compressibleContinuityErrors.H"

// --- Adjust Mass
rho = thermo.rho();
rho.relax();

if (!rho0Specified)
{
    rho0 = fvc::domainIntegrate(rho)/totalVolume;
}

//bool closedVolume = p_rgh.needReference();
//dimensionedScalar compressibility = fvc::domainIntegrate(psi);
//bool compressible = (compressibility.value() > SMALL);

//if (closedVolume && compressible)
//{
//    p += (initialMass - fvc::domainIntegrate(rho))/compressibility;

//    p_rgh = p - rho0*gh - Op;
//}

if (finalIter)
{
    mesh.data::remove("finalIteration");
}
