{
/*    massImbalance *= 0.0;

    const unallocLabelList& own = mesh.owner();
    const unallocLabelList& nei = mesh.neighbour();

    forAll(own, facei)
    {
        massImbalance.internalField()[own[facei]]
            -= phi.internalField()[facei]/mesh.V()[own[facei]];
        massImbalance.internalField()[nei[facei]]
            += phi.internalField()[facei]/mesh.V()[nei[facei]];
    }

    forAll(mesh.boundary(), patchi)
    {
        const unallocLabelList& pFaceCells
            = mesh.boundary()[patchi].faceCells();

        const fvsPatchScalarField& pphi = phi.boundaryField()[patchi];

        forAll(mesh.boundary()[patchi], facei)
        {
            massImbalance.internalField()[pFaceCells[facei]]
                -= pphi[facei]/mesh.V()[pFaceCells[facei]];
        }
    } */

    // Solve energy equation
    volScalarField& he = thermo.he();

    fvScalarMatrix EEqn
    (
        fvm::div(phi, he)
      + (
            he.name() == "e"
          ? fvc::div(phi, volScalarField("Ekp", 0.5*magSqr(U) + p/rho))
          : fvc::div(phi, volScalarField("K", 0.5*magSqr(U)))
        )
      - fvm::laplacian(turbulence.alphaEff(), he)
     ==
        radiation.Sh(thermo)
      + fvOptions(rho, he)
//      - fvm::SuSp(massImbalance, he) //cwo
    );

    EEqn.relax();

    fvOptions.constrain(EEqn);

    EEqn.solve();

    fvOptions.correct(he);

    thermo.correct();

    radiation.correct();

    Info<< "Min/max T:" << min(thermo.T()).value() << ' '
        << max(thermo.T()).value() << endl;
}
