{
    volScalarField rAU(1.0/UEqn().A());
    surfaceScalarField rhorAUf("rhorAUf", fvc::interpolate(rho*rAU));

    volVectorField HbyA("HbyA", U);
    HbyA = rAU*UEqn().H();
    UEqn.clear();

    surfaceScalarField phiHbyA
    (
        "phiHbyA",
        fvc::interpolate(rho*HbyA) & mesh.Sf()
    );

    fvOptions.makeRelative(fvc::interpolate(rho), phiHbyA);

    adjustPhi(phiHbyA, U, p_rgh);

    // Update the fixedFluxPressure BCs to ensure flux consistency
    setSnGrad<fixedFluxPressureFvPatchScalarField>
    (
        p_rgh.boundaryField(),
        (
            phiHbyA.boundaryField()
          - fvOptions.relative(mesh.Sf().boundaryField() & U.boundaryField())
           *rho.boundaryField()
        )/(mesh.magSf().boundaryField()*rhorAUf.boundaryField())
    );

    for (int nonOrth=0; nonOrth<=nNonOrthCorr; nonOrth++)
    {
        fvScalarMatrix p_rghEqn
        (
            fvm::laplacian(rhorAUf, p_rgh) == fvc::div(phiHbyA)
        );

        p_rghEqn.solve();

        if (nonOrth == nNonOrthCorr)
        {
            phi = phiHbyA - p_rghEqn.flux();

            p_rgh.relax();
            // Correct the momentum source with the pressure gradient flux
            U = HbyA - rAU*fvc::grad(p_rgh);
            U.correctBoundaryConditions();

            //p_rgh.relax();

            fvOptions.correct(U);
        }
    }

    p = p_rgh + Op + rho0*gh;
}
