{
    forAll(uds, udsI)
    {
        bool& solveScalar = solveScalarFluid[udsI][i];

        if (solveScalar)
        {
            volScalarField& S = scalarFluid[udsI][i];
            scalarTransportModel& ST = scalarTransportFluid[udsI][i];

            OStringStream buffer;
            buffer << udsI;

            Info << nl
                 << "\33[92m" << "updating diffusivity for "
                 << "\33[95m" << S.name()
                 << "\33[92m" << " using "
                 << "\33[95m" << ST.subDict
                                 (
                                     "scalar" + buffer.str()
                                 ).lookup("diffusivityModel")[0]
                 << "\33[92m" << " for region "
                 << "\33[93m" << mesh.name()
                 << "\33[0m"  << endl;

            ST.correct();

            Info << nl
                 << "\33[92m" << "solving "
                 << "\33[95m" << S.name()
                 << "\33[92m" << " for region "
                 << "\33[93m" << mesh.name()
                 << "\33[0m"  << endl;

            fvScalarMatrix SEqn
            (
                fvm::div(phi, S)
              - fvm::laplacian(ST.d(), S)
             ==
                fvOptions(rho, S)
            );

            SEqn.relax();

            fvOptions.constrain(SEqn);

            SEqn.solve();
        }
    }
}
