{
    IOdictionary decomposeParDict
    (
        IOobject
        (
            "decomposeParDict",
            runTime.system(),
            runTime,
            IOobject::MUST_READ,
            IOobject::NO_WRITE
        )
    );

    const scalar nProc(readScalar(decomposeParDict.lookup("numberOfSubdomains")));
    OStringStream buffer;
    buffer  << nProc;
    string nproc = buffer.str();

    forAll(fluidNames, i)
    {
        IOobject decomposeParDict
        (
            "decomposeParDict",
            runTime.system(),
            fluidNames[i],
            runTime,
            IOobject::NO_READ,
            IOobject::NO_WRITE,
            false
        );


        Info<< "Writing default " << fluidNames[i]/decomposeParDict.name()
            << endl;

        dictionary defaultDict;

        defaultDict.add("numberOfSubdomains", nProc, true);
        defaultDict.add("method", "scotch", true);

        IOdictionary(decomposeParDict, defaultDict).regIOobject::write();
    }

    forAll(solidNames, i)
    {
        IOobject decomposeParDict
        (
            "decomposeParDict",
            runTime.system(),
            solidNames[i],
            runTime,
            IOobject::NO_READ,
            IOobject::NO_WRITE,
            false
        );


        Info<< "Writing default " << solidNames[i]/decomposeParDict.name()
            << endl;

        dictionary defaultDict;

        defaultDict.add("numberOfSubdomains", nProc, true);
        defaultDict.add("method", "scotch", true);

        IOdictionary(decomposeParDict, defaultDict).regIOobject::write();
    }

    forAll(fluidNames, i)
    {
        Foam::system("decomposePar -region " + fluidNames[i]);
    }

    forAll(solidNames, i)
    {
        Foam::system("decomposePar -region " + solidNames[i]);
    }

    if (renumberMesh)
    {
        forAll(fluidNames, i)
        {
            Foam::system
            (
                "mpirun -np "
               + nproc
               + " renumberMesh "
               + " -region "
               + fluidNames[i]
               + " -parallel -overwrite"
            );
        }

        forAll(solidNames, i)
        {
            Foam::system
            (
                "mpirun -np " 
               + nproc
               + " renumberMesh "
               + " -region " 
               + solidNames[i] 
               + " -parallel -overwrite"
            );
        }
    }
}
