forAll(fluidNames, i)
{
    IOobject fvSchemes
    (
        "fvSchemes",
        runTime.system(),
        fluidNames[i],
        runTime,
        IOobject::NO_READ,
        IOobject::NO_WRITE,
        false
    );

    Info<< "Testing:" << fvSchemes.objectPath() << endl;

    if (!fvSchemes.headerOk())
    {
        Info<< "Writing default " << fluidNames[i]/fvSchemes.name() << endl;

        dictionary defaultDict;

        dictionary ddtDict;
        ddtDict.add("default", "Euler", true);
        defaultDict.add("ddtSchemes", ddtDict);

        dictionary gradDict;
        gradDict.add("default", "cellMDLimited Gauss linear 1", true);
        defaultDict.add("gradSchemes", gradDict);

        dictionary divDict;
        divDict.add("default", "none", true);
        divDict.add("div(phi,U)", "Gauss upwind", true);
        divDict.add("div(phi,K)", "Gauss upwind", true);
        divDict.add("div(phi,h)", "Gauss upwind", true);
        divDict.add("div(phi,k)", "Gauss upwind", true);
        divDict.add("div(phi,epsilon)", "Gauss upwind", true);
        divDict.add("div(phi,omega)", "Gauss upwind", true);
        divDict.add("div(phi,R)", "Gauss upwind", true);
        divDict.add("div(R)", "Gauss linear", true);
        divDict.add("div((muEff*dev2(T(grad(U)))))", "Gauss linear", true);
        defaultDict.add("divSchemes", divDict);

        dictionary laplDict;
        laplDict.add("default", "Gauss linear limited 1", true);
        defaultDict.add("laplacianSchemes", laplDict);

        dictionary interpDict;
        interpDict.add("default", "linear", true);
        defaultDict.add("interpolationSchemes", interpDict);

        dictionary snGradDict;
        snGradDict.add("default", "limited 1", true);
        defaultDict.add("snGradSchemes", snGradDict);

        dictionary fluxDict;
        fluxDict.add("default", "no", true);
        fluxDict.add("p_rgh", "", true);
        defaultDict.add("fluxRequired", fluxDict);

        IOdictionary(fvSchemes, defaultDict).regIOobject::write();
    }
}

forAll(solidNames, i)
{
    IOobject fvSchemes
    (
        "fvSchemes",
        runTime.system(),
        solidNames[i],
        runTime,
        IOobject::NO_READ,
        IOobject::NO_WRITE,
        false
    );

    Info<< "Testing:" << fvSchemes.objectPath() << endl;

    if (!fvSchemes.headerOk())
    {
        Info<< "Writing default " << solidNames[i]/fvSchemes.name() << endl;

        dictionary defaultDict;

        dictionary ddtDict;
        ddtDict.add("default", "Euler", true);
        defaultDict.add("ddtSchemes", ddtDict);

        dictionary gradDict;
        gradDict.add("default", "Gauss linear", true);
        defaultDict.add("gradSchemes", gradDict);

        dictionary divDict;
        divDict.add("default", "none", true);
        defaultDict.add("divSchemes", divDict);

        dictionary laplDict;
        laplDict.add("default", "Gauss linear corrected", true);
        defaultDict.add("laplacianSchemes", laplDict);

        dictionary interpDict;
        interpDict.add("default", "linear", true);
        defaultDict.add("interpolationSchemes", interpDict);

        dictionary snGradDict;
        snGradDict.add("default", "corrected", true);
        defaultDict.add("snGradSchemes", snGradDict);

        dictionary fluxDict;
        fluxDict.add("default", "no", true);
        defaultDict.add("fluxRequired", fluxDict);

        IOdictionary(fvSchemes, defaultDict).regIOobject::write();
    }
}
