forAll(fluidNames, i)
{
}

forAll(solidNames, i)
{
    IOobject thermophysicalProperties
    (
        "thermophysicalProperties",
        runTime.constant(),
        solidNames[i],
        runTime,
        IOobject::NO_READ,
        IOobject::NO_WRITE,
        false
    );

    Info<< "Testing:" << thermophysicalProperties.objectPath() << endl;

    if (!thermophysicalProperties.headerOk())
    {
        Info<< "Writing default " 
            << solidNames[i]/thermophysicalProperties.name() << endl;

        dictionary defaultDict;

        dictionary thermoTypeDict;
        thermoTypeDict.add("type", "heSolidThermo", true);
        thermoTypeDict.add("mixture", "pureMixture", true);
        thermoTypeDict.add("transport", "constIso", true);
        thermoTypeDict.add("thermo", "hConst", true);
        thermoTypeDict.add("equationOfState", "rhoConst", true);
        thermoTypeDict.add("specie", "specie", true);
        thermoTypeDict.add("energy", "sensibleEnthalpy", true);
        defaultDict.add("thermoType", thermoTypeDict);

        dictionary mixtureDict;

        dictionary specieDict;
        specieDict.add("nMoles", "1", true);
        specieDict.add("molWeight", "1", true);
        mixtureDict.add("specie", specieDict);

        dictionary transportDict;
        transportDict.add("kappa", "0.016", true);
        mixtureDict.add("transport", transportDict);

        dictionary thermoDict;
        thermoDict.add("Hf", "0", true);
        thermoDict.add("Cp", "1900", true);
        mixtureDict.add("thermodynamics", thermoDict);

        dictionary eosDict;
        eosDict.add("rho", "30", true);
        mixtureDict.add("equationOfState", eosDict);

        defaultDict.add("mixture", mixtureDict);

        IOdictionary(thermophysicalProperties, defaultDict).regIOobject::write();
    }
}
