    // Momentum predictor

    tmp<fvVectorMatrix> UEqn
    (
        fvm::div(phi, U)
      + turbulence->divDevReff(U)
      ==
        fvOptions(U)
    );

    UEqn().relax(1.0);

    volScalarField rAU("rAU", 1.0/UEqn().A());
    surfaceScalarField rAUf("rAUf", fvc::interpolate(rAU));

    UEqn().relax();

    fvOptions.constrain(UEqn());

    volVectorField gradp = fvc::div(fvc::interpolate(p) * mesh.Sf());

    solve(UEqn() == -gradp);

    fvOptions.correct(U);

    U += rAU*gradp;

    phi = fvc::interpolate(U) & mesh.Sf();

    UEqn.clear();
