{
    adjustPhi(phi, U, p);

    // Non-orthogonal pressure corrector loop
    while (simple.correctNonOrthogonal())
    {
        fvScalarMatrix pEqn
        (
            fvm::laplacian(rAUf, p) == fvc::div(phi)
        );

        relaxSnGradCorr(pEqn, surfaceScalarField);

        pEqn.setReference(pRefCell, pRefValue);

        pEqn.solve();

        if (simple.finalNonOrthogonalIter())
        {
            phi -= pEqn.flux();
        }
    }

    #include "continuityErrs.H"

    U -= rAU*fvc::div(fvc::interpolate(p) * mesh.Sf());

    U.correctBoundaryConditions();
    fvOptions.correct(U);

    // Update reconstruction gradient for velocity
    rcGradU = fvc::grad(U, "rcGrad(U)");

    // Explicitly relax pressure for next momentum predictor
    p.relax();

    // Update reconstruction gradient for pressure
    rcGradp = fvc::grad(p, "rcGrad(p)");

    fvOptions.makeRelative(phi);
}
