{
    wordList volScalarFields(mesh.names("volScalarField"));
    wordList volVectorFields(mesh.names("volVectorField"));

    forAll(volScalarFields, fieldI)
    {
        if 
        (
            volScalarFields[fieldI] != "nu"
         && volScalarFields[fieldI] != "mu"
         && volScalarFields[fieldI] != "alpha"
        )
        {
            const volScalarField& field
            (
                mesh.lookupObject<volScalarField>
                (
                    volScalarFields[fieldI]
                )
            );

            IOobject bf
            (
                volScalarFields[fieldI] + ".boundary",
                runTime.timeName(),
                mesh,
                IOobject::NO_READ,
                IOobject::NO_WRITE,
                false
            );

            OFstream bfOs
            (
                bf.objectPath(),
                runTime.writeFormat(),
                IOstream::currentVersion,
                runTime.writeCompression()
            );

            bf.writeHeader(bfOs);
            field.boundaryField().writeEntry("boundaryField", bfOs);
            bf.writeEndDivider(bfOs);
        }
    }

    forAll(volVectorFields, fieldI)
    {
        const volVectorField& field
        (
            mesh.lookupObject<volVectorField>
            (
                volVectorFields[fieldI]
            )
        );

        IOobject bf
        (
            volVectorFields[fieldI] + ".boundary",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::NO_WRITE,
            false
        );

        OFstream bfOs
        (
            bf.objectPath(),
            runTime.writeFormat(),
            IOstream::currentVersion,
            runTime.writeCompression()
        );

        bf.writeHeader(bfOs);
        field.boundaryField().writeEntry("boundaryField", bfOs);
        bf.writeEndDivider(bfOs);
    }
}
