void replaceEntryValue
(
    const objectRegistry& runTime,
    const fileName& regionName,
    const fileName& timeName,
    const word& fieldName,
    const word& patchName,
    const word& entry,
    const string& value
)
{
    IOobject field
    (
        fieldName,
        timeName,
        regionName,
        runTime,
        IOobject::MUST_READ,
        IOobject::NO_WRITE
    );

    if (regionName == "region0")
    {
        field = IOobject
        (   
            fieldName,
            timeName,
            runTime,
            IOobject::MUST_READ,
            IOobject::NO_WRITE
        );  
    }

    if (!field.headerOk())
    {
        return;
    }

    const word oldTypeName = IOdictionary::typeName;
    const_cast<word&>(IOdictionary::typeName) = word::null;

    IOdictionary dict(field);

    const_cast<word&>(IOdictionary::typeName) = oldTypeName;
    const_cast<word&>(dict.type()) = dict.headerClassName();

    dictionary& boundaryFieldDict = dict.subDict("boundaryField");
    dictionary& patchDict = boundaryFieldDict.subDict(patchName);

    regExp re(".*[Vv]alue.*");

    bool modified = false;

    if (patchDict.found(entry))
    {
        if (re.match(entry))
        {
            OStringStream buffer;
            buffer << patchDict.lookup(entry)[1]; 
            if (buffer.str() == "(")
            {
                buffer << patchDict.lookup(entry)[2]
                       << token::SPACE
                       << patchDict.lookup(entry)[3]
                       << token::SPACE
                       << patchDict.lookup(entry)[4]
                       << patchDict.lookup(entry)[5];
            }

            if (buffer.str() != value)
            {
                patchDict.remove(entry);
                patchDict.add(entry, ("uniform " + value).c_str());
                modified = true;
            }
        }
        else
        {
            OStringStream buffer;
            buffer << patchDict.lookup(entry)[0];
            if (buffer.str() == "(")
            {
                buffer << patchDict.lookup(entry)[1]
                       << token::SPACE
                       << patchDict.lookup(entry)[2]
                       << token::SPACE
                       << patchDict.lookup(entry)[3]
                       << patchDict.lookup(entry)[4];
            }

            if (buffer.str() != value)
            {
                patchDict.remove(entry);
                patchDict.add(entry, (value).c_str());
                modified = true;
            }
        }
    }
    else
    {
        if (re.match(entry))
        {
            patchDict.add(entry, ("uniform " + value).c_str());
        }
        else
        {
            patchDict.add(entry, (value).c_str());
        }

        modified = true;
/*
        WarningIn
        (
            "replaceEntryValue"
            "("
                "const objectRegistry& runTime,"
                "const word& regionName,"
                "const word& timeName,"
                "const word& fieldName,"
                "const word& patchName,"
                "const word& entry,"
                "const string& value"
            ")"
        )   << nl
            << "There is no entry "
            << "\33[91m"
            << "'" << entry << "' "
            << "\33[0m"
            << "in patch "
            << "\33[92m"
            << patchDict.name()
            << "\33[0m" << nl << nl
            << "The entry " 
            << "\33[91m"
            << "'" << entry << "' "
            << "\33[0m"
            << "added to existing entries :" << nl
            << "\33[96m"
            << patchDict.toc()
            << "\33[0m";
*/
    }

    //Info << dict << nl << endl;
    if (modified)
    {
        //Info << "Re-writing dictionary" << nl << endl;
        dict.regIOobject::write();
    }
}

